/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/strings","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/nls","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/objects","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/diffComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(B){for(var n=[],M=0,t=B.length;M<t;M++)n[M]=J[B[M]];return n},Ie=this,Te=typeof global=="object"?global:{},le;(function(B){B.global=Ie;var n=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();B.Environment=n})(le||(le={}));var le;(function(B){var n=function(){function R(o,y,h){this.type=o,this.detail=y,this.timestamp=h}return R}();B.LoaderEvent=n;var M=function(){function R(o){this._events=[new n(1,"",o)]}return R.prototype.record=function(o,y){this._events.push(new n(o,y,B.Utilities.getHighPerformanceTimestamp()))},R.prototype.getEvents=function(){return this._events},R}();B.LoaderEventRecorder=M;var t=function(){function R(){}return R.prototype.record=function(o,y){},R.prototype.getEvents=function(){return[]},R.INSTANCE=new R,R}();B.NullLoaderEventRecorder=t})(le||(le={}));var le;(function(B){var n=function(){function M(){}return M.fileUriToFilePath=function(t,R){if(R=decodeURI(R).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(R))return R.substr(8);if(/^file:\/\//.test(R))return R.substr(5)}else if(/^file:\/\//.test(R))return R.substr(7);return R},M.startsWith=function(t,R){return t.length>=R.length&&t.substr(0,R.length)===R},M.endsWith=function(t,R){return t.length>=R.length&&t.substr(t.length-R.length)===R},M.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},M.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},M.forEachProperty=function(t,R){if(t){var o=void 0;for(o in t)t.hasOwnProperty(o)&&R(o,t[o])}},M.isEmpty=function(t){var R=!0;return M.forEachProperty(t,function(){R=!1}),R},M.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var R=Array.isArray(t)?[]:{};return M.forEachProperty(t,function(o,y){y&&typeof y=="object"?R[o]=M.recursiveClone(y):R[o]=y}),R},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(t){return M.startsWith(t,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();B.Utilities=n})(le||(le={}));var le;(function(B){function n(R){if(R instanceof Error)return R;var o=new Error(R.message||String(R)||"Unknown Error");return R.stack&&(o.stack=R.stack),o}B.ensureError=n;var M=function(){function R(){}return R.validateConfigurationOptions=function(o){function y(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.buildForceInvokeFactory!="object"&&(o.buildForceInvokeFactory={}),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError=="undefined"&&(o.catchError=!1),typeof o.recordStats=="undefined"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=y),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(B.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags=="undefined"&&(o.preferScriptTags=!1),Array.isArray(o.nodeModules)||(o.nodeModules=[]),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){var h=n(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",o.onError(h),o.nodeCachedData=void 0}return o},R.mergeConfigurationOptions=function(o,y){o===void 0&&(o=null),y===void 0&&(y=null);var h=B.Utilities.recursiveClone(y||{});return B.Utilities.forEachProperty(o,function(a,m){a==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules!="undefined"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(m):a==="paths"&&typeof h.paths!="undefined"?B.Utilities.forEachProperty(m,function(E,P){return h.paths[E]=P}):a==="config"&&typeof h.config!="undefined"?B.Utilities.forEachProperty(m,function(E,P){return h.config[E]=P}):h[a]=B.Utilities.recursiveClone(m)}),R.validateConfigurationOptions(h)},R}();B.ConfigurationOptionsUtil=M;var t=function(){function R(o,y){if(this._env=o,this.options=M.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var h=this.options.nodeRequire.main.filename,a=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,a+1)}if(this.options.nodeMain&&this._env.isNode){var h=this.options.nodeMain,a=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,a+1)}}}return R.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0},R.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var o=0,y=this.options.nodeModules;o<y.length;o++){var h=y[o];this.nodeModulesMap[h]=!0}},R.prototype._createSortedPathsRules=function(){var o=this;this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,function(y,h){Array.isArray(h)?o.sortedPathsRules.push({from:y,to:h}):o.sortedPathsRules.push({from:y,to:[h]})}),this.sortedPathsRules.sort(function(y,h){return h.from.length-y.from.length})},R.prototype.cloneAndMerge=function(o){return new R(this._env,M.mergeConfigurationOptions(o,this.options))},R.prototype.getOptionsLiteral=function(){return this.options},R.prototype._applyPaths=function(o){for(var y,h=0,a=this.sortedPathsRules.length;h<a;h++)if(y=this.sortedPathsRules[h],B.Utilities.startsWith(o,y.from)){for(var m=[],E=0,P=y.to.length;E<P;E++)m.push(y.to[E]+o.substr(y.from.length));return m}return[o]},R.prototype._addUrlArgsToUrl=function(o){return B.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs},R.prototype._addUrlArgsIfNecessaryToUrl=function(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o},R.prototype._addUrlArgsIfNecessaryToUrls=function(o){if(this.options.urlArgs)for(var y=0,h=o.length;y<h;y++)o[y]=this._addUrlArgsToUrl(o[y]);return o},R.prototype.moduleIdToPaths=function(o){if(this._env.isNode){var y=this.nodeModulesMap[o]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o);if(y)return this.isBuild()?["empty:"]:["node|"+o]}var h=o,a;if(!B.Utilities.endsWith(h,".js")&&!B.Utilities.isAbsolutePath(h)){a=this._applyPaths(h);for(var m=0,E=a.length;m<E;m++)this.isBuild()&&a[m]==="empty:"||(B.Utilities.isAbsolutePath(a[m])||(a[m]=this.options.baseUrl+a[m]),!B.Utilities.endsWith(a[m],".js")&&!B.Utilities.containsQueryString(a[m])&&(a[m]=a[m]+".js"))}else!B.Utilities.endsWith(h,".js")&&!B.Utilities.containsQueryString(h)&&(h=h+".js"),a=[h];return this._addUrlArgsIfNecessaryToUrls(a)},R.prototype.requireToUrl=function(o){var y=o;return B.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],B.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)},R.prototype.isBuild=function(){return this.options.isBuild},R.prototype.shouldInvokeFactory=function(o){return this.options.isBuild?this.options.buildForceInvokeFactory[o]||B.Utilities.isAnonymousModule(o):!0},R.prototype.isDuplicateMessageIgnoredFor=function(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)},R.prototype.getConfigForModule=function(o){if(this.options.config)return this.options.config[o]},R.prototype.shouldCatchError=function(){return this.options.catchError},R.prototype.shouldRecordStats=function(){return this.options.recordStats},R.prototype.onError=function(o){this.options.onError(o)},R}();B.Configuration=t})(le||(le={}));var le;(function(B){var n=function(){function a(m){this._env=m,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(m,E,P,C){var _=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new R;else if(this._env.isElectronRenderer){var e=m.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new M:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new M;var A={callback:P,errorback:C};if(this._callbackMap.hasOwnProperty(E)){this._callbackMap[E].push(A);return}this._callbackMap[E]=[A],this._scriptLoader.load(m,E,function(){return _.triggerCallback(E)},function(p){return _.triggerErrorback(E,p)})},a.prototype.triggerCallback=function(m){var E=this._callbackMap[m];delete this._callbackMap[m];for(var P=0;P<E.length;P++)E[P].callback()},a.prototype.triggerErrorback=function(m,E){var P=this._callbackMap[m];delete this._callbackMap[m];for(var C=0;C<P.length;C++)P[C].errorback(E)},a}(),M=function(){function a(){}return a.prototype.attachListeners=function(m,E,P){var C=function(){m.removeEventListener("load",_),m.removeEventListener("error",e)},_=function(A){C(),E()},e=function(A){C(),P(A)};m.addEventListener("load",_),m.addEventListener("error",e)},a.prototype.load=function(m,E,P,C){if(/^node\|/.test(E)){var _=m.getConfig().getOptionsLiteral(),e=y(m.getRecorder(),_.nodeRequire||B.global.nodeRequire),A=E.split("|"),p=null;try{p=e(A[1])}catch(i){C(i);return}m.enqueueDefineAnonymousModule([],function(){return p}),P()}else{var N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript"),this.attachListeners(N,P,C);var u=m.getConfig().getOptionsLiteral().trustedTypesPolicy;u&&(E=u.createScriptURL(E)),N.setAttribute("src",E);var s=m.getConfig().getOptionsLiteral().cspNonce;s&&N.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(N)}},a}();function t(a){var m=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var E=m?self.eval(m.createScript("","true")):new Function("true");return E.call(self),!0}catch{return!1}}var R=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(m){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(m)),this._cachedCanUseEval},a.prototype.load=function(m,E,P,C){if(/^node\|/.test(E)){var _=m.getConfig().getOptionsLiteral(),e=y(m.getRecorder(),_.nodeRequire||B.global.nodeRequire),A=E.split("|"),p=null;try{p=e(A[1])}catch(s){C(s);return}m.enqueueDefineAnonymousModule([],function(){return p}),P()}else{var N=m.getConfig().getOptionsLiteral().trustedTypesPolicy,u=/^((http:)|(https:)|(file:))/.test(E)&&E.substring(0,self.origin.length)!==self.origin;if(!u&&this._canUseEval(m)){fetch(E).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+E;var i=N?self.eval(N.createScript("",s)):new Function(s);i.call(self),P()}).then(void 0,C);return}try{N&&(E=N.createScriptURL(E)),importScripts(E),P()}catch(s){C(s)}}},a}(),o=function(){function a(m){this._env=m,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(m){this._didInitialize||(this._didInitialize=!0,this._fs=m("fs"),this._vm=m("vm"),this._path=m("path"),this._crypto=m("crypto"))},a.prototype._initNodeRequire=function(m,E){var P=E.getConfig().getOptionsLiteral().nodeCachedData;if(!P||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var C=this,_=m("module");function e(A){var p=A.constructor,N=function(s){try{return A.require(s)}finally{}};return N.resolve=function(s,i){return p._resolveFilename(s,A,!1,i)},N.resolve.paths=function(s){return p._resolveLookupPaths(s,A)},N.main=process.mainModule,N.extensions=p._extensions,N.cache=p._cache,N}_.prototype._compile=function(A,p){var N=_.wrap(A.replace(/^#!.*/,"")),u=E.getRecorder(),s=C._getCachedDataPath(P,p),i={filename:p},l;try{var c=C._fs.readFileSync(s);l=c.slice(0,16),i.cachedData=c.slice(16),u.record(60,s)}catch{u.record(61,s)}var w=new C._vm.Script(N,i),b=w.runInThisContext(i),d=C._path.dirname(p),v=e(this),L=[this.exports,v,this,p,d,process,Te,Buffer],g=b.apply(this.exports,L);return C._handleCachedData(w,N,s,!i.cachedData,E),C._verifyCachedData(w,N,s,l,E),g}},a.prototype.load=function(m,E,P,C){var _=this,e=m.getConfig().getOptionsLiteral(),A=y(m.getRecorder(),e.nodeRequire||B.global.nodeRequire),p=e.nodeInstrumenter||function(b){return b};this._init(A),this._initNodeRequire(A,m);var N=m.getRecorder();if(/^node\|/.test(E)){var u=E.split("|"),s=null;try{s=A(u[1])}catch(b){C(b);return}m.enqueueDefineAnonymousModule([],function(){return s}),P()}else{E=B.Utilities.fileUriToFilePath(this._env.isWindows,E);var i=this._path.normalize(E),l=this._getElectronRendererScriptPathOrUri(i),c=Boolean(e.nodeCachedData),w=c?this._getCachedDataPath(e.nodeCachedData,E):void 0;this._readSourceAndCachedData(i,w,N,function(b,d,v,L){if(b){C(b);return}var g;d.charCodeAt(0)===a._BOM?g=a._PREFIX+d.substring(1)+a._SUFFIX:g=a._PREFIX+d+a._SUFFIX,g=p(g,i);var f={filename:l,cachedData:v},D=_._createAndEvalScript(m,g,f,P,C);_._handleCachedData(D,g,w,c&&!v,m),_._verifyCachedData(D,g,w,L,m)})}},a.prototype._createAndEvalScript=function(m,E,P,C,_){var e=m.getRecorder();e.record(31,P.filename);var A=new this._vm.Script(E,P),p=A.runInThisContext(P),N=m.getGlobalAMDDefineFunc(),u=!1,s=function(){return u=!0,N.apply(null,arguments)};return s.amd=N.amd,p.call(B.global,m.getGlobalAMDRequireFunc(),s,P.filename,this._path.dirname(P.filename)),e.record(32,P.filename),u?C():_(new Error("Didn't receive define call in "+P.filename+"!")),A},a.prototype._getElectronRendererScriptPathOrUri=function(m){if(!this._env.isElectronRenderer)return m;var E=m.match(/^([a-z])\:(.*)/i);return E?"file:///"+(E[1].toUpperCase()+":"+E[2]).replace(/\\/g,"/"):"file://"+m},a.prototype._getCachedDataPath=function(m,E){var P=this._crypto.createHash("md5").update(E,"utf8").update(m.seed,"utf8").update(process.arch,"").digest("hex"),C=this._path.basename(E).replace(/\.js$/,"");return this._path.join(m.path,C+"-"+P+".code")},a.prototype._handleCachedData=function(m,E,P,C,_){var e=this;m.cachedDataRejected?this._fs.unlink(P,function(A){_.getRecorder().record(62,P),e._createAndWriteCachedData(m,E,P,_),A&&_.getConfig().onError(A)}):C&&this._createAndWriteCachedData(m,E,P,_)},a.prototype._createAndWriteCachedData=function(m,E,P,C){var _=this,e=Math.ceil(C.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),A=-1,p=0,N=void 0,u=function(){setTimeout(function(){N||(N=_._crypto.createHash("md5").update(E,"utf8").digest());var s=m.createCachedData();if(!(s.length===0||s.length===A||p>=5)){if(s.length<A){u();return}A=s.length,_._fs.writeFile(P,Buffer.concat([N,s]),function(i){i&&C.getConfig().onError(i),C.getRecorder().record(63,P),u()})}},e*Math.pow(4,p++))};u()},a.prototype._readSourceAndCachedData=function(m,E,P,C){if(!E)this._fs.readFile(m,{encoding:"utf8"},C);else{var _=void 0,e=void 0,A=void 0,p=2,N=function(u){u?C(u):--p==0&&C(void 0,_,e,A)};this._fs.readFile(m,{encoding:"utf8"},function(u,s){_=s,N(u)}),this._fs.readFile(E,function(u,s){!u&&s&&s.length>0?(A=s.slice(0,16),e=s.slice(16),P.record(60,E)):P.record(61,E),N()})}},a.prototype._verifyCachedData=function(m,E,P,C,_){var e=this;!C||m.cachedDataRejected||setTimeout(function(){var A=e._crypto.createHash("md5").update(E,"utf8").digest();C.equals(A)||(_.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+P+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(P,function(p){p&&_.getConfig().onError(p)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function y(a,m){if(m.__$__isRecorded)return m;var E=function(C){a.record(33,C);try{return m(C)}finally{a.record(34,C)}};return E.__$__isRecorded=!0,E}B.ensureRecordedNodeRequire=y;function h(a){return new n(a)}B.createScriptLoader=h})(le||(le={}));var le;(function(B){var n=function(){function h(a){var m=a.lastIndexOf("/");m!==-1?this.fromModulePath=a.substr(0,m+1):this.fromModulePath=""}return h._normalizeModuleId=function(a){var m=a,E;for(E=/\/\.\//;E.test(m);)m=m.replace(E,"/");for(m=m.replace(/^\.\//g,""),E=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;E.test(m);)m=m.replace(E,"/");return m=m.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),m},h.prototype.resolveModule=function(a){var m=a;return B.Utilities.isAbsolutePath(m)||(B.Utilities.startsWith(m,"./")||B.Utilities.startsWith(m,"../"))&&(m=h._normalizeModuleId(this.fromModulePath+m)),m},h.ROOT=new h(""),h}();B.ModuleIdResolver=n;var M=function(){function h(a,m,E,P,C,_){this.id=a,this.strId=m,this.dependencies=E,this._callback=P,this._errorback=C,this.moduleIdResolver=_,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return h._safeInvokeFunction=function(a,m){try{return{returnedValue:a.apply(B.global,m),producedError:null}}catch(E){return{returnedValue:null,producedError:E}}},h._invokeFactory=function(a,m,E,P){return a.shouldInvokeFactory(m)?a.shouldCatchError()?this._safeInvokeFunction(E,P):{returnedValue:E.apply(B.global,P),producedError:null}:{returnedValue:null,producedError:null}},h.prototype.complete=function(a,m,E,P){this._isComplete=!0;var C=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var _=h._invokeFactory(m,this.strId,this._callback,E);C=_.producedError,a.record(22,this.strId),!C&&typeof _.returnedValue!="undefined"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=_.returnedValue)}else this.exports=this._callback;if(C){var e=B.ensureError(C);e.phase="factory",e.moduleId=this.strId,e.neededBy=P(this.id),this.error=e,m.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},h.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},h.prototype.isComplete=function(){return this._isComplete},h}();B.Module=M;var t=function(){function h(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return h.prototype.getMaxModuleId=function(){return this._nextId},h.prototype.getModuleId=function(a){var m=this._strModuleIdToIntModuleId.get(a);return typeof m=="undefined"&&(m=this._nextId++,this._strModuleIdToIntModuleId.set(a,m),this._intModuleIdToStrModuleId[m]=a),m},h.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},h}(),R=function(){function h(a){this.id=a}return h.EXPORTS=new h(0),h.MODULE=new h(1),h.REQUIRE=new h(2),h}();B.RegularDependency=R;var o=function(){function h(a,m,E){this.id=a,this.pluginId=m,this.pluginParam=E}return h}();B.PluginDependency=o;var y=function(){function h(a,m,E,P,C){C===void 0&&(C=0),this._env=a,this._scriptLoader=m,this._loaderAvailableTimestamp=C,this._defineFunc=E,this._requireFunc=P,this._moduleIdProvider=new t,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return h.prototype.reset=function(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},h.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},h.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},h._findRelevantLocationInStack=function(a,m){for(var E=function(i){return i.replace(/\\/g,"/")},P=E(a),C=m.split(/\n/),_=0;_<C.length;_++){var e=C[_].match(/(.*):(\d+):(\d+)\)?$/);if(e){var A=e[1],p=e[2],N=e[3],u=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(u),A=E(A),A===P){var s={line:parseInt(p,10),col:parseInt(N,10)};return s.line===1&&(s.col-="(function (require, define, __filename, __dirname) { ".length),s}}}throw new Error("Could not correlate define call site for needle "+a)},h.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],m=0,E=0,P=this._modules2.length;E<P;E++){var C=this._modules2[E];if(!!C){var _=this._buildInfoPath[C.id]||null,e=this._buildInfoDefineStack[C.id]||null,A=this._buildInfoDependencies[C.id];a[m++]={id:C.strId,path:_,defineLocation:_&&e?h._findRelevantLocationInStack(_,e):null,dependencies:A,shim:null,exports:C.exports}}}return a},h.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder},h.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},h.prototype.enqueueDefineAnonymousModule=function(a,m){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var E=null;this._config.isBuild()&&(E=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:E,dependencies:a,callback:m}},h.prototype.defineModule=function(a,m,E,P,C,_){var e=this;_===void 0&&(_=new n(a));var A=this._moduleIdProvider.getModuleId(a);if(this._modules2[A]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var p=new M(A,a,this._normalizeDependencies(m,_),E,P,_);this._modules2[A]=p,this._config.isBuild()&&(this._buildInfoDefineStack[A]=C,this._buildInfoDependencies[A]=(p.dependencies||[]).map(function(N){return e._moduleIdProvider.getStrModuleId(N.id)})),this._resolve(p)},h.prototype._normalizeDependency=function(a,m){if(a==="exports")return R.EXPORTS;if(a==="module")return R.MODULE;if(a==="require")return R.REQUIRE;var E=a.indexOf("!");if(E>=0){var P=m.resolveModule(a.substr(0,E)),C=m.resolveModule(a.substr(E+1)),_=this._moduleIdProvider.getModuleId(P+"!"+C),e=this._moduleIdProvider.getModuleId(P);return new o(_,e,C)}return new R(this._moduleIdProvider.getModuleId(m.resolveModule(a)))},h.prototype._normalizeDependencies=function(a,m){for(var E=[],P=0,C=0,_=a.length;C<_;C++)E[P++]=this._normalizeDependency(a[C],m);return E},h.prototype._relativeRequire=function(a,m,E,P){if(typeof m=="string")return this.synchronousRequire(m,a);this.defineModule(B.Utilities.generateAnonymousModule(),m,E,P,null,a)},h.prototype.synchronousRequire=function(a,m){m===void 0&&(m=new n(a));var E=this._normalizeDependency(a,m),P=this._modules2[E.id];if(!P)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!P.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(P.error)throw P.error;return P.exports},h.prototype.configure=function(a,m){var E=this._config.shouldRecordStats();m?this._config=new B.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!E&&(this._recorder=null)},h.prototype.getConfig=function(){return this._config},h.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var m=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),m.dependencies,m.callback,null,m.stack)}},h.prototype._createLoadError=function(a,m){var E=this,P=this._moduleIdProvider.getStrModuleId(a),C=(this._inverseDependencies2[a]||[]).map(function(e){return E._moduleIdProvider.getStrModuleId(e)}),_=B.ensureError(m);return _.phase="loading",_.moduleId=P,_.neededBy=C,_},h.prototype._onLoadError=function(a,m){var E=this._createLoadError(a,m);this._modules2[a]||(this._modules2[a]=new M(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var P=[],C=0,_=this._moduleIdProvider.getMaxModuleId();C<_;C++)P[C]=!1;var e=!1,A=[];for(A.push(a),P[a]=!0;A.length>0;){var p=A.shift(),N=this._modules2[p];N&&(e=N.onDependencyError(E)||e);var u=this._inverseDependencies2[p];if(u)for(var C=0,_=u.length;C<_;C++){var s=u[C];P[s]||(A.push(s),P[s]=!0)}}e||this._config.onError(E)},h.prototype._hasDependencyPath=function(a,m){var E=this._modules2[a];if(!E)return!1;for(var P=[],C=0,_=this._moduleIdProvider.getMaxModuleId();C<_;C++)P[C]=!1;var e=[];for(e.push(E),P[a]=!0;e.length>0;){var A=e.shift(),p=A.dependencies;if(p)for(var C=0,_=p.length;C<_;C++){var N=p[C];if(N.id===m)return!0;var u=this._modules2[N.id];u&&!P[N.id]&&(P[N.id]=!0,e.push(u))}}return!1},h.prototype._findCyclePath=function(a,m,E){if(a===m||E===50)return[a];var P=this._modules2[a];if(!P)return null;var C=P.dependencies;if(C)for(var _=0,e=C.length;_<e;_++){var A=this._findCyclePath(C[_].id,m,E+1);if(A!==null)return A.push(a),A}return null},h.prototype._createRequire=function(a){var m=this,E=function(P,C,_){return m._relativeRequire(a,P,C,_)};return E.toUrl=function(P){return m._config.requireToUrl(a.resolveModule(P))},E.getStats=function(){return m.getLoaderEvents()},E.hasDependencyCycle=function(){return m._hasDependencyCycle},E.config=function(P,C){C===void 0&&(C=!1),m.configure(P,C)},E.__$__nodeRequire=B.global.nodeRequire,E},h.prototype._loadModule=function(a){var m=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var E=this._moduleIdProvider.getStrModuleId(a),P=this._config.moduleIdToPaths(E),C=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(E.indexOf("/")===-1||C.test(E))&&P.push("node|"+E);var _=-1,e=function(A){if(_++,_>=P.length)m._onLoadError(a,A);else{var p=P[_],N=m.getRecorder();if(m._config.isBuild()&&p==="empty:"){m._buildInfoPath[a]=p,m.defineModule(m._moduleIdProvider.getStrModuleId(a),[],null,null,null),m._onLoad(a);return}N.record(10,p),m._scriptLoader.load(m,p,function(){m._config.isBuild()&&(m._buildInfoPath[a]=p),N.record(11,p),m._onLoad(a)},function(u){N.record(12,p),e(u)})}};e(null)}},h.prototype._loadPluginDependency=function(a,m){var E=this;if(!(this._modules2[m.id]||this._knownModules2[m.id])){this._knownModules2[m.id]=!0;var P=function(C){E.defineModule(E._moduleIdProvider.getStrModuleId(m.id),[],C,null,null)};P.error=function(C){E._config.onError(E._createLoadError(m.id,C))},a.load(m.pluginParam,this._createRequire(n.ROOT),P,this._config.getOptionsLiteral())}},h.prototype._resolve=function(a){var m=this,E=a.dependencies;if(E)for(var P=0,C=E.length;P<C;P++){var _=E[P];if(_===R.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(_===R.MODULE){a.unresolvedDependenciesCount--;continue}if(_===R.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[_.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(_.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(_.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var A=this._findCyclePath(_.id,a.id,0)||[];A.reverse(),A.push(_.id),console.warn(A.map(function(u){return m._moduleIdProvider.getStrModuleId(u)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[_.id]=this._inverseDependencies2[_.id]||[],this._inverseDependencies2[_.id].push(a.id),_ instanceof o){var p=this._modules2[_.pluginId];if(p&&p.isComplete()){this._loadPluginDependency(p.exports,_);continue}var N=this._inversePluginDependencies2.get(_.pluginId);N||(N=[],this._inversePluginDependencies2.set(_.pluginId,N)),N.push(_),this._loadModule(_.pluginId);continue}this._loadModule(_.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},h.prototype._onModuleComplete=function(a){var m=this,E=this.getRecorder();if(!a.isComplete()){var P=a.dependencies,C=[];if(P)for(var _=0,e=P.length;_<e;_++){var A=P[_];if(A===R.EXPORTS){C[_]=a.exports;continue}if(A===R.MODULE){C[_]={id:a.strId,config:function(){return m._config.getConfigForModule(a.strId)}};continue}if(A===R.REQUIRE){C[_]=this._createRequire(a.moduleIdResolver);continue}var p=this._modules2[A.id];if(p){C[_]=p.exports;continue}C[_]=null}var N=function(c){return(m._inverseDependencies2[c]||[]).map(function(w){return m._moduleIdProvider.getStrModuleId(w)})};a.complete(E,this._config,C,N);var u=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,u)for(var _=0,e=u.length;_<e;_++){var s=u[_],i=this._modules2[s];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var l=this._inversePluginDependencies2.get(a.id);if(l){this._inversePluginDependencies2.delete(a.id);for(var _=0,e=l.length;_<e;_++)this._loadPluginDependency(a.exports,l[_])}}},h}();B.ModuleManager=y})(le||(le={}));var X,le;(function(B){var n=new B.Environment,M=null,t=function(h,a,m){typeof h!="string"&&(m=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),a||(a=["require","exports","module"]),h?M.defineModule(h,a,m,null,null):M.enqueueDefineAnonymousModule(a,m)};t.amd={jQuery:!0};var R=function(h,a){a===void 0&&(a=!1),M.configure(h,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){R(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=R,o.getConfig=function(){return M.getConfig().getOptionsLiteral()},o.reset=function(){M=M.reset()},o.getBuildInfo=function(){return M.getBuildInfo()},o.getStats=function(){return M.getLoaderEvents()},o.define=t;function y(){if(typeof B.global.require!="undefined"||typeof require!="undefined"){var h=B.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){var a=B.ensureRecordedNodeRequire(M.getRecorder(),h);B.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=o,require=o):(n.isElectronRenderer||(B.global.define=t),B.global.require=o)}B.init=y,(typeof B.global.define!="function"||!B.global.define.amd)&&(M=new B.ModuleManager(n,B.createScriptLoader(n),t,o,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require!="undefined"&&typeof B.global.require!="function"&&o.config(B.global.require),X=function(){return t.apply(null,arguments)},X.amd=t.amd,typeof doNotInitLoader=="undefined"&&y())})(le||(le={})),X(J[20],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let M=typeof document!="undefined"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function R(e,A){let p;return A.length===0?p=e:p=e.replace(/\{(\d+)\}/g,(N,u)=>{const s=u[0],i=A[s];let l=N;return typeof i=="string"?l=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(l=String(i)),l}),M&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function o(e,A){let p=e[A];return p||(p=e["*"],p)?p:null}function y(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function h(e,A,p){const N=y(e)+y(A)+"vscode/"+y(p),u=await fetch(N);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function a(e){return function(A,p){const N=Array.prototype.slice.call(arguments,2);return R(e[A],N)}}function m(e,A,...p){return R(A,p)}n.localize=m;function E(e){}n.getConfiguredDefaultLocale=E;function P(e){M=e}n.setPseudoTranslation=P;function C(e,A){return{localize:a(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(p=>{})}}n.create=C;function _(e,A,p,N){const u=N["vs/nls"]??{};if(!e||e.length===0)return p({localize:m,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const s=u.availableLanguages?o(u.availableLanguages,e):null,i=s===null||s===t;let l=".nls";i||(l=l+"."+s);const c=w=>{Array.isArray(w)?w.localize=a(w):w.localize=a(w[e]),w.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],p(w)};typeof u.loadBundle=="function"?u.loadBundle(e,s,(w,b)=>{w?A([e+".nls"],c):c(b)}):u.translationServiceUrl&&!i?(async()=>{try{const w=await h(u.translationServiceUrl,s,e);return c(w)}catch(w){if(!s.includes("-"))return console.error(w),A([e+".nls"],c);try{const b=s.split("-")[0],d=await h(u.translationServiceUrl,b,e);return u.availableLanguages??(u.availableLanguages={}),u.availableLanguages["*"]=b,c(d)}catch(b){return console.error(b),A([e+".nls"],c)}}})():A([e+l],c,w=>{if(l===".nls"){console.error("Failed trying to load default language strings",w);return}console.error(`Failed to load message bundle for language ${s}. Falling back to the default language:`,w),A([e+".nls"],c)})}n.load=_}),function(){const B=self.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../",M=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:m=>m,createScript:(m,...E)=>{const P=E.slice(0,-1).join(","),C=E.pop().toString();return`(function anonymous(${P}) {
${C}
})`}}):void 0;function t(){try{return(M?self.eval(M.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function R(){return new Promise((m,E)=>{if(typeof self.define=="function"&&self.define.amd)return m();const P=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(P)&&P.substring(0,self.origin.length)!==self.origin)&&t()){fetch(P).then(_=>{if(_.status!==200)throw new Error(_.statusText);return _.text()}).then(_=>{_=`${_}
//# sourceURL=${P}`,(M?self.eval(M.createScript("",_)):new Function(_)).call(self),m()}).then(void 0,E);return}M?importScripts(M.createScriptURL(P)):importScripts(P),m()})}function o(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function y(m){R().then(()=>{o(),require([m],function(E){setTimeout(function(){const P=E.create((C,_)=>{self.postMessage(C,_)},null);for(self.onmessage=C=>P.onmessage(C.data,C.ports);a.length>0;)self.onmessage(a.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&o();let h=!0;const a=[];self.onmessage=m=>{if(!h){a.push(m);return}h=!1,y(m.data)}}(),X(J[21],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function M(y){return y?y.replace(/\$\((.*?)\)/g,(h,a)=>` ${a} `).trim():""}n.getCodiconAriaLabel=M;class t{constructor(h,a,m){this.id=h,this.definition=a,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\f101"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(y,h){const a=["codicon","codicon-"+y];return h&&a.push("codicon-modifier-"+h),a}n.getClassNamesArray=R;var o;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function a(P){if(P instanceof t)return["codicon","codicon-"+P.id];const C=h.exec(P.id);if(!C)return a(t.error);const[,_,e]=C,A=["codicon","codicon-"+_];return e&&A.push("codicon-modifier-"+e.substr(1)),A}y.asClassNameArray=a;function m(P){return a(P).join(" ")}y.asClassName=m;function E(P){return"."+a(P).join(".")}y.asCSSSelector=E})(o=n.CSSIcon||(n.CSSIcon={}))}),X(J[22],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class M{constructor(R,o,y,h){this.originalStart=R,this.originalLength=o,this.modifiedStart=y,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=M}),X(J[9],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?s.isErrorNoTelemetry(c)?new s(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(w=>{w(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}n.ErrorHandler=M,n.errorHandler=new M;function t(l){n.errorHandler.setUnexpectedErrorHandler(l)}n.setUnexpectedErrorHandler=t;function R(l){a(l)||n.errorHandler.onUnexpectedError(l)}n.onUnexpectedError=R;function o(l){a(l)||n.errorHandler.onUnexpectedExternalError(l)}n.onUnexpectedExternalError=o;function y(l){if(l instanceof Error){const{name:c,message:w}=l,b=l.stacktrace||l.stack;return{$isError:!0,name:c,message:w,stack:b,noTelemetry:s.isErrorNoTelemetry(l)}}return l}n.transformErrorForSerialization=y;const h="Canceled";function a(l){return l instanceof m?!0:l instanceof Error&&l.name===h&&l.message===h}n.isCancellationError=a;class m extends Error{constructor(){super(h);this.name=this.message}}n.CancellationError=m;function E(){const l=new Error(h);return l.name=l.message,l}n.canceled=E;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}n.illegalArgument=P;function C(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}n.illegalState=C;function _(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=_;function e(l){const c=new Error(`${l} has been disposed`);return c.name="DISPOSED",c}n.disposed=e;function A(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}n.getErrorMessage=A;class p extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}n.NotImplementedError=p;class N extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}n.NotSupportedError=N;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=u;class s extends Error{constructor(c){super(c);this.name="ErrorNoTelemetry"}static fromError(c){if(c instanceof s)return c;const w=new s;return w.message=c.message,w.stack=c.stack,w}static isErrorNoTelemetry(c){return c.name==="ErrorNoTelemetry"}}n.ErrorNoTelemetry=s;class i extends Error{constructor(c){super(c||"An unexpected bug occurred.");Object.setPrototypeOf(this,i.prototype);debugger}}n.BugIndicatingError=i}),X(J[23],K([0,1,9]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function t(S,I=0){return S[S.length-(1+I)]}n.tail=t;function R(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}n.tail2=R;function o(S,I,U=(q,H)=>q===H){if(S===I)return!0;if(!S||!I||S.length!==I.length)return!1;for(let q=0,H=S.length;q<H;q++)if(!U(S[q],I[q]))return!1;return!0}n.equals=o;function y(S,I,U){return h(S.length,q=>U(S[q],I))}n.binarySearch=y;function h(S,I){let U=0,q=S-1;for(;U<=q;){const H=(U+q)/2|0,ie=I(H);if(ie<0)U=H+1;else if(ie>0)q=H-1;else return H}return-(U+1)}n.binarySearch2=h;function a(S,I){let U=0,q=S.length;if(q===0)return 0;for(;U<q;){const H=Math.floor((U+q)/2);I(S[H])?q=H:U=H+1}return U}n.findFirstInSorted=a;function m(S,I,U){if(S=S|0,S>=I.length)throw new TypeError("invalid index");const q=I[Math.floor(I.length*Math.random())],H=[],ie=[],re=[];for(const ue of I){const ce=U(ue,q);ce<0?H.push(ue):ce>0?ie.push(ue):re.push(ue)}return S<H.length?m(S,H,U):S<H.length+re.length?re[0]:m(S-(H.length+re.length),ie,U)}n.quickSelect=m;function E(S,I){const U=[];let q;for(const H of S.slice(0).sort(I))!q||I(q[0],H)!==0?(q=[H],U.push(q)):q.push(H);return U}n.groupBy=E;function P(S,I,U){const q=[];function H(ue,ce,ge){if(ce===0&&ge.length===0)return;const me=q[q.length-1];me&&me.start+me.deleteCount===ue?(me.deleteCount+=ce,me.toInsert.push(...ge)):q.push({start:ue,deleteCount:ce,toInsert:ge})}let ie=0,re=0;for(;;){if(ie===S.length){H(ie,0,I.slice(re));break}if(re===I.length){H(ie,S.length-ie,[]);break}const ue=S[ie],ce=I[re],ge=U(ue,ce);ge===0?(ie+=1,re+=1):ge<0?(H(ie,1,[]),ie+=1):ge>0&&(H(ie,0,[ce]),re+=1)}return q}n.sortedDiff=P;function C(S,I,U){const q=P(S,I,U),H=[],ie=[];for(const re of q)H.push(...S.slice(re.start,re.start+re.deleteCount)),ie.push(...re.toInsert);return{removed:H,added:ie}}n.delta=C;function _(S,I,U){if(U===0)return[];const q=S.slice(0,U).sort(I);return A(S,I,q,U,S.length),q}n.top=_;function e(S,I,U,q,H){return U===0?Promise.resolve([]):new Promise((ie,re)=>{(async()=>{const ue=S.length,ce=S.slice(0,U).sort(I);for(let ge=U,me=Math.min(U+q,ue);ge<ue;ge=me,me=Math.min(me+q,ue)){if(ge>U&&await new Promise(Re=>setTimeout(Re)),H&&H.isCancellationRequested)throw new M.CancellationError;A(S,I,ce,ge,me)}return ce})().then(ie,re)})}n.topAsync=e;function A(S,I,U,q,H){for(const ie=U.length;q<H;q++){const re=S[q];if(I(re,U[ie-1])<0){U.pop();const ue=a(U,ce=>I(re,ce)<0);U.splice(ue,0,re)}}}function p(S){return S.filter(I=>!!I)}n.coalesce=p;function N(S){let I=0;for(let U=0;U<S.length;U++)S[U]&&(S[I]=S[U],I+=1);S.length=I}n.coalesceInPlace=N;function u(S,I,U){S.splice(U,0,S.splice(I,1)[0])}n.move=u;function s(S){return!Array.isArray(S)||S.length===0}n.isFalsyOrEmpty=s;function i(S){return Array.isArray(S)&&S.length>0}n.isNonEmptyArray=i;function l(S,I=U=>U){const U=new Set;return S.filter(q=>{const H=I(q);return U.has(H)?!1:(U.add(H),!0)})}n.distinct=l;function c(S){const I=new Set;return U=>{const q=S(U);return I.has(q)?!1:(I.add(q),!0)}}n.uniqueFilter=c;function w(S,I){const U=b(S,I);if(U!==-1)return S[U]}n.findLast=w;function b(S,I){for(let U=S.length-1;U>=0;U--){const q=S[U];if(I(q))return U}return-1}n.lastIndex=b;function d(S,I){return S.length>0?S[0]:I}n.firstOrDefault=d;function v(S,I){return S.length>0?S[S.length-1]:I}n.lastOrDefault=v;function L(S,I,U=(q,H)=>q===H){let q=0;for(let H=0,ie=Math.min(S.length,I.length);H<ie&&U(S[H],I[H]);H++)q++;return q}n.commonPrefixLength=L;function g(S){return[].concat(...S)}n.flatten=g;function f(S,I){let U=typeof I=="number"?S:0;typeof I=="number"?U=S:(U=0,I=S);const q=[];if(U<=I)for(let H=U;H<I;H++)q.push(H);else for(let H=U;H>I;H--)q.push(H);return q}n.range=f;function D(S,I,U){return S.reduce((q,H)=>(q[I(H)]=U?U(H):H,q),Object.create(null))}n.index=D;function T(S,I){return S.push(I),()=>O(S,I)}n.insert=T;function O(S,I){const U=S.indexOf(I);if(U>-1)return S.splice(U,1),I}n.remove=O;function W(S,I,U){const q=S.slice(0,I),H=S.slice(I);return q.concat(U,H)}n.arrayInsert=W;function $(S,I){let U;if(typeof I=="number"){let q=I;U=()=>{const H=Math.sin(q++)*179426549;return H-Math.floor(H)}}else U=Math.random;for(let q=S.length-1;q>0;q-=1){const H=Math.floor(U()*(q+1)),ie=S[q];S[q]=S[H],S[H]=ie}}n.shuffle=$;function j(S,I){const U=S.indexOf(I);U>-1&&(S.splice(U,1),S.unshift(I))}n.pushToStart=j;function ne(S,I){const U=S.indexOf(I);U>-1&&(S.splice(U,1),S.push(I))}n.pushToEnd=ne;function ae(S,I){for(const U of I)S.push(U)}n.pushMany=ae;function te(S,I){return Array.isArray(S)?S.map(I):I(S)}n.mapArrayOrNot=te;function r(S){return Array.isArray(S)?S:[S]}n.asArray=r;function he(S){return S[Math.floor(Math.random()*S.length)]}n.getRandomElement=he;function de(S,I){for(const U of S){const q=I(U);if(q!==void 0)return q}}n.mapFind=de;function Ne(S,I,U){const q=pe(S,I),H=S.length,ie=U.length;S.length=H+ie;for(let re=H-1;re>=q;re--)S[re+ie]=S[re];for(let re=0;re<ie;re++)S[re+q]=U[re]}n.insertInto=Ne;function De(S,I,U,q){const H=pe(S,I),ie=S.splice(H,U);return Ne(S,H,q),ie}n.splice=De;function pe(S,I){return I<0?Math.max(I+S.length,0):Math.min(I,S.length)}var Le;(function(S){function I(H){return H<0}S.isLessThan=I;function U(H){return H>0}S.isGreaterThan=U;function q(H){return H===0}S.isNeitherLessOrGreaterThan=q,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(Le=n.CompareResult||(n.CompareResult={}));function Ee(S,I){return(U,q)=>I(S(U),S(q))}n.compareBy=Ee;function ye(...S){return(I,U)=>{for(const q of S){const H=q(I,U);if(!Le.isNeitherLessOrGreaterThan(H))return H}return Le.neitherLessOrGreaterThan}}n.tieBreakComparators=ye;const x=(S,I)=>S-I;n.numberComparator=x;function Q(S,I){if(S.length===0)return;let U=S[0];for(let q=1;q<S.length;q++){const H=S[q];I(H,U)>0&&(U=H)}return U}n.findMaxBy=Q;function Z(S,I){if(S.length===0)return;let U=S[0];for(let q=1;q<S.length;q++){const H=S[q];I(H,U)>=0&&(U=H)}return U}n.findLastMaxBy=Z;function Y(S,I){return Q(S,(U,q)=>-I(U,q))}n.findMinBy=Y;class ee{constructor(I){this.items=I,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(I){let U=this.firstIdx;for(;U<this.items.length&&I(this.items[U]);)U++;const q=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,q}takeFromEndWhile(I){let U=this.lastIdx;for(;U>=0&&I(this.items[U]);)U--;const q=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,q}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const I=this.items[this.firstIdx];return this.firstIdx++,I}removeLast(){const I=this.items[this.lastIdx];return this.lastIdx--,I}takeCount(I){const U=this.items.slice(this.firstIdx,this.firstIdx+I);return this.firstIdx+=I,U}}n.ArrayQueue=ee}),X(J[11],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function M(t){const R=this;let o=!1,y;return function(){return o||(o=!0,y=t.apply(R,arguments)),y}}n.once=M}),X(J[12],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var M;(function(t){function R(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}t.is=R;const o=Object.freeze([]);function y(){return o}t.empty=y;function*h(w){yield w}t.single=h;function a(w){return w||o}t.from=a;function m(w){return!w||w[Symbol.iterator]().next().done===!0}t.isEmpty=m;function E(w){return w[Symbol.iterator]().next().value}t.first=E;function P(w,b){for(const d of w)if(b(d))return!0;return!1}t.some=P;function C(w,b){for(const d of w)if(b(d))return d}t.find=C;function*_(w,b){for(const d of w)b(d)&&(yield d)}t.filter=_;function*e(w,b){let d=0;for(const v of w)yield b(v,d++)}t.map=e;function*A(...w){for(const b of w)for(const d of b)yield d}t.concat=A;function*p(w){for(const b of w)for(const d of b)yield d}t.concatNested=p;function N(w,b,d){let v=d;for(const L of w)v=b(v,L);return v}t.reduce=N;function u(w,b){let d=0;for(const v of w)b(v,d++)}t.forEach=u;function*s(w,b,d=w.length){for(b<0&&(b+=w.length),d<0?d+=w.length:d>w.length&&(d=w.length);b<d;b++)yield w[b]}t.slice=s;function i(w,b=Number.POSITIVE_INFINITY){const d=[];if(b===0)return[d,w];const v=w[Symbol.iterator]();for(let L=0;L<b;L++){const g=v.next();if(g.done)return[d,t.empty()];d.push(g.value)}return[d,{[Symbol.iterator](){return v}}]}t.consume=i;function l(w){return i(w)[0]}t.collect=l;function c(w,b,d=(v,L)=>v===L){const v=w[Symbol.iterator](),L=b[Symbol.iterator]();for(;;){const g=v.next(),f=L.next();if(g.done!==f.done)return!1;if(g.done)return!0;if(!d(g.value,f.value))return!1}}t.equals=c})(M=n.Iterable||(n.Iterable={}))}),X(J[24],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var M;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(M=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,p){this._keyCodeToStr[A]=p,this._strToKeyCode[p.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const o=new R,y=new R,h=new R;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],m=Object.create(null),E=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>E[e]||0,toEnum:e=>m[e]||0,toString:e=>a[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",A=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],p=[],N=[];for(const u of A){const[s,i,l,c,w,b,d,v,L,g]=u;if(N[l]||(N[l]=!0,a[l]=c,m[c]=l,E[c.toLowerCase()]=l,i&&(n.IMMUTABLE_CODE_TO_KEY_CODE[l]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[w]=l))),!p[w]){if(p[w]=!0,!b)throw new Error(`String representation missing for key code ${w} around scan code ${c}`);o.define(w,b),y.define(w,L||b),h.define(w,g||L||b)}d&&(n.EVENT_KEY_CODE_MAP[d]=w),v&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[v]=w)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function A(l){return o.keyCodeToStr(l)}e.toString=A;function p(l){return o.strToKeyCode(l)}e.fromString=p;function N(l){return y.keyCodeToStr(l)}e.toUserSettingsUS=N;function u(l){return h.keyCodeToStr(l)}e.toUserSettingsGeneral=u;function s(l){return y.strToKeyCode(l)||h.strToKeyCode(l)}e.fromUserSettings=s;function i(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(l)}e.toElectronAccelerator=i})(P=n.KeyCodeUtils||(n.KeyCodeUtils={}));var C;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(C=n.KeyMod||(n.KeyMod={}));function _(e,A){const p=(A&65535)<<16>>>0;return(e|p)>>>0}n.KeyChord=_}),X(J[25],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class M{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new M(()=>R(this.getValue()))}}n.Lazy=M}),X(J[6],K([0,1,11,12]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const R=!1;let o=null;function y(v){o=v}if(n.setDisposableTracker=y,R){const v="__is_disposable_tracked__";y(new class{trackDisposable(L){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[v]||console.log(g)},3e3)}setParent(L,g){if(L&&L!==u.None)try{L[v]=!0}catch{}}markAsDisposed(L){if(L&&L!==u.None)try{L[v]=!0}catch{}}markAsSingleton(L){}})}function h(v){return o?.trackDisposable(v),v}function a(v){o?.markAsDisposed(v)}function m(v,L){o?.setParent(v,L)}function E(v,L){if(!!o)for(const g of v)o.setParent(g,L)}function P(v){return o?.markAsSingleton(v),v}n.markAsSingleton=P;class C extends Error{constructor(L){super(`Encountered errors while disposing of store. Errors: [${L.join(", ")}]`);this.errors=L}}n.MultiDisposeError=C;function _(v){return typeof v.dispose=="function"&&v.dispose.length===0}n.isDisposable=_;function e(v){if(t.Iterable.is(v)){const L=[];for(const g of v)if(g)try{g.dispose()}catch(f){L.push(f)}if(L.length===1)throw L[0];if(L.length>1)throw new C(L);return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}n.dispose=e;function A(...v){const L=p(()=>e(v));return E(v,L),L}n.combinedDisposable=A;function p(v){const L=h({dispose:(0,M.once)(()=>{a(L),v()})});return L}n.toDisposable=p;class N{constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return m(L,this),this._isDisposed?N.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(L),L}}n.DisposableStore=N,N.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new N,h(this),m(this._store,this)}dispose(){a(this),this._store.dispose()}_register(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(L)}}n.Disposable=u,u.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(L){this._isDisposed||L===this._value||(this._value?.dispose(),L&&m(L,this),this._value=L)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,a(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const L=this._value;return this._value=void 0,L&&m(L,null),L}}n.MutableDisposable=s;class i{constructor(L){this._disposable=L,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=i;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(L){let g=L;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,a(this))},this}}n.SafeDisposable=l;class c{constructor(){this.references=new Map}acquire(L,...g){let f=this.references.get(L);f||(f={counter:0,object:this.createReferencedObject(L,...g)},this.references.set(L,f));const{object:D}=f,T=(0,M.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(L,f.object),this.references.delete(L))});return f.counter++,{object:D,dispose:T}}}n.ReferenceCollection=c;class w{constructor(L){this.referenceCollection=L}async acquire(L,...g){const f=this.referenceCollection.acquire(L,...g);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(D){throw f.dispose(),D}}}n.AsyncReferenceCollection=w;class b{constructor(L){this.object=L}dispose(){}}n.ImmortalReference=b;function d(v){const L=new N;try{v(L)}finally{L.dispose()}}n.disposeOnReturn=d}),X(J[13],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class M{constructor(o){this.element=o,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class t{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let o=this._first;for(;o!==M.Undefined;){const y=o.next;o.prev=M.Undefined,o.next=M.Undefined,o=y}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,y){const h=new M(o);if(this._first===M.Undefined)this._first=h,this._last=h;else if(y){const m=this._last;this._last=h,h.prev=m,m.next=h}else{const m=this._first;this._first=h,h.next=m,m.prev=h}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(h))}}shift(){if(this._first!==M.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==M.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==M.Undefined&&o.next!==M.Undefined){const y=o.prev;y.next=o.next,o.next.prev=y}else o.prev===M.Undefined&&o.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):o.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):o.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==M.Undefined;)yield o.element,o=o.next}}n.LinkedList=t}),X(J[7],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function M(g){return Array.isArray(g)}n.isArray=M;function t(g){return typeof g=="string"}n.isString=t;function R(g){return Array.isArray(g)&&g.every(f=>t(f))}n.isStringArray=R;function o(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}n.isObject=o;function y(g){return typeof g=="object"&&(g instanceof Uint8Array||g instanceof Uint16Array||g instanceof Uint32Array||g instanceof Float32Array||g instanceof Float64Array||g instanceof Int8Array||g instanceof Int16Array||g instanceof Int32Array||g instanceof BigInt64Array||g instanceof BigUint64Array||g instanceof Uint8ClampedArray)}n.isTypedArray=y;function h(g){return typeof g=="number"&&!isNaN(g)}n.isNumber=h;function a(g){return!!g&&typeof g[Symbol.iterator]=="function"}n.isIterable=a;function m(g){return g===!0||g===!1}n.isBoolean=m;function E(g){return typeof g=="undefined"}n.isUndefined=E;function P(g){return!C(g)}n.isDefined=P;function C(g){return E(g)||g===null}n.isUndefinedOrNull=C;function _(g,f){if(!g)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}n.assertType=_;function e(g){if(C(g))throw new Error("Assertion Failed: argument is undefined or null");return g}n.assertIsDefined=e;function A(...g){const f=[];for(let D=0;D<g.length;D++){const T=g[D];if(C(T))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);f.push(T)}return f}n.assertAllDefined=A;const p=Object.prototype.hasOwnProperty;function N(g){if(!o(g))return!1;for(const f in g)if(p.call(g,f))return!1;return!0}n.isEmptyObject=N;function u(g){return typeof g=="function"}n.isFunction=u;function s(...g){return g.length>0&&g.every(u)}n.areFunctions=s;function i(g,f){const D=Math.min(g.length,f.length);for(let T=0;T<D;T++)l(g[T],f[T])}n.validateConstraints=i;function l(g,f){if(t(f)){if(typeof g!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(u(f)){try{if(g instanceof f)return}catch{}if(!C(g)&&g.constructor===f||f.length===1&&f.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=l;function c(g){let f=[],D=Object.getPrototypeOf(g);for(;Object.prototype!==D;)f=f.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return f}n.getAllPropertyNames=c;function w(g){const f=[];for(const D of c(g))typeof g[D]=="function"&&f.push(D);return f}n.getAllMethodNames=w;function b(g,f){const D=O=>function(){const W=Array.prototype.slice.call(arguments,0);return f(O,W)},T={};for(const O of g)T[O]=D(O);return T}n.createProxyObject=b;function d(g){return g===null?void 0:g}n.withNullAsUndefined=d;function v(g){return typeof g=="undefined"?null:g}n.withUndefinedAsNull=v;function L(g,f="Unreachable"){throw new Error(f)}n.assertNever=L}),X(J[26],K([0,1,7]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const A=Array.isArray(e)?[]:{};return Object.keys(e).forEach(p=>{e[p]&&typeof e[p]=="object"?A[p]=t(e[p]):A[p]=e[p]}),A}n.deepClone=t;function R(e){if(!e||typeof e!="object")return e;const A=[e];for(;A.length>0;){const p=A.shift();Object.freeze(p);for(const N in p)if(o.call(p,N)){const u=p[N];typeof u=="object"&&!Object.isFrozen(u)&&!(0,M.isTypedArray)(u)&&A.push(u)}}return e}n.deepFreeze=R;const o=Object.prototype.hasOwnProperty;function y(e,A){return h(e,A,new Set)}n.cloneAndChange=y;function h(e,A,p){if((0,M.isUndefinedOrNull)(e))return e;const N=A(e);if(typeof N!="undefined")return N;if((0,M.isArray)(e)){const u=[];for(const s of e)u.push(h(s,A,p));return u}if((0,M.isObject)(e)){if(p.has(e))throw new Error("Cannot clone recursive data-structure");p.add(e);const u={};for(const s in e)o.call(e,s)&&(u[s]=h(e[s],A,p));return p.delete(e),u}return e}function a(e,A,p=!0){return(0,M.isObject)(e)?((0,M.isObject)(A)&&Object.keys(A).forEach(N=>{N in e?p&&((0,M.isObject)(e[N])&&(0,M.isObject)(A[N])?a(e[N],A[N],p):e[N]=A[N]):e[N]=A[N]}),e):A}n.mixin=a;function m(e,A){if(e===A)return!0;if(e==null||A===null||A===void 0||typeof e!=typeof A||typeof e!="object"||Array.isArray(e)!==Array.isArray(A))return!1;let p,N;if(Array.isArray(e)){if(e.length!==A.length)return!1;for(p=0;p<e.length;p++)if(!m(e[p],A[p]))return!1}else{const u=[];for(N in e)u.push(N);u.sort();const s=[];for(N in A)s.push(N);if(s.sort(),!m(u,s))return!1;for(p=0;p<u.length;p++)if(!m(e[u[p]],A[u[p]]))return!1}return!0}n.equals=m;function E(e){const A=new Set;return JSON.stringify(e,(p,N)=>{if((0,M.isObject)(N)||Array.isArray(N)){if(A.has(N))return"[Circular]";A.add(N)}return N})}n.safeStringify=E;function P(e,A){const p=Object.create(null);return!e||!A||Object.keys(A).forEach(u=>{const s=e[u],i=A[u];m(s,i)||(p[u]=i)}),p}n.distinct=P;function C(e,A){const p=A.toLowerCase(),N=Object.keys(e).find(u=>u.toLowerCase()===p);return N?e[N]:e[A]}n.getCaseInsensitive=C;function _(e,A){const p=Object.create(null);for(const[N,u]of Object.entries(e))A(N,u)&&(p[N]=u);return p}n.filter=_}),X(J[14],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var M;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=n.Constants||(n.Constants={}));function t(o){return o<0?0:o>255?255:o|0}n.toUint8=t;function R(o){return o<0?0:o>4294967295?4294967295:o|0}n.toUint32=R}),X(J[15],K([0,1,14]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(h){const a=(0,M.toUint8)(h);this._defaultValue=a,this._asciiMap=t._createAsciiMap(a),this._map=new Map}static _createAsciiMap(h){const a=new Uint8Array(256);for(let m=0;m<256;m++)a[m]=h;return a}set(h,a){const m=(0,M.toUint8)(a);h>=0&&h<256?this._asciiMap[h]=m:this._map.set(h,m)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}}n.CharacterClassifier=t;var R;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(R||(R={}));class o{constructor(){this._actual=new t(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}}n.CharacterSet=o}),X(J[2],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class M{constructor(R,o){this.lineNumber=R,this.column=o}with(R=this.lineNumber,o=this.column){return R===this.lineNumber&&o===this.column?this:new M(R,o)}delta(R=0,o=0){return this.with(this.lineNumber+R,this.column+o)}equals(R){return M.equals(this,R)}static equals(R,o){return!R&&!o?!0:!!R&&!!o&&R.lineNumber===o.lineNumber&&R.column===o.column}isBefore(R){return M.isBefore(this,R)}static isBefore(R,o){return R.lineNumber<o.lineNumber?!0:o.lineNumber<R.lineNumber?!1:R.column<o.column}isBeforeOrEqual(R){return M.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,o){return R.lineNumber<o.lineNumber?!0:o.lineNumber<R.lineNumber?!1:R.column<=o.column}static compare(R,o){const y=R.lineNumber|0,h=o.lineNumber|0;if(y===h){const a=R.column|0,m=o.column|0;return a-m}return y-h}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new M(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}n.Position=M}),X(J[3],K([0,1,2]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(o,y,h,a){o>h||o===h&&y>a?(this.startLineNumber=h,this.startColumn=a,this.endLineNumber=o,this.endColumn=y):(this.startLineNumber=o,this.startColumn=y,this.endLineNumber=h,this.endColumn=a)}isEmpty(){return t.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return t.containsPosition(this,o)}static containsPosition(o,y){return!(y.lineNumber<o.startLineNumber||y.lineNumber>o.endLineNumber||y.lineNumber===o.startLineNumber&&y.column<o.startColumn||y.lineNumber===o.endLineNumber&&y.column>o.endColumn)}static strictContainsPosition(o,y){return!(y.lineNumber<o.startLineNumber||y.lineNumber>o.endLineNumber||y.lineNumber===o.startLineNumber&&y.column<=o.startColumn||y.lineNumber===o.endLineNumber&&y.column>=o.endColumn)}containsRange(o){return t.containsRange(this,o)}static containsRange(o,y){return!(y.startLineNumber<o.startLineNumber||y.endLineNumber<o.startLineNumber||y.startLineNumber>o.endLineNumber||y.endLineNumber>o.endLineNumber||y.startLineNumber===o.startLineNumber&&y.startColumn<o.startColumn||y.endLineNumber===o.endLineNumber&&y.endColumn>o.endColumn)}strictContainsRange(o){return t.strictContainsRange(this,o)}static strictContainsRange(o,y){return!(y.startLineNumber<o.startLineNumber||y.endLineNumber<o.startLineNumber||y.startLineNumber>o.endLineNumber||y.endLineNumber>o.endLineNumber||y.startLineNumber===o.startLineNumber&&y.startColumn<=o.startColumn||y.endLineNumber===o.endLineNumber&&y.endColumn>=o.endColumn)}plusRange(o){return t.plusRange(this,o)}static plusRange(o,y){let h,a,m,E;return y.startLineNumber<o.startLineNumber?(h=y.startLineNumber,a=y.startColumn):y.startLineNumber===o.startLineNumber?(h=y.startLineNumber,a=Math.min(y.startColumn,o.startColumn)):(h=o.startLineNumber,a=o.startColumn),y.endLineNumber>o.endLineNumber?(m=y.endLineNumber,E=y.endColumn):y.endLineNumber===o.endLineNumber?(m=y.endLineNumber,E=Math.max(y.endColumn,o.endColumn)):(m=o.endLineNumber,E=o.endColumn),new t(h,a,m,E)}intersectRanges(o){return t.intersectRanges(this,o)}static intersectRanges(o,y){let h=o.startLineNumber,a=o.startColumn,m=o.endLineNumber,E=o.endColumn;const P=y.startLineNumber,C=y.startColumn,_=y.endLineNumber,e=y.endColumn;return h<P?(h=P,a=C):h===P&&(a=Math.max(a,C)),m>_?(m=_,E=e):m===_&&(E=Math.min(E,e)),h>m||h===m&&a>E?null:new t(h,a,m,E)}equalsRange(o){return t.equalsRange(this,o)}static equalsRange(o,y){return!!o&&!!y&&o.startLineNumber===y.startLineNumber&&o.startColumn===y.startColumn&&o.endLineNumber===y.endLineNumber&&o.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(o){return new M.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(o){return new M.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,y){return new t(this.startLineNumber,this.startColumn,o,y)}setStartPosition(o,y){return new t(o,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(o){return new t(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}static fromPositions(o,y=o){return new t(o.lineNumber,o.column,y.lineNumber,y.column)}static lift(o){return o?new t(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,y){return!(o.endLineNumber<y.startLineNumber||o.endLineNumber===y.startLineNumber&&o.endColumn<y.startColumn||y.endLineNumber<o.startLineNumber||y.endLineNumber===o.startLineNumber&&y.endColumn<o.startColumn)}static areIntersecting(o,y){return!(o.endLineNumber<y.startLineNumber||o.endLineNumber===y.startLineNumber&&o.endColumn<=y.startColumn||y.endLineNumber<o.startLineNumber||y.endLineNumber===o.startLineNumber&&y.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,y){if(o&&y){const m=o.startLineNumber|0,E=y.startLineNumber|0;if(m===E){const P=o.startColumn|0,C=y.startColumn|0;if(P===C){const _=o.endLineNumber|0,e=y.endLineNumber|0;if(_===e){const A=o.endColumn|0,p=y.endColumn|0;return A-p}return _-e}return P-C}return m-E}return(o?1:0)-(y?1:0)}static compareRangesUsingEnds(o,y){return o.endLineNumber===y.endLineNumber?o.endColumn===y.endColumn?o.startLineNumber===y.startLineNumber?o.startColumn-y.startColumn:o.startLineNumber-y.startLineNumber:o.endColumn-y.endColumn:o.endLineNumber-y.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}n.Range=t}),X(J[27],K([0,1,2,3]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var R;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(R=n.SelectionDirection||(n.SelectionDirection={}));class o extends t.Range{constructor(h,a,m,E){super(h,a,m,E);this.selectionStartLineNumber=h,this.selectionStartColumn=a,this.positionLineNumber=m,this.positionColumn=E}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return o.selectionsEqual(this,h)}static selectionsEqual(h,a){return h.selectionStartLineNumber===a.selectionStartLineNumber&&h.selectionStartColumn===a.selectionStartColumn&&h.positionLineNumber===a.positionLineNumber&&h.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,h,a):new o(h,a,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,a){return this.getDirection()===0?new o(h,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,h,a)}static fromPositions(h,a=h){return new o(h.lineNumber,h.column,a.lineNumber,a.column)}static fromRange(h,a){return a===0?new o(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new o(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new o(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,a){if(h&&!a||!h&&a)return!1;if(!h&&!a)return!0;if(h.length!==a.length)return!1;for(let m=0,E=h.length;m<E;m++)if(!this.selectionsEqual(h[m],a[m]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,a,m,E,P){return P===0?new o(h,a,m,E):new o(m,E,h,a)}}n.Selection=o}),X(J[28],K([0,1,15]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class R extends M.CharacterClassifier{constructor(h){super(0);for(let a=0,m=h.length;a<m;a++)this.set(h.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=R;function o(y){const h={};return a=>(h.hasOwnProperty(a)||(h[a]=y(a)),h[a])}n.getMapForWordSeparators=o(y=>new R(y))}),X(J[16],K([0,1,12,6,13]),function(B,n,M,t,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(P=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const _ of n.USUAL_WORD_SEPARATORS)P.indexOf(_)>=0||(C+="\\"+_);return C+="\\s]+)",new RegExp(C,"g")}n.DEFAULT_WORD_REGEXP=o();function y(P){let C=n.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)C=P;else{let _="g";P.ignoreCase&&(_+="i"),P.multiline&&(_+="m"),P.unicode&&(_+="u"),C=new RegExp(P.source,_)}return C.lastIndex=0,C}n.ensureValidWordDefinition=y;const h=new R.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(P){const C=h.unshift(P);return(0,t.toDisposable)(C)}n.setDefaultGetWordAtTextConfig=a;function m(P,C,_,e,A){if(A||(A=M.Iterable.first(h)),_.length>A.maxLen){let i=P-A.maxLen/2;return i<0?i=0:e+=i,_=_.substring(i,P+A.maxLen/2),m(P,C,_,e,A)}const p=Date.now(),N=P-1-e;let u=-1,s=null;for(let i=1;!(Date.now()-p>=A.timeBudget);i++){const l=N-A.windowSize*i;C.lastIndex=Math.max(0,l);const c=E(C,_,N,u);if(!c&&s||(s=c,l<=0))break;u=l}if(s){const i={word:s[0],startColumn:e+1+s.index,endColumn:e+1+s.index+s[0].length};return C.lastIndex=0,i}return null}n.getWordAtText=m;function E(P,C,_,e){let A;for(;A=P.exec(C);){const p=A.index||0;if(p<=_&&P.lastIndex>=_)return A;if(e>0&&p>e)return null}return null}}),X(J[29],K([0,1,15]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class R{constructor(e,A,p){const N=new Uint8Array(e*A);for(let u=0,s=e*A;u<s;u++)N[u]=p;this._data=N,this.rows=e,this.cols=A}get(e,A){return this._data[e*this.cols+A]}set(e,A,p){this._data[e*this.cols+A]=p}}n.Uint8Matrix=R;class o{constructor(e){let A=0,p=0;for(let u=0,s=e.length;u<s;u++){const[i,l,c]=e[u];l>A&&(A=l),i>p&&(p=i),c>p&&(p=c)}A++,p++;const N=new R(p,A,0);for(let u=0,s=e.length;u<s;u++){const[i,l,c]=e[u];N.set(i,l,c)}this._states=N,this._maxCharCode=A}nextState(e,A){return A<0||A>=this._maxCharCode?0:this._states.get(e,A)}}n.StateMachine=o;let y=null;function h(){return y===null&&(y=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var a;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let m=null;function E(){if(m===null){m=new M.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<_.length;A++)m.set(_.charCodeAt(A),1);const e=".,;:";for(let A=0;A<e.length;A++)m.set(e.charCodeAt(A),2)}return m}class P{static _createLink(e,A,p,N,u){let s=u-1;do{const i=A.charCodeAt(s);if(e.get(i)!==2)break;s--}while(s>N);if(N>0){const i=A.charCodeAt(N-1),l=A.charCodeAt(s);(i===40&&l===41||i===91&&l===93||i===123&&l===125)&&s--}return{range:{startLineNumber:p,startColumn:N+1,endLineNumber:p,endColumn:s+2},url:A.substring(N,s+1)}}static computeLinks(e,A=h()){const p=E(),N=[];for(let u=1,s=e.getLineCount();u<=s;u++){const i=e.getLineContent(u),l=i.length;let c=0,w=0,b=0,d=1,v=!1,L=!1,g=!1,f=!1;for(;c<l;){let D=!1;const T=i.charCodeAt(c);if(d===13){let O;switch(T){case 40:v=!0,O=0;break;case 41:O=v?0:1;break;case 91:g=!0,L=!0,O=0;break;case 93:g=!1,O=L?0:1;break;case 123:f=!0,O=0;break;case 125:O=f?0:1;break;case 39:O=b===39?1:0;break;case 34:O=b===34?1:0;break;case 96:O=b===96?1:0;break;case 42:O=b===42?1:0;break;case 124:O=b===124?1:0;break;case 32:O=g?0:1;break;default:O=p.get(T)}O===1&&(N.push(P._createLink(p,i,u,w,c)),D=!0)}else if(d===12){let O;T===91?(L=!0,O=0):O=p.get(T),O===1?D=!0:d=13}else d=A.nextState(d,T),d===0&&(D=!0);D&&(d=1,v=!1,L=!1,f=!1,w=c+1,b=T),c++}d===13&&N.push(P._createLink(p,i,u,w,l))}return N}}n.LinkComputer=P;function C(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:P.computeLinks(_)}n.computeLinks=C}),X(J[30],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(R,o,y,h,a){if(R&&o){const m=this.doNavigateValueSet(o,a);if(m)return{range:R,value:m}}if(y&&h){const m=this.doNavigateValueSet(h,a);if(m)return{range:y,value:m}}return null}doNavigateValueSet(R,o){const y=this.numberReplace(R,o);return y!==null?y:this.textReplace(R,o)}numberReplace(R,o){const y=Math.pow(10,R.length-(R.lastIndexOf(".")+1));let h=Number(R);const a=parseFloat(R);return!isNaN(h)&&!isNaN(a)&&h===a?h===0&&!o?null:(h=Math.floor(h*y),h+=o?y:-y,String(h/y)):null}textReplace(R,o){return this.valueSetsReplace(this._defaultValueSet,R,o)}valueSetsReplace(R,o,y){let h=null;for(let a=0,m=R.length;h===null&&a<m;a++)h=this.valueSetReplace(R[a],o,y);return h}valueSetReplace(R,o,y){let h=R.indexOf(o);return h>=0?(h+=y?1:-1,h<0?h=R.length-1:h%=R.length,R[h]):null}}n.BasicInplaceReplace=M,M.INSTANCE=new M}),X(J[31],K([0,1,26]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var R;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(R=n.MinimapPosition||(n.MinimapPosition={}));var o;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(o=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var y;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(y=n.EndOfLinePreference||(n.EndOfLinePreference={}));var h;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var a;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(a=n.EndOfLineSequence||(n.EndOfLineSequence={}));class m{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}n.TextModelResolvedOptions=m;class E{constructor(s,i){this._findMatchBrand=void 0,this.range=s,this.matches=i}}n.FindMatch=E;var P;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var C;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(C=n.PositionAffinity||(n.PositionAffinity={}));var _;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(_=n.ModelConstants||(n.ModelConstants={}));class e{constructor(s,i,l,c,w,b){this.identifier=s,this.range=i,this.text=l,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=w,this._isTracked=b}}n.ValidAnnotatedEditOperation=e;class A{constructor(s,i,l){this.regex=s,this.wordSeparators=i,this.simpleSearch=l}}n.SearchData=A;class p{constructor(s,i,l){this.reverseEdits=s,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}n.ApplyEditsResult=p;function N(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}n.shouldSynchronizeModel=N}),X(J[32],K([0,1,23,14]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class R{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(a,m){a=(0,t.toUint32)(a);const E=this.values,P=this.prefixSum,C=m.length;return C===0?!1:(this.values=new Uint32Array(E.length+C),this.values.set(E.subarray(0,a),0),this.values.set(E.subarray(a),a+C),this.values.set(m,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,m){return a=(0,t.toUint32)(a),m=(0,t.toUint32)(m),this.values[a]===m?!1:(this.values[a]=m,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,m){a=(0,t.toUint32)(a),m=(0,t.toUint32)(m);const E=this.values,P=this.prefixSum;if(a>=E.length)return!1;const C=E.length-a;return m>=C&&(m=C),m===0?!1:(this.values=new Uint32Array(E.length-m),this.values.set(E.subarray(0,a),0),this.values.set(E.subarray(a+m),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,t.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let m=this.prefixSumValidIndex[0]+1;m===0&&(this.prefixSum[0]=this.values[0],m++),a>=this.values.length&&(a=this.values.length-1);for(let E=m;E<=a;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let m=0,E=this.values.length-1,P=0,C=0,_=0;for(;m<=E;)if(P=m+(E-m)/2|0,C=this.prefixSum[P],_=C-this.values[P],a<_)E=P-1;else if(a>=C)m=P+1;else break;return new y(P,a-_)}}n.PrefixSumComputer=R;class o{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const m=this._indexBySum[a],E=m>0?this._prefixSum[m-1]:0;return new y(m,a-E)}removeValues(a,m){this._values.splice(a,m),this._invalidate(a)}insertValues(a,m){this._values=(0,M.arrayInsert)(this._values,a,m),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,m=this._values.length;a<m;a++){const E=this._values[a],P=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=P+E;for(let C=0;C<E;C++)this._indexBySum[P+C]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,m){this._values[a]!==m&&(this._values[a]=m,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=o;class y{constructor(a,m){this.index=a,this.remainder=m,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=m}}n.PrefixSumIndexOfResult=y}),X(J[33],K([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var M;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(M=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(t=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var R;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(R=n.CompletionItemKind||(n.CompletionItemKind={}));var o;(function(r){r[r.Deprecated=1]="Deprecated"})(o=n.CompletionItemTag||(n.CompletionItemTag={}));var y;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var h;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(h=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var a;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(a=n.CursorChangeReason||(n.CursorChangeReason={}));var m;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(m=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var E;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(E=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var P;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(P=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var C;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.enableDropIntoEditor=32]="enableDropIntoEditor",r[r.emptySelectionClipboard=33]="emptySelectionClipboard",r[r.extraEditorClassName=34]="extraEditorClassName",r[r.fastScrollSensitivity=35]="fastScrollSensitivity",r[r.find=36]="find",r[r.fixedOverflowWidgets=37]="fixedOverflowWidgets",r[r.folding=38]="folding",r[r.foldingStrategy=39]="foldingStrategy",r[r.foldingHighlight=40]="foldingHighlight",r[r.foldingImportsByDefault=41]="foldingImportsByDefault",r[r.foldingMaximumRegions=42]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=44]="fontFamily",r[r.fontInfo=45]="fontInfo",r[r.fontLigatures=46]="fontLigatures",r[r.fontSize=47]="fontSize",r[r.fontWeight=48]="fontWeight",r[r.formatOnPaste=49]="formatOnPaste",r[r.formatOnType=50]="formatOnType",r[r.glyphMargin=51]="glyphMargin",r[r.gotoLocation=52]="gotoLocation",r[r.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",r[r.hover=54]="hover",r[r.inDiffEditor=55]="inDiffEditor",r[r.inlineSuggest=56]="inlineSuggest",r[r.letterSpacing=57]="letterSpacing",r[r.lightbulb=58]="lightbulb",r[r.lineDecorationsWidth=59]="lineDecorationsWidth",r[r.lineHeight=60]="lineHeight",r[r.lineNumbers=61]="lineNumbers",r[r.lineNumbersMinChars=62]="lineNumbersMinChars",r[r.linkedEditing=63]="linkedEditing",r[r.links=64]="links",r[r.matchBrackets=65]="matchBrackets",r[r.minimap=66]="minimap",r[r.mouseStyle=67]="mouseStyle",r[r.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=69]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",r[r.multiCursorModifier=71]="multiCursorModifier",r[r.multiCursorPaste=72]="multiCursorPaste",r[r.occurrencesHighlight=73]="occurrencesHighlight",r[r.overviewRulerBorder=74]="overviewRulerBorder",r[r.overviewRulerLanes=75]="overviewRulerLanes",r[r.padding=76]="padding",r[r.parameterHints=77]="parameterHints",r[r.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",r[r.quickSuggestions=80]="quickSuggestions",r[r.quickSuggestionsDelay=81]="quickSuggestionsDelay",r[r.readOnly=82]="readOnly",r[r.renameOnType=83]="renameOnType",r[r.renderControlCharacters=84]="renderControlCharacters",r[r.renderFinalNewline=85]="renderFinalNewline",r[r.renderLineHighlight=86]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=88]="renderValidationDecorations",r[r.renderWhitespace=89]="renderWhitespace",r[r.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",r[r.roundedSelection=91]="roundedSelection",r[r.rulers=92]="rulers",r[r.scrollbar=93]="scrollbar",r[r.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=95]="scrollBeyondLastLine",r[r.scrollPredominantAxis=96]="scrollPredominantAxis",r[r.selectionClipboard=97]="selectionClipboard",r[r.selectionHighlight=98]="selectionHighlight",r[r.selectOnLineNumbers=99]="selectOnLineNumbers",r[r.showFoldingControls=100]="showFoldingControls",r[r.showUnused=101]="showUnused",r[r.snippetSuggestions=102]="snippetSuggestions",r[r.smartSelect=103]="smartSelect",r[r.smoothScrolling=104]="smoothScrolling",r[r.stickyTabStops=105]="stickyTabStops",r[r.stopRenderingLineAfter=106]="stopRenderingLineAfter",r[r.suggest=107]="suggest",r[r.suggestFontSize=108]="suggestFontSize",r[r.suggestLineHeight=109]="suggestLineHeight",r[r.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",r[r.suggestSelection=111]="suggestSelection",r[r.tabCompletion=112]="tabCompletion",r[r.tabIndex=113]="tabIndex",r[r.unicodeHighlighting=114]="unicodeHighlighting",r[r.unusualLineTerminators=115]="unusualLineTerminators",r[r.useShadowDOM=116]="useShadowDOM",r[r.useTabStops=117]="useTabStops",r[r.wordSeparators=118]="wordSeparators",r[r.wordWrap=119]="wordWrap",r[r.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=122]="wordWrapColumn",r[r.wordWrapOverride1=123]="wordWrapOverride1",r[r.wordWrapOverride2=124]="wordWrapOverride2",r[r.wrappingIndent=125]="wrappingIndent",r[r.wrappingStrategy=126]="wrappingStrategy",r[r.showDeprecated=127]="showDeprecated",r[r.inlayHints=128]="inlayHints",r[r.editorClassName=129]="editorClassName",r[r.pixelRatio=130]="pixelRatio",r[r.tabFocusMode=131]="tabFocusMode",r[r.layoutInfo=132]="layoutInfo",r[r.wrappingInfo=133]="wrappingInfo"})(C=n.EditorOption||(n.EditorOption={}));var _;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(_=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var A;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(A=n.IndentAction||(n.IndentAction={}));var p;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(p=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var N;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(N=n.InlayHintKind||(n.InlayHintKind={}));var u;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(u=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(s=n.KeyCode||(n.KeyCode={}));var i;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=n.MarkerTag||(n.MarkerTag={}));var c;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(c=n.MinimapPosition||(n.MinimapPosition={}));var w;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(w=n.MouseTargetType||(n.MouseTargetType={}));var b;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(b=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var d;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(d=n.OverviewRulerLane||(n.OverviewRulerLane={}));var v;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(v=n.PositionAffinity||(n.PositionAffinity={}));var L;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(L=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var g;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(g=n.RenderMinimap||(n.RenderMinimap={}));var f;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(f=n.ScrollType||(n.ScrollType={}));var D;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(D=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var T;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(T=n.SelectionDirection||(n.SelectionDirection={}));var O;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(O=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var W;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(W=n.SymbolKind||(n.SymbolKind={}));var $;(function(r){r[r.Deprecated=1]="Deprecated"})($=n.SymbolTag||(n.SymbolTag={}));var j;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(j=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var ne;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(ne=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var ae;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ae=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var te;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(te=n.WrappingIndent||(n.WrappingIndent={}))}),X(J[34],K([20,46]),function(B,n){return B.create("vs/base/common/platform",n)}),X(J[5],K([0,1,34]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=void 0;const t="en";let R=!1,o=!1,y=!1,h=!1,a=!1,m=!1,E=!1,P=!1,C=!1,_,e=t,A,p;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let N;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?N=n.globals.vscode.process:typeof process!="undefined"&&(N=process);const u=typeof N?.versions?.electron=="string",s=u&&N?.type==="renderer";if(typeof navigator=="object"&&!s)p=navigator.userAgent,R=p.indexOf("Windows")>=0,o=p.indexOf("Macintosh")>=0,P=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=p.indexOf("Linux")>=0,m=!0,_=M.getConfiguredDefaultLocale(M.localize(0,null))||t,e=_;else if(typeof N=="object"){R=N.platform==="win32",o=N.platform==="darwin",y=N.platform==="linux",h=y&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,E=u,C=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,_=t,e=t;const g=N.env.VSCODE_NLS_CONFIG;if(g)try{const f=JSON.parse(g),D=f.availableLanguages["*"];_=f.locale,e=D||t,A=f._translationsConfigFile}catch{}a=!0}else console.error("Unable to resolve platform.");var i;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(i=n.Platform||(n.Platform={}));function l(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=l;let c=0;o?c=1:R?c=3:y&&(c=2),n.isWindows=R,n.isMacintosh=o,n.isLinux=y,n.isLinuxSnap=h,n.isNative=a,n.isElectron=E,n.isWeb=m,n.isWebWorker=m&&typeof n.globals.importScripts=="function",n.isIOS=P,n.isCI=C,n.platform=c,n.userAgent=p,n.language=e;var w;(function(g){function f(){return n.language}g.value=f;function D(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}g.isDefaultVariant=D;function T(){return n.language==="en"}g.isDefault=T})(w=n.Language||(n.Language={})),n.locale=_,n.translationsConfigFile=A,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const g=[];n.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let T=0,O=g.length;T<O;T++){const W=g[T];if(W.id===D.data.vscodeScheduleAsyncWork){g.splice(T,1),W.callback();return}}});let f=0;return D=>{const T=++f;g.push({id:T,callback:D}),n.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return g=>setTimeout(g)})();var b;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(b=n.OperatingSystem||(n.OperatingSystem={})),n.OS=o||P?2:R?1:3;let d=!0,v=!1;function L(){if(!v){v=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,d=new Uint16Array(g.buffer)[0]===(2<<8)+1}return d}n.isLittleEndian=L,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),X(J[35],K([0,1,5]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.process!="undefined"){const R=M.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),X(J[36],K([0,1,35]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,R=97,o=90,y=122,h=46,a=47,m=92,E=58,P=63;class C extends Error{constructor(i,l,c){let w;typeof l=="string"&&l.indexOf("not ")===0?(w="must not be",l=l.replace(/^not /,"")):w="must be";const b=i.indexOf(".")!==-1?"property":"argument";let d=`The "${i}" ${b} ${w} of type ${l}`;d+=`. Received type ${typeof c}`;super(d);this.code="ERR_INVALID_ARG_TYPE"}}function _(s,i){if(typeof s!="string")throw new C(i,"string",s)}function e(s){return s===a||s===m}function A(s){return s===a}function p(s){return s>=t&&s<=o||s>=R&&s<=y}function N(s,i,l,c){let w="",b=0,d=-1,v=0,L=0;for(let g=0;g<=s.length;++g){if(g<s.length)L=s.charCodeAt(g);else{if(c(L))break;L=a}if(c(L)){if(!(d===g-1||v===1))if(v===2){if(w.length<2||b!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const f=w.lastIndexOf(l);f===-1?(w="",b=0):(w=w.slice(0,f),b=w.length-1-w.lastIndexOf(l)),d=g,v=0;continue}else if(w.length!==0){w="",b=0,d=g,v=0;continue}}i&&(w+=w.length>0?`${l}..`:"..",b=2)}else w.length>0?w+=`${l}${s.slice(d+1,g)}`:w=s.slice(d+1,g),b=g-d-1;d=g,v=0}else L===h&&v!==-1?++v:v=-1}return w}function u(s,i){if(i===null||typeof i!="object")throw new C("pathObject","Object",i);const l=i.dir||i.root,c=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${c}`:`${l}${s}${c}`:c}n.win32={resolve(...s){let i="",l="",c=!1;for(let w=s.length-1;w>=-1;w--){let b;if(w>=0){if(b=s[w],_(b,"path"),b.length===0)continue}else i.length===0?b=M.cwd():(b=M.env[`=${i}`]||M.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==i.toLowerCase()&&b.charCodeAt(2)===m)&&(b=`${i}\\`));const d=b.length;let v=0,L="",g=!1;const f=b.charCodeAt(0);if(d===1)e(f)&&(v=1,g=!0);else if(e(f))if(g=!0,e(b.charCodeAt(1))){let D=2,T=D;for(;D<d&&!e(b.charCodeAt(D));)D++;if(D<d&&D!==T){const O=b.slice(T,D);for(T=D;D<d&&e(b.charCodeAt(D));)D++;if(D<d&&D!==T){for(T=D;D<d&&!e(b.charCodeAt(D));)D++;(D===d||D!==T)&&(L=`\\\\${O}\\${b.slice(T,D)}`,v=D)}}}else v=1;else p(f)&&b.charCodeAt(1)===E&&(L=b.slice(0,2),v=2,d>2&&e(b.charCodeAt(2))&&(g=!0,v=3));if(L.length>0)if(i.length>0){if(L.toLowerCase()!==i.toLowerCase())continue}else i=L;if(c){if(i.length>0)break}else if(l=`${b.slice(v)}\\${l}`,c=g,g&&i.length>0)break}return l=N(l,!c,"\\",e),c?`${i}\\${l}`:`${i}${l}`||"."},normalize(s){_(s,"path");const i=s.length;if(i===0)return".";let l=0,c,w=!1;const b=s.charCodeAt(0);if(i===1)return A(b)?"\\":s;if(e(b))if(w=!0,e(s.charCodeAt(1))){let v=2,L=v;for(;v<i&&!e(s.charCodeAt(v));)v++;if(v<i&&v!==L){const g=s.slice(L,v);for(L=v;v<i&&e(s.charCodeAt(v));)v++;if(v<i&&v!==L){for(L=v;v<i&&!e(s.charCodeAt(v));)v++;if(v===i)return`\\\\${g}\\${s.slice(L)}\\`;v!==L&&(c=`\\\\${g}\\${s.slice(L,v)}`,l=v)}}}else l=1;else p(b)&&s.charCodeAt(1)===E&&(c=s.slice(0,2),l=2,i>2&&e(s.charCodeAt(2))&&(w=!0,l=3));let d=l<i?N(s.slice(l),!w,"\\",e):"";return d.length===0&&!w&&(d="."),d.length>0&&e(s.charCodeAt(i-1))&&(d+="\\"),c===void 0?w?`\\${d}`:d:w?`${c}\\${d}`:`${c}${d}`},isAbsolute(s){_(s,"path");const i=s.length;if(i===0)return!1;const l=s.charCodeAt(0);return e(l)||i>2&&p(l)&&s.charCodeAt(1)===E&&e(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,l;for(let b=0;b<s.length;++b){const d=s[b];_(d,"path"),d.length>0&&(i===void 0?i=l=d:i+=`\\${d}`)}if(i===void 0)return".";let c=!0,w=0;if(typeof l=="string"&&e(l.charCodeAt(0))){++w;const b=l.length;b>1&&e(l.charCodeAt(1))&&(++w,b>2&&(e(l.charCodeAt(2))?++w:c=!1))}if(c){for(;w<i.length&&e(i.charCodeAt(w));)w++;w>=2&&(i=`\\${i.slice(w)}`)}return n.win32.normalize(i)},relative(s,i){if(_(s,"from"),_(i,"to"),s===i)return"";const l=n.win32.resolve(s),c=n.win32.resolve(i);if(l===c||(s=l.toLowerCase(),i=c.toLowerCase(),s===i))return"";let w=0;for(;w<s.length&&s.charCodeAt(w)===m;)w++;let b=s.length;for(;b-1>w&&s.charCodeAt(b-1)===m;)b--;const d=b-w;let v=0;for(;v<i.length&&i.charCodeAt(v)===m;)v++;let L=i.length;for(;L-1>v&&i.charCodeAt(L-1)===m;)L--;const g=L-v,f=d<g?d:g;let D=-1,T=0;for(;T<f;T++){const W=s.charCodeAt(w+T);if(W!==i.charCodeAt(v+T))break;W===m&&(D=T)}if(T!==f){if(D===-1)return c}else{if(g>f){if(i.charCodeAt(v+T)===m)return c.slice(v+T+1);if(T===2)return c.slice(v+T)}d>f&&(s.charCodeAt(w+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let O="";for(T=w+D+1;T<=b;++T)(T===b||s.charCodeAt(T)===m)&&(O+=O.length===0?"..":"\\..");return v+=D,O.length>0?`${O}${c.slice(v,L)}`:(c.charCodeAt(v)===m&&++v,c.slice(v,L))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const i=n.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===m){if(i.charCodeAt(1)===m){const l=i.charCodeAt(2);if(l!==P&&l!==h)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(p(i.charCodeAt(0))&&i.charCodeAt(1)===E&&i.charCodeAt(2)===m)return`\\\\?\\${i}`;return s},dirname(s){_(s,"path");const i=s.length;if(i===0)return".";let l=-1,c=0;const w=s.charCodeAt(0);if(i===1)return e(w)?s:".";if(e(w)){if(l=c=1,e(s.charCodeAt(1))){let v=2,L=v;for(;v<i&&!e(s.charCodeAt(v));)v++;if(v<i&&v!==L){for(L=v;v<i&&e(s.charCodeAt(v));)v++;if(v<i&&v!==L){for(L=v;v<i&&!e(s.charCodeAt(v));)v++;if(v===i)return s;v!==L&&(l=c=v+1)}}}}else p(w)&&s.charCodeAt(1)===E&&(l=i>2&&e(s.charCodeAt(2))?3:2,c=l);let b=-1,d=!0;for(let v=i-1;v>=c;--v)if(e(s.charCodeAt(v))){if(!d){b=v;break}}else d=!1;if(b===-1){if(l===-1)return".";b=l}return s.slice(0,b)},basename(s,i){i!==void 0&&_(i,"ext"),_(s,"path");let l=0,c=-1,w=!0,b;if(s.length>=2&&p(s.charCodeAt(0))&&s.charCodeAt(1)===E&&(l=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let d=i.length-1,v=-1;for(b=s.length-1;b>=l;--b){const L=s.charCodeAt(b);if(e(L)){if(!w){l=b+1;break}}else v===-1&&(w=!1,v=b+1),d>=0&&(L===i.charCodeAt(d)?--d==-1&&(c=b):(d=-1,c=v))}return l===c?c=v:c===-1&&(c=s.length),s.slice(l,c)}for(b=s.length-1;b>=l;--b)if(e(s.charCodeAt(b))){if(!w){l=b+1;break}}else c===-1&&(w=!1,c=b+1);return c===-1?"":s.slice(l,c)},extname(s){_(s,"path");let i=0,l=-1,c=0,w=-1,b=!0,d=0;s.length>=2&&s.charCodeAt(1)===E&&p(s.charCodeAt(0))&&(i=c=2);for(let v=s.length-1;v>=i;--v){const L=s.charCodeAt(v);if(e(L)){if(!b){c=v+1;break}continue}w===-1&&(b=!1,w=v+1),L===h?l===-1?l=v:d!==1&&(d=1):l!==-1&&(d=-1)}return l===-1||w===-1||d===0||d===1&&l===w-1&&l===c+1?"":s.slice(l,w)},format:u.bind(null,"\\"),parse(s){_(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const l=s.length;let c=0,w=s.charCodeAt(0);if(l===1)return e(w)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(e(w)){if(c=1,e(s.charCodeAt(1))){let D=2,T=D;for(;D<l&&!e(s.charCodeAt(D));)D++;if(D<l&&D!==T){for(T=D;D<l&&e(s.charCodeAt(D));)D++;if(D<l&&D!==T){for(T=D;D<l&&!e(s.charCodeAt(D));)D++;D===l?c=D:D!==T&&(c=D+1)}}}}else if(p(w)&&s.charCodeAt(1)===E){if(l<=2)return i.root=i.dir=s,i;if(c=2,e(s.charCodeAt(2))){if(l===3)return i.root=i.dir=s,i;c=3}}c>0&&(i.root=s.slice(0,c));let b=-1,d=c,v=-1,L=!0,g=s.length-1,f=0;for(;g>=c;--g){if(w=s.charCodeAt(g),e(w)){if(!L){d=g+1;break}continue}v===-1&&(L=!1,v=g+1),w===h?b===-1?b=g:f!==1&&(f=1):b!==-1&&(f=-1)}return v!==-1&&(b===-1||f===0||f===1&&b===v-1&&b===d+1?i.base=i.name=s.slice(d,v):(i.name=s.slice(d,b),i.base=s.slice(d,v),i.ext=s.slice(b,v))),d>0&&d!==c?i.dir=s.slice(0,d-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...s){let i="",l=!1;for(let c=s.length-1;c>=-1&&!l;c--){const w=c>=0?s[c]:M.cwd();_(w,"path"),w.length!==0&&(i=`${w}/${i}`,l=w.charCodeAt(0)===a)}return i=N(i,!l,"/",A),l?`/${i}`:i.length>0?i:"."},normalize(s){if(_(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===a,l=s.charCodeAt(s.length-1)===a;return s=N(s,!i,"/",A),s.length===0?i?"/":l?"./":".":(l&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return _(s,"path"),s.length>0&&s.charCodeAt(0)===a},join(...s){if(s.length===0)return".";let i;for(let l=0;l<s.length;++l){const c=s[l];_(c,"path"),c.length>0&&(i===void 0?i=c:i+=`/${c}`)}return i===void 0?".":n.posix.normalize(i)},relative(s,i){if(_(s,"from"),_(i,"to"),s===i||(s=n.posix.resolve(s),i=n.posix.resolve(i),s===i))return"";const l=1,c=s.length,w=c-l,b=1,d=i.length-b,v=w<d?w:d;let L=-1,g=0;for(;g<v;g++){const D=s.charCodeAt(l+g);if(D!==i.charCodeAt(b+g))break;D===a&&(L=g)}if(g===v)if(d>v){if(i.charCodeAt(b+g)===a)return i.slice(b+g+1);if(g===0)return i.slice(b+g)}else w>v&&(s.charCodeAt(l+g)===a?L=g:g===0&&(L=0));let f="";for(g=l+L+1;g<=c;++g)(g===c||s.charCodeAt(g)===a)&&(f+=f.length===0?"..":"/..");return`${f}${i.slice(b+L)}`},toNamespacedPath(s){return s},dirname(s){if(_(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===a;let l=-1,c=!0;for(let w=s.length-1;w>=1;--w)if(s.charCodeAt(w)===a){if(!c){l=w;break}}else c=!1;return l===-1?i?"/":".":i&&l===1?"//":s.slice(0,l)},basename(s,i){i!==void 0&&_(i,"ext"),_(s,"path");let l=0,c=-1,w=!0,b;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let d=i.length-1,v=-1;for(b=s.length-1;b>=0;--b){const L=s.charCodeAt(b);if(L===a){if(!w){l=b+1;break}}else v===-1&&(w=!1,v=b+1),d>=0&&(L===i.charCodeAt(d)?--d==-1&&(c=b):(d=-1,c=v))}return l===c?c=v:c===-1&&(c=s.length),s.slice(l,c)}for(b=s.length-1;b>=0;--b)if(s.charCodeAt(b)===a){if(!w){l=b+1;break}}else c===-1&&(w=!1,c=b+1);return c===-1?"":s.slice(l,c)},extname(s){_(s,"path");let i=-1,l=0,c=-1,w=!0,b=0;for(let d=s.length-1;d>=0;--d){const v=s.charCodeAt(d);if(v===a){if(!w){l=d+1;break}continue}c===-1&&(w=!1,c=d+1),v===h?i===-1?i=d:b!==1&&(b=1):i!==-1&&(b=-1)}return i===-1||c===-1||b===0||b===1&&i===c-1&&i===l+1?"":s.slice(i,c)},format:u.bind(null,"/"),parse(s){_(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const l=s.charCodeAt(0)===a;let c;l?(i.root="/",c=1):c=0;let w=-1,b=0,d=-1,v=!0,L=s.length-1,g=0;for(;L>=c;--L){const f=s.charCodeAt(L);if(f===a){if(!v){b=L+1;break}continue}d===-1&&(v=!1,d=L+1),f===h?w===-1?w=L:g!==1&&(g=1):w!==-1&&(g=-1)}if(d!==-1){const f=b===0&&l?1:b;w===-1||g===0||g===1&&w===d-1&&w===b+1?i.base=i.name=s.slice(f,d):(i.name=s.slice(f,w),i.base=s.slice(f,d),i.ext=s.slice(w,d))}return b>0?i.dir=s.slice(0,b-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=M.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=M.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=M.platform==="win32"?n.win32.join:n.posix.join,n.resolve=M.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=M.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=M.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=M.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=M.platform==="win32"?n.win32.extname:n.posix.extname,n.format=M.platform==="win32"?n.win32.format:n.posix.format,n.parse=M.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=M.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=M.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=M.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),X(J[17],K([0,1,5]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=M.globals.performance&&typeof M.globals.performance.now=="function";class R{constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new R(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}n.StopWatch=R}),X(J[8],K([0,1,9,11,6,13,17]),function(B,n,M,t,R,o,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;const h=!1,a=!1;var m;(function(L){L.None=()=>R.Disposable.None;function g(x){if(a){const{onListenerDidAdd:Q}=x,Z=e.create();let Y=0;x.onListenerDidAdd=()=>{++Y==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),Q?.()}}}function f(x){return(Q,Z=null,Y)=>{let ee=!1,S;return S=x(I=>{if(!ee)return S?S.dispose():ee=!0,Q.call(Z,I)},null,Y),ee&&S.dispose(),S}}L.once=f;function D(x,Q,Z){return ne((Y,ee=null,S)=>x(I=>Y.call(ee,Q(I)),null,S),Z)}L.map=D;function T(x,Q,Z){return ne((Y,ee=null,S)=>x(I=>{Q(I),Y.call(ee,I)},null,S),Z)}L.forEach=T;function O(x,Q,Z){return ne((Y,ee=null,S)=>x(I=>Q(I)&&Y.call(ee,I),null,S),Z)}L.filter=O;function W(x){return x}L.signal=W;function $(...x){return(Q,Z=null,Y)=>(0,R.combinedDisposable)(...x.map(ee=>ee(S=>Q.call(Z,S),null,Y)))}L.any=$;function j(x,Q,Z,Y){let ee=Z;return D(x,S=>(ee=Q(ee,S),ee),Y)}L.reduce=j;function ne(x,Q){let Z;const Y={onFirstListenerAdd(){Z=x(ee.fire,ee)},onLastListenerRemove(){Z?.dispose()}};Q||g(Y);const ee=new p(Y);return Q?.add(ee),ee.event}function ae(x,Q,Z=100,Y=!1,ee,S){let I,U,q,H=0;const ie={leakWarningThreshold:ee,onFirstListenerAdd(){I=x(ue=>{H++,U=Q(U,ue),Y&&!q&&(re.fire(U),U=void 0),clearTimeout(q),q=setTimeout(()=>{const ce=U;U=void 0,q=void 0,(!Y||H>1)&&re.fire(ce),H=0},Z)})},onLastListenerRemove(){I.dispose()}};S||g(ie);const re=new p(ie);return S?.add(re),re.event}L.debounce=ae;function te(x,Q=(Y,ee)=>Y===ee,Z){let Y=!0,ee;return O(x,S=>{const I=Y||!Q(S,ee);return Y=!1,ee=S,I},Z)}L.latch=te;function r(x,Q,Z){return[L.filter(x,Q,Z),L.filter(x,Y=>!Q(Y),Z)]}L.split=r;function he(x,Q=!1,Z=[]){let Y=Z.slice(),ee=x(U=>{Y?Y.push(U):I.fire(U)});const S=()=>{Y?.forEach(U=>I.fire(U)),Y=null},I=new p({onFirstListenerAdd(){ee||(ee=x(U=>I.fire(U)))},onFirstListenerDidAdd(){Y&&(Q?setTimeout(S):S())},onLastListenerRemove(){ee&&ee.dispose(),ee=null}});return I.event}L.buffer=he;class de{constructor(Q){this.event=Q,this.disposables=new R.DisposableStore}map(Q){return new de(D(this.event,Q,this.disposables))}forEach(Q){return new de(T(this.event,Q,this.disposables))}filter(Q){return new de(O(this.event,Q,this.disposables))}reduce(Q,Z){return new de(j(this.event,Q,Z,this.disposables))}latch(){return new de(te(this.event,void 0,this.disposables))}debounce(Q,Z=100,Y=!1,ee){return new de(ae(this.event,Q,Z,Y,ee,this.disposables))}on(Q,Z,Y){return this.event(Q,Z,Y)}once(Q,Z,Y){return f(this.event)(Q,Z,Y)}dispose(){this.disposables.dispose()}}function Ne(x){return new de(x)}L.chain=Ne;function De(x,Q,Z=Y=>Y){const Y=(...U)=>I.fire(Z(...U)),ee=()=>x.on(Q,Y),S=()=>x.removeListener(Q,Y),I=new p({onFirstListenerAdd:ee,onLastListenerRemove:S});return I.event}L.fromNodeEventEmitter=De;function pe(x,Q,Z=Y=>Y){const Y=(...U)=>I.fire(Z(...U)),ee=()=>x.addEventListener(Q,Y),S=()=>x.removeEventListener(Q,Y),I=new p({onFirstListenerAdd:ee,onLastListenerRemove:S});return I.event}L.fromDOMEventEmitter=pe;function Le(x){return new Promise(Q=>f(x)(Q))}L.toPromise=Le;function Ee(x,Q){return Q(void 0),x(Z=>Q(Z))}L.runAndSubscribe=Ee;function ye(x,Q){let Z=null;function Y(S){Z?.dispose(),Z=new R.DisposableStore,Q(S,Z)}Y(void 0);const ee=x(S=>Y(S));return(0,R.toDisposable)(()=>{ee.dispose(),Z?.dispose()})}L.runAndSubscribeWithStore=ye})(m=n.Event||(n.Event={}));class E{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${E._idPool++}`}start(g){this._stopWatch=new y.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let P=-1;function C(L){const g=P;return P=L,{dispose(){P=g}}}n.setGlobalLeakWarningThreshold=C;class _{constructor(g,f=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g,f){let D=P;if(typeof this.customThreshold=="number"&&(D=this.customThreshold),D<=0||f<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(g.value)||0;if(this._stacks.set(g.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let O,W=0;for(const[$,j]of this._stacks)(!O||W<j)&&(O=$,W=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${W}):`),console.warn(O)}return()=>{const O=this._stacks.get(g.value)||0;this._stacks.set(g.value,O-1)}}}class e{constructor(g){this.value=g}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class A{constructor(g,f,D){this.callback=g,this.callbackThis=f,this.stack=D,this.subscription=new R.SafeDisposable}invoke(g){this.callback.call(this.callbackThis,g)}}class p{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=P>0?new _(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(h){const g=Array.from(this._listeners);queueMicrotask(()=>{for(const f of g)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(g,f,D)=>{this._listeners||(this._listeners=new o.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,W;this._leakageMon&&this._listeners.size>=30&&(W=e.create(),O=this._leakageMon.check(W,this._listeners.size+1)),h&&(W=W??e.create());const $=new A(g,f,W),j=this._listeners.push($);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,f);const ne=$.subscription.set(()=>{O?.(),this._disposed||(j(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return D instanceof R.DisposableStore?D.add(ne):Array.isArray(D)&&D.push(ne),ne}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u);for(const f of this._listeners)this._deliveryQueue.push(this,f,g);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=p;class N{constructor(){this._queue=new o.LinkedList}get size(){return this._queue.size}push(g,f,D){this._queue.push(new s(g,f,D))}clear(g){const f=new o.LinkedList;for(const D of this._queue)D.emitter!==g&&f.push(D);this._queue=f}deliver(){for(;this._queue.size>0;){const g=this._queue.shift();try{g.listener.invoke(g.event)}catch(f){(0,M.onUnexpectedError)(f)}}}}n.EventDeliveryQueue=N;class u extends N{clear(g){this._queue.clear()}}class s{constructor(g,f,D){this.emitter=g,this.listener=f,this.event=D}}class i extends p{async fireAsync(g,f,D){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new o.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,g]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[T,O]=this._asyncDeliveryQueue.shift(),W=[],$={...O,token:f,waitUntil:j=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");D&&(j=D(j,T.callback)),W.push(j)}};try{T.invoke($)}catch(j){(0,M.onUnexpectedError)(j);continue}Object.freeze(W),await Promise.allSettled(W).then(j=>{for(const ne of j)ne.status==="rejected"&&(0,M.onUnexpectedError)(ne.reason)})}}}}n.AsyncEmitter=i;class l extends p{constructor(g){super(g);this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}n.PauseableEmitter=l;class c extends l{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}n.DebounceEmitter=c;class w extends p{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}n.MicrotaskEmitter=w;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const f={event:g,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const D=()=>{this.hasListeners&&this.unhook(f);const T=this.events.indexOf(f);this.events.splice(T,1)};return(0,R.toDisposable)((0,t.once)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(f=>this.emitter.fire(f))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=b;class d{constructor(){this.buffers=[]}wrapEvent(g){return(f,D,T)=>g(O=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>f.call(D,O)):f.call(D,O)},void 0,T)}bufferEvents(g){const f=[];this.buffers.push(f);const D=g();return this.buffers.pop(),f.forEach(T=>T()),D}}n.EventBufferer=d;class v{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=R.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=v}),X(J[18],K([0,1,8]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(h,a){const m=setTimeout(h.bind(a),0);return{dispose(){clearTimeout(m)}}});var R;(function(h){function a(m){return m===h.None||m===h.Cancelled||m instanceof o?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}h.isCancellationToken=a,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=n.CancellationToken||(n.CancellationToken={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=R.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=R.None}}n.CancellationTokenSource=y}),X(J[37],K([0,1,18]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new M.CancellationTokenSource,a=this.task(h.token);return this.result={promise:a,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}n.Cache=t;class R{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const a=JSON.stringify(h);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this.fn(h)),this.lastCache}}n.LRUCachedFunction=R;class o{constructor(h){this.fn=h,this._map=new Map}get cachedValues(){return this._map}get(h){if(this._map.has(h))return this._map.get(h);const a=this.fn(h);return this._map.set(h,a),a}}n.CachedFunction=o}),X(J[4],K([0,1,37,25]),function(B,n,M,t){"use strict";var R;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function o(F){return!F||typeof F!="string"?!0:F.trim().length===0}n.isFalsyOrWhitespace=o;const y=/{(\d+)}/g;function h(F,...k){return k.length===0?F:F.replace(y,function(V,z){const G=parseInt(z,10);return isNaN(G)||G<0||G>=k.length?V:k[G]})}n.format=h;const a=/{([^}]+)}/g;function m(F,k){return F.replace(a,(V,z)=>k[z]??V)}n.format2=m;function E(F){return F.replace(/[<>&]/g,function(k){switch(k){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return k}})}n.escape=E;function P(F){return F.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=P;function C(F,k){let V=0;const z=k.charCodeAt(0);for(let G=F.length-1;G>=0;G--)F.charCodeAt(G)===z&&V++;return V}n.count=C;function _(F,k,V="\u2026"){return F.length<=k?F:`${F.substr(0,k)}${V}`}n.truncate=_;function e(F,k=" "){const V=A(F,k);return p(V,k)}n.trim=e;function A(F,k){if(!F||!k)return F;const V=k.length;if(V===0||F.length===0)return F;let z=0;for(;F.indexOf(k,z)===z;)z=z+V;return F.substring(z)}n.ltrim=A;function p(F,k){if(!F||!k)return F;const V=k.length,z=F.length;if(V===0||z===0)return F;let G=z,se=-1;for(;se=F.lastIndexOf(k,G-1),!(se===-1||se+V!==G);){if(se===0)return"";G=se}return F.substring(0,G)}n.rtrim=p;function N(F){return F.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=N;function u(F){return F.replace(/\*/g,"")}n.stripWildcards=u;function s(F,k,V={}){if(!F)throw new Error("Cannot create regex from empty string");k||(F=P(F)),V.wholeWord&&(/\B/.test(F.charAt(0))||(F="\\b"+F),/\B/.test(F.charAt(F.length-1))||(F=F+"\\b"));let z="";return V.global&&(z+="g"),V.matchCase||(z+="i"),V.multiline&&(z+="m"),V.unicode&&(z+="u"),new RegExp(F,z)}n.createRegExp=s;function i(F){return F.source==="^"||F.source==="^$"||F.source==="$"||F.source==="^\\s*$"?!1:!!(F.exec("")&&F.lastIndex===0)}n.regExpLeadsToEndlessLoop=i;function l(F){return!!F.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=l;function c(F){return(F.global?"g":"")+(F.ignoreCase?"i":"")+(F.multiline?"m":"")+(F.unicode?"u":"")}n.regExpFlags=c;function w(F){return F.split(/\r\n|\r|\n/)}n.splitLines=w;function b(F){for(let k=0,V=F.length;k<V;k++){const z=F.charCodeAt(k);if(z!==32&&z!==9)return k}return-1}n.firstNonWhitespaceIndex=b;function d(F,k=0,V=F.length){for(let z=k;z<V;z++){const G=F.charCodeAt(z);if(G!==32&&G!==9)return F.substring(k,z)}return F.substring(k,V)}n.getLeadingWhitespace=d;function v(F,k=F.length-1){for(let V=k;V>=0;V--){const z=F.charCodeAt(V);if(z!==32&&z!==9)return V}return-1}n.lastNonWhitespaceIndex=v;function L(F,k,V){const z=[];let G=0;for(const se of F.matchAll(k)){if(z.push(F.slice(G,se.index)),se.index===void 0)throw new Error("match.index should be defined");G=se.index+se[0].length,z.push(V(se[0],...se.slice(1),se.index,F,se.groups))}return z.push(F.slice(G)),Promise.all(z).then(se=>se.join(""))}n.replaceAsync=L;function g(F,k){return F<k?-1:F>k?1:0}n.compare=g;function f(F,k,V=0,z=F.length,G=0,se=k.length){for(;V<z&&G<se;V++,G++){const we=F.charCodeAt(V),oe=k.charCodeAt(G);if(we<oe)return-1;if(we>oe)return 1}const fe=z-V,Ae=se-G;return fe<Ae?-1:fe>Ae?1:0}n.compareSubstring=f;function D(F,k){return T(F,k,0,F.length,0,k.length)}n.compareIgnoreCase=D;function T(F,k,V=0,z=F.length,G=0,se=k.length){for(;V<z&&G<se;V++,G++){let we=F.charCodeAt(V),oe=k.charCodeAt(G);if(we===oe)continue;if(we>=128||oe>=128)return f(F.toLowerCase(),k.toLowerCase(),V,z,G,se);W(we)&&(we-=32),W(oe)&&(oe-=32);const _e=we-oe;if(_e!==0)return _e}const fe=z-V,Ae=se-G;return fe<Ae?-1:fe>Ae?1:0}n.compareSubstringIgnoreCase=T;function O(F){return F>=48&&F<=57}n.isAsciiDigit=O;function W(F){return F>=97&&F<=122}n.isLowerAsciiLetter=W;function $(F){return F>=65&&F<=90}n.isUpperAsciiLetter=$;function j(F,k){return F.length===k.length&&T(F,k)===0}n.equalsIgnoreCase=j;function ne(F,k){const V=k.length;return k.length>F.length?!1:T(F,k,0,V)===0}n.startsWithIgnoreCase=ne;function ae(F,k){const V=Math.min(F.length,k.length);let z;for(z=0;z<V;z++)if(F.charCodeAt(z)!==k.charCodeAt(z))return z;return V}n.commonPrefixLength=ae;function te(F,k){const V=Math.min(F.length,k.length);let z;const G=F.length-1,se=k.length-1;for(z=0;z<V;z++)if(F.charCodeAt(G-z)!==k.charCodeAt(se-z))return z;return V}n.commonSuffixLength=te;function r(F){return 55296<=F&&F<=56319}n.isHighSurrogate=r;function he(F){return 56320<=F&&F<=57343}n.isLowSurrogate=he;function de(F,k){return(F-55296<<10)+(k-56320)+65536}n.computeCodePoint=de;function Ne(F,k,V){const z=F.charCodeAt(V);if(r(z)&&V+1<k){const G=F.charCodeAt(V+1);if(he(G))return de(z,G)}return z}n.getNextCodePoint=Ne;function De(F,k){const V=F.charCodeAt(k-1);if(he(V)&&k>1){const z=F.charCodeAt(k-2);if(r(z))return de(z,V)}return V}class pe{constructor(k,V=0){this._str=k,this._len=k.length,this._offset=V}get offset(){return this._offset}setOffset(k){this._offset=k}prevCodePoint(){const k=De(this._str,this._offset);return this._offset-=k>=65536?2:1,k}nextCodePoint(){const k=Ne(this._str,this._len,this._offset);return this._offset+=k>=65536?2:1,k}eol(){return this._offset>=this._len}}n.CodePointIterator=pe;class Le{constructor(k,V=0){this._iterator=new pe(k,V)}get offset(){return this._iterator.offset}nextGraphemeLength(){const k=Ce.getInstance(),V=this._iterator,z=V.offset;let G=k.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,fe=k.getGraphemeBreakType(V.nextCodePoint());if(Se(G,fe)){V.setOffset(se);break}G=fe}return V.offset-z}prevGraphemeLength(){const k=Ce.getInstance(),V=this._iterator,z=V.offset;let G=k.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,fe=k.getGraphemeBreakType(V.prevCodePoint());if(Se(fe,G)){V.setOffset(se);break}G=fe}return z-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Le;function Ee(F,k){return new Le(F,k).nextGraphemeLength()}n.nextCharLength=Ee;function ye(F,k){return new Le(F,k).prevGraphemeLength()}n.prevCharLength=ye;function x(F,k){k>0&&he(F.charCodeAt(k))&&k--;const V=k+Ee(F,k);return[V-ye(F,V),V]}n.getCharContainingOffset=x;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(F){return Q.test(F)}n.containsRTL=Z;const Y=/^[\t\n\r\x20-\x7E]*$/;function ee(F){return Y.test(F)}n.isBasicASCII=ee,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(F){return n.UNUSUAL_LINE_TERMINATORS.test(F)}n.containsUnusualLineTerminators=S;function I(F){return F>=11904&&F<=55215||F>=63744&&F<=64255||F>=65281&&F<=65374}n.isFullWidthCharacter=I;function U(F){return F>=127462&&F<=127487||F===8986||F===8987||F===9200||F===9203||F>=9728&&F<=10175||F===11088||F===11093||F>=127744&&F<=128591||F>=128640&&F<=128764||F>=128992&&F<=129008||F>=129280&&F<=129535||F>=129648&&F<=129782}n.isEmojiImprecise=U;function q(F,k){if(F.length<k)return F;const V=/\b/g;let z=0;for(;V.test(F)&&!(F.length-V.lastIndex<k);)z=V.lastIndex,V.lastIndex+=1;return F.substring(z).replace(/^\s/,"")}n.lcut=q;const H=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(F){return F&&(F=F.replace(H,""),F=F.replace(ie,""),F=F.replace(re,"")),F}n.removeAnsiEscapeCodes=ue,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(F){return!!(F&&F.length>0&&F.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ce;function ge(F){return ce(F)?F.substr(1):F}n.stripUTF8BOM=ge;function me(F,k){if(!F||!k||F.length<k.length)return!1;const V=k.length,z=F.toLowerCase();let G=0,se=-1;for(;G<V;){const fe=z.indexOf(k[G],se+1);if(fe<0)return!1;se=fe,G++}return!0}n.fuzzyContains=me;function Re(F,k=!1){return F?(k&&(F=F.replace(/\\./g,"")),F.toLowerCase()!==F):!1}n.containsUppercaseCharacter=Re;function Ue(F){return F.charAt(0).toUpperCase()+F.slice(1)}n.uppercaseFirstLetter=Ue;function Oe(F,k=1){if(k===0)return"";let V=-1;do V=F.indexOf(`
`,V+1),k--;while(k>0&&V>=0);return V===-1?F:(F[V-1]==="\r"&&V--,F.substr(0,V))}n.getNLines=Oe;function Be(F){const k=90-65+1;return F=F%(2*k),F<k?String.fromCharCode(97+F):String.fromCharCode(65+F-k)}n.singleLetterHash=Be;function Ve(F){return Ce.getInstance().getGraphemeBreakType(F)}n.getGraphemeBreakType=Ve;function Se(F,k){return F===0?k!==5&&k!==7:F===2&&k===3?!1:F===4||F===2||F===3||k===4||k===2||k===3?!0:!(F===8&&(k===8||k===9||k===11||k===12)||(F===11||F===9)&&(k===9||k===10)||(F===12||F===10)&&k===10||k===5||k===13||k===7||F===1||F===13&&k===14||F===6&&k===6)}var We;(function(F){F[F.Other=0]="Other",F[F.Prepend=1]="Prepend",F[F.CR=2]="CR",F[F.LF=3]="LF",F[F.Control=4]="Control",F[F.Extend=5]="Extend",F[F.Regional_Indicator=6]="Regional_Indicator",F[F.SpacingMark=7]="SpacingMark",F[F.L=8]="L",F[F.V=9]="V",F[F.T=10]="T",F[F.LV=11]="LV",F[F.LVT=12]="LVT",F[F.ZWJ=13]="ZWJ",F[F.Extended_Pictographic=14]="Extended_Pictographic"})(We=n.GraphemeBreakType||(n.GraphemeBreakType={}));class Ce{constructor(){this._data=qe()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(k){if(k<32)return k===10?3:k===13?2:4;if(k<127)return 0;const V=this._data,z=V.length/3;let G=1;for(;G<=z;)if(k<V[3*G])G=2*G;else if(k>V[3*G+1])G=2*G+1;else return V[3*G+2];return 0}}Ce._INSTANCE=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(F,k){if(F===0)return 0;const V=ze(F,k);if(V!==void 0)return V;const z=new pe(k,F);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=He;function ze(F,k){const V=new pe(k,F);let z=V.prevCodePoint();for(;je(z)||z===65039||z===8419;){if(V.offset===0)return;z=V.prevCodePoint()}if(!U(z))return;let G=V.offset;return G>0&&V.prevCodePoint()===8205&&(G=V.offset),G}function je(F){return 127995<=F&&F<=127999}var ke;(function(F){F[F.zwj=8205]="zwj",F[F.emojiVariantSelector=65039]="emojiVariantSelector",F[F.enclosingKeyCap=8419]="enclosingKeyCap"})(ke||(ke={})),n.noBreakWhitespace="\xA0";class be{constructor(k){this.confusableDictionary=k}static getInstance(k){return be.cache.get(Array.from(k))}static getLocales(){return be._locales.getValue()}isAmbiguous(k){return this.confusableDictionary.has(k)}getPrimaryConfusable(k){return this.confusableDictionary.get(k)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=be,R=be,be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),be.cache=new M.LRUCachedFunction(F=>{function k(oe){const _e=new Map;for(let ve=0;ve<oe.length;ve+=2)_e.set(oe[ve],oe[ve+1]);return _e}function V(oe,_e){const ve=new Map(oe);for(const[Fe,Pe]of _e)ve.set(Fe,Pe);return ve}function z(oe,_e){if(!oe)return _e;const ve=new Map;for(const[Fe,Pe]of oe)_e.has(Fe)&&ve.set(Fe,Pe);return ve}const G=R.ambiguousCharacterData.getValue();let se=F.filter(oe=>!oe.startsWith("_")&&oe in G);se.length===0&&(se=["_default"]);let fe;for(const oe of se){const _e=k(G[oe]);fe=z(fe,_e)}const Ae=k(G._common),we=V(Ae,fe);return new be(we)}),be._locales=new t.Lazy(()=>Object.keys(be.ambiguousCharacterData.getValue()).filter(F=>!F.startsWith("_")));class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(k){return Me.getData().has(k)}static get codePoints(){return Me.getData()}}n.InvisibleCharacters=Me,Me._data=void 0}),X(J[38],K([0,1,4]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(N){return R(N,0)}n.hash=t;function R(N,u){switch(typeof N){case"object":return N===null?o(349,u):Array.isArray(N)?a(N,u):m(N,u);case"string":return h(N,u);case"boolean":return y(N,u);case"number":return o(N,u);case"undefined":return o(937,u);default:return o(617,u)}}n.doHash=R;function o(N,u){return(u<<5)-u+N|0}n.numberHash=o;function y(N,u){return o(N?433:863,u)}function h(N,u){u=o(149417,u);for(let s=0,i=N.length;s<i;s++)u=o(N.charCodeAt(s),u);return u}n.stringHash=h;function a(N,u){return u=o(104579,u),N.reduce((s,i)=>R(i,s),u)}function m(N,u){return u=o(181387,u),Object.keys(N).sort().reduce((s,i)=>(s=h(i,s),R(N[i],s)),u)}class E{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=R(u,this._value),this._value}}n.Hasher=E;var P;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function C(N,u,s=32){const i=s-u,l=~((1<<i)-1);return(N<<u|(l&N)>>>i)>>>0}function _(N,u=0,s=N.byteLength,i=0){for(let l=0;l<s;l++)N[u+l]=i}function e(N,u,s="0"){for(;N.length<u;)N=s+N;return N}function A(N,u=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(s=>s.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),u/4)}n.toHexString=A;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const s=u.length;if(s===0)return;const i=this._buff;let l=this._buffLen,c=this._leftoverHighSurrogate,w,b;for(c!==0?(w=c,b=-1,c=0):(w=u.charCodeAt(0),b=0);;){let d=w;if(M.isHighSurrogate(w))if(b+1<s){const v=u.charCodeAt(b+1);M.isLowSurrogate(v)?(b++,d=M.computeCodePoint(w,v)):d=65533}else{c=w;break}else M.isLowSurrogate(w)&&(d=65533);if(l=this._push(i,l,d),b++,b<s)w=u.charCodeAt(b);else break}this._buffLen=l,this._leftoverHighSurrogate=c}_push(u,s,i){return i<128?u[s++]=i:i<2048?(u[s++]=192|(i&1984)>>>6,u[s++]=128|(i&63)>>>0):i<65536?(u[s++]=224|(i&61440)>>>12,u[s++]=128|(i&4032)>>>6,u[s++]=128|(i&63)>>>0):(u[s++]=240|(i&1835008)>>>18,u[s++]=128|(i&258048)>>>12,u[s++]=128|(i&4032)>>>6,u[s++]=128|(i&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),A(this._h0)+A(this._h1)+A(this._h2)+A(this._h3)+A(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=p._bigBlock32,s=this._buffDV;for(let g=0;g<64;g+=4)u.setUint32(g,s.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)u.setUint32(g,C(u.getUint32(g-12,!1)^u.getUint32(g-32,!1)^u.getUint32(g-56,!1)^u.getUint32(g-64,!1),1),!1);let i=this._h0,l=this._h1,c=this._h2,w=this._h3,b=this._h4,d,v,L;for(let g=0;g<80;g++)g<20?(d=l&c|~l&w,v=1518500249):g<40?(d=l^c^w,v=1859775393):g<60?(d=l&c|l&w|c&w,v=2400959708):(d=l^c^w,v=3395469782),L=C(i,5)+d+b+v+u.getUint32(g*4,!1)&4294967295,b=w,w=c,c=C(l,30),l=i,i=L;this._h0=this._h0+i&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+w&4294967295,this._h4=this._h4+b&4294967295}}n.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),X(J[19],K([0,1,22,38]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class R{constructor(C){this.source=C}getElements(){const C=this.source,_=new Int32Array(C.length);for(let e=0,A=C.length;e<A;e++)_[e]=C.charCodeAt(e);return _}}n.StringDiffSequence=R;function o(P,C,_){return new E(new R(P),new R(C)).ComputeDiff(_).changes}n.stringDiff=o;class y{static Assert(C,_){if(!C)throw new Error(_)}}n.Debug=y;class h{static Copy(C,_,e,A,p){for(let N=0;N<p;N++)e[A+N]=C[_+N]}static Copy2(C,_,e,A,p){for(let N=0;N<p;N++)e[A+N]=C[_+N]}}n.MyArray=h;var a;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class m{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(C,_){this.m_originalStart=Math.min(this.m_originalStart,C),this.m_modifiedStart=Math.min(this.m_modifiedStart,_),this.m_originalCount++}AddModifiedElement(C,_){this.m_originalStart=Math.min(this.m_originalStart,C),this.m_modifiedStart=Math.min(this.m_modifiedStart,_),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class E{constructor(C,_,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=C,this._modifiedSequence=_;const[A,p,N]=E._getElements(C),[u,s,i]=E._getElements(_);this._hasStrings=N&&i,this._originalStringElements=A,this._originalElementsOrHash=p,this._modifiedStringElements=u,this._modifiedElementsOrHash=s,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(C){return C.length>0&&typeof C[0]=="string"}static _getElements(C){const _=C.getElements();if(E._isStringArray(_)){const e=new Int32Array(_.length);for(let A=0,p=_.length;A<p;A++)e[A]=(0,t.stringHash)(_[A],0);return[_,e,!0]}return _ instanceof Int32Array?[[],_,!1]:[[],new Int32Array(_),!1]}ElementsAreEqual(C,_){return this._originalElementsOrHash[C]!==this._modifiedElementsOrHash[_]?!1:this._hasStrings?this._originalStringElements[C]===this._modifiedStringElements[_]:!0}ElementsAreStrictEqual(C,_){if(!this.ElementsAreEqual(C,_))return!1;const e=E._getStrictElement(this._originalSequence,C),A=E._getStrictElement(this._modifiedSequence,_);return e===A}static _getStrictElement(C,_){return typeof C.getStrictElement=="function"?C.getStrictElement(_):null}OriginalElementsAreEqual(C,_){return this._originalElementsOrHash[C]!==this._originalElementsOrHash[_]?!1:this._hasStrings?this._originalStringElements[C]===this._originalStringElements[_]:!0}ModifiedElementsAreEqual(C,_){return this._modifiedElementsOrHash[C]!==this._modifiedElementsOrHash[_]?!1:this._hasStrings?this._modifiedStringElements[C]===this._modifiedStringElements[_]:!0}ComputeDiff(C){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,C)}_ComputeDiff(C,_,e,A,p){const N=[!1];let u=this.ComputeDiffRecursive(C,_,e,A,N);return p&&(u=this.PrettifyChanges(u)),{quitEarly:N[0],changes:u}}ComputeDiffRecursive(C,_,e,A,p){for(p[0]=!1;C<=_&&e<=A&&this.ElementsAreEqual(C,e);)C++,e++;for(;_>=C&&A>=e&&this.ElementsAreEqual(_,A);)_--,A--;if(C>_||e>A){let c;return e<=A?(y.Assert(C===_+1,"originalStart should only be one more than originalEnd"),c=[new M.DiffChange(C,0,e,A-e+1)]):C<=_?(y.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),c=[new M.DiffChange(C,_-C+1,e,0)]):(y.Assert(C===_+1,"originalStart should only be one more than originalEnd"),y.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),c=[]),c}const N=[0],u=[0],s=this.ComputeRecursionPoint(C,_,e,A,N,u,p),i=N[0],l=u[0];if(s!==null)return s;if(!p[0]){const c=this.ComputeDiffRecursive(C,i,e,l,p);let w=[];return p[0]?w=[new M.DiffChange(i+1,_-(i+1)+1,l+1,A-(l+1)+1)]:w=this.ComputeDiffRecursive(i+1,_,l+1,A,p),this.ConcatenateChanges(c,w)}return[new M.DiffChange(C,_-C+1,e,A-e+1)]}WALKTRACE(C,_,e,A,p,N,u,s,i,l,c,w,b,d,v,L,g,f){let D=null,T=null,O=new m,W=_,$=e,j=b[0]-L[0]-A,ne=-1073741824,ae=this.m_forwardHistory.length-1;do{const te=j+C;te===W||te<$&&i[te-1]<i[te+1]?(c=i[te+1],d=c-j-A,c<ne&&O.MarkNextChange(),ne=c,O.AddModifiedElement(c+1,d),j=te+1-C):(c=i[te-1]+1,d=c-j-A,c<ne&&O.MarkNextChange(),ne=c-1,O.AddOriginalElement(c,d+1),j=te-1-C),ae>=0&&(i=this.m_forwardHistory[ae],C=i[0],W=1,$=i.length-1)}while(--ae>=-1);if(D=O.getReverseChanges(),f[0]){let te=b[0]+1,r=L[0]+1;if(D!==null&&D.length>0){const he=D[D.length-1];te=Math.max(te,he.getOriginalEnd()),r=Math.max(r,he.getModifiedEnd())}T=[new M.DiffChange(te,w-te+1,r,v-r+1)]}else{O=new m,W=N,$=u,j=b[0]-L[0]-s,ne=1073741824,ae=g?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const te=j+p;te===W||te<$&&l[te-1]>=l[te+1]?(c=l[te+1]-1,d=c-j-s,c>ne&&O.MarkNextChange(),ne=c+1,O.AddOriginalElement(c+1,d+1),j=te+1-p):(c=l[te-1],d=c-j-s,c>ne&&O.MarkNextChange(),ne=c,O.AddModifiedElement(c+1,d+1),j=te-1-p),ae>=0&&(l=this.m_reverseHistory[ae],p=l[0],W=1,$=l.length-1)}while(--ae>=-1);T=O.getChanges()}return this.ConcatenateChanges(D,T)}ComputeRecursionPoint(C,_,e,A,p,N,u){let s=0,i=0,l=0,c=0,w=0,b=0;C--,e--,p[0]=0,N[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=_-C+(A-e),v=d+1,L=new Int32Array(v),g=new Int32Array(v),f=A-e,D=_-C,T=C-e,O=_-A,$=(D-f)%2==0;L[f]=C,g[D]=_,u[0]=!1;for(let j=1;j<=d/2+1;j++){let ne=0,ae=0;l=this.ClipDiagonalBound(f-j,j,f,v),c=this.ClipDiagonalBound(f+j,j,f,v);for(let r=l;r<=c;r+=2){r===l||r<c&&L[r-1]<L[r+1]?s=L[r+1]:s=L[r-1]+1,i=s-(r-f)-T;const he=s;for(;s<_&&i<A&&this.ElementsAreEqual(s+1,i+1);)s++,i++;if(L[r]=s,s+i>ne+ae&&(ne=s,ae=i),!$&&Math.abs(r-D)<=j-1&&s>=g[r])return p[0]=s,N[0]=i,he<=g[r]&&1447>0&&j<=1447+1?this.WALKTRACE(f,l,c,T,D,w,b,O,L,g,s,_,p,i,A,N,$,u):null}const te=(ne-C+(ae-e)-j)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ne,te))return u[0]=!0,p[0]=ne,N[0]=ae,te>0&&1447>0&&j<=1447+1?this.WALKTRACE(f,l,c,T,D,w,b,O,L,g,s,_,p,i,A,N,$,u):(C++,e++,[new M.DiffChange(C,_-C+1,e,A-e+1)]);w=this.ClipDiagonalBound(D-j,j,D,v),b=this.ClipDiagonalBound(D+j,j,D,v);for(let r=w;r<=b;r+=2){r===w||r<b&&g[r-1]>=g[r+1]?s=g[r+1]-1:s=g[r-1],i=s-(r-D)-O;const he=s;for(;s>C&&i>e&&this.ElementsAreEqual(s,i);)s--,i--;if(g[r]=s,$&&Math.abs(r-f)<=j&&s<=L[r])return p[0]=s,N[0]=i,he>=L[r]&&1447>0&&j<=1447+1?this.WALKTRACE(f,l,c,T,D,w,b,O,L,g,s,_,p,i,A,N,$,u):null}if(j<=1447){let r=new Int32Array(c-l+2);r[0]=f-l+1,h.Copy2(L,l,r,1,c-l+1),this.m_forwardHistory.push(r),r=new Int32Array(b-w+2),r[0]=D-w+1,h.Copy2(g,w,r,1,b-w+1),this.m_reverseHistory.push(r)}}return this.WALKTRACE(f,l,c,T,D,w,b,O,L,g,s,_,p,i,A,N,$,u)}PrettifyChanges(C){for(let _=0;_<C.length;_++){const e=C[_],A=_<C.length-1?C[_+1].originalStart:this._originalElementsOrHash.length,p=_<C.length-1?C[_+1].modifiedStart:this._modifiedElementsOrHash.length,N=e.originalLength>0,u=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<p&&(!N||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!u||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const i=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!i)break;e.originalStart++,e.modifiedStart++}const s=[null];if(_<C.length-1&&this.ChangesOverlap(C[_],C[_+1],s)){C[_]=s[0],C.splice(_+1,1),_--;continue}}for(let _=C.length-1;_>=0;_--){const e=C[_];let A=0,p=0;if(_>0){const c=C[_-1];A=c.originalStart+c.originalLength,p=c.modifiedStart+c.modifiedLength}const N=e.originalLength>0,u=e.modifiedLength>0;let s=0,i=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let c=1;;c++){const w=e.originalStart-c,b=e.modifiedStart-c;if(w<A||b<p||N&&!this.OriginalElementsAreEqual(w,w+e.originalLength)||u&&!this.ModifiedElementsAreEqual(b,b+e.modifiedLength))break;const v=(w===A&&b===p?5:0)+this._boundaryScore(w,e.originalLength,b,e.modifiedLength);v>i&&(i=v,s=c)}e.originalStart-=s,e.modifiedStart-=s;const l=[null];if(_>0&&this.ChangesOverlap(C[_-1],C[_],l)){C[_-1]=l[0],C.splice(_,1),_++;continue}}if(this._hasStrings)for(let _=1,e=C.length;_<e;_++){const A=C[_-1],p=C[_],N=p.originalStart-A.originalStart-A.originalLength,u=A.originalStart,s=p.originalStart+p.originalLength,i=s-u,l=A.modifiedStart,c=p.modifiedStart+p.modifiedLength,w=c-l;if(N<5&&i<20&&w<20){const b=this._findBetterContiguousSequence(u,i,l,w,N);if(b){const[d,v]=b;(d!==A.originalStart+A.originalLength||v!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=d-A.originalStart,A.modifiedLength=v-A.modifiedStart,p.originalStart=d+N,p.modifiedStart=v+N,p.originalLength=s-p.originalStart,p.modifiedLength=c-p.modifiedStart)}}}return C}_findBetterContiguousSequence(C,_,e,A,p){if(_<p||A<p)return null;const N=C+_-p+1,u=e+A-p+1;let s=0,i=0,l=0;for(let c=C;c<N;c++)for(let w=e;w<u;w++){const b=this._contiguousSequenceScore(c,w,p);b>0&&b>s&&(s=b,i=c,l=w)}return s>0?[i,l]:null}_contiguousSequenceScore(C,_,e){let A=0;for(let p=0;p<e;p++){if(!this.ElementsAreEqual(C+p,_+p))return 0;A+=this._originalStringElements[C+p].length}return A}_OriginalIsBoundary(C){return C<=0||C>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[C])}_OriginalRegionIsBoundary(C,_){if(this._OriginalIsBoundary(C)||this._OriginalIsBoundary(C-1))return!0;if(_>0){const e=C+_;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(C){return C<=0||C>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[C])}_ModifiedRegionIsBoundary(C,_){if(this._ModifiedIsBoundary(C)||this._ModifiedIsBoundary(C-1))return!0;if(_>0){const e=C+_;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(C,_,e,A){const p=this._OriginalRegionIsBoundary(C,_)?1:0,N=this._ModifiedRegionIsBoundary(e,A)?1:0;return p+N}ConcatenateChanges(C,_){const e=[];if(C.length===0||_.length===0)return _.length>0?_:C;if(this.ChangesOverlap(C[C.length-1],_[0],e)){const A=new Array(C.length+_.length-1);return h.Copy(C,0,A,0,C.length-1),A[C.length-1]=e[0],h.Copy(_,1,A,C.length,_.length-1),A}else{const A=new Array(C.length+_.length);return h.Copy(C,0,A,0,C.length),h.Copy(_,0,A,C.length,_.length),A}}ChangesOverlap(C,_,e){if(y.Assert(C.originalStart<=_.originalStart,"Left change is not less than or equal to right change"),y.Assert(C.modifiedStart<=_.modifiedStart,"Left change is not less than or equal to right change"),C.originalStart+C.originalLength>=_.originalStart||C.modifiedStart+C.modifiedLength>=_.modifiedStart){const A=C.originalStart;let p=C.originalLength;const N=C.modifiedStart;let u=C.modifiedLength;return C.originalStart+C.originalLength>=_.originalStart&&(p=_.originalStart+_.originalLength-C.originalStart),C.modifiedStart+C.modifiedLength>=_.modifiedStart&&(u=_.modifiedStart+_.modifiedLength-C.modifiedStart),e[0]=new M.DiffChange(A,p,N,u),!0}else return e[0]=null,!1}ClipDiagonalBound(C,_,e,A){if(C>=0&&C<A)return C;const p=e,N=A-e-1,u=_%2==0;if(C<0){const s=p%2==0;return u===s?0:1}else{const s=N%2==0;return u===s?A-1:A-2}}}n.LcsDiff=E}),X(J[10],K([0,1,36,5]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const R=/^\w[\w\d+.-]*$/,o=/^\//,y=/^\/\//;function h(b,d){if(!b.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${b.authority}", path: "${b.path}", query: "${b.query}", fragment: "${b.fragment}"}`);if(b.scheme&&!R.test(b.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(b.path){if(b.authority){if(!o.test(b.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(b.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(b,d){return!b&&!d?"file":b}function m(b,d){switch(b){case"https":case"http":case"file":d?d[0]!==P&&(d=P+d):d=P;break}return d}const E="",P="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{constructor(d,v,L,g,f,D=!1){typeof d=="object"?(this.scheme=d.scheme||E,this.authority=d.authority||E,this.path=d.path||E,this.query=d.query||E,this.fragment=d.fragment||E):(this.scheme=a(d,D),this.authority=v||E,this.path=m(this.scheme,L||E),this.query=g||E,this.fragment=f||E,h(this,D))}static isUri(d){return d instanceof _?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return s(this,!1)}with(d){if(!d)return this;let{scheme:v,authority:L,path:g,query:f,fragment:D}=d;return v===void 0?v=this.scheme:v===null&&(v=E),L===void 0?L=this.authority:L===null&&(L=E),g===void 0?g=this.path:g===null&&(g=E),f===void 0?f=this.query:f===null&&(f=E),D===void 0?D=this.fragment:D===null&&(D=E),v===this.scheme&&L===this.authority&&g===this.path&&f===this.query&&D===this.fragment?this:new A(v,L,g,f,D)}static parse(d,v=!1){const L=C.exec(d);return L?new A(L[2]||E,w(L[4]||E),w(L[5]||E),w(L[7]||E),w(L[9]||E),v):new A(E,E,E,E,E)}static file(d){let v=E;if(t.isWindows&&(d=d.replace(/\\/g,P)),d[0]===P&&d[1]===P){const L=d.indexOf(P,2);L===-1?(v=d.substring(2),d=P):(v=d.substring(2,L),d=d.substring(L)||P)}return new A("file",v,d,E,E)}static from(d){const v=new A(d.scheme,d.authority,d.path,d.query,d.fragment);return h(v,!0),v}static joinPath(d,...v){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return t.isWindows&&d.scheme==="file"?L=_.file(M.win32.join(s(d,!0),...v)).path:L=M.posix.join(d.path,...v),d.with({path:L})}toString(d=!1){return i(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof _)return d;{const v=new A(d);return v._formatted=d.external,v._fsPath=d._sep===e?d.fsPath:null,v}}else return d}}n.URI=_;const e=t.isWindows?1:void 0;class A extends _{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(d=!1){return d?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=e),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(b,d){let v,L=-1;for(let g=0;g<b.length;g++){const f=b.charCodeAt(g);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||d&&f===47)L!==-1&&(v+=encodeURIComponent(b.substring(L,g)),L=-1),v!==void 0&&(v+=b.charAt(g));else{v===void 0&&(v=b.substr(0,g));const D=p[f];D!==void 0?(L!==-1&&(v+=encodeURIComponent(b.substring(L,g)),L=-1),v+=D):L===-1&&(L=g)}}return L!==-1&&(v+=encodeURIComponent(b.substring(L))),v!==void 0?v:b}function u(b){let d;for(let v=0;v<b.length;v++){const L=b.charCodeAt(v);L===35||L===63?(d===void 0&&(d=b.substr(0,v)),d+=p[L]):d!==void 0&&(d+=b[v])}return d!==void 0?d:b}function s(b,d){let v;return b.authority&&b.path.length>1&&b.scheme==="file"?v=`//${b.authority}${b.path}`:b.path.charCodeAt(0)===47&&(b.path.charCodeAt(1)>=65&&b.path.charCodeAt(1)<=90||b.path.charCodeAt(1)>=97&&b.path.charCodeAt(1)<=122)&&b.path.charCodeAt(2)===58?d?v=b.path.substr(1):v=b.path[1].toLowerCase()+b.path.substr(2):v=b.path,t.isWindows&&(v=v.replace(/\//g,"\\")),v}n.uriToFsPath=s;function i(b,d){const v=d?u:N;let L="",{scheme:g,authority:f,path:D,query:T,fragment:O}=b;if(g&&(L+=g,L+=":"),(f||g==="file")&&(L+=P,L+=P),f){let W=f.indexOf("@");if(W!==-1){const $=f.substr(0,W);f=f.substr(W+1),W=$.indexOf(":"),W===-1?L+=v($,!1):(L+=v($.substr(0,W),!1),L+=":",L+=v($.substr(W+1),!1)),L+="@"}f=f.toLowerCase(),W=f.indexOf(":"),W===-1?L+=v(f,!1):(L+=v(f.substr(0,W),!1),L+=f.substr(W))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const W=D.charCodeAt(1);W>=65&&W<=90&&(D=`/${String.fromCharCode(W+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const W=D.charCodeAt(0);W>=65&&W<=90&&(D=`${String.fromCharCode(W+32)}:${D.substr(2)}`)}L+=v(D,!0)}return T&&(L+="?",L+=v(T,!1)),O&&(L+="#",L+=d?O:N(O,!1)),L}function l(b){try{return decodeURIComponent(b)}catch{return b.length>3?b.substr(0,3)+l(b.substr(3)):b}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(b){return b.match(c)?b.replace(c,d=>l(d)):b}}),X(J[47],K([0,1,9,8,6,5,7,4]),function(B,n,M,t,R,o,y,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let m=!1;function E(b){!o.isWeb||(m||(m=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(b.message))}n.logOnceWebWorkerWarning=E;var P;(function(b){b[b.Request=0]="Request",b[b.Reply=1]="Reply",b[b.SubscribeEvent=2]="SubscribeEvent",b[b.Event=3]="Event",b[b.UnsubscribeEvent=4]="UnsubscribeEvent"})(P||(P={}));class C{constructor(d,v,L,g){this.vsWorker=d,this.req=v,this.method=L,this.args=g,this.type=0}}class _{constructor(d,v,L,g){this.vsWorker=d,this.seq=v,this.res=L,this.err=g,this.type=1}}class e{constructor(d,v,L,g){this.vsWorker=d,this.req=v,this.eventName=L,this.arg=g,this.type=2}}class A{constructor(d,v,L){this.vsWorker=d,this.req=v,this.event=L,this.type=3}}class p{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class N{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,v){const L=String(++this._lastSentReq);return new Promise((g,f)=>{this._pendingReplies[L]={resolve:g,reject:f},this._send(new C(this._workerId,L,d,v))})}listen(d,v){let L=null;const g=new t.Emitter({onFirstListenerAdd:()=>{L=String(++this._lastSentReq),this._pendingEmitters.set(L,g),this._send(new e(this._workerId,L,d,v))},onLastListenerRemove:()=>{this._pendingEmitters.delete(L),this._send(new p(this._workerId,L)),L=null}});return g.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let L=d.err;d.err.$isError&&(L=new Error,L.name=d.err.name,L.message=d.err.message,L.stack=d.err.stack),v.reject(L);return}v.resolve(d.res)}_handleRequestMessage(d){const v=d.req;this._handler.handleMessage(d.method,d.args).then(g=>{this._send(new _(this._workerId,v,g,void 0))},g=>{g.detail instanceof Error&&(g.detail=(0,M.transformErrorForSerialization)(g.detail)),this._send(new _(this._workerId,v,void 0,(0,M.transformErrorForSerialization)(g)))})}_handleSubscribeEventMessage(d){const v=d.req,L=this._handler.handleEvent(d.eventName,d.arg)(g=>{this._send(new A(this._workerId,v,g))});this._pendingEvents.set(v,L)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const v=[];if(d.type===0)for(let L=0;L<d.args.length;L++)d.args[L]instanceof ArrayBuffer&&v.push(d.args[L]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this._handler.sendMessage(d,v)}}class u extends R.Disposable{constructor(d,v,L){super();let g=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",W=>{this._protocol.handleMessage(W)},W=>{g?.(W)})),this._protocol=new N({sendMessage:(W,$)=>{this._worker.postMessage(W,$)},handleMessage:(W,$)=>{if(typeof L[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(L[W].apply(L,$))}catch(j){return Promise.reject(j)}},handleEvent:(W,$)=>{if(i(W)){const j=L[W].call(L,$);if(typeof j!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return j}if(s(W)){const j=L[W];if(typeof j!="function")throw new Error(`Missing event ${W} on main thread host.`);return j}throw new Error(`Malformed event name ${W}`)}}),this._protocol.setWorkerId(this._worker.getId());let f=null;typeof o.globals.require!="undefined"&&typeof o.globals.require.getConfig=="function"?f=o.globals.require.getConfig():typeof o.globals.requirejs!="undefined"&&(f=o.globals.requirejs.s.contexts._.config);const D=y.getAllMethodNames(L);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(f)),v,D]);const T=(W,$)=>this._request(W,$),O=(W,$)=>this._protocol.listen(W,$);this._lazyProxy=new Promise((W,$)=>{g=$,this._onModuleLoaded.then(j=>{W(l(j,T,O))},j=>{$(j),this._onError("Worker failed to load "+v,j)})})}getProxyObject(){return this._lazyProxy}_request(d,v){return new Promise((L,g)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,v).then(L,g)},g)})}_onError(d,v){console.error(d),console.info(v)}}n.SimpleWorkerClient=u;function s(b){return b[0]==="o"&&b[1]==="n"&&h.isUpperAsciiLetter(b.charCodeAt(2))}function i(b){return/^onDynamic/.test(b)&&h.isUpperAsciiLetter(b.charCodeAt(9))}function l(b,d,v){const L=D=>function(){const T=Array.prototype.slice.call(arguments,0);return d(D,T)},g=D=>function(T){return v(D,T)},f={};for(const D of b){if(i(D)){f[D]=g(D);continue}if(s(D)){f[D]=v(D,void 0);continue}f[D]=L(D)}return f}class c{constructor(d,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new N({sendMessage:(L,g)=>{d(L,g)},handleMessage:(L,g)=>this._handleMessage(L,g),handleEvent:(L,g)=>this._handleEvent(L,g)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,v){if(d===a)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,v))}catch(L){return Promise.reject(L)}}_handleEvent(d,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(i(d)){const L=this._requestHandler[d].call(this._requestHandler,v);if(typeof L!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return L}if(s(d)){const L=this._requestHandler[d];if(typeof L!="function")throw new Error(`Missing event ${d} on request handler.`);return L}throw new Error(`Malformed event name ${d}`)}initialize(d,v,L,g){this._protocol.setWorkerId(d);const T=l(g,(O,W)=>this._protocol.sendMessage(O,W),(O,W)=>this._protocol.listen(O,W));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(T),Promise.resolve(y.getAllMethodNames(this._requestHandler))):(v&&(typeof v.baseUrl!="undefined"&&delete v.baseUrl,typeof v.paths!="undefined"&&typeof v.paths.vs!="undefined"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,o.globals.require.config(v)),new Promise((O,W)=>{(o.globals.require||B)([L],j=>{if(this._requestHandler=j.create(T),!this._requestHandler){W(new Error("No RequestHandler!"));return}O(y.getAllMethodNames(this._requestHandler))},W)}))}}n.SimpleWorkerServer=c;function w(b){return new c(b,null)}n.create=w}),X(J[39],K([0,1,19,4]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const R=3;function o(A,p,N,u){return new M.LcsDiff(A,p,N).ComputeDiff(u)}class y{constructor(p){const N=[],u=[];for(let s=0,i=p.length;s<i;s++)N[s]=C(p[s],1),u[s]=_(p[s],1);this.lines=p,this._startColumns=N,this._endColumns=u}getElements(){const p=[];for(let N=0,u=this.lines.length;N<u;N++)p[N]=this.lines[N].substring(this._startColumns[N]-1,this._endColumns[N]-1);return p}getStrictElement(p){return this.lines[p]}getStartLineNumber(p){return p+1}getEndLineNumber(p){return p+1}createCharSequence(p,N,u){const s=[],i=[],l=[];let c=0;for(let w=N;w<=u;w++){const b=this.lines[w],d=p?this._startColumns[w]:1,v=p?this._endColumns[w]:b.length+1;for(let L=d;L<v;L++)s[c]=b.charCodeAt(L-1),i[c]=w+1,l[c]=L,c++;!p&&w<u&&(s[c]=10,i[c]=w+1,l[c]=b.length+1,c++)}return new h(s,i,l)}}class h{constructor(p,N,u){this._charCodes=p,this._lineNumbers=N,this._columns=u}toString(){return"["+this._charCodes.map((p,N)=>(p===10?"\\n":String.fromCharCode(p))+`-(${this._lineNumbers[N]},${this._columns[N]})`).join(", ")+"]"}_assertIndex(p,N){if(p<0||p>=N.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(p){return p>0&&p===this._lineNumbers.length?this.getEndLineNumber(p-1):(this._assertIndex(p,this._lineNumbers),this._lineNumbers[p])}getEndLineNumber(p){return p===-1?this.getStartLineNumber(p+1):(this._assertIndex(p,this._lineNumbers),this._charCodes[p]===10?this._lineNumbers[p]+1:this._lineNumbers[p])}getStartColumn(p){return p>0&&p===this._columns.length?this.getEndColumn(p-1):(this._assertIndex(p,this._columns),this._columns[p])}getEndColumn(p){return p===-1?this.getStartColumn(p+1):(this._assertIndex(p,this._columns),this._charCodes[p]===10?1:this._columns[p]+1)}}class a{constructor(p,N,u,s,i,l,c,w){this.originalStartLineNumber=p,this.originalStartColumn=N,this.originalEndLineNumber=u,this.originalEndColumn=s,this.modifiedStartLineNumber=i,this.modifiedStartColumn=l,this.modifiedEndLineNumber=c,this.modifiedEndColumn=w}static createFromDiffChange(p,N,u){const s=N.getStartLineNumber(p.originalStart),i=N.getStartColumn(p.originalStart),l=N.getEndLineNumber(p.originalStart+p.originalLength-1),c=N.getEndColumn(p.originalStart+p.originalLength-1),w=u.getStartLineNumber(p.modifiedStart),b=u.getStartColumn(p.modifiedStart),d=u.getEndLineNumber(p.modifiedStart+p.modifiedLength-1),v=u.getEndColumn(p.modifiedStart+p.modifiedLength-1);return new a(s,i,l,c,w,b,d,v)}}function m(A){if(A.length<=1)return A;const p=[A[0]];let N=p[0];for(let u=1,s=A.length;u<s;u++){const i=A[u],l=i.originalStart-(N.originalStart+N.originalLength),c=i.modifiedStart-(N.modifiedStart+N.modifiedLength);Math.min(l,c)<R?(N.originalLength=i.originalStart+i.originalLength-N.originalStart,N.modifiedLength=i.modifiedStart+i.modifiedLength-N.modifiedStart):(p.push(i),N=i)}return p}class E{constructor(p,N,u,s,i){this.originalStartLineNumber=p,this.originalEndLineNumber=N,this.modifiedStartLineNumber=u,this.modifiedEndLineNumber=s,this.charChanges=i}static createFromDiffResult(p,N,u,s,i,l,c){let w,b,d,v,L;if(N.originalLength===0?(w=u.getStartLineNumber(N.originalStart)-1,b=0):(w=u.getStartLineNumber(N.originalStart),b=u.getEndLineNumber(N.originalStart+N.originalLength-1)),N.modifiedLength===0?(d=s.getStartLineNumber(N.modifiedStart)-1,v=0):(d=s.getStartLineNumber(N.modifiedStart),v=s.getEndLineNumber(N.modifiedStart+N.modifiedLength-1)),l&&N.originalLength>0&&N.originalLength<20&&N.modifiedLength>0&&N.modifiedLength<20&&i()){const g=u.createCharSequence(p,N.originalStart,N.originalStart+N.originalLength-1),f=s.createCharSequence(p,N.modifiedStart,N.modifiedStart+N.modifiedLength-1);if(g.getElements().length>0&&f.getElements().length>0){let D=o(g,f,i,!0).changes;c&&(D=m(D)),L=[];for(let T=0,O=D.length;T<O;T++)L.push(a.createFromDiffChange(D[T],g,f))}}return new E(w,b,d,v,L)}}class P{constructor(p,N,u){this.shouldComputeCharChanges=u.shouldComputeCharChanges,this.shouldPostProcessCharChanges=u.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=u.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=u.shouldMakePrettyDiff,this.originalLines=p,this.modifiedLines=N,this.original=new y(p),this.modified=new y(N),this.continueLineDiff=e(u.maxComputationTime),this.continueCharDiff=e(u.maxComputationTime===0?0:Math.min(u.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const p=o(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),N=p.changes,u=p.quitEarly;if(this.shouldIgnoreTrimWhitespace){const c=[];for(let w=0,b=N.length;w<b;w++)c.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,N[w],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:u,changes:c}}const s=[];let i=0,l=0;for(let c=-1,w=N.length;c<w;c++){const b=c+1<w?N[c+1]:null,d=b?b.originalStart:this.originalLines.length,v=b?b.modifiedStart:this.modifiedLines.length;for(;i<d&&l<v;){const L=this.originalLines[i],g=this.modifiedLines[l];if(L!==g){{let f=C(L,1),D=C(g,1);for(;f>1&&D>1;){const T=L.charCodeAt(f-2),O=g.charCodeAt(D-2);if(T!==O)break;f--,D--}(f>1||D>1)&&this._pushTrimWhitespaceCharChange(s,i+1,1,f,l+1,1,D)}{let f=_(L,1),D=_(g,1);const T=L.length+1,O=g.length+1;for(;f<T&&D<O;){const W=L.charCodeAt(f-1),$=L.charCodeAt(D-1);if(W!==$)break;f++,D++}(f<T||D<O)&&this._pushTrimWhitespaceCharChange(s,i+1,f,T,l+1,D,O)}}i++,l++}b&&(s.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,b,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=b.originalLength,l+=b.modifiedLength)}return{quitEarly:u,changes:s}}_pushTrimWhitespaceCharChange(p,N,u,s,i,l,c){if(this._mergeTrimWhitespaceCharChange(p,N,u,s,i,l,c))return;let w;this.shouldComputeCharChanges&&(w=[new a(N,u,N,s,i,l,i,c)]),p.push(new E(N,N,i,i,w))}_mergeTrimWhitespaceCharChange(p,N,u,s,i,l,c){const w=p.length;if(w===0)return!1;const b=p[w-1];return b.originalEndLineNumber===0||b.modifiedEndLineNumber===0?!1:b.originalEndLineNumber+1===N&&b.modifiedEndLineNumber+1===i?(b.originalEndLineNumber=N,b.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&b.charChanges&&b.charChanges.push(new a(N,u,N,s,i,l,i,c)),!0):!1}}n.DiffComputer=P;function C(A,p){const N=t.firstNonWhitespaceIndex(A);return N===-1?p:N+1}function _(A,p){const N=t.lastNonWhitespaceIndex(A);return N===-1?p:N+2}function e(A){if(A===0)return()=>!0;const p=Date.now();return()=>Date.now()-p<A}}),X(J[40],K([0,1,4,2,32]),function(B,n,M,t,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(h,a,m,E){this._uri=h,this._lines=a,this._eol=m,this._versionId=E,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const a=h.changes;for(const m of a)this._acceptDeleteRange(m.range),this._acceptInsertText(new t.Position(m.range.startLineNumber,m.range.startColumn),m.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,a=this._lines.length,m=new Uint32Array(a);for(let E=0;E<a;E++)m[E]=this._lines[E].length+h;this._lineStarts=new R.PrefixSumComputer(m)}}_setLineText(h,a){this._lines[h]=a,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,a){if(a.length===0)return;const m=(0,M.splitLines)(a);if(m.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+m[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}m[m.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+m[0]);const E=new Uint32Array(m.length-1);for(let P=1;P<m.length;P++)this._lines.splice(h.lineNumber+P-1,0,m[P]),E[P-1]=m[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,E)}}n.MirrorTextModel=o}),X(J[41],K([0,1,4,28,2,3,31]),function(B,n,M,t,R,o,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const h=999;class a{constructor(u,s,i,l){this.searchString=u,this.isRegex=s,this.matchCase=i,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=m(this.searchString):u=this.searchString.indexOf(`
`)>=0;let s=null;try{s=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!u;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new y.SearchData(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}}n.SearchParams=a;function m(N){if(!N||N.length===0)return!1;for(let u=0,s=N.length;u<s;u++)if(N.charCodeAt(u)===92){if(u++,u>=s)break;const l=N.charCodeAt(u);if(l===110||l===114||l===87)return!0}return!1}n.isMultilineRegexSource=m;function E(N,u,s){if(!s)return new y.FindMatch(N,null);const i=[];for(let l=0,c=u.length;l<c;l++)i[l]=u[l];return new y.FindMatch(N,i)}n.createFindMatch=E;class P{constructor(u){const s=[];let i=0;for(let l=0,c=u.length;l<c;l++)u.charCodeAt(l)===10&&(s[i++]=l);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(u){const s=this._lineFeedsOffsets;let i=0,l=s.length-1;if(l===-1||u<=s[0])return 0;for(;i<l;){const c=i+((l-i)/2>>0);s[c]>=u?l=c-1:s[c+1]>=u?(i=c,l=c):i=c+1}return i+1}}class C{static findMatches(u,s,i,l,c){const w=s.parseSearchRequest();return w?w.regex.multiline?this._doFindMatchesMultiline(u,i,new p(w.wordSeparators,w.regex),l,c):this._doFindMatchesLineByLine(u,i,w,l,c):[]}static _getMultilineMatchRange(u,s,i,l,c,w){let b,d=0;l?(d=l.findLineFeedCountBeforeOffset(c),b=s+c+d):b=s+c;let v;if(l){const D=l.findLineFeedCountBeforeOffset(c+w.length)-d;v=b+w.length+D}else v=b+w.length;const L=u.getPositionAt(b),g=u.getPositionAt(v);return new o.Range(L.lineNumber,L.column,g.lineNumber,g.column)}static _doFindMatchesMultiline(u,s,i,l,c){const w=u.getOffsetAt(s.getStartPosition()),b=u.getValueInRange(s,1),d=u.getEOL()===`\r
`?new P(b):null,v=[];let L=0,g;for(i.reset(0);g=i.next(b);)if(v[L++]=E(this._getMultilineMatchRange(u,w,b,d,g.index,g[0]),g,l),L>=c)return v;return v}static _doFindMatchesLineByLine(u,s,i,l,c){const w=[];let b=0;if(s.startLineNumber===s.endLineNumber){const v=u.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return b=this._findMatchesInLine(i,v,s.startLineNumber,s.startColumn-1,b,w,l,c),w}const d=u.getLineContent(s.startLineNumber).substring(s.startColumn-1);b=this._findMatchesInLine(i,d,s.startLineNumber,s.startColumn-1,b,w,l,c);for(let v=s.startLineNumber+1;v<s.endLineNumber&&b<c;v++)b=this._findMatchesInLine(i,u.getLineContent(v),v,0,b,w,l,c);if(b<c){const v=u.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);b=this._findMatchesInLine(i,v,s.endLineNumber,0,b,w,l,c)}return w}static _findMatchesInLine(u,s,i,l,c,w,b,d){const v=u.wordSeparators;if(!b&&u.simpleSearch){const f=u.simpleSearch,D=f.length,T=s.length;let O=-D;for(;(O=s.indexOf(f,O+D))!==-1;)if((!v||A(v,s,T,O,D))&&(w[c++]=new y.FindMatch(new o.Range(i,O+1+l,i,O+1+D+l),null),c>=d))return c;return c}const L=new p(u.wordSeparators,u.regex);let g;L.reset(0);do if(g=L.next(s),g&&(w[c++]=E(new o.Range(i,g.index+1+l,i,g.index+1+g[0].length+l),g,b),c>=d))return c;while(g);return c}static findNextMatch(u,s,i,l){const c=s.parseSearchRequest();if(!c)return null;const w=new p(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindNextMatchMultiline(u,i,w,l):this._doFindNextMatchLineByLine(u,i,w,l)}static _doFindNextMatchMultiline(u,s,i,l){const c=new R.Position(s.lineNumber,1),w=u.getOffsetAt(c),b=u.getLineCount(),d=u.getValueInRange(new o.Range(c.lineNumber,c.column,b,u.getLineMaxColumn(b)),1),v=u.getEOL()===`\r
`?new P(d):null;i.reset(s.column-1);const L=i.next(d);return L?E(this._getMultilineMatchRange(u,w,d,v,L.index,L[0]),L,l):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(u,new R.Position(1,1),i,l):null}static _doFindNextMatchLineByLine(u,s,i,l){const c=u.getLineCount(),w=s.lineNumber,b=u.getLineContent(w),d=this._findFirstMatchInLine(i,b,w,s.column,l);if(d)return d;for(let v=1;v<=c;v++){const L=(w+v-1)%c,g=u.getLineContent(L+1),f=this._findFirstMatchInLine(i,g,L+1,1,l);if(f)return f}return null}static _findFirstMatchInLine(u,s,i,l,c){u.reset(l-1);const w=u.next(s);return w?E(new o.Range(i,w.index+1,i,w.index+1+w[0].length),w,c):null}static findPreviousMatch(u,s,i,l){const c=s.parseSearchRequest();if(!c)return null;const w=new p(c.wordSeparators,c.regex);return c.regex.multiline?this._doFindPreviousMatchMultiline(u,i,w,l):this._doFindPreviousMatchLineByLine(u,i,w,l)}static _doFindPreviousMatchMultiline(u,s,i,l){const c=this._doFindMatchesMultiline(u,new o.Range(1,1,s.lineNumber,s.column),i,l,10*h);if(c.length>0)return c[c.length-1];const w=u.getLineCount();return s.lineNumber!==w||s.column!==u.getLineMaxColumn(w)?this._doFindPreviousMatchMultiline(u,new R.Position(w,u.getLineMaxColumn(w)),i,l):null}static _doFindPreviousMatchLineByLine(u,s,i,l){const c=u.getLineCount(),w=s.lineNumber,b=u.getLineContent(w).substring(0,s.column-1),d=this._findLastMatchInLine(i,b,w,l);if(d)return d;for(let v=1;v<=c;v++){const L=(c+w-v-1)%c,g=u.getLineContent(L+1),f=this._findLastMatchInLine(i,g,L+1,l);if(f)return f}return null}static _findLastMatchInLine(u,s,i,l){let c=null,w;for(u.reset(0);w=u.next(s);)c=E(new o.Range(i,w.index+1,i,w.index+1+w[0].length),w,l);return c}}n.TextModelSearch=C;function _(N,u,s,i,l){if(i===0)return!0;const c=u.charCodeAt(i-1);if(N.get(c)!==0||c===13||c===10)return!0;if(l>0){const w=u.charCodeAt(i);if(N.get(w)!==0)return!0}return!1}function e(N,u,s,i,l){if(i+l===s)return!0;const c=u.charCodeAt(i+l);if(N.get(c)!==0||c===13||c===10)return!0;if(l>0){const w=u.charCodeAt(i+l-1);if(N.get(w)!==0)return!0}return!1}function A(N,u,s,i,l){return _(N,u,s,i,l)&&e(N,u,s,i,l)}n.isValidMatch=A;class p{constructor(u,s){this._wordSeparators=u,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const s=u.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(i=this._searchRegex.exec(u),!i))return null;const l=i.index,c=i[0].length;if(l===this._prevMatchStartIndex&&c===this._prevMatchLength){if(c===0){M.getNextCodePoint(u,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=c,!this._wordSeparators||A(this._wordSeparators,u,s,l,c))return i}while(i);return null}}n.Searcher=p}),X(J[42],K([0,1,3,41,4,7,16]),function(B,n,M,t,R,o,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,A,p){const N=p?p.startLineNumber:1,u=p?p.endLineNumber:e.getLineCount(),s=new E(A),i=s.getCandidateCodePoints();let l;i==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(i))}`,"g");const c=new t.Searcher(null,l),w=[];let b=!1,d,v=0,L=0,g=0;e:for(let f=N,D=u;f<=D;f++){const T=e.getLineContent(f),O=T.length;c.reset(0);do if(d=c.next(T),d){let W=d.index,$=d.index+d[0].length;if(W>0){const te=T.charCodeAt(W-1);R.isHighSurrogate(te)&&W--}if($+1<O){const te=T.charCodeAt($-1);R.isHighSurrogate(te)&&$++}const j=T.substring(W,$),ne=(0,y.getWordAtText)(W+1,y.DEFAULT_WORD_REGEXP,T,0),ae=s.shouldHighlightNonBasicASCII(j,ne?ne.word:null);if(ae!==0){ae===3?v++:ae===2?L++:ae===1?g++:(0,o.assertNever)(ae);const te=1e3;if(w.length>=te){b=!0;break e}w.push(new M.Range(f,W+1,f,$+1))}}while(d)}return{ranges:w,hasMore:b,ambiguousCharacterCount:v,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:g}}static computeUnicodeHighlightReason(e,A){const p=new E(A);switch(p.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const u=e.codePointAt(0),s=p.ambiguousCharacters.getPrimaryConfusable(u),i=R.AmbiguousCharacters.getLocales().filter(l=>!R.AmbiguousCharacters.getInstance(new Set([...A.allowedLocales,l])).isAmbiguous(u));return{kind:0,confusableWith:String.fromCodePoint(s),notAmbiguousInLocales:i}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=h;function a(_,e){return`[${R.escapeRegExpCharacters(_.map(p=>String.fromCodePoint(p)).join(""))}]`}var m;(function(_){_[_.Ambiguous=0]="Ambiguous",_[_.Invisible=1]="Invisible",_[_.NonBasicAscii=2]="NonBasicAscii"})(m=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class E{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=R.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const A of R.InvisibleCharacters.codePoints)P(String.fromCodePoint(A))||e.add(A);if(this.options.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.allowedCodePoints)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const p=e.codePointAt(0);if(this.allowedCodePoints.has(p))return 0;if(this.options.nonBasicASCII)return 1;let N=!1,u=!1;if(A)for(const s of A){const i=s.codePointAt(0),l=R.isBasicASCII(s);N=N||l,!l&&!this.ambiguousCharacters.isAmbiguous(i)&&!R.InvisibleCharacters.isInvisibleCharacter(i)&&(u=!0)}return!N&&u?0:this.options.invisibleCharacters&&!P(e)&&R.InvisibleCharacters.isInvisibleCharacter(p)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(p)?3:0}}function P(_){return _===" "||_===`
`||_==="	"}var C;(function(_){_[_.None=0]="None",_[_.NonBasicASCII=1]="NonBasicASCII",_[_.Invisible=2]="Invisible",_[_.Ambiguous=3]="Ambiguous"})(C||(C={}))}),X(J[43],K([0,1,8,6]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class R{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,a){return this._map.set(h,a),this.fire([h]),(0,t.toDisposable)(()=>{this._map.get(h)===a&&(this._map.delete(h),this.fire([h]))})}registerFactory(h,a){this._factories.get(h)?.dispose();const m=new o(this,h,a);return this._factories.set(h,m),(0,t.toDisposable)(()=>{const E=this._factories.get(h);!E||E!==m||(this._factories.delete(h),E.dispose())})}async getOrCreate(h){const a=this.get(h);if(a)return a;const m=this._factories.get(h);return!m||m.isResolved?null:(await m.resolve(),this.get(h))}get(h){return this._map.get(h)||null}isResolved(h){if(this.get(h))return!0;const m=this._factories.get(h);return!!(!m||m.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=R;class o extends t.Disposable{constructor(h,a,m){super();this._registry=h,this._languageId=a,this._factory=m,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),X(J[44],K([0,1,21,10,3,43]),function(B,n,M,t,R,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class y{constructor(D,T,O){this._tokenBrand=void 0,this.offset=D,this.type=T,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=y;class h{constructor(D,T){this._tokenizationResultBrand=void 0,this.tokens=D,this.endState=T}}n.TokenizationResult=h;class a{constructor(D,T){this._encodedTokenizationResultBrand=void 0,this.tokens=D,this.endState=T}}n.EncodedTokenizationResult=a;var m;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(m=n.CompletionItemKind||(n.CompletionItemKind={}));var E;(function(f){const D=new Map;D.set(0,M.Codicon.symbolMethod),D.set(1,M.Codicon.symbolFunction),D.set(2,M.Codicon.symbolConstructor),D.set(3,M.Codicon.symbolField),D.set(4,M.Codicon.symbolVariable),D.set(5,M.Codicon.symbolClass),D.set(6,M.Codicon.symbolStruct),D.set(7,M.Codicon.symbolInterface),D.set(8,M.Codicon.symbolModule),D.set(9,M.Codicon.symbolProperty),D.set(10,M.Codicon.symbolEvent),D.set(11,M.Codicon.symbolOperator),D.set(12,M.Codicon.symbolUnit),D.set(13,M.Codicon.symbolValue),D.set(15,M.Codicon.symbolEnum),D.set(14,M.Codicon.symbolConstant),D.set(15,M.Codicon.symbolEnum),D.set(16,M.Codicon.symbolEnumMember),D.set(17,M.Codicon.symbolKeyword),D.set(27,M.Codicon.symbolSnippet),D.set(18,M.Codicon.symbolText),D.set(19,M.Codicon.symbolColor),D.set(20,M.Codicon.symbolFile),D.set(21,M.Codicon.symbolReference),D.set(22,M.Codicon.symbolCustomColor),D.set(23,M.Codicon.symbolFolder),D.set(24,M.Codicon.symbolTypeParameter),D.set(25,M.Codicon.account),D.set(26,M.Codicon.issues);function T($){let j=D.get($);return j||(console.info("No codicon found for CompletionItemKind "+$),j=M.Codicon.symbolProperty),j}f.toIcon=T;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W($,j){let ne=O.get($);return typeof ne=="undefined"&&!j&&(ne=9),ne}f.fromString=W})(E=n.CompletionItemKinds||(n.CompletionItemKinds={}));var P;(function(f){f[f.Deprecated=1]="Deprecated"})(P=n.CompletionItemTag||(n.CompletionItemTag={}));var C;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(C=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var _;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var A;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(A=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var p;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(p=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var N;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(N=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function u(f){return f&&t.URI.isUri(f.uri)&&R.Range.isIRange(f.range)&&(R.Range.isIRange(f.originSelectionRange)||R.Range.isIRange(f.targetSelectionRange))}n.isLocationLink=u;var s;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(s=n.SymbolKind||(n.SymbolKind={}));var i;(function(f){f[f.Deprecated=1]="Deprecated"})(i=n.SymbolTag||(n.SymbolTag={}));var l;(function(f){const D=new Map;D.set(0,M.Codicon.symbolFile),D.set(1,M.Codicon.symbolModule),D.set(2,M.Codicon.symbolNamespace),D.set(3,M.Codicon.symbolPackage),D.set(4,M.Codicon.symbolClass),D.set(5,M.Codicon.symbolMethod),D.set(6,M.Codicon.symbolProperty),D.set(7,M.Codicon.symbolField),D.set(8,M.Codicon.symbolConstructor),D.set(9,M.Codicon.symbolEnum),D.set(10,M.Codicon.symbolInterface),D.set(11,M.Codicon.symbolFunction),D.set(12,M.Codicon.symbolVariable),D.set(13,M.Codicon.symbolConstant),D.set(14,M.Codicon.symbolString),D.set(15,M.Codicon.symbolNumber),D.set(16,M.Codicon.symbolBoolean),D.set(17,M.Codicon.symbolArray),D.set(18,M.Codicon.symbolObject),D.set(19,M.Codicon.symbolKey),D.set(20,M.Codicon.symbolNull),D.set(21,M.Codicon.symbolEnumMember),D.set(22,M.Codicon.symbolStruct),D.set(23,M.Codicon.symbolEvent),D.set(24,M.Codicon.symbolOperator),D.set(25,M.Codicon.symbolTypeParameter);function T(O){let W=D.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=M.Codicon.symbolProperty),W}f.toIcon=T})(l=n.SymbolKinds||(n.SymbolKinds={}));class c{constructor(D){this.value=D}}n.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var w;(function(f){function D(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}f.is=D})(w=n.Command||(n.Command={}));var b;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(b=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var d;(function(f){f[f.Unresolved=0]="Unresolved",f[f.Resolved=1]="Resolved"})(d=n.CommentThreadState||(n.CommentThreadState={}));var v;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(v=n.CommentMode||(n.CommentMode={}));var L;(function(f){f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(L=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new o.TokenizationRegistry;var g;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(g=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),X(J[45],K([0,1,18,8,24,10,2,3,27,44,33]),function(B,n,M,t,R,o,y,h,a,m,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class P{static chord(e,A){return(0,R.KeyChord)(e,A)}}n.KeyMod=P,P.CtrlCmd=2048,P.Shift=1024,P.Alt=512,P.WinCtrl=256;function C(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:t.Emitter,KeyCode:E.KeyCode,KeyMod:P,Position:y.Position,Range:h.Range,Selection:a.Selection,SelectionDirection:E.SelectionDirection,MarkerSeverity:E.MarkerSeverity,MarkerTag:E.MarkerTag,Uri:o.URI,Token:m.Token}}n.createMonacoBaseAPI=C}),X(J[48],K([0,1,19,5,10,2,3,39,40,16,29,30,45,7,17,42]),function(B,n,M,t,R,o,y,h,a,m,E,P,C,_,e,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class p extends a.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,l){const c=(0,m.getWordAtText)(i.column,(0,m.ensureValidWordDefinition)(l),this._lines[i.lineNumber-1],0);return c?new y.Range(i.lineNumber,c.startColumn,i.lineNumber,c.endColumn):null}getWordUntilPosition(i,l){const c=this.getWordAtPosition(i,l);return c?{word:this._lines[i.lineNumber-1].substring(c.startColumn-1,i.column-1),startColumn:c.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this._lines,c=this._wordenize.bind(this);let w=0,b="",d=0,v=[];return{*[Symbol.iterator](){for(;;)if(d<v.length){const L=b.substring(v[d].start,v[d].end);d+=1,yield L}else if(w<l.length)b=l[w],v=c(b,i),d=0,w+=1;else break}}}getLineWords(i,l){const c=this._lines[i-1],w=this._wordenize(c,l),b=[];for(const d of w)b.push({word:c.substring(d.start,d.end),startColumn:d.start+1,endColumn:d.end+1});return b}_wordenize(i,l){const c=[];let w;for(l.lastIndex=0;(w=l.exec(i))&&w[0].length!==0;)c.push({start:w.index,end:w.index+w[0].length});return c}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this._eol,c=i.startLineNumber-1,w=i.endLineNumber-1,b=[];b.push(this._lines[c].substring(i.startColumn-1));for(let d=c+1;d<w;d++)b.push(this._lines[d]);return b.push(this._lines[w].substring(0,i.endColumn-1)),b.join(l)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(i),c=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,c)}}_validateRange(i){const l=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),c=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||c.lineNumber!==i.endLineNumber||c.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:c.lineNumber,endColumn:c.column}:i}_validatePosition(i){if(!o.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:c}=i,w=!1;if(l<1)l=1,c=1,w=!0;else if(l>this._lines.length)l=this._lines.length,c=this._lines[l-1].length+1,w=!0;else{const b=this._lines[l-1].length+1;c<1?(c=1,w=!0):c>b&&(c=b,w=!0)}return w?{lineNumber:l,column:c}:i}}n.MirrorModel=p;class N{constructor(i,l){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(l=>i.push(this._models[l])),i}acceptNewModel(i){this._models[i.url]=new p(R.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this._models[i])return;this._models[i].onEvents(l)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeUnicodeHighlights(i,l,c){const w=this._getModel(i);return w?A.UnicodeTextModelHighlighter.computeUnicodeHighlights(w,l,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,c,w){const b=this._getModel(i),d=this._getModel(l);return!b||!d?null:N.computeDiff(b,d,c,w)}static computeDiff(i,l,c,w){const b=i.getLinesContent(),d=l.getLinesContent(),L=new h.DiffComputer(b,d,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:w}).computeDiff(),g=L.changes.length>0?!1:this._modelsAreIdentical(i,l);return{quitEarly:L.quitEarly,identical:g,changes:L.changes}}static _modelsAreIdentical(i,l){const c=i.getLineCount(),w=l.getLineCount();if(c!==w)return!1;for(let b=1;b<=c;b++){const d=i.getLineContent(b),v=l.getLineContent(b);if(d!==v)return!1}return!0}async computeDirtyDiff(i,l,c){const w=this._getModel(i),b=this._getModel(l);if(!w||!b)return null;const d=w.getLinesContent(),v=b.getLinesContent();return new h.DiffComputer(d,v,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,l){const c=this._getModel(i);if(!c)return l;const w=[];let b;l=l.slice(0).sort((d,v)=>{if(d.range&&v.range)return y.Range.compareRangesUsingStarts(d.range,v.range);const L=d.range?0:1,g=v.range?0:1;return L-g});for(let{range:d,text:v,eol:L}of l){if(typeof L=="number"&&(b=L),y.Range.isEmpty(d)&&!v)continue;const g=c.getValueInRange(d);if(v=v.replace(/\r\n|\n|\r/g,c.eol),g===v)continue;if(Math.max(v.length,g.length)>N._diffLimit){w.push({range:d,text:v});continue}const f=(0,M.stringDiff)(g,v,!1),D=c.offsetAt(y.Range.lift(d).getStartPosition());for(const T of f){const O=c.positionAt(D+T.originalStart),W=c.positionAt(D+T.originalStart+T.originalLength),$={text:v.substr(T.modifiedStart,T.modifiedLength),range:{startLineNumber:O.lineNumber,startColumn:O.column,endLineNumber:W.lineNumber,endColumn:W.column}};c.getValueInRange($.range)!==$.text&&w.push($)}}return typeof b=="number"&&w.push({eol:b,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const l=this._getModel(i);return l?(0,E.computeLinks)(l):null}async textualSuggest(i,l,c,w){const b=new e.StopWatch(!0),d=new RegExp(c,w),v=new Set;e:for(const L of i){const g=this._getModel(L);if(!!g){for(const f of g.words(d))if(!(f===l||!isNaN(Number(f)))&&(v.add(f),v.size>N._suggestionsLimit))break e}}return{words:Array.from(v),duration:b.elapsed()}}async computeWordRanges(i,l,c,w){const b=this._getModel(i);if(!b)return Object.create(null);const d=new RegExp(c,w),v=Object.create(null);for(let L=l.startLineNumber;L<l.endLineNumber;L++){const g=b.getLineWords(L,d);for(const f of g){if(!isNaN(Number(f.word)))continue;let D=v[f.word];D||(D=[],v[f.word]=D),D.push({startLineNumber:L,startColumn:f.startColumn,endLineNumber:L,endColumn:f.endColumn})}}return v}async navigateValueSet(i,l,c,w,b){const d=this._getModel(i);if(!d)return null;const v=new RegExp(w,b);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const L=d.getValueInRange(l),g=d.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},v);if(!g)return null;const f=d.getValueInRange(g);return P.BasicInplaceReplace.INSTANCE.navigateValueSet(l,L,g,f,c)}loadForeignModule(i,l,c){const w=(v,L)=>this._host.fhr(v,L),d={host:_.createProxyObject(c,w),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(d,l),Promise.resolve(_.getAllMethodNames(this._foreignModule))):new Promise((v,L)=>{B([i],g=>{this._foreignModule=g.create(d,l),v(_.getAllMethodNames(this._foreignModule))},L)})}fmr(i,l){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,l))}catch(c){return Promise.reject(c)}}}n.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function u(s){return new N(s,null)}n.create=u,typeof importScripts=="function"&&(t.globals.monaco=(0,C.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b06ae3b2d2dbfe28bca3134cc6be65935cdfea6a/core/vs/base/worker/workerMain.js.map
