/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/base/common/map","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","net","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/browser/1dsAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Z){for(var e=[],k=0,t=Z.length;k<t;k++)e[k]=re[Z[k]];return e};define(re[111],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,T){if(!t)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=k}),define(re[51],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(I,b,P){this.id=I,this.definition=b,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\f101"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function T(A,I){const b=["codicon","codicon-"+A];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=T;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(E){if(E instanceof t)return["codicon","codicon-"+E.id];const p=I.exec(E.id);if(!p)return b(t.error);const[,C,d]=p,S=["codicon","codicon-"+C];return d&&S.push("codicon-modifier-"+d.substr(1)),S}A.asClassNameArray=b;function P(E){return b(E).join(" ")}A.asClassName=P;function D(E){return"."+b(E).join(".")}A.asCSSSelector=D})(L=e.CSSIcon||(e.CSSIcon={}))}),define(re[75],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=e.forEach=void 0;function k(I,b){for(const[P,D]of Object.entries(I))if(b({key:P,value:D})===!1)return}e.forEach=k;function t(I,b){const P=Object.create(null);for(const D of I){const E=b(D);let p=P[E];p||(p=P[E]=[]),p.push(D)}return P}e.groupBy=t;function T(I,b){const P=[],D=[];for(const E of I)b.has(E)||P.push(E);for(const E of b)I.has(E)||D.push(E);return{removed:P,added:D}}e.diffSets=T;function L(I,b){const P=[],D=[];for(const[E,p]of I)b.has(E)||P.push(p);for(const[E,p]of b)I.has(E)||D.push(p);return{removed:P,added:D}}e.diffMaps=L;class A{constructor(){this.map=new Map}add(b,P){let D=this.map.get(b);D||(D=new Set,this.map.set(b,D)),D.add(P)}delete(b,P){const D=this.map.get(b);!D||(D.delete(P),D.size===0&&this.map.delete(b))}forEach(b,P){const D=this.map.get(b);!D||D.forEach(P)}}e.SetMap=A}),define(re[60],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(I,b,P)=>{let D=null,E=null;if(typeof P.value=="function"?(D="value",E=P.value):typeof P.get=="function"&&(D="get",E=P.get),!E)throw new Error("not supported");P[D]=A(E,b)}}e.createDecorator=k;function t(A,I,b){let P=null,D=null;if(typeof b.value=="function"?(P="value",D=b.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(P="get",D=b.get),!D)throw new Error("not supported");const E=`$memoize$${I}`;b[P]=function(...p){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,p)}),this[E]}}e.memoize=t;function T(A,I,b){return k((P,D)=>{const E=`$debounce$${D}`,p=`$debounce$result$${D}`;return function(...C){this[p]||(this[p]=b?b():void 0),clearTimeout(this[E]),I&&(this[p]=I(this[p],...C),C=[this[p]]),this[E]=setTimeout(()=>{P.apply(this,C),this[p]=b?b():void 0},A)}})}e.debounce=T;function L(A,I,b){return k((P,D)=>{const E=`$throttle$timer$${D}`,p=`$throttle$result$${D}`,C=`$throttle$lastRun$${D}`,d=`$throttle$pending$${D}`;return function(...S){if(this[p]||(this[p]=b?b():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...S)),this[d])return;const w=this[C]+A;w<=Date.now()?(this[C]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[C]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0},w-Date.now()))}})}e.throttle=L}),define(re[9],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?g.isErrorNoTelemetry(n)?new g(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(r=>{r(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=k,e.errorHandler=new k;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function T(u){b(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=T;function L(u){b(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=L;function A(u){if(u instanceof Error){const{name:n,message:r}=u,i=u.stacktrace||u.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:g.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=A;const I="Canceled";function b(u){return u instanceof P?!0:u instanceof Error&&u.name===I&&u.message===I}e.isCancellationError=b;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function D(){const u=new Error(I);return u.name=u.message,u}e.canceled=D;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function p(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=p;function C(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function d(u){const n=new Error(`${u} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function S(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=S;class w extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=w;class h extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=h;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;class g extends Error{constructor(n){super(n);this.name="ErrorNoTelemetry"}static fromError(n){if(n instanceof g)return n;const r=new g;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=g;class f extends Error{constructor(n){super(n||"An unexpected bug occurred.");Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(re[17],se([0,1,9]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(H,ee=0){return H[H.length-(1+ee)]}e.tail=t;function T(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=T;function L(H,ee,ne=(ae,ue)=>ae===ue){if(H===ee)return!0;if(!H||!ee||H.length!==ee.length)return!1;for(let ae=0,ue=H.length;ae<ue;ae++)if(!ne(H[ae],ee[ae]))return!1;return!0}e.equals=L;function A(H,ee,ne){return I(H.length,ae=>ne(H[ae],ee))}e.binarySearch=A;function I(H,ee){let ne=0,ae=H-1;for(;ne<=ae;){const ue=(ne+ae)/2|0,Se=ee(ue);if(Se<0)ne=ue+1;else if(Se>0)ae=ue-1;else return ue}return-(ne+1)}e.binarySearch2=I;function b(H,ee){let ne=0,ae=H.length;if(ae===0)return 0;for(;ne<ae;){const ue=Math.floor((ne+ae)/2);ee(H[ue])?ae=ue:ne=ue+1}return ne}e.findFirstInSorted=b;function P(H,ee,ne){if(H=H|0,H>=ee.length)throw new TypeError("invalid index");const ae=ee[Math.floor(ee.length*Math.random())],ue=[],Se=[],fe=[];for(const pe of ee){const Ce=ne(pe,ae);Ce<0?ue.push(pe):Ce>0?Se.push(pe):fe.push(pe)}return H<ue.length?P(H,ue,ne):H<ue.length+fe.length?fe[0]:P(H-(ue.length+fe.length),Se,ne)}e.quickSelect=P;function D(H,ee){const ne=[];let ae;for(const ue of H.slice(0).sort(ee))!ae||ee(ae[0],ue)!==0?(ae=[ue],ne.push(ae)):ae.push(ue);return ne}e.groupBy=D;function E(H,ee,ne){const ae=[];function ue(pe,Ce,be){if(Ce===0&&be.length===0)return;const Ie=ae[ae.length-1];Ie&&Ie.start+Ie.deleteCount===pe?(Ie.deleteCount+=Ce,Ie.toInsert.push(...be)):ae.push({start:pe,deleteCount:Ce,toInsert:be})}let Se=0,fe=0;for(;;){if(Se===H.length){ue(Se,0,ee.slice(fe));break}if(fe===ee.length){ue(Se,H.length-Se,[]);break}const pe=H[Se],Ce=ee[fe],be=ne(pe,Ce);be===0?(Se+=1,fe+=1):be<0?(ue(Se,1,[]),Se+=1):be>0&&(ue(Se,0,[Ce]),fe+=1)}return ae}e.sortedDiff=E;function p(H,ee,ne){const ae=E(H,ee,ne),ue=[],Se=[];for(const fe of ae)ue.push(...H.slice(fe.start,fe.start+fe.deleteCount)),Se.push(...fe.toInsert);return{removed:ue,added:Se}}e.delta=p;function C(H,ee,ne){if(ne===0)return[];const ae=H.slice(0,ne).sort(ee);return S(H,ee,ae,ne,H.length),ae}e.top=C;function d(H,ee,ne,ae,ue){return ne===0?Promise.resolve([]):new Promise((Se,fe)=>{(async()=>{const pe=H.length,Ce=H.slice(0,ne).sort(ee);for(let be=ne,Ie=Math.min(ne+ae,pe);be<pe;be=Ie,Ie=Math.min(Ie+ae,pe)){if(be>ne&&await new Promise(qe=>setTimeout(qe)),ue&&ue.isCancellationRequested)throw new k.CancellationError;S(H,ee,Ce,be,Ie)}return Ce})().then(Se,fe)})}e.topAsync=d;function S(H,ee,ne,ae,ue){for(const Se=ne.length;ae<ue;ae++){const fe=H[ae];if(ee(fe,ne[Se-1])<0){ne.pop();const pe=b(ne,Ce=>ee(fe,Ce)<0);ne.splice(pe,0,fe)}}}function w(H){return H.filter(ee=>!!ee)}e.coalesce=w;function h(H){let ee=0;for(let ne=0;ne<H.length;ne++)H[ne]&&(H[ee]=H[ne],ee+=1);H.length=ee}e.coalesceInPlace=h;function m(H,ee,ne){H.splice(ne,0,H.splice(ee,1)[0])}e.move=m;function g(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=g;function f(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=f;function u(H,ee=ne=>ne){const ne=new Set;return H.filter(ae=>{const ue=ee(ae);return ne.has(ue)?!1:(ne.add(ue),!0)})}e.distinct=u;function n(H){const ee=new Set;return ne=>{const ae=H(ne);return ee.has(ae)?!1:(ee.add(ae),!0)}}e.uniqueFilter=n;function r(H,ee){const ne=i(H,ee);if(ne!==-1)return H[ne]}e.findLast=r;function i(H,ee){for(let ne=H.length-1;ne>=0;ne--){const ae=H[ne];if(ee(ae))return ne}return-1}e.lastIndex=i;function a(H,ee){return H.length>0?H[0]:ee}e.firstOrDefault=a;function c(H,ee){return H.length>0?H[H.length-1]:ee}e.lastOrDefault=c;function s(H,ee,ne=(ae,ue)=>ae===ue){let ae=0;for(let ue=0,Se=Math.min(H.length,ee.length);ue<Se&&ne(H[ue],ee[ue]);ue++)ae++;return ae}e.commonPrefixLength=s;function o(H){return[].concat(...H)}e.flatten=o;function l(H,ee){let ne=typeof ee=="number"?H:0;typeof ee=="number"?ne=H:(ne=0,ee=H);const ae=[];if(ne<=ee)for(let ue=ne;ue<ee;ue++)ae.push(ue);else for(let ue=ne;ue>ee;ue--)ae.push(ue);return ae}e.range=l;function v(H,ee,ne){return H.reduce((ae,ue)=>(ae[ee(ue)]=ne?ne(ue):ue,ae),Object.create(null))}e.index=v;function y(H,ee){return H.push(ee),()=>O(H,ee)}e.insert=y;function O(H,ee){const ne=H.indexOf(ee);if(ne>-1)return H.splice(ne,1),ee}e.remove=O;function _(H,ee,ne){const ae=H.slice(0,ee),ue=H.slice(ee);return ae.concat(ne,ue)}e.arrayInsert=_;function N(H,ee){let ne;if(typeof ee=="number"){let ae=ee;ne=()=>{const ue=Math.sin(ae++)*179426549;return ue-Math.floor(ue)}}else ne=Math.random;for(let ae=H.length-1;ae>0;ae-=1){const ue=Math.floor(ne()*(ae+1)),Se=H[ae];H[ae]=H[ue],H[ue]=Se}}e.shuffle=N;function R(H,ee){const ne=H.indexOf(ee);ne>-1&&(H.splice(ne,1),H.unshift(ee))}e.pushToStart=R;function M(H,ee){const ne=H.indexOf(ee);ne>-1&&(H.splice(ne,1),H.push(ee))}e.pushToEnd=M;function F(H,ee){for(const ne of ee)H.push(ne)}e.pushMany=F;function j(H,ee){return Array.isArray(H)?H.map(ee):ee(H)}e.mapArrayOrNot=j;function W(H){return Array.isArray(H)?H:[H]}e.asArray=W;function z(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=z;function te(H,ee){for(const ne of H){const ae=ee(ne);if(ae!==void 0)return ae}}e.mapFind=te;function G(H,ee,ne){const ae=X(H,ee),ue=H.length,Se=ne.length;H.length=ue+Se;for(let fe=ue-1;fe>=ae;fe--)H[fe+Se]=H[fe];for(let fe=0;fe<Se;fe++)H[fe+ae]=ne[fe]}e.insertInto=G;function K(H,ee,ne,ae){const ue=X(H,ee),Se=H.splice(ue,ne);return G(H,ue,ae),Se}e.splice=K;function X(H,ee){return ee<0?Math.max(ee+H.length,0):Math.min(ee,H.length)}var Y;(function(H){function ee(ue){return ue<0}H.isLessThan=ee;function ne(ue){return ue>0}H.isGreaterThan=ne;function ae(ue){return ue===0}H.isNeitherLessOrGreaterThan=ae,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function q(H,ee){return(ne,ae)=>ee(H(ne),H(ae))}e.compareBy=q;function x(...H){return(ee,ne)=>{for(const ae of H){const ue=ae(ee,ne);if(!Y.isNeitherLessOrGreaterThan(ue))return ue}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const B=(H,ee)=>H-ee;e.numberComparator=B;function U(H,ee){if(H.length===0)return;let ne=H[0];for(let ae=1;ae<H.length;ae++){const ue=H[ae];ee(ue,ne)>0&&(ne=ue)}return ne}e.findMaxBy=U;function $(H,ee){if(H.length===0)return;let ne=H[0];for(let ae=1;ae<H.length;ae++){const ue=H[ae];ee(ue,ne)>=0&&(ne=ue)}return ne}e.findLastMaxBy=$;function V(H,ee){return U(H,(ne,ae)=>-ee(ne,ae))}e.findMinBy=V;class J{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let ne=this.firstIdx;for(;ne<this.items.length&&ee(this.items[ne]);)ne++;const ae=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ae}takeFromEndWhile(ee){let ne=this.lastIdx;for(;ne>=0&&ee(this.items[ne]);)ne--;const ae=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const ne=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,ne}}e.ArrayQueue=J}),define(re[76],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const T=this;let L=!1,A;return function(){return L||(L=!0,A=t.apply(T,arguments)),A}}e.once=k}),define(re[52],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function T(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=T;const L=Object.freeze([]);function A(){return L}t.empty=A;function*I(r){yield r}t.single=I;function b(r){return r||L}t.from=b;function P(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=P;function D(r){return r[Symbol.iterator]().next().value}t.first=D;function E(r,i){for(const a of r)if(i(a))return!0;return!1}t.some=E;function p(r,i){for(const a of r)if(i(a))return a}t.find=p;function*C(r,i){for(const a of r)i(a)&&(yield a)}t.filter=C;function*d(r,i){let a=0;for(const c of r)yield i(c,a++)}t.map=d;function*S(...r){for(const i of r)for(const a of i)yield a}t.concat=S;function*w(r){for(const i of r)for(const a of i)yield a}t.concatNested=w;function h(r,i,a){let c=a;for(const s of r)c=i(c,s);return c}t.reduce=h;function m(r,i){let a=0;for(const c of r)i(c,a++)}t.forEach=m;function*g(r,i,a=r.length){for(i<0&&(i+=r.length),a<0?a+=r.length:a>r.length&&(a=r.length);i<a;i++)yield r[i]}t.slice=g;function f(r,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,r];const c=r[Symbol.iterator]();for(let s=0;s<i;s++){const o=c.next();if(o.done)return[a,t.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return c}}]}t.consume=f;function u(r){return f(r)[0]}t.collect=u;function n(r,i,a=(c,s)=>c===s){const c=r[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const o=c.next(),l=s.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!a(o.value,l.value))return!1}}t.equals=n})(k=e.Iterable||(e.Iterable={}))}),define(re[34],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(n,r=!1){let i=0;const a=n.length;let c="",s=0,o=16,l=0;function v(F){let j=0,W=0;for(;j<F;){const z=n.charCodeAt(i);if(z>=48&&z<=57)W=W*16+z-48;else if(z>=65&&z<=70)W=W*16+z-65+10;else if(z>=97&&z<=102)W=W*16+z-97+10;else break;i++,j++}return j<F&&(W=-1),W}function y(F){i=F,c="",s=0,o=16,l=0}function O(){const F=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&P(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&P(n.charCodeAt(i)))for(i++;i<n.length&&P(n.charCodeAt(i));)i++;else return l=3,n.substring(F,i);let j=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&P(n.charCodeAt(i))){for(i++;i<n.length&&P(n.charCodeAt(i));)i++;j=i}else l=3;return n.substring(F,j)}function _(){let F="",j=i;for(;;){if(i>=a){F+=n.substring(j,i),l=2;break}const W=n.charCodeAt(i);if(W===34){F+=n.substring(j,i),i++;break}if(W===92){if(F+=n.substring(j,i),i++,i>=a){l=2;break}switch(n.charCodeAt(i++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const te=v(4);te>=0?F+=String.fromCharCode(te):l=4;break}default:l=5}j=i;continue}if(W>=0&&W<=31)if(b(W)){F+=n.substring(j,i),l=2;break}else l=6;i++}return F}function N(){if(c="",l=0,s=i,i>=a)return s=a,o=17;let F=n.charCodeAt(i);if(I(F)){do i++,c+=String.fromCharCode(F),F=n.charCodeAt(i);while(I(F));return o=15}if(b(F))return i++,c+=String.fromCharCode(F),F===13&&n.charCodeAt(i)===10&&(i++,c+=`
`),o=14;switch(F){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,c=_(),o=10;case 47:{const j=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<a&&!b(n.charCodeAt(i));)i++;return c=n.substring(j,i),o=12}if(n.charCodeAt(i+1)===42){i+=2;const W=a-1;let z=!1;for(;i<W;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,l=1),c=n.substring(j,i),o=13}return c+=String.fromCharCode(F),i++,o=16}case 45:if(c+=String.fromCharCode(F),i++,i===a||!P(n.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),o=11;default:for(;i<a&&R(F);)i++,F=n.charCodeAt(i);if(s!==i){switch(c=n.substring(s,i),c){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return c+=String.fromCharCode(F),i++,o=16}}function R(F){if(I(F)||b(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let F;do F=N();while(F>=12&&F<=15);return F}return{setPosition:y,getPosition:()=>i,scan:r?M:N,getToken:()=>o,getTokenValue:()=>c,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>l}}e.createScanner=A;function I(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function b(n){return n===10||n===13||n===8232||n===8233}function P(n){return n>=48&&n<=57}var D;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(D||(D={}));function E(n,r){const i=[],a=new Object;let c;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(v,y,O,_){s.value=v,s.offset=y,s.length=O,s.type=_,s.colonOffset=void 0,c=s}try{g(n,{onObjectBegin:(v,y)=>{if(r<=v)throw a;c=void 0,o=r>v,i.push("")},onObjectProperty:(v,y,O)=>{if(r<y||(l(v,y,O,"property"),i[i.length-1]=v,r<=y+O))throw a},onObjectEnd:(v,y)=>{if(r<=v)throw a;c=void 0,i.pop()},onArrayBegin:(v,y)=>{if(r<=v)throw a;c=void 0,i.push(0)},onArrayEnd:(v,y)=>{if(r<=v)throw a;c=void 0,i.pop()},onLiteralValue:(v,y,O)=>{if(r<y||(l(v,y,O,u(v)),r<=y+O))throw a},onSeparator:(v,y,O)=>{if(r<=y)throw a;if(v===":"&&c&&c.type==="property")c.colonOffset=y,o=!1,c=void 0;else if(v===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(o=!0,i[i.length-1]=""),c=void 0}}})}catch(v){if(v!==a)throw v}return{path:i,previousNode:c,isAtPropertyKey:o,matches:v=>{let y=0;for(let O=0;y<v.length&&O<i.length;O++)if(v[y]===i[O]||v[y]==="*")y++;else if(v[y]!=="**")return!1;return y===v.length}}}e.getLocation=E;function p(n,r=[],i=L.DEFAULT){let a=null,c=[];const s=[];function o(v){Array.isArray(c)?c.push(v):a!==null&&(c[a]=v)}return g(n,{onObjectBegin:()=>{const v={};o(v),s.push(c),c=v,a=null},onObjectProperty:v=>{a=v},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const v=[];o(v),s.push(c),c=v,a=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:o,onError:(v,y,O)=>{r.push({error:v,offset:y,length:O})}},i),c[0]}e.parse=p;function C(n,r=[],i=L.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){a.type==="property"&&(a.length=v-a.offset,a=a.parent)}function s(v){return a.children.push(v),v}g(n,{onObjectBegin:v=>{a=s({type:"object",offset:v,length:-1,parent:a,children:[]})},onObjectProperty:(v,y,O)=>{a=s({type:"property",offset:y,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:v,offset:y,length:O,parent:a})},onObjectEnd:(v,y)=>{a.length=v+y-a.offset,a=a.parent,c(v+y)},onArrayBegin:(v,y)=>{a=s({type:"array",offset:v,length:-1,parent:a,children:[]})},onArrayEnd:(v,y)=>{a.length=v+y-a.offset,a=a.parent,c(v+y)},onLiteralValue:(v,y,O)=>{s({type:u(v),offset:y,length:O,parent:a,value:v}),c(y+O)},onSeparator:(v,y,O)=>{a.type==="property"&&(v===":"?a.colonOffset=y:v===","&&c(y))},onError:(v,y,O)=>{r.push({error:v,offset:y,length:O})}},i);const l=a.children[0];return l&&delete l.parent,l}e.parseTree=C;function d(n,r){if(!n)return;let i=n;for(const a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===a){i=s.children[1],c=!0;break}if(!c)return}else{const c=a;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=d;function S(n){if(!n.parent||!n.parent.children)return[];const r=S(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=S;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const r=Object.create(null);for(const i of n.children){const a=i.children[1];a&&(r[i.children[0].value]=w(a))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function h(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=h;function m(n,r,i=!1){if(h(n,r,i)){const a=n.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=r;c++){const s=m(a[c],r,i);if(s)return s}return n}}e.findNodeAtOffset=m;function g(n,r,i=L.DEFAULT){const a=A(n,!1);function c(x){return x?()=>x(a.getTokenOffset(),a.getTokenLength()):()=>!0}function s(x){return x?B=>x(B,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=c(r.onObjectBegin),l=s(r.onObjectProperty),v=c(r.onObjectEnd),y=c(r.onArrayBegin),O=c(r.onArrayEnd),_=s(r.onLiteralValue),N=s(r.onSeparator),R=c(r.onComment),M=s(r.onError),F=i&&i.disallowComments,j=i&&i.allowTrailingComma;function W(){for(;;){const x=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:F||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(x){case 12:case 13:F?z(10):R();break;case 16:z(1);break;case 15:case 14:break;default:return x}}}function z(x,B=[],U=[]){if(M(x),B.length+U.length>0){let $=a.getToken();for(;$!==17;){if(B.indexOf($)!==-1){W();break}else if(U.indexOf($)!==-1)break;$=W()}}}function te(x){const B=a.getTokenValue();return x?_(B):l(B),W(),!0}function G(){switch(a.getToken()){case 11:{let x=0;try{x=JSON.parse(a.getTokenValue()),typeof x!="number"&&(z(2),x=0)}catch{z(2)}_(x);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return W(),!0}function K(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(te(!1),a.getToken()===6?(N(":"),W(),q()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){o(),W();let x=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(x||z(4,[],[]),N(","),W(),a.getToken()===2&&j)break}else x&&z(6,[],[]);K()||z(4,[],[2,5]),x=!0}return v(),a.getToken()!==2?z(7,[2],[]):W(),!0}function Y(){y(),W();let x=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(x||z(4,[],[]),N(","),W(),a.getToken()===4&&j)break}else x&&z(6,[],[]);q()||z(4,[],[4,5]),x=!0}return O(),a.getToken()!==4?z(8,[4],[]):W(),!0}function q(){switch(a.getToken()){case 3:return Y();case 1:return X();case 10:return te(!0);default:return G()}}return W(),a.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):q()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=g;function f(n,r){const i=A(n),a=[];let c,s=0,o;do switch(o=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:s!==o&&a.push(n.substring(s,o)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),s=i.getPosition();break}while(c!==17);return a.join("")}e.stripComments=f;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(re[53],se([0,1,34]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,D,E){let p,C,d,S,w;if(D){for(S=D.offset,w=S+D.length,d=S;d>0&&!b(P,d-1);)d--;let o=w;for(;o<P.length&&!b(P,o);)o++;C=P.substring(d,o),p=A(C,E)}else C=P,p=0,d=0,S=0,w=P.length;const h=I(E,P);let m=!1,g=0,f;E.insertSpaces?f=L(" ",E.tabSize||4):f="	";const u=(0,k.createScanner)(C,!1);let n=!1;function r(){return h+L(f,p+g)}function i(){let o=u.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=u.scan();return n=o===16||u.getTokenError()!==0,o}const a=[];function c(o,l,v){!n&&l<w&&v>S&&P.substring(l,v)!==o&&a.push({offset:l,length:v-l,content:o})}let s=i();if(s!==17){const o=u.getTokenOffset()+d,l=L(f,p);c(l,d,o)}for(;s!==17;){let o=u.getTokenOffset()+u.getTokenLength()+d,l=i(),v="";for(;!m&&(l===12||l===13);){const O=u.getTokenOffset()+d;c(" ",o,O),o=u.getTokenOffset()+u.getTokenLength()+d,v=l===12?r():"",l=i()}if(l===2)s!==1&&(g--,v=r());else if(l===4)s!==3&&(g--,v=r());else{switch(s){case 3:case 1:g++,v=r();break;case 5:case 12:v=r();break;case 13:m?v=r():v=" ";break;case 6:v=" ";break;case 10:if(l===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?v=" ":l!==5&&l!==17&&(n=!0);break;case 16:n=!0;break}m&&(l===12||l===13)&&(v=r())}const y=u.getTokenOffset()+d;c(v,o,y),s=l}return a}e.format=t;function T(P,D){const E=JSON.stringify(P,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?E.replace(/\r\n|\r|\n/g,D.eol):E}e.toFormattedString=T;function L(P,D){let E="";for(let p=0;p<D;p++)E+=P;return E}function A(P,D){let E=0,p=0;const C=D.tabSize||4;for(;E<P.length;){const d=P.charAt(E);if(d===" ")p++;else if(d==="	")p+=C;else break;E++}return Math.floor(p/C)}function I(P,D){for(let E=0;E<D.length;E++){const p=D.charAt(E);if(p==="\r")return E+1<D.length&&D.charAt(E+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function b(P,D){return`\r
`.indexOf(P.charAt(D))!==-1}e.isEOL=b}),define(re[77],se([0,1,34,53]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(P,D,E){return L(P,D,void 0,E)}e.removeProperty=T;function L(P,D,E,p,C){const d=D.slice(),S=[],w=(0,k.parseTree)(P,S);let h,m;for(;d.length>0&&(m=d.pop(),h=(0,k.findNodeAtLocation)(w,d),h===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(h)if(h.type==="object"&&typeof m=="string"&&Array.isArray(h.children)){const g=(0,k.findNodeAtLocation)(h,[m]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const f=h.children.indexOf(g.parent);let u,n=g.parent.offset+g.parent.length;if(f>0){const r=h.children[f-1];u=r.offset+r.length}else u=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return A(P,{offset:u,length:n-u,content:""},p)}else return A(P,{offset:g.offset,length:g.length,content:JSON.stringify(E)},p);else{if(E===void 0)return[];const f=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,u=C?C(h.children.map(r=>r.children[0].value)):h.children.length;let n;if(u>0){const r=h.children[u-1];n={offset:r.offset+r.length,length:0,content:","+f}}else h.children.length===0?n={offset:h.offset+1,length:0,content:f}:n={offset:h.offset+1,length:0,content:f+","};return A(P,n,p)}}else if(h.type==="array"&&typeof m=="number"&&Array.isArray(h.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let f;if(h.children.length===0||m===0)f={offset:h.offset+1,length:0,content:h.children.length===0?g:g+","};else{const u=m===-1||m>h.children.length?h.children.length:m,n=h.children[u-1];f={offset:n.offset+n.length,length:0,content:","+g}}return A(P,f,p)}else{const g=m,f=h.children[g];let u;if(h.children.length===1)u={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===g){const n=h.children[g-1],r=n.offset+n.length,i=h.offset+h.length;u={offset:r,length:i-2-r,content:""}}else u={offset:f.offset,length:h.children[g+1].offset-f.offset,content:""};return A(P,u,p)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${h.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},p)}}e.setProperty=L;function A(P,D,E){let p=I(P,D),C=D.offset,d=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;C>0&&!(0,t.isEOL)(p,C-1);)C--;for(;d<p.length&&!(0,t.isEOL)(p,d);)d++}const S=(0,t.format)(p,{offset:C,length:d-C},E);for(let h=S.length-1;h>=0;h--){const m=S[h];p=I(p,m),C=Math.min(C,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const w=P.length-(p.length-d)-C;return[{offset:C,length:w,content:p.substring(C,d)}]}e.withFormatting=A;function I(P,D){return P.substring(0,D.offset)+D.content+P.substring(D.offset+D.length)}e.applyEdit=I;function b(P,D){const E=D.slice(0).sort((C,d)=>{const S=C.offset-d.offset;return S===0?C.length-d.length:S});let p=P.length;for(let C=E.length-1;C>=0;C--){const d=E[C];if(d.offset+d.length<=p)P=I(P,d);else throw new Error("Overlapping edit");p=d.offset}return P}e.applyEdits=b}),define(re[112],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new k(()=>T(this.getValue()))}}e.Lazy=k}),define(re[2],se([0,1,76,52]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let L=null;function A(c){L=c}if(e.setDisposableTracker=A,T){const c="__is_disposable_tracked__";A(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==m.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==m.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function I(c){return L?.trackDisposable(c),c}function b(c){L?.markAsDisposed(c)}function P(c,s){L?.setParent(c,s)}function D(c,s){if(!!L)for(const o of c)L.setParent(o,s)}function E(c){return L?.markAsSingleton(c),c}e.markAsSingleton=E;class p extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=p;function C(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=C;function d(c){if(t.Iterable.is(c)){const s=[];for(const o of c)if(o)try{o.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new p(s);return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=d;function S(...c){const s=w(()=>d(c));return D(c,s),s}e.combinedDisposable=S;function w(c){const s=I({dispose:(0,k.once)(()=>{b(s),c()})});return s}e.toDisposable=w;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return P(s,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new h,I(this),P(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&P(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&P(s,null),s}}e.MutableDisposable=g;class f{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(s){let o=s;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,b(this))},this}}e.SafeDisposable=u;class n{constructor(){this.references=new Map}acquire(s,...o){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,l));const{object:v}=l,y=(0,k.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:v,dispose:y}}}e.ReferenceCollection=n;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const l=this.referenceCollection.acquire(s,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(v){throw l.dispose(),v}}}e.AsyncReferenceCollection=r;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function a(c){const s=new h;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=a}),define(re[113],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(L){this.element=L,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let L=this._first;for(;L!==k.Undefined;){const A=L.next;L.prev=k.Undefined,L.next=k.Undefined,L=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const I=new k(L);if(this._first===k.Undefined)this._first=I,this._last=I;else if(A){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(I))}}shift(){if(this._first!==k.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==k.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==k.Undefined&&L.next!==k.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===k.Undefined&&L.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):L.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):L.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==k.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),function(){function Z(T){const L=[];typeof T=="number"&&L.push("code/timeOrigin",T);function A(b){L.push(b,Date.now())}function I(){const b=[];for(let P=0;P<L.length;P+=2)b.push({name:L[P],startTime:L[P+1]});return b}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(T+A.startTime)});return L}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function k(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:Z)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(Z){var e={};function k(t){if(e[t])return e[t].exports;var T=e[t]={i:t,l:!1,exports:{}};return Z[t].call(T.exports,T,T.exports,k),T.l=!0,T.exports}return k.m=Z,k.c=e,k.d=function(t,T,L){k.o(t,T)||Object.defineProperty(t,T,{enumerable:!0,get:L})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,T){if(1&T&&(t=k(t)),8&T||4&T&&typeof t=="object"&&t&&t.__esModule)return t;var L=Object.create(null);if(k.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:t}),2&T&&typeof t!="string")for(var A in t)k.d(L,A,function(I){return t[I]}.bind(null,A));return L},k.n=function(t){var T=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(T,"a",T),T},k.o=function(t,T){return Object.prototype.hasOwnProperty.call(t,T)},k.p="",k(k.s=0)}([function(Z,e,k){(function(t){var T;e=Z.exports=U,T=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],P=0,D=P++;b[D]="0|[1-9]\\d*";var E=P++;b[E]="[0-9]+";var p=P++;b[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=P++;b[C]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var d=P++;b[d]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var S=P++;b[S]="(?:"+b[D]+"|"+b[p]+")";var w=P++;b[w]="(?:"+b[E]+"|"+b[p]+")";var h=P++;b[h]="(?:-("+b[S]+"(?:\\."+b[S]+")*))";var m=P++;b[m]="(?:-?("+b[w]+"(?:\\."+b[w]+")*))";var g=P++;b[g]="[0-9A-Za-z-]+";var f=P++;b[f]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var u=P++,n="v?"+b[C]+b[h]+"?"+b[f]+"?";b[u]="^"+n+"$";var r="[v=\\s]*"+b[d]+b[m]+"?"+b[f]+"?",i=P++;b[i]="^"+r+"$";var a=P++;b[a]="((?:<|>)?=?)";var c=P++;b[c]=b[E]+"|x|X|\\*";var s=P++;b[s]=b[D]+"|x|X|\\*";var o=P++;b[o]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[h]+")?"+b[f]+"?)?)?";var l=P++;b[l]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[m]+")?"+b[f]+"?)?)?";var v=P++;b[v]="^"+b[a]+"\\s*"+b[o]+"$";var y=P++;b[y]="^"+b[a]+"\\s*"+b[l]+"$";var O=P++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=P++;b[_]="(?:~>?)";var N=P++;b[N]="(\\s*)"+b[_]+"\\s+",I[N]=new RegExp(b[N],"g");var R=P++;b[R]="^"+b[_]+b[o]+"$";var M=P++;b[M]="^"+b[_]+b[l]+"$";var F=P++;b[F]="(?:\\^)";var j=P++;b[j]="(\\s*)"+b[F]+"\\s+",I[j]=new RegExp(b[j],"g");var W=P++;b[W]="^"+b[F]+b[o]+"$";var z=P++;b[z]="^"+b[F]+b[l]+"$";var te=P++;b[te]="^"+b[a]+"\\s*("+r+")$|^$";var G=P++;b[G]="^"+b[a]+"\\s*("+n+")$|^$";var K=P++;b[K]="(\\s*)"+b[a]+"\\s*("+r+"|"+b[o]+")",I[K]=new RegExp(b[K],"g");var X=P++;b[X]="^\\s*("+b[o]+")\\s+-\\s+("+b[o]+")\\s*$";var Y=P++;b[Y]="^\\s*("+b[l]+")\\s+-\\s+("+b[l]+")\\s*$";var q=P++;b[q]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)T(x,b[x]),I[x]||(I[x]=new RegExp(b[x]));function B(oe,le){if(oe instanceof U)return oe;if(typeof oe!="string"||oe.length>L||!(le?I[i]:I[u]).test(oe))return null;try{return new U(oe,le)}catch{return null}}function U(oe,le){if(oe instanceof U){if(oe.loose===le)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(oe,le);T("SemVer",oe,le),this.loose=le;var he=oe.trim().match(le?I[i]:I[u]);if(!he)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Pe=+Ee;if(Pe>=0&&Pe<A)return Pe}return Ee}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=B,e.valid=function(oe,le){var he=B(oe,le);return he?he.version:null},e.clean=function(oe,le){var he=B(oe.trim().replace(/^[=v]+/,""),le);return he?he.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(oe){return T("SemVer.compare",this.version,this.loose,oe),oe instanceof U||(oe=new U(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},U.prototype.compareMain=function(oe){return oe instanceof U||(oe=new U(oe,this.loose)),V(this.major,oe.major)||V(this.minor,oe.minor)||V(this.patch,oe.patch)},U.prototype.comparePre=function(oe){if(oe instanceof U||(oe=new U(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var le=0;do{var he=this.prerelease[le],Ee=oe.prerelease[le];if(T("prerelease compare",le,he,Ee),he===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(he===void 0)return-1;if(he!==Ee)return V(he,Ee)}while(++le)},U.prototype.inc=function(oe,le){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,le,he,Ee){typeof he=="string"&&(Ee=he,he=void 0);try{return new U(oe,he).inc(le,Ee).version}catch{return null}},e.diff=function(oe,le){if(ne(oe,le))return null;var he=B(oe),Ee=B(le);if(he.prerelease.length||Ee.prerelease.length){for(var Pe in he)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&he[Pe]!==Ee[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in he)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&he[Pe]!==Ee[Pe])return Pe},e.compareIdentifiers=V;var $=/^[0-9]+$/;function V(oe,le){var he=$.test(oe),Ee=$.test(le);return he&&Ee&&(oe=+oe,le=+le),he&&!Ee?-1:Ee&&!he?1:oe<le?-1:oe>le?1:0}function J(oe,le,he){return new U(oe,he).compare(new U(le,he))}function H(oe,le,he){return J(oe,le,he)>0}function ee(oe,le,he){return J(oe,le,he)<0}function ne(oe,le,he){return J(oe,le,he)===0}function ae(oe,le,he){return J(oe,le,he)!==0}function ue(oe,le,he){return J(oe,le,he)>=0}function Se(oe,le,he){return J(oe,le,he)<=0}function fe(oe,le,he,Ee){var Pe;switch(le){case"===":typeof oe=="object"&&(oe=oe.version),typeof he=="object"&&(he=he.version),Pe=oe===he;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof he=="object"&&(he=he.version),Pe=oe!==he;break;case"":case"=":case"==":Pe=ne(oe,he,Ee);break;case"!=":Pe=ae(oe,he,Ee);break;case">":Pe=H(oe,he,Ee);break;case">=":Pe=ue(oe,he,Ee);break;case"<":Pe=ee(oe,he,Ee);break;case"<=":Pe=Se(oe,he,Ee);break;default:throw new TypeError("Invalid operator: "+le)}return Pe}function pe(oe,le){if(oe instanceof pe){if(oe.loose===le)return oe;oe=oe.value}if(!(this instanceof pe))return new pe(oe,le);T("comparator",oe,le),this.loose=le,this.parse(oe),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(oe,le){return V(le,oe)},e.major=function(oe,le){return new U(oe,le).major},e.minor=function(oe,le){return new U(oe,le).minor},e.patch=function(oe,le){return new U(oe,le).patch},e.compare=J,e.compareLoose=function(oe,le){return J(oe,le,!0)},e.rcompare=function(oe,le,he){return J(le,oe,he)},e.sort=function(oe,le){return oe.sort(function(he,Ee){return e.compare(he,Ee,le)})},e.rsort=function(oe,le){return oe.sort(function(he,Ee){return e.rcompare(he,Ee,le)})},e.gt=H,e.lt=ee,e.eq=ne,e.neq=ae,e.gte=ue,e.lte=Se,e.cmp=fe,e.Comparator=pe;var Ce={};function be(oe,le){if(oe instanceof be)return oe.loose===le?oe:new be(oe.raw,le);if(oe instanceof pe)return new be(oe.value,le);if(!(this instanceof be))return new be(oe,le);if(this.loose=le,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ie(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function qe(oe,le,he,Ee,Pe,Ue,Re,Ne,_e,Te,Me,ie,ce){return((le=Ie(he)?"":Ie(Ee)?">="+he+".0.0":Ie(Pe)?">="+he+"."+Ee+".0":">="+le)+" "+(Ne=Ie(_e)?"":Ie(Te)?"<"+(+_e+1)+".0.0":Ie(Me)?"<"+_e+"."+(+Te+1)+".0":ie?"<="+_e+"."+Te+"."+Me+"-"+ie:"<="+Ne)).trim()}function Qe(oe,le){for(var he=0;he<oe.length;he++)if(!oe[he].test(le))return!1;if(le.prerelease.length){for(he=0;he<oe.length;he++)if(T(oe[he].semver),oe[he].semver!==Ce&&oe[he].semver.prerelease.length>0){var Ee=oe[he].semver;if(Ee.major===le.major&&Ee.minor===le.minor&&Ee.patch===le.patch)return!0}return!1}return!0}function Ke(oe,le,he){try{le=new be(le,he)}catch{return!1}return le.test(oe)}function Ye(oe,le,he,Ee){var Pe,Ue,Re,Ne,_e;switch(oe=new U(oe,Ee),le=new be(le,Ee),he){case">":Pe=H,Ue=Se,Re=ee,Ne=">",_e=">=";break;case"<":Pe=ee,Ue=ue,Re=H,Ne="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ke(oe,le,Ee))return!1;for(var Te=0;Te<le.set.length;++Te){var Me=le.set[Te],ie=null,ce=null;if(Me.forEach(function(de){de.semver===Ce&&(de=new pe(">=0.0.0")),ie=ie||de,ce=ce||de,Pe(de.semver,ie.semver,Ee)?ie=de:Re(de.semver,ce.semver,Ee)&&(ce=de)}),ie.operator===Ne||ie.operator===_e||(!ce.operator||ce.operator===Ne)&&Ue(oe,ce.semver)||ce.operator===_e&&Re(oe,ce.semver))return!1}return!0}pe.prototype.parse=function(oe){var le=this.loose?I[te]:I[G],he=oe.match(le);if(!he)throw new TypeError("Invalid comparator: "+oe);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new U(he[2],this.loose):this.semver=Ce},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(oe){return T("Comparator.test",oe,this.loose),this.semver===Ce||(typeof oe=="string"&&(oe=new U(oe,this.loose)),fe(oe,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(oe,le){if(!(oe instanceof pe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new be(oe.value,le),Ke(this.value,he,le);if(oe.operator==="")return he=new be(this.value,le),Ke(oe.semver,he,le);var Ee=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Ue=this.semver.version===oe.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Ne=fe(this.semver,"<",oe.semver,le)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),_e=fe(this.semver,">",oe.semver,le)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ee||Pe||Ue&&Re||Ne||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(oe){var le=this.loose;oe=oe.trim(),T("range",oe,le);var he=le?I[Y]:I[X];oe=oe.replace(he,qe),T("hyphen replace",oe),oe=oe.replace(I[K],"$1$2$3"),T("comparator trim",oe,I[K]),oe=(oe=(oe=oe.replace(I[N],"$1~")).replace(I[j],"$1^")).split(/\s+/).join(" ");var Ee=le?I[te]:I[G],Pe=oe.split(" ").map(function(Ue){return function(Re,Ne){return T("comp",Re),Re=function(_e,Te){return _e.trim().split(/\s+/).map(function(Me){return function(ie,ce){T("caret",ie,ce);var de=ce?I[z]:I[W];return ie.replace(de,function(ve,ge,we,De,ke){var Le;return T("caret",ie,ve,ge,we,De,ke),Ie(ge)?Le="":Ie(we)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(De)?Le=ge==="0"?">="+ge+"."+we+".0 <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+".0 <"+(+ge+1)+".0.0":ke?(T("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ge==="0"?we==="0"?">="+ge+"."+we+"."+De+ke+" <"+ge+"."+we+"."+(+De+1):">="+ge+"."+we+"."+De+ke+" <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+"."+De+ke+" <"+(+ge+1)+".0.0"):(T("no pr"),Le=ge==="0"?we==="0"?">="+ge+"."+we+"."+De+" <"+ge+"."+we+"."+(+De+1):">="+ge+"."+we+"."+De+" <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+"."+De+" <"+(+ge+1)+".0.0"),T("caret return",Le),Le})}(Me,Te)}).join(" ")}(Re,Ne),T("caret",Re),Re=function(_e,Te){return _e.trim().split(/\s+/).map(function(Me){return function(ie,ce){var de=ce?I[M]:I[R];return ie.replace(de,function(ve,ge,we,De,ke){var Le;return T("tilde",ie,ve,ge,we,De,ke),Ie(ge)?Le="":Ie(we)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(De)?Le=">="+ge+"."+we+".0 <"+ge+"."+(+we+1)+".0":ke?(T("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ge+"."+we+"."+De+ke+" <"+ge+"."+(+we+1)+".0"):Le=">="+ge+"."+we+"."+De+" <"+ge+"."+(+we+1)+".0",T("tilde return",Le),Le})}(Me,Te)}).join(" ")}(Re,Ne),T("tildes",Re),Re=function(_e,Te){return T("replaceXRanges",_e,Te),_e.split(/\s+/).map(function(Me){return function(ie,ce){ie=ie.trim();var de=ce?I[y]:I[v];return ie.replace(de,function(ve,ge,we,De,ke,Le){T("xRange",ie,ve,ge,we,De,ke,Le);var Ae=Ie(we),Fe=Ae||Ie(De),$e=Fe||Ie(ke);return ge==="="&&$e&&(ge=""),Ae?ve=ge===">"||ge==="<"?"<0.0.0":"*":ge&&$e?(Fe&&(De=0),$e&&(ke=0),ge===">"?(ge=">=",Fe?(we=+we+1,De=0,ke=0):$e&&(De=+De+1,ke=0)):ge==="<="&&(ge="<",Fe?we=+we+1:De=+De+1),ve=ge+we+"."+De+"."+ke):Fe?ve=">="+we+".0.0 <"+(+we+1)+".0.0":$e&&(ve=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),T("xRange return",ve),ve})}(Me,Te)}).join(" ")}(Re,Ne),T("xrange",Re),Re=function(_e,Te){return T("replaceStars",_e,Te),_e.trim().replace(I[q],"")}(Re,Ne),T("stars",Re),Re}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(Ee)})),Pe=Pe.map(function(Ue){return new pe(Ue,le)})},be.prototype.intersects=function(oe,le){if(!(oe instanceof be))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ee){return oe.set.some(function(Pe){return Pe.every(function(Ue){return Ee.intersects(Ue,le)})})})})},e.toComparators=function(oe,le){return new be(oe,le).set.map(function(he){return he.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},be.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new U(oe,this.loose));for(var le=0;le<this.set.length;le++)if(Qe(this.set[le],oe))return!0;return!1},e.satisfies=Ke,e.maxSatisfying=function(oe,le,he){var Ee=null,Pe=null;try{var Ue=new be(le,he)}catch{return null}return oe.forEach(function(Re){Ue.test(Re)&&(Ee&&Pe.compare(Re)!==-1||(Pe=new U(Ee=Re,he)))}),Ee},e.minSatisfying=function(oe,le,he){var Ee=null,Pe=null;try{var Ue=new be(le,he)}catch{return null}return oe.forEach(function(Re){Ue.test(Re)&&(Ee&&Pe.compare(Re)!==1||(Pe=new U(Ee=Re,he)))}),Ee},e.validRange=function(oe,le){try{return new be(oe,le).range||"*"}catch{return null}},e.ltr=function(oe,le,he){return Ye(oe,le,"<",he)},e.gtr=function(oe,le,he){return Ye(oe,le,">",he)},e.outside=Ye,e.prerelease=function(oe,le){var he=B(oe,le);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(oe,le,he){return oe=new be(oe,he),le=new be(le,he),oe.intersects(le)},e.coerce=function(oe){if(oe instanceof U)return oe;if(typeof oe!="string")return null;var le=oe.match(I[O]);return le==null?null:B((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,k(1))},function(Z,e){var k,t,T=Z.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(w){if(k===setTimeout)return setTimeout(w,0);if((k===L||!k)&&setTimeout)return k=setTimeout,setTimeout(w,0);try{return k(w,0)}catch{try{return k.call(null,w,0)}catch{return k.call(this,w,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:L}catch{k=L}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var b,P=[],D=!1,E=-1;function p(){D&&b&&(D=!1,b.length?P=b.concat(P):E=-1,P.length&&C())}function C(){if(!D){var w=I(p);D=!0;for(var h=P.length;h;){for(b=P,P=[];++E<h;)b&&b[E].run();E=-1,h=P.length}b=null,D=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(w)}}function d(w,h){this.fun=w,this.array=h}function S(){}T.nextTick=function(w){var h=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)h[m-1]=arguments[m];P.push(new d(w,h)),P.length!==1||D||I(C)},d.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=S,T.addListener=S,T.once=S,T.off=S,T.removeListener=S,T.removeAllListeners=S,T.emit=S,T.prependListener=S,T.prependOnceListener=S,T.listeners=function(w){return[]},T.binding=function(w){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(w){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(re[114],se([0,1]),function(Z,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,b,P){this.level=I,this.key=b,this.value=P,this.forward=[]}}const T=void 0;class L{constructor(I,b=2**16){this.comparator=I,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new t(this._maxLevel,T,T)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,T,T)}has(I){return Boolean(L._search(this,I,this.comparator))}get(I){return L._search(this,I,this.comparator)?.value}set(I,b){return L._insert(this,I,b,this.comparator)&&(this._size+=1),this}delete(I){const b=L._delete(this,I,this.comparator);return b&&(this._size-=1),b}forEach(I,b){let P=this._header.forward[0];for(;P;)I.call(b,P.value,P.key,this),P=P.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this._header.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static _search(I,b,P){let D=I._header;for(let E=I._level-1;E>=0;E--)for(;D.forward[E]&&P(D.forward[E].key,b)<0;)D=D.forward[E];if(D=D.forward[0],D&&P(D.key,b)===0)return D}static _insert(I,b,P,D){const E=[];let p=I._header;for(let C=I._level-1;C>=0;C--){for(;p.forward[C]&&D(p.forward[C].key,b)<0;)p=p.forward[C];E[C]=p}if(p=p.forward[0],p&&D(p.key,b)===0)return p.value=P,!1;{const C=L._randomLevel(I);if(C>I._level){for(let d=I._level;d<C;d++)E[d]=I._header;I._level=C}p=new t(C,b,P);for(let d=0;d<C;d++)p.forward[d]=E[d].forward[d],E[d].forward[d]=p;return!0}}static _randomLevel(I,b=.5){let P=1;for(;Math.random()<b&&P<I._maxLevel;)P+=1;return P}static _delete(I,b,P){const D=[];let E=I._header;for(let p=I._level-1;p>=0;p--){for(;E.forward[p]&&P(E.forward[p].key,b)<0;)E=E.forward[p];D[p]=E}if(E=E.forward[0],!E||P(E.key,b)!==0)return!1;for(let p=0;p<I._level&&D[p].forward[p]===E;p++)D[p].forward[p]=E.forward[p];for(;I._level>0&&I._header.forward[I._level-1]===T;)I._level-=1;return!0}}e.SkipList=L}),define(re[41],se([0,1,9,2]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(f){const u=f;return u?typeof u.read=="function":!1}e.isReadable=T;function L(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function A(f){const u=f;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(f,u){return new b(f,u)}e.newWriteableStream=I;class b{constructor(u,n){this.reducer=u,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(n=>n(u))}emitError(u){this.listeners.error.length===0?(0,k.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(n=>n(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,n){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(u,n){if(this.state.destroyed)return;let r;switch(u){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(f,u){const n=[];let r;for(;(r=f.read())!==null;)n.push(r);return u(n)}e.consumeReadable=P;function D(f,u,n){const r=[];let i;for(;(i=f.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?u(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const a=i;return i=void 0,a}return f.read()}}}e.peekReadable=D;function E(f,u){return new Promise((n,r)=>{const i=[];p(f,{onData:a=>{u&&i.push(a)},onError:a=>{u?r(a):n(void 0)},onEnd:()=>{n(u?u(i):void 0)}})})}e.consumeStream=E;function p(f,u){let n=!1;return f.on("error",r=>{n||u.onError(r)}),f.on("end",()=>{n||u.onEnd()}),f.on("data",r=>{n||u.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=p;function C(f,u){return new Promise((n,r)=>{const i=new t.DisposableStore,a=[],c=l=>{if(a.push(l),a.length>u)return i.dispose(),f.pause(),n({stream:f,buffer:a,ended:!1})},s=l=>r(l),o=()=>n({stream:f,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),i.add((0,t.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),i.add((0,t.toDisposable)(()=>f.removeListener("data",c))),f.on("data",c)})}e.peekStream=C;function d(f,u){const n=I(u);return n.end(f),n}e.toStream=d;function S(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function w(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=w;function h(f,u,n){const r=I(n);return p(f,{onData:i=>r.write(u.data(i)),onError:i=>r.error(u.error?u.error(i):i),onEnd:()=>r.end()}),r}e.transform=h;function m(f,u,n){let r=!1;return{read:()=>{const i=u.read();return r?i:(r=!0,i!==null?n([f,i]):f)}}}e.prefixedReadable=m;function g(f,u,n){let r=!1;const i=I(n);return p(u,{onData:a=>r?i.write(a):(r=!0,i.write(n([f,a]))),onError:a=>i.error(a),onEnd:()=>{r||(r=!0,i.write(f)),i.end()}}),i}e.prefixedStream=g}),define(re[16],se([0,1,41]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let T,L;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return t?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return t&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,v){return!(v?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(l)):(T||(T=new TextEncoder),new A(T.encode(l)))}static fromByteArray(l){const v=A.alloc(l.length);for(let y=0,O=l.length;y<O;y++)v.buffer[y]=l[y];return v}static concat(l,v){if(typeof v=="undefined"){v=0;for(let _=0,N=l.length;_<N;_++)v+=l[_].byteLength}const y=A.alloc(v);let O=0;for(let _=0,N=l.length;_<N;_++){const R=l[_];y.set(R,O),O+=R.byteLength}return y}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(l,v){return new A(this.buffer.subarray(l,v))}set(l,v){if(l instanceof A)this.buffer.set(l.buffer,v);else if(l instanceof Uint8Array)this.buffer.set(l,v);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),v);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return P(this.buffer,l)}writeUInt32BE(l,v){D(this.buffer,l,v)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,v){p(this.buffer,l,v)}readUInt8(l){return C(this.buffer,l)}writeUInt8(l,v){d(this.buffer,l,v)}}e.VSBuffer=A;function I(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=I;function b(o,l,v){o[v+0]=l&255,l=l>>>8,o[v+1]=l&255}e.writeUInt16LE=b;function P(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=P;function D(o,l,v){o[v+3]=l,l=l>>>8,o[v+2]=l,l=l>>>8,o[v+1]=l,l=l>>>8,o[v]=l}e.writeUInt32BE=D;function E(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=E;function p(o,l,v){o[v+0]=l&255,l=l>>>8,o[v+1]=l&255,l=l>>>8,o[v+2]=l&255,l=l>>>8,o[v+3]=l&255}e.writeUInt32LE=p;function C(o,l){return o[l]}e.readUInt8=C;function d(o,l,v){o[v]=l}e.writeUInt8=d;function S(o){return k.consumeReadable(o,l=>A.concat(l))}e.readableToBuffer=S;function w(o){return k.toReadable(o)}e.bufferToReadable=w;function h(o){return k.consumeStream(o,l=>A.concat(l))}e.streamToBuffer=h;async function m(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await h(o.stream)])}e.bufferedStreamToBuffer=m;function g(o){return k.toStream(o,l=>A.concat(l))}e.bufferToStream=g;function f(o){return k.transform(o,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=f;function u(o){return k.newWriteableStream(l=>A.concat(l),o)}e.newWriteableBufferStream=u;function n(o,l){return k.prefixedReadable(o,l,v=>A.concat(v))}e.prefixedBufferReadable=n;function r(o,l){return k.prefixedStream(o,l,v=>A.concat(v))}e.prefixedBufferStream=r;function i(o){let l=0,v=0,y=0;const O=new Uint8Array(Math.floor(o.length/4*3)),_=R=>{switch(v){case 3:O[y++]=l|R,v=0;break;case 2:O[y++]=l|R>>>2,l=R<<6,v=3;break;case 1:O[y++]=l|R>>>4,l=R<<4,v=2;break;default:l=R<<2,v=1}};for(let R=0;R<o.length;R++){const M=o.charCodeAt(R);if(M>=65&&M<=90)_(M-65);else if(M>=97&&M<=122)_(M-97+26);else if(M>=48&&M<=57)_(M-48+52);else if(M===43||M===45)_(62);else if(M===47||M===95)_(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${o[R]}`)}}const N=y;for(;v>0;)_(0);return A.wrap(O).slice(0,N)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:o},l=!0,v=!1){const y=v?c:a;let O="";const _=o.byteLength%3;let N=0;for(;N<o.byteLength-_;N+=3){const R=o[N+0],M=o[N+1],F=o[N+2];O+=y[R>>>2],O+=y[(R<<4|M>>>4)&63],O+=y[(M<<2|F>>>6)&63],O+=y[F&63]}if(_===1){const R=o[N+0];O+=y[R>>>2],O+=y[R<<4&63],l&&(O+="==")}else if(_===2){const R=o[N+0],M=o[N+1];O+=y[R>>>2],O+=y[(R<<4|M>>>4)&63],O+=y[M<<2&63],l&&(O+="=")}return O}e.encodeBase64=s}),define(re[14],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(o){return Array.isArray(o)}e.isArray=k;function t(o){return typeof o=="string"}e.isString=t;function T(o){return Array.isArray(o)&&o.every(l=>t(l))}e.isStringArray=T;function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=L;function A(o){return typeof o=="object"&&(o instanceof Uint8Array||o instanceof Uint16Array||o instanceof Uint32Array||o instanceof Float32Array||o instanceof Float64Array||o instanceof Int8Array||o instanceof Int16Array||o instanceof Int32Array||o instanceof BigInt64Array||o instanceof BigUint64Array||o instanceof Uint8ClampedArray)}e.isTypedArray=A;function I(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=I;function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=b;function P(o){return o===!0||o===!1}e.isBoolean=P;function D(o){return typeof o=="undefined"}e.isUndefined=D;function E(o){return!p(o)}e.isDefined=E;function p(o){return D(o)||o===null}e.isUndefinedOrNull=p;function C(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=C;function d(o){if(p(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=d;function S(...o){const l=[];for(let v=0;v<o.length;v++){const y=o[v];if(p(y))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);l.push(y)}return l}e.assertAllDefined=S;const w=Object.prototype.hasOwnProperty;function h(o){if(!L(o))return!1;for(const l in o)if(w.call(o,l))return!1;return!0}e.isEmptyObject=h;function m(o){return typeof o=="function"}e.isFunction=m;function g(...o){return o.length>0&&o.every(m)}e.areFunctions=g;function f(o,l){const v=Math.min(o.length,l.length);for(let y=0;y<v;y++)u(o[y],l[y])}e.validateConstraints=f;function u(o,l){if(t(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(m(l)){try{if(o instanceof l)return}catch{}if(!p(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function n(o){let l=[],v=Object.getPrototypeOf(o);for(;Object.prototype!==v;)l=l.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return l}e.getAllPropertyNames=n;function r(o){const l=[];for(const v of n(o))typeof o[v]=="function"&&l.push(v);return l}e.getAllMethodNames=r;function i(o,l){const v=O=>function(){const _=Array.prototype.slice.call(arguments,0);return l(O,_)},y={};for(const O of o)y[O]=v(O);return y}e.createProxyObject=i;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function c(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=c;function s(o,l="Unreachable"){throw new Error(l)}e.assertNever=s}),define(re[29],se([0,1,14]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?S[w]=t(d[w]):S[w]=d[w]}),S}e.deepClone=t;function T(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const h in w)if(L.call(w,h)){const m=w[h];typeof m=="object"&&!Object.isFrozen(m)&&!(0,k.isTypedArray)(m)&&S.push(m)}}return d}e.deepFreeze=T;const L=Object.prototype.hasOwnProperty;function A(d,S){return I(d,S,new Set)}e.cloneAndChange=A;function I(d,S,w){if((0,k.isUndefinedOrNull)(d))return d;const h=S(d);if(typeof h!="undefined")return h;if((0,k.isArray)(d)){const m=[];for(const g of d)m.push(I(g,S,w));return m}if((0,k.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const m={};for(const g in d)L.call(d,g)&&(m[g]=I(d[g],S,w));return w.delete(d),m}return d}function b(d,S,w=!0){return(0,k.isObject)(d)?((0,k.isObject)(S)&&Object.keys(S).forEach(h=>{h in d?w&&((0,k.isObject)(d[h])&&(0,k.isObject)(S[h])?b(d[h],S[h],w):d[h]=S[h]):d[h]=S[h]}),d):S}e.mixin=b;function P(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let w,h;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(w=0;w<d.length;w++)if(!P(d[w],S[w]))return!1}else{const m=[];for(h in d)m.push(h);m.sort();const g=[];for(h in S)g.push(h);if(g.sort(),!P(m,g))return!1;for(w=0;w<m.length;w++)if(!P(d[m[w]],S[m[w]]))return!1}return!0}e.equals=P;function D(d){const S=new Set;return JSON.stringify(d,(w,h)=>{if((0,k.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}e.safeStringify=D;function E(d,S){const w=Object.create(null);return!d||!S||Object.keys(S).forEach(m=>{const g=d[m],f=S[m];P(g,f)||(w[m]=f)}),w}e.distinct=E;function p(d,S){const w=S.toLowerCase(),h=Object.keys(d).find(m=>m.toLowerCase()===w);return h?d[h]:d[S]}e.getCaseInsensitive=p;function C(d,S){const w=Object.create(null);for(const[h,m]of Object.entries(d))S(h,m)&&(w[h]=m);return w}e.filter=C}),define(re[31],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(T){return k.test(T)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){T(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,P="";return P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+="-",P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P+=A[L[b++]],P}}()}),define(re[115],se([0,1,266]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(L="utf8"){this.stringDecoder=new k.StringDecoder(L),this.remaining=null}write(L){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(I.length<1)return A;let b=0,P,D=b;for(;D<I.length;)if(P=I.charCodeAt(D),P===13||P===10){if(A.push(I.substring(b,D)),D++,D<I.length){const E=P;P=I.charCodeAt(D),(E===13&&P===10||E===10&&P===13)&&D++}b=D}else D++;return this.remaining=b<I.length?I.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(re[116],se([0,1,35]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function T(A){const I=A.replace(/\-/g,":").toLowerCase();return!t.has(I)}function L(){const A=(0,k.networkInterfaces)();for(const I in A){const b=A[I];if(b){for(const{mac:P}of b)if(T(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(re[117],se([0,1,61]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,b,P,D=1){let E=!1;return new Promise(p=>{const C=setTimeout(()=>{if(!E)return E=!0,p(0)},P);T(I,b,D,d=>{if(!E)return E=!0,clearTimeout(C),p(d)})})}e.findFreePort=t;function T(I,b,P,D){if(b===0)return D(0);const E=new k.Socket;E.once("connect",()=>(A(E),T(I+P,b-1,P,D))),E.once("data",()=>{}),E.once("error",p=>(A(E),p.code!=="ECONNREFUSED"?T(I+P,b-1,P,D):D(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,b,P){let D=!1,E,p=1;const C=k.createServer({pauseOnConnect:!0});function d(S,w){D||(D=!0,C.removeAllListeners(),C.close(),E&&clearTimeout(E),w(S))}return new Promise(S=>{E=setTimeout(()=>{d(0,S)},P),C.on("listening",()=>{d(I,S)}),C.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&p<b?(I++,p++,C.listen(I,"127.0.0.1")):d(0,S)}),C.on("close",()=>{d(0,S)}),C.listen(I,"127.0.0.1")})}e.findFreePortFaster=L;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),define(re[118],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function t(L){return L instanceof T?!0:L instanceof Error&&L.name===k&&L.message===k}e.isOfflineError=t;class T extends Error{constructor(){super(k);this.name=this.message}}e.OfflineError=T}),define(re[119],se([0,1,16,9,118]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(b,P){if(!navigator.onLine)throw new T.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const D=new XMLHttpRequest;return new Promise((E,p)=>{D.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(D,b),D.responseType="arraybuffer",D.onerror=C=>p(new Error(D.statusText&&"XHR failed: "+D.statusText||"XHR failed")),D.onload=C=>{E({res:{statusCode:D.status,headers:I(D)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(D.response)))})},D.ontimeout=C=>p(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(D.timeout=b.timeout),D.send(b.data),P.onCancellationRequested(()=>{D.abort(),p((0,t.canceled)())})})}e.request=L;function A(b,P){if(P.headers){e:for(const D in P.headers){switch(D){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(D,P.headers[D])}}}function I(b){const P=Object.create(null);for(const D of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(D){const E=D.indexOf(":");P[D.substr(0,E).trim().toLowerCase()]=D.substr(E+1).trim()}return P}}),define(re[120],se([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(re[62],se([0,1,120]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,T=t*60,L=T*24,A=L*7,I=L*30,b=L*365;function P(E,p,C){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,k.localize)(0,null,P(new Date().getTime()+d*1e3,!1));if(d<30)return(0,k.localize)(1,null);let S;return d<t?(S=d,p?S===1?C?(0,k.localize)(2,null,S):(0,k.localize)(3,null,S):C?(0,k.localize)(4,null,S):(0,k.localize)(5,null,S):S===1?C?(0,k.localize)(6,null,S):(0,k.localize)(7,null,S):C?(0,k.localize)(8,null,S):(0,k.localize)(9,null,S)):d<T?(S=Math.floor(d/t),p?S===1?C?(0,k.localize)(10,null,S):(0,k.localize)(11,null,S):C?(0,k.localize)(12,null,S):(0,k.localize)(13,null,S):S===1?C?(0,k.localize)(14,null,S):(0,k.localize)(15,null,S):C?(0,k.localize)(16,null,S):(0,k.localize)(17,null,S)):d<L?(S=Math.floor(d/T),p?S===1?C?(0,k.localize)(18,null,S):(0,k.localize)(19,null,S):C?(0,k.localize)(20,null,S):(0,k.localize)(21,null,S):S===1?C?(0,k.localize)(22,null,S):(0,k.localize)(23,null,S):C?(0,k.localize)(24,null,S):(0,k.localize)(25,null,S)):d<A?(S=Math.floor(d/L),p?S===1?(0,k.localize)(26,null,S):(0,k.localize)(27,null,S):S===1?(0,k.localize)(28,null,S):(0,k.localize)(29,null,S)):d<I?(S=Math.floor(d/A),p?S===1?C?(0,k.localize)(30,null,S):(0,k.localize)(31,null,S):C?(0,k.localize)(32,null,S):(0,k.localize)(33,null,S):S===1?C?(0,k.localize)(34,null,S):(0,k.localize)(35,null,S):C?(0,k.localize)(36,null,S):(0,k.localize)(37,null,S)):d<b?(S=Math.floor(d/I),p?S===1?C?(0,k.localize)(38,null,S):(0,k.localize)(39,null,S):C?(0,k.localize)(40,null,S):(0,k.localize)(41,null,S):S===1?C?(0,k.localize)(42,null,S):(0,k.localize)(43,null,S):C?(0,k.localize)(44,null,S):(0,k.localize)(45,null,S)):(S=Math.floor(d/b),p?S===1?C?(0,k.localize)(46,null,S):(0,k.localize)(47,null,S):C?(0,k.localize)(48,null,S):(0,k.localize)(49,null,S):S===1?C?(0,k.localize)(50,null,S):(0,k.localize)(51,null,S):C?(0,k.localize)(52,null,S):(0,k.localize)(53,null,S))}e.fromNow=P;function D(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(re[121],se([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(re[37],se([0,1,17,14,121]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(E,p){return p&&(E.stack||E.stacktrace)?T.localize(0,null,I(E),A(E.stack)||A(E.stacktrace)):I(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function I(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?T.localize(1,null,E.message):E.message||T.localize(2,null)}function b(E=null,p=!1){if(!E)return T.localize(3,null);if(Array.isArray(E)){const C=k.coalesce(E),d=b(C[0],p);return C.length>1?T.localize(4,null,d,C.length):d}if(t.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return L(C.error,p);if(C.exception)return L(C.exception,p)}return E.stack?L(E,p):E.message?E.message:T.localize(5,null)}e.toErrorMessage=b;function P(E){const p=E;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=P;function D(E,p){let C;return typeof E=="string"?C=new Error(E):C=E,C.actions=p,C}e.createErrorWithActions=D}),define(re[122],se([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(re[123],se([0,1,122]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(T){switch(T){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(re[124],se([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(re[4],se([0,1,124]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let T=!1,L=!1,A=!1,I=!1,b=!1,P=!1,D=!1,E=!1,p=!1,C,d=t,S,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const m=typeof h?.versions?.electron=="string",g=m&&h?.type==="renderer";if(typeof navigator=="object"&&!g)w=navigator.userAgent,T=w.indexOf("Windows")>=0,L=w.indexOf("Macintosh")>=0,E=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=w.indexOf("Linux")>=0,P=!0,C=k.getConfiguredDefaultLocale(k.localize(0,null))||t,d=C;else if(typeof h=="object"){T=h.platform==="win32",L=h.platform==="darwin",A=h.platform==="linux",I=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=m,p=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=t,d=t;const o=h.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),v=l.availableLanguages["*"];C=l.locale,d=v||t,S=l._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var f;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function u(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let n=0;L?n=1:T?n=3:A&&(n=2),e.isWindows=T,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=I,e.isNative=b,e.isElectron=D,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isCI=p,e.platform=n,e.userAgent=w,e.language=d;var r;(function(o){function l(){return e.language}o.value=l;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=v;function y(){return e.language==="en"}o.isDefault=y})(r=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let y=0,O=o.length;y<O;y++){const _=o[y];if(_.id===v.data.vscodeScheduleAsyncWork){o.splice(y,1),_.callback();return}}});let l=0;return v=>{const y=++l;o.push({id:y,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||E?2:T?1:3;let a=!0,c=!1;function s(){if(!c){c=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const T=k.globals.vscode.process;t={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(re[12],se([0,1,36]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,T=97,L=90,A=122,I=46,b=47,P=92,D=58,E=63;class p extends Error{constructor(f,u,n){let r;typeof u=="string"&&u.indexOf("not ")===0?(r="must not be",u=u.replace(/^not /,"")):r="must be";const i=f.indexOf(".")!==-1?"property":"argument";let a=`The "${f}" ${i} ${r} of type ${u}`;a+=`. Received type ${typeof n}`;super(a);this.code="ERR_INVALID_ARG_TYPE"}}function C(g,f){if(typeof g!="string")throw new p(f,"string",g)}function d(g){return g===b||g===P}function S(g){return g===b}function w(g){return g>=t&&g<=L||g>=T&&g<=A}function h(g,f,u,n){let r="",i=0,a=-1,c=0,s=0;for(let o=0;o<=g.length;++o){if(o<g.length)s=g.charCodeAt(o);else{if(n(s))break;s=b}if(n(s)){if(!(a===o-1||c===1))if(c===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==I||r.charCodeAt(r.length-2)!==I){if(r.length>2){const l=r.lastIndexOf(u);l===-1?(r="",i=0):(r=r.slice(0,l),i=r.length-1-r.lastIndexOf(u)),a=o,c=0;continue}else if(r.length!==0){r="",i=0,a=o,c=0;continue}}f&&(r+=r.length>0?`${u}..`:"..",i=2)}else r.length>0?r+=`${u}${g.slice(a+1,o)}`:r=g.slice(a+1,o),i=o-a-1;a=o,c=0}else s===I&&c!==-1?++c:c=-1}return r}function m(g,f){if(f===null||typeof f!="object")throw new p("pathObject","Object",f);const u=f.dir||f.root,n=f.base||`${f.name||""}${f.ext||""}`;return u?u===f.root?`${u}${n}`:`${u}${g}${n}`:n}e.win32={resolve(...g){let f="",u="",n=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],C(i,"path"),i.length===0)continue}else f.length===0?i=k.cwd():(i=k.env[`=${f}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${f}\\`));const a=i.length;let c=0,s="",o=!1;const l=i.charCodeAt(0);if(a===1)d(l)&&(c=1,o=!0);else if(d(l))if(o=!0,d(i.charCodeAt(1))){let v=2,y=v;for(;v<a&&!d(i.charCodeAt(v));)v++;if(v<a&&v!==y){const O=i.slice(y,v);for(y=v;v<a&&d(i.charCodeAt(v));)v++;if(v<a&&v!==y){for(y=v;v<a&&!d(i.charCodeAt(v));)v++;(v===a||v!==y)&&(s=`\\\\${O}\\${i.slice(y,v)}`,c=v)}}}else c=1;else w(l)&&i.charCodeAt(1)===D&&(s=i.slice(0,2),c=2,a>2&&d(i.charCodeAt(2))&&(o=!0,c=3));if(s.length>0)if(f.length>0){if(s.toLowerCase()!==f.toLowerCase())continue}else f=s;if(n){if(f.length>0)break}else if(u=`${i.slice(c)}\\${u}`,n=o,o&&f.length>0)break}return u=h(u,!n,"\\",d),n?`${f}\\${u}`:`${f}${u}`||"."},normalize(g){C(g,"path");const f=g.length;if(f===0)return".";let u=0,n,r=!1;const i=g.charCodeAt(0);if(f===1)return S(i)?"\\":g;if(d(i))if(r=!0,d(g.charCodeAt(1))){let c=2,s=c;for(;c<f&&!d(g.charCodeAt(c));)c++;if(c<f&&c!==s){const o=g.slice(s,c);for(s=c;c<f&&d(g.charCodeAt(c));)c++;if(c<f&&c!==s){for(s=c;c<f&&!d(g.charCodeAt(c));)c++;if(c===f)return`\\\\${o}\\${g.slice(s)}\\`;c!==s&&(n=`\\\\${o}\\${g.slice(s,c)}`,u=c)}}}else u=1;else w(i)&&g.charCodeAt(1)===D&&(n=g.slice(0,2),u=2,f>2&&d(g.charCodeAt(2))&&(r=!0,u=3));let a=u<f?h(g.slice(u),!r,"\\",d):"";return a.length===0&&!r&&(a="."),a.length>0&&d(g.charCodeAt(f-1))&&(a+="\\"),n===void 0?r?`\\${a}`:a:r?`${n}\\${a}`:`${n}${a}`},isAbsolute(g){C(g,"path");const f=g.length;if(f===0)return!1;const u=g.charCodeAt(0);return d(u)||f>2&&w(u)&&g.charCodeAt(1)===D&&d(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let f,u;for(let i=0;i<g.length;++i){const a=g[i];C(a,"path"),a.length>0&&(f===void 0?f=u=a:f+=`\\${a}`)}if(f===void 0)return".";let n=!0,r=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++r;const i=u.length;i>1&&d(u.charCodeAt(1))&&(++r,i>2&&(d(u.charCodeAt(2))?++r:n=!1))}if(n){for(;r<f.length&&d(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(g,f){if(C(g,"from"),C(f,"to"),g===f)return"";const u=e.win32.resolve(g),n=e.win32.resolve(f);if(u===n||(g=u.toLowerCase(),f=n.toLowerCase(),g===f))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===P;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===P;)i--;const a=i-r;let c=0;for(;c<f.length&&f.charCodeAt(c)===P;)c++;let s=f.length;for(;s-1>c&&f.charCodeAt(s-1)===P;)s--;const o=s-c,l=a<o?a:o;let v=-1,y=0;for(;y<l;y++){const _=g.charCodeAt(r+y);if(_!==f.charCodeAt(c+y))break;_===P&&(v=y)}if(y!==l){if(v===-1)return n}else{if(o>l){if(f.charCodeAt(c+y)===P)return n.slice(c+y+1);if(y===2)return n.slice(c+y)}a>l&&(g.charCodeAt(r+y)===P?v=y:y===2&&(v=3)),v===-1&&(v=0)}let O="";for(y=r+v+1;y<=i;++y)(y===i||g.charCodeAt(y)===P)&&(O+=O.length===0?"..":"\\..");return c+=v,O.length>0?`${O}${n.slice(c,s)}`:(n.charCodeAt(c)===P&&++c,n.slice(c,s))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const f=e.win32.resolve(g);if(f.length<=2)return g;if(f.charCodeAt(0)===P){if(f.charCodeAt(1)===P){const u=f.charCodeAt(2);if(u!==E&&u!==I)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===D&&f.charCodeAt(2)===P)return`\\\\?\\${f}`;return g},dirname(g){C(g,"path");const f=g.length;if(f===0)return".";let u=-1,n=0;const r=g.charCodeAt(0);if(f===1)return d(r)?g:".";if(d(r)){if(u=n=1,d(g.charCodeAt(1))){let c=2,s=c;for(;c<f&&!d(g.charCodeAt(c));)c++;if(c<f&&c!==s){for(s=c;c<f&&d(g.charCodeAt(c));)c++;if(c<f&&c!==s){for(s=c;c<f&&!d(g.charCodeAt(c));)c++;if(c===f)return g;c!==s&&(u=n=c+1)}}}}else w(r)&&g.charCodeAt(1)===D&&(u=f>2&&d(g.charCodeAt(2))?3:2,n=u);let i=-1,a=!0;for(let c=f-1;c>=n;--c)if(d(g.charCodeAt(c))){if(!a){i=c;break}}else a=!1;if(i===-1){if(u===-1)return".";i=u}return g.slice(0,i)},basename(g,f){f!==void 0&&C(f,"ext"),C(g,"path");let u=0,n=-1,r=!0,i;if(g.length>=2&&w(g.charCodeAt(0))&&g.charCodeAt(1)===D&&(u=2),f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,c=-1;for(i=g.length-1;i>=u;--i){const s=g.charCodeAt(i);if(d(s)){if(!r){u=i+1;break}}else c===-1&&(r=!1,c=i+1),a>=0&&(s===f.charCodeAt(a)?--a==-1&&(n=i):(a=-1,n=c))}return u===n?n=c:n===-1&&(n=g.length),g.slice(u,n)}for(i=g.length-1;i>=u;--i)if(d(g.charCodeAt(i))){if(!r){u=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(u,n)},extname(g){C(g,"path");let f=0,u=-1,n=0,r=-1,i=!0,a=0;g.length>=2&&g.charCodeAt(1)===D&&w(g.charCodeAt(0))&&(f=n=2);for(let c=g.length-1;c>=f;--c){const s=g.charCodeAt(c);if(d(s)){if(!i){n=c+1;break}continue}r===-1&&(i=!1,r=c+1),s===I?u===-1?u=c:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||r===-1||a===0||a===1&&u===r-1&&u===n+1?"":g.slice(u,r)},format:m.bind(null,"\\"),parse(g){C(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const u=g.length;let n=0,r=g.charCodeAt(0);if(u===1)return d(r)?(f.root=f.dir=g,f):(f.base=f.name=g,f);if(d(r)){if(n=1,d(g.charCodeAt(1))){let v=2,y=v;for(;v<u&&!d(g.charCodeAt(v));)v++;if(v<u&&v!==y){for(y=v;v<u&&d(g.charCodeAt(v));)v++;if(v<u&&v!==y){for(y=v;v<u&&!d(g.charCodeAt(v));)v++;v===u?n=v:v!==y&&(n=v+1)}}}}else if(w(r)&&g.charCodeAt(1)===D){if(u<=2)return f.root=f.dir=g,f;if(n=2,d(g.charCodeAt(2))){if(u===3)return f.root=f.dir=g,f;n=3}}n>0&&(f.root=g.slice(0,n));let i=-1,a=n,c=-1,s=!0,o=g.length-1,l=0;for(;o>=n;--o){if(r=g.charCodeAt(o),d(r)){if(!s){a=o+1;break}continue}c===-1&&(s=!1,c=o+1),r===I?i===-1?i=o:l!==1&&(l=1):i!==-1&&(l=-1)}return c!==-1&&(i===-1||l===0||l===1&&i===c-1&&i===a+1?f.base=f.name=g.slice(a,c):(f.name=g.slice(a,i),f.base=g.slice(a,c),f.ext=g.slice(i,c))),a>0&&a!==n?f.dir=g.slice(0,a-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let f="",u=!1;for(let n=g.length-1;n>=-1&&!u;n--){const r=n>=0?g[n]:k.cwd();C(r,"path"),r.length!==0&&(f=`${r}/${f}`,u=r.charCodeAt(0)===b)}return f=h(f,!u,"/",S),u?`/${f}`:f.length>0?f:"."},normalize(g){if(C(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===b,u=g.charCodeAt(g.length-1)===b;return g=h(g,!f,"/",S),g.length===0?f?"/":u?"./":".":(u&&(g+="/"),f?`/${g}`:g)},isAbsolute(g){return C(g,"path"),g.length>0&&g.charCodeAt(0)===b},join(...g){if(g.length===0)return".";let f;for(let u=0;u<g.length;++u){const n=g[u];C(n,"path"),n.length>0&&(f===void 0?f=n:f+=`/${n}`)}return f===void 0?".":e.posix.normalize(f)},relative(g,f){if(C(g,"from"),C(f,"to"),g===f||(g=e.posix.resolve(g),f=e.posix.resolve(f),g===f))return"";const u=1,n=g.length,r=n-u,i=1,a=f.length-i,c=r<a?r:a;let s=-1,o=0;for(;o<c;o++){const v=g.charCodeAt(u+o);if(v!==f.charCodeAt(i+o))break;v===b&&(s=o)}if(o===c)if(a>c){if(f.charCodeAt(i+o)===b)return f.slice(i+o+1);if(o===0)return f.slice(i+o)}else r>c&&(g.charCodeAt(u+o)===b?s=o:o===0&&(s=0));let l="";for(o=u+s+1;o<=n;++o)(o===n||g.charCodeAt(o)===b)&&(l+=l.length===0?"..":"/..");return`${l}${f.slice(i+s)}`},toNamespacedPath(g){return g},dirname(g){if(C(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===b;let u=-1,n=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===b){if(!n){u=r;break}}else n=!1;return u===-1?f?"/":".":f&&u===1?"//":g.slice(0,u)},basename(g,f){f!==void 0&&C(f,"ext"),C(g,"path");let u=0,n=-1,r=!0,i;if(f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,c=-1;for(i=g.length-1;i>=0;--i){const s=g.charCodeAt(i);if(s===b){if(!r){u=i+1;break}}else c===-1&&(r=!1,c=i+1),a>=0&&(s===f.charCodeAt(a)?--a==-1&&(n=i):(a=-1,n=c))}return u===n?n=c:n===-1&&(n=g.length),g.slice(u,n)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===b){if(!r){u=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(u,n)},extname(g){C(g,"path");let f=-1,u=0,n=-1,r=!0,i=0;for(let a=g.length-1;a>=0;--a){const c=g.charCodeAt(a);if(c===b){if(!r){u=a+1;break}continue}n===-1&&(r=!1,n=a+1),c===I?f===-1?f=a:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||n===-1||i===0||i===1&&f===n-1&&f===u+1?"":g.slice(f,n)},format:m.bind(null,"/"),parse(g){C(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const u=g.charCodeAt(0)===b;let n;u?(f.root="/",n=1):n=0;let r=-1,i=0,a=-1,c=!0,s=g.length-1,o=0;for(;s>=n;--s){const l=g.charCodeAt(s);if(l===b){if(!c){i=s+1;break}continue}a===-1&&(c=!1,a=s+1),l===I?r===-1?r=s:o!==1&&(o=1):r!==-1&&(o=-1)}if(a!==-1){const l=i===0&&u?1:i;r===-1||o===0||o===1&&r===a-1&&r===i+1?f.base=f.name=g.slice(l,a):(f.name=g.slice(l,r),f.base=g.slice(l,a),f.ext=g.slice(r,a))}return i>0?f.dir=g.slice(0,i-1):u&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[125],se([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(D){const E=(0,k.extname)(D),p=t[E.toLowerCase()];return p!==void 0?p:A(D)}e.getMediaOrTextMime=L;function A(D){const E=(0,k.extname)(D);return T[E.toLowerCase()]}e.getMediaMime=A;function I(D){for(const E in T)if(T[E]===D)return E}e.getExtensionForMimeType=I;const b=/^(.+)\/(.+?)(;.+)?$/;function P(D,E){const p=b.exec(D);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:E?void 0:D}e.normalizeMimeType=P}),define(re[78],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var T;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(I,...b){const P=b.reduce((p,C)=>(p[C]=!0,p),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!P[p]).forEach(p=>{for(let C=0;C<D.length;C++)if(p.search(D[C])!==-1){delete I[p];break}})}e.sanitizeProcessEnvironment=L;function A(I){!I||(delete I.DEBUG,k.isMacintosh&&delete I.DYLD_LIBRARY_PATH,k.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(re[126],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class T{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new T(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=T}),define(re[3],se([0,1,9,76,2,113,126]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const I=!1,b=!1;var P;(function(s){s.None=()=>T.Disposable.None;function o(B){if(b){const{onListenerDidAdd:U}=B,$=d.create();let V=0;B.onListenerDidAdd=()=>{++V==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$.print()),U?.()}}}function l(B){return(U,$=null,V)=>{let J=!1,H;return H=B(ee=>{if(!J)return H?H.dispose():J=!0,U.call($,ee)},null,V),J&&H.dispose(),H}}s.once=l;function v(B,U,$){return M((V,J=null,H)=>B(ee=>V.call(J,U(ee)),null,H),$)}s.map=v;function y(B,U,$){return M((V,J=null,H)=>B(ee=>{U(ee),V.call(J,ee)},null,H),$)}s.forEach=y;function O(B,U,$){return M((V,J=null,H)=>B(ee=>U(ee)&&V.call(J,ee),null,H),$)}s.filter=O;function _(B){return B}s.signal=_;function N(...B){return(U,$=null,V)=>(0,T.combinedDisposable)(...B.map(J=>J(H=>U.call($,H),null,V)))}s.any=N;function R(B,U,$,V){let J=$;return v(B,H=>(J=U(J,H),J),V)}s.reduce=R;function M(B,U){let $;const V={onFirstListenerAdd(){$=B(J.fire,J)},onLastListenerRemove(){$?.dispose()}};U||o(V);const J=new w(V);return U?.add(J),J.event}function F(B,U,$=100,V=!1,J,H){let ee,ne,ae,ue=0;const Se={leakWarningThreshold:J,onFirstListenerAdd(){ee=B(pe=>{ue++,ne=U(ne,pe),V&&!ae&&(fe.fire(ne),ne=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Ce=ne;ne=void 0,ae=void 0,(!V||ue>1)&&fe.fire(Ce),ue=0},$)})},onLastListenerRemove(){ee.dispose()}};H||o(Se);const fe=new w(Se);return H?.add(fe),fe.event}s.debounce=F;function j(B,U=(V,J)=>V===J,$){let V=!0,J;return O(B,H=>{const ee=V||!U(H,J);return V=!1,J=H,ee},$)}s.latch=j;function W(B,U,$){return[s.filter(B,U,$),s.filter(B,V=>!U(V),$)]}s.split=W;function z(B,U=!1,$=[]){let V=$.slice(),J=B(ne=>{V?V.push(ne):ee.fire(ne)});const H=()=>{V?.forEach(ne=>ee.fire(ne)),V=null},ee=new w({onFirstListenerAdd(){J||(J=B(ne=>ee.fire(ne)))},onFirstListenerDidAdd(){V&&(U?setTimeout(H):H())},onLastListenerRemove(){J&&J.dispose(),J=null}});return ee.event}s.buffer=z;class te{constructor(U){this.event=U,this.disposables=new T.DisposableStore}map(U){return new te(v(this.event,U,this.disposables))}forEach(U){return new te(y(this.event,U,this.disposables))}filter(U){return new te(O(this.event,U,this.disposables))}reduce(U,$){return new te(R(this.event,U,$,this.disposables))}latch(){return new te(j(this.event,void 0,this.disposables))}debounce(U,$=100,V=!1,J){return new te(F(this.event,U,$,V,J,this.disposables))}on(U,$,V){return this.event(U,$,V)}once(U,$,V){return l(this.event)(U,$,V)}dispose(){this.disposables.dispose()}}function G(B){return new te(B)}s.chain=G;function K(B,U,$=V=>V){const V=(...ne)=>ee.fire($(...ne)),J=()=>B.on(U,V),H=()=>B.removeListener(U,V),ee=new w({onFirstListenerAdd:J,onLastListenerRemove:H});return ee.event}s.fromNodeEventEmitter=K;function X(B,U,$=V=>V){const V=(...ne)=>ee.fire($(...ne)),J=()=>B.addEventListener(U,V),H=()=>B.removeEventListener(U,V),ee=new w({onFirstListenerAdd:J,onLastListenerRemove:H});return ee.event}s.fromDOMEventEmitter=X;function Y(B){return new Promise(U=>l(B)(U))}s.toPromise=Y;function q(B,U){return U(void 0),B($=>U($))}s.runAndSubscribe=q;function x(B,U){let $=null;function V(H){$?.dispose(),$=new T.DisposableStore,U(H,$)}V(void 0);const J=B(H=>V(H));return(0,T.toDisposable)(()=>{J.dispose(),$?.dispose()})}s.runAndSubscribeWithStore=x})(P=e.Event||(e.Event={}));class D{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${D._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let E=-1;function p(s){const o=E;return E=s,{dispose(){E=o}}}e.setGlobalLeakWarningThreshold=p;class C{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,l){let v=E;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||l<v)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let O,_=0;for(const[N,R]of this._stacks)(!O||_<R)&&(O=N,_=R);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${_}):`),console.warn(O)}return()=>{const O=this._stacks.get(o.value)||0;this._stacks.set(o.value,O-1)}}}class d{constructor(o){this.value=o}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(o,l,v){this.callback=o,this.callbackThis=l,this.stack=v,this.subscription=new T.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class w{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const l of o)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,l,v)=>{this._listeners||(this._listeners=new L.LinkedList);const y=this._listeners.isEmpty();y&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,_;this._leakageMon&&this._listeners.size>=30&&(_=d.create(),O=this._leakageMon.check(_,this._listeners.size+1)),I&&(_=_??d.create());const N=new S(o,l,_),R=this._listeners.push(N);y&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const M=N.subscription.set(()=>{O?.(),this._disposed||(R(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof T.DisposableStore?v.add(M):Array.isArray(v)&&v.push(M),M}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const l of this._listeners)this._deliveryQueue.push(this,l,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class h{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(o,l,v){this._queue.push(new g(o,l,v))}clear(o){const l=new L.LinkedList;for(const v of this._queue)v.emitter!==o&&l.push(v);this._queue=l}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(l){(0,k.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=h;class m extends h{clear(o){this._queue.clear()}}class g{constructor(o,l,v){this.emitter=o,this.listener=l,this.event=v}}class f extends w{async fireAsync(o,l,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const y of this._listeners)this._asyncDeliveryQueue.push([y,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[y,O]=this._asyncDeliveryQueue.shift(),_=[],N={...O,token:l,waitUntil:R=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");v&&(R=v(R,y.callback)),_.push(R)}};try{y.invoke(N)}catch(R){(0,k.onUnexpectedError)(R);continue}Object.freeze(_),await Promise.allSettled(_).then(R=>{for(const M of R)M.status==="rejected"&&(0,k.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=f;class u extends w{constructor(o){super(o);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class n extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=n;class r extends w{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const v=()=>{this.hasListeners&&this.unhook(l);const y=this.events.indexOf(l);this.events.splice(y,1)};return(0,T.toDisposable)((0,t.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.buffers=[]}wrapEvent(o){return(l,v,y)=>o(O=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>l.call(v,O)):l.call(v,O)},void 0,y)}bufferEvents(o){const l=[];this.buffers.push(l);const v=o();return this.buffers.pop(),l.forEach(y=>y()),v}}e.EventBufferer=a;class c{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(re[23],se([0,1,3]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,b){const P=setTimeout(I.bind(b),0);return{dispose(){clearTimeout(P)}}});var T;(function(I){function b(P){return P===I.None||P===I.Cancelled||P instanceof L?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=b,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(T=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=T.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=A}),define(re[127],se([0,1,23]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new k.CancellationTokenSource,b=this.task(I.token);return this.result={promise:b,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class T{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const b=JSON.stringify(I);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=T;class L{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const b=this.fn(I);return this._map.set(I,b),b}}e.CachedFunction=L}),define(re[79],se([0,1,3,2]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const T=A=>({onDidChange:k.Event.None,value:A});e.staticObservableValue=T;class L extends t.Disposable{constructor(I){super();this._value=I,this.changeEmitter=this._register(new k.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=L}),define(re[26],se([0,1,127,112]),function(Z,e,k,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function I(ie,...ce){return ce.length===0?ie:ie.replace(A,function(de,ve){const ge=parseInt(ve,10);return isNaN(ge)||ge<0||ge>=ce.length?de:ce[ge]})}e.format=I;const b=/{([^}]+)}/g;function P(ie,ce){return ie.replace(b,(de,ve)=>ce[ve]??de)}e.format2=P;function D(ie){return ie.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=D;function E(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function p(ie,ce){let de=0;const ve=ce.charCodeAt(0);for(let ge=ie.length-1;ge>=0;ge--)ie.charCodeAt(ge)===ve&&de++;return de}e.count=p;function C(ie,ce,de="\u2026"){return ie.length<=ce?ie:`${ie.substr(0,ce)}${de}`}e.truncate=C;function d(ie,ce=" "){const de=S(ie,ce);return w(de,ce)}e.trim=d;function S(ie,ce){if(!ie||!ce)return ie;const de=ce.length;if(de===0||ie.length===0)return ie;let ve=0;for(;ie.indexOf(ce,ve)===ve;)ve=ve+de;return ie.substring(ve)}e.ltrim=S;function w(ie,ce){if(!ie||!ce)return ie;const de=ce.length,ve=ie.length;if(de===0||ve===0)return ie;let ge=ve,we=-1;for(;we=ie.lastIndexOf(ce,ge-1),!(we===-1||we+de!==ge);){if(we===0)return"";ge=we}return ie.substring(0,ge)}e.rtrim=w;function h(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function m(ie){return ie.replace(/\*/g,"")}e.stripWildcards=m;function g(ie,ce,de={}){if(!ie)throw new Error("Cannot create regex from empty string");ce||(ie=E(ie)),de.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ve="";return de.global&&(ve+="g"),de.matchCase||(ve+="i"),de.multiline&&(ve+="m"),de.unicode&&(ve+="u"),new RegExp(ie,ve)}e.createRegExp=g;function f(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function u(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function n(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=n;function r(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=r;function i(ie){for(let ce=0,de=ie.length;ce<de;ce++){const ve=ie.charCodeAt(ce);if(ve!==32&&ve!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(ie,ce=0,de=ie.length){for(let ve=ce;ve<de;ve++){const ge=ie.charCodeAt(ve);if(ge!==32&&ge!==9)return ie.substring(ce,ve)}return ie.substring(ce,de)}e.getLeadingWhitespace=a;function c(ie,ce=ie.length-1){for(let de=ce;de>=0;de--){const ve=ie.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}e.lastNonWhitespaceIndex=c;function s(ie,ce,de){const ve=[];let ge=0;for(const we of ie.matchAll(ce)){if(ve.push(ie.slice(ge,we.index)),we.index===void 0)throw new Error("match.index should be defined");ge=we.index+we[0].length,ve.push(de(we[0],...we.slice(1),we.index,ie,we.groups))}return ve.push(ie.slice(ge)),Promise.all(ve).then(we=>we.join(""))}e.replaceAsync=s;function o(ie,ce){return ie<ce?-1:ie>ce?1:0}e.compare=o;function l(ie,ce,de=0,ve=ie.length,ge=0,we=ce.length){for(;de<ve&&ge<we;de++,ge++){const Le=ie.charCodeAt(de),Ae=ce.charCodeAt(ge);if(Le<Ae)return-1;if(Le>Ae)return 1}const De=ve-de,ke=we-ge;return De<ke?-1:De>ke?1:0}e.compareSubstring=l;function v(ie,ce){return y(ie,ce,0,ie.length,0,ce.length)}e.compareIgnoreCase=v;function y(ie,ce,de=0,ve=ie.length,ge=0,we=ce.length){for(;de<ve&&ge<we;de++,ge++){let Le=ie.charCodeAt(de),Ae=ce.charCodeAt(ge);if(Le===Ae)continue;if(Le>=128||Ae>=128)return l(ie.toLowerCase(),ce.toLowerCase(),de,ve,ge,we);_(Le)&&(Le-=32),_(Ae)&&(Ae-=32);const Fe=Le-Ae;if(Fe!==0)return Fe}const De=ve-de,ke=we-ge;return De<ke?-1:De>ke?1:0}e.compareSubstringIgnoreCase=y;function O(ie){return ie>=48&&ie<=57}e.isAsciiDigit=O;function _(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=_;function N(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=N;function R(ie,ce){return ie.length===ce.length&&y(ie,ce)===0}e.equalsIgnoreCase=R;function M(ie,ce){const de=ce.length;return ce.length>ie.length?!1:y(ie,ce,0,de)===0}e.startsWithIgnoreCase=M;function F(ie,ce){const de=Math.min(ie.length,ce.length);let ve;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ve)!==ce.charCodeAt(ve))return ve;return de}e.commonPrefixLength=F;function j(ie,ce){const de=Math.min(ie.length,ce.length);let ve;const ge=ie.length-1,we=ce.length-1;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ge-ve)!==ce.charCodeAt(we-ve))return ve;return de}e.commonSuffixLength=j;function W(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=W;function z(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=z;function te(ie,ce){return(ie-55296<<10)+(ce-56320)+65536}e.computeCodePoint=te;function G(ie,ce,de){const ve=ie.charCodeAt(de);if(W(ve)&&de+1<ce){const ge=ie.charCodeAt(de+1);if(z(ge))return te(ve,ge)}return ve}e.getNextCodePoint=G;function K(ie,ce){const de=ie.charCodeAt(ce-1);if(z(de)&&ce>1){const ve=ie.charCodeAt(ce-2);if(W(ve))return te(ve,de)}return de}class X{constructor(ce,de=0){this._str=ce,this._len=ce.length,this._offset=de}get offset(){return this._offset}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=K(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=G(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=X;class Y{constructor(ce,de=0){this._iterator=new X(ce,de)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ce=Ee.getInstance(),de=this._iterator,ve=de.offset;let ge=ce.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const we=de.offset,De=ce.getGraphemeBreakType(de.nextCodePoint());if(le(ge,De)){de.setOffset(we);break}ge=De}return de.offset-ve}prevGraphemeLength(){const ce=Ee.getInstance(),de=this._iterator,ve=de.offset;let ge=ce.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const we=de.offset,De=ce.getGraphemeBreakType(de.prevCodePoint());if(le(De,ge)){de.setOffset(we);break}ge=De}return ve-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function q(ie,ce){return new Y(ie,ce).nextGraphemeLength()}e.nextCharLength=q;function x(ie,ce){return new Y(ie,ce).prevGraphemeLength()}e.prevCharLength=x;function B(ie,ce){ce>0&&z(ie.charCodeAt(ce))&&ce--;const de=ce+q(ie,ce);return[de-x(ie,de),de]}e.getCharContainingOffset=B;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(ie){return U.test(ie)}e.containsRTL=$;const V=/^[\t\n\r\x20-\x7E]*$/;function J(ie){return V.test(ie)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=H;function ee(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=ee;function ne(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=ne;function ae(ie,ce){if(ie.length<ce)return ie;const de=/\b/g;let ve=0;for(;de.test(ie)&&!(ie.length-de.lastIndex<ce);)ve=de.lastIndex,de.lastIndex+=1;return ie.substring(ve).replace(/^\s/,"")}e.lcut=ae;const ue=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function pe(ie){return ie&&(ie=ie.replace(ue,""),ie=ie.replace(Se,""),ie=ie.replace(fe,"")),ie}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function be(ie){return Ce(ie)?ie.substr(1):ie}e.stripUTF8BOM=be;function Ie(ie,ce){if(!ie||!ce||ie.length<ce.length)return!1;const de=ce.length,ve=ie.toLowerCase();let ge=0,we=-1;for(;ge<de;){const De=ve.indexOf(ce[ge],we+1);if(De<0)return!1;we=De,ge++}return!0}e.fuzzyContains=Ie;function qe(ie,ce=!1){return ie?(ce&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=qe;function Qe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Qe;function Ke(ie,ce=1){if(ce===0)return"";let de=-1;do de=ie.indexOf(`
`,de+1),ce--;while(ce>0&&de>=0);return de===-1?ie:(ie[de-1]==="\r"&&de--,ie.substr(0,de))}e.getNLines=Ke;function Ye(ie){const ce=90-65+1;return ie=ie%(2*ce),ie<ce?String.fromCharCode(97+ie):String.fromCharCode(65+ie-ce)}e.singleLetterHash=Ye;function oe(ie){return Ee.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=oe;function le(ie,ce){return ie===0?ce!==5&&ce!==7:ie===2&&ce===3?!1:ie===4||ie===2||ie===3||ce===4||ce===2||ce===3?!0:!(ie===8&&(ce===8||ce===9||ce===11||ce===12)||(ie===11||ie===9)&&(ce===9||ce===10)||(ie===12||ie===10)&&ce===10||ce===5||ce===13||ce===7||ie===1||ie===13&&ce===14||ie===6&&ce===6)}var he;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=Pe()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const de=this._data,ve=de.length/3;let ge=1;for(;ge<=ve;)if(ce<de[3*ge])ge=2*ge;else if(ce>de[3*ge+1])ge=2*ge+1;else return de[3*ge+2];return 0}}Ee._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(ie,ce){if(ie===0)return 0;const de=Re(ie,ce);if(de!==void 0)return de;const ve=new X(ce,ie);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Ue;function Re(ie,ce){const de=new X(ce,ie);let ve=de.prevCodePoint();for(;Ne(ve)||ve===65039||ve===8419;){if(de.offset===0)return;ve=de.prevCodePoint()}if(!ne(ve))return;let ge=de.offset;return ge>0&&de.prevCodePoint()===8205&&(ge=de.offset),ge}function Ne(ie){return 127995<=ie&&ie<=127999}var _e;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.noBreakWhitespace="\xA0";class Te{constructor(ce){this.confusableDictionary=ce}static getInstance(ce){return Te.cache.get(Array.from(ce))}static getLocales(){return Te._locales.getValue()}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,T=Te,Te.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new k.LRUCachedFunction(ie=>{function ce(Ae){const Fe=new Map;for(let $e=0;$e<Ae.length;$e+=2)Fe.set(Ae[$e],Ae[$e+1]);return Fe}function de(Ae,Fe){const $e=new Map(Ae);for(const[Xe,rt]of Fe)$e.set(Xe,rt);return $e}function ve(Ae,Fe){if(!Ae)return Fe;const $e=new Map;for(const[Xe,rt]of Ae)Fe.has(Xe)&&$e.set(Xe,rt);return $e}const ge=T.ambiguousCharacterData.getValue();let we=ie.filter(Ae=>!Ae.startsWith("_")&&Ae in ge);we.length===0&&(we=["_default"]);let De;for(const Ae of we){const Fe=ce(ge[Ae]);De=ve(De,Fe)}const ke=ce(ge._common),Le=de(ke,De);return new Te(Le)}),Te._locales=new t.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(ie=>!ie.startsWith("_")));class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(ce){return Me.getData().has(ce)}static get codePoints(){return Me.getData()}}e.InvisibleCharacters=Me,Me._data=void 0}),define(re[42],se([0,1,12,4,26,14]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(c){return c===47||c===92}e.isPathSeparator=A;function I(c){return c.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=I;function b(c){return c.indexOf("/")===-1&&(c=I(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=b;function P(c,s=k.posix.sep){if(!c)return"";const o=c.length,l=c.charCodeAt(0);if(A(l)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let y=3;const O=y;for(;y<o&&!A(c.charCodeAt(y));y++);if(O!==y&&!A(c.charCodeAt(y+1))){for(y+=1;y<o;y++)if(A(c.charCodeAt(y)))return c.slice(0,y+1).replace(/[\\/]/g,s)}}return s}else if(h(l)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+s:c.slice(0,2);let v=c.indexOf("://");if(v!==-1){for(v+=3;v<o;v++)if(A(c.charCodeAt(v)))return c.slice(0,v+1)}return""}e.getRoot=P;function D(c){if(!t.isWindows||!c||c.length<5)return!1;let s=c.charCodeAt(0);if(s!==92||(s=c.charCodeAt(1),s!==92))return!1;let o=2;const l=o;for(;o<c.length&&(s=c.charCodeAt(o),s!==92);o++);return!(l===o||(s=c.charCodeAt(o+1),isNaN(s)||s===92))}e.isUNC=D;const E=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(c,s=t.isWindows){const o=s?E:p;return!(!c||c.length===0||/^\s+$/.test(c)||(o.lastIndex=0,o.test(c))||s&&C.test(c)||c==="."||c===".."||s&&c[c.length-1]==="."||s&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=d;function S(c,s,o){const l=c===s;return!o||l?l:!c||!s?!1:(0,T.equalsIgnoreCase)(c,s)}e.isEqual=S;function w(c,s,o,l=k.sep){if(c===s)return!0;if(!c||!s||s.length>c.length)return!1;if(o){if(!(0,T.startsWithIgnoreCase)(c,s))return!1;if(s.length===c.length)return!0;let y=s.length;return s.charAt(s.length-1)===l&&y--,c.charAt(y)===l}return s.charAt(s.length-1)!==l&&(s+=l),c.indexOf(s)===0}e.isEqualOrParent=w;function h(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=h;function m(c,s){return t.isWindows&&c.endsWith(":")&&(c+=k.sep),(0,k.isAbsolute)(c)||(c=(0,k.join)(s,c)),c=(0,k.normalize)(c),t.isWindows?(c=(0,T.rtrim)(c,k.sep),c.endsWith(":")&&(c+=k.sep)):(c=(0,T.rtrim)(c,k.sep),c||(c=k.sep)),c}e.sanitizeFilePath=m;function g(c){const s=(0,k.normalize)(c);return t.isWindows?c.length>3?!1:f(s)&&(c.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=g;function f(c,s=t.isWindows){return s?h(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(c){return f(c)?c[0]:void 0}e.getDriveLetter=u;function n(c,s,o){return s.length>c.length?-1:c===s?0:(o&&(c=c.toLowerCase(),s=s.toLowerCase()),c.indexOf(s))}e.indexOfPath=n;function r(c){const s=c.split(":");let o,l,v;for(const y of s){const O=Number(y);(0,L.isNumber)(O)?l===void 0?l=O:v===void 0&&(v=O):o=o?[o,y].join(":"):y}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:v!==void 0?v:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(c,s,o=8){let l="";for(let y=0;y<o;y++)l+=i.charAt(Math.floor(Math.random()*i.length));let v;return s?v=`${s}-${l}`:v=l,c?(0,k.join)(c,v):v}e.randomPath=a}),define(re[63],se([0,1,26]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return T(h,0)}e.hash=t;function T(h,m){switch(typeof h){case"object":return h===null?L(349,m):Array.isArray(h)?b(h,m):P(h,m);case"string":return I(h,m);case"boolean":return A(h,m);case"number":return L(h,m);case"undefined":return L(937,m);default:return L(617,m)}}e.doHash=T;function L(h,m){return(m<<5)-m+h|0}e.numberHash=L;function A(h,m){return L(h?433:863,m)}function I(h,m){m=L(149417,m);for(let g=0,f=h.length;g<f;g++)m=L(h.charCodeAt(g),m);return m}e.stringHash=I;function b(h,m){return m=L(104579,m),h.reduce((g,f)=>T(f,g),m)}function P(h,m){return m=L(181387,m),Object.keys(h).sort().reduce((g,f)=>(g=I(f,g),T(h[f],g)),m)}class D{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=T(m,this._value),this._value}}e.Hasher=D;var E;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function p(h,m,g=32){const f=g-m,u=~((1<<f)-1);return(h<<m|(u&h)>>>f)>>>0}function C(h,m=0,g=h.byteLength,f=0){for(let u=0;u<g;u++)h[m+u]=f}function d(h,m,g="0"){for(;h.length<m;)h=g+h;return h}function S(h,m=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(g=>g.toString(16).padStart(2,"0")).join(""):d((h>>>0).toString(16),m/4)}e.toHexString=S;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const g=m.length;if(g===0)return;const f=this._buff;let u=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=m.charCodeAt(0),i=0);;){let a=r;if(k.isHighSurrogate(r))if(i+1<g){const c=m.charCodeAt(i+1);k.isLowSurrogate(c)?(i++,a=k.computeCodePoint(r,c)):a=65533}else{n=r;break}else k.isLowSurrogate(r)&&(a=65533);if(u=this._push(f,u,a),i++,i<g)r=m.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=n}_push(m,g,f){return f<128?m[g++]=f:f<2048?(m[g++]=192|(f&1984)>>>6,m[g++]=128|(f&63)>>>0):f<65536?(m[g++]=224|(f&61440)>>>12,m[g++]=128|(f&4032)>>>6,m[g++]=128|(f&63)>>>0):(m[g++]=240|(f&1835008)>>>18,m[g++]=128|(f&258048)>>>12,m[g++]=128|(f&4032)>>>6,m[g++]=128|(f&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,C(this._buff,this._buffLen),this._buffLen>56&&(this._step(),C(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=w._bigBlock32,g=this._buffDV;for(let o=0;o<64;o+=4)m.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,p(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let f=this._h0,u=this._h1,n=this._h2,r=this._h3,i=this._h4,a,c,s;for(let o=0;o<80;o++)o<20?(a=u&n|~u&r,c=1518500249):o<40?(a=u^n^r,c=1859775393):o<60?(a=u&n|u&r|n&r,c=2400959708):(a=u^n^r,c=3395469782),s=p(f,5)+a+i+c+m.getUint32(o*4,!1)&4294967295,i=r,r=n,n=p(u,30),u=f,f=s;this._h0=this._h0+f&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(Z,e,k,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(Z,k):T?T.value=k:e.set(Z,k),k},Ge=this&&this.__classPrivateFieldGet||function(Z,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(Z):t?t.value:e.get(Z)};define(re[38],se([0,1,17,26]),function(Z,e,k,t){"use strict";var T,L,A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(c,s,o){let l=c.get(s);return l===void 0&&(l=o,c.set(s,l)),l}e.getOrSet=b;function P(c){const s=[];return c.forEach((o,l)=>{s.push(`${l} => ${o}`)}),`Map(${c.size}) {${s.join(", ")}}`}e.mapToString=P;function D(c){const s=[];return c.forEach(o=>{s.push(o)}),`Set(${c.size}) {${s.join(", ")}}`}e.setToString=D;class E{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const o=s.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=E;class p{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class C{constructor(s=!0,o=!0){this._splitOnBackslash=s,this._caseSensitive=o}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let o=s.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var d;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(d||(d={}));class S{constructor(s,o){this._ignorePathCasing=s,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,t.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(h||(h={}));class m{constructor(s){this._iter=s}static forUris(s=()=>!1,o=()=>!1){return new m(new S(s,o))}static forPaths(s=!1){return new m(new C(void 0,!s))}static forStrings(){return new m(new E)}static forConfigKeys(){return new m(new p)}clear(){this._root=void 0}fill(s,o){if(o){const l=o.slice(0);(0,k.shuffle)(l);for(const v of l)this.set(v,s)}else{const l=s.slice(0);(0,k.shuffle)(l);for(const v of l)this.set(v[0],v[1])}}set(s,o){const l=this._iter.reset(s);let v;this._root||(this._root=new w,this._root.segment=l.value());const y=[];for(v=this._root;;){const _=l.cmp(v.segment);if(_>0)v.left||(v.left=new w,v.left.segment=l.value()),y.push([-1,v]),v=v.left;else if(_<0)v.right||(v.right=new w,v.right.segment=l.value()),y.push([1,v]),v=v.right;else if(l.hasNext())l.next(),v.mid||(v.mid=new w,v.mid.segment=l.value()),y.push([0,v]),v=v.mid;else break}const O=v.value;v.value=o,v.key=s;for(let _=y.length-1;_>=0;_--){const N=y[_][1];N.updateHeight();const R=N.balanceFactor();if(R<-1||R>1){const M=y[_][0],F=y[_+1][0];if(M===1&&F===1)y[_][1]=N.rotateLeft();else if(M===-1&&F===-1)y[_][1]=N.rotateRight();else if(M===1&&F===-1)N.right=y[_+1][1]=y[_+1][1].rotateRight(),y[_][1]=N.rotateLeft();else if(M===-1&&F===1)N.left=y[_+1][1]=y[_+1][1].rotateLeft(),y[_][1]=N.rotateRight();else throw new Error;if(_>0)switch(y[_-1][0]){case-1:y[_-1][1].left=y[_][1];break;case 1:y[_-1][1].right=y[_][1];break;case 0:y[_-1][1].mid=y[_][1];break}else this._root=y[0][1]}}return O}get(s){return this._getNode(s)?.value}_getNode(s){const o=this._iter.reset(s);let l=this._root;for(;l;){const v=o.cmp(l.segment);if(v>0)l=l.left;else if(v<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(s){const o=this._getNode(s);return!(o?.value===void 0&&o?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,o){const l=this._iter.reset(s),v=[];let y=this._root;for(;y;){const O=l.cmp(y.segment);if(O>0)v.push([-1,y]),y=y.left;else if(O<0)v.push([1,y]),y=y.right;else if(l.hasNext())l.next(),v.push([0,y]),y=y.mid;else break}if(!!y){if(o?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const O=this._min(y.right),{key:_,value:N,segment:R}=O;this._delete(O.key,!1),y.key=_,y.value=N,y.segment=R}else{const O=y.left??y.right;if(v.length>0){const[_,N]=v[v.length-1];switch(_){case-1:N.left=O;break;case 0:N.mid=O;break;case 1:N.right=O;break}}else this._root=O}for(let O=v.length-1;O>=0;O--){const _=v[O][1];_.updateHeight();const N=_.balanceFactor();if(N>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),v[O][1]=_.rotateLeft()):N<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),v[O][1]=_.rotateRight()),O>0)switch(v[O-1][0]){case-1:v[O-1][1].left=v[O][1];break;case 1:v[O-1][1].right=v[O][1];break;case 0:v[O-1][1].mid=v[O][1];break}else this._root=v[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const o=this._iter.reset(s);let l=this._root,v;for(;l;){const y=o.cmp(l.segment);if(y>0)l=l.left;else if(y<0)l=l.right;else if(o.hasNext())o.next(),v=l.value||v,l=l.mid;else break}return l&&l.value||v}findSuperstr(s){const o=this._iter.reset(s);let l=this._root;for(;l;){const v=o.cmp(l.segment);if(v>0)l=l.left;else if(v<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(s){for(const[o,l]of this)s(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){!s||(s.left&&(yield*this._entries(s.left)),s.value&&(yield[s.key,s.value]),s.mid&&(yield*this._entries(s.mid)),s.right&&(yield*this._entries(s.right)))}_isBalanced(){const s=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:s(o.left)&&s(o.right)};return s(this._root)}}e.TernarySearchTree=m;class g{constructor(s,o){this.uri=s,this.value=o}}class f{constructor(s,o){this[T]="ResourceMap",s instanceof f?(this.map=new Map(s.map),this.toKey=o??f.defaultToKey):(this.map=new Map,this.toKey=s??f.defaultToKey)}set(s,o){return this.map.set(this.toKey(s),new g(s,o)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o!="undefined"&&(s=s.bind(o));for(const[l,v]of this.map)s(v.value,v.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=f,f.defaultToKey=c=>c.toString();class u{constructor(s,o){this[L]="ResourceSet",!s||typeof s=="function"?this._map=new f(s):(this._map=new f(o),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,o){this._map.forEach((l,v)=>s.call(o,v,v,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var n;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class r{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,o=0){const l=this._map.get(s);if(!!l)return o!==0&&this.touch(l,o),l.value}set(s,o,l=0){let v=this._map.get(s);if(v)v.value=o,l!==0&&this.touch(v,l);else{switch(v={key:s,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(s,v),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(!!o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const l=this._state;let v=this._head;for(;v;){if(o?s.bind(o)(v.value,v.key,this):s(v.value,v.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const s=this,o=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}values(){const s=this,o=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}entries(){const s=this,o=this._state;let l=this._head;const v={[Symbol.iterator](){return v},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return v}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>s;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,l=s.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const l=s.next,v=s.previous;s===this._tail?(v.next=void 0,this._tail=v):(l.previous=v,v.next=l),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const l=s.next,v=s.previous;s===this._head?(l.previous=void 0,this._head=l):(l.previous=v,v.next=l),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,l)=>{s.push([l,o])}),s}fromJSON(s){this.clear();for(const[o,l]of s)this.set(o,l)}}e.LinkedMap=r;class i extends r{constructor(s,o=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(s){I.set(this,void 0),It(this,I,s,"f")}get size(){return Ge(this,I,"f").size}forEach(s,o){Ge(this,I,"f").forEach(s,o)}get(s){return Ge(this,I,"f").get(s)}has(s){return Ge(this,I,"f").has(s)}entries(){return Ge(this,I,"f").entries()}keys(){return Ge(this,I,"f").keys()}values(){return Ge(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Ge(this,I,"f").entries()}}e.ReadonlyMapView=a}),define(re[80],se([0,1,38]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function T(P){return b(P,"NFC",t)}e.normalizeNFC=T;const L=new k.LRUCache(1e4);function A(P){return b(P,"NFD",L)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function b(P,D,E){if(!P)return P;const p=E.get(P);if(p)return p;let C;return I.test(P)?C=P.normalize(D):C=P,E.set(P,C),C}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(D){return A(D).replace(P,"")}}()}),define(re[81],se([0,1,26]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(t||(t={})),function(T){const L="error",A="warning",I="warn",b="info",P="ignore";function D(p){return p?k.equalsIgnoreCase(L,p)?T.Error:k.equalsIgnoreCase(A,p)||k.equalsIgnoreCase(I,p)?T.Warning:k.equalsIgnoreCase(b,p)?T.Info:T.Ignore:T.Ignore}T.fromValue=D;function E(p){switch(p){case T.Error:return L;case T.Warning:return A;case T.Info:return b;default:return P}}T.toString=E}(t||(t={})),e.default=t}),define(re[8],se([0,1,12,4]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function I(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!T.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,a){return!i&&!a?"file":i}function P(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==E&&(a=E+a):a=E;break}return a}const D="",E="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(a,c,s,o,l,v=!1){typeof a=="object"?(this.scheme=a.scheme||D,this.authority=a.authority||D,this.path=a.path||D,this.query=a.query||D,this.fragment=a.fragment||D):(this.scheme=b(a,v),this.authority=c||D,this.path=P(this.scheme,s||D),this.query=o||D,this.fragment=l||D,I(this,v))}static isUri(a){return a instanceof C?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:s,path:o,query:l,fragment:v}=a;return c===void 0?c=this.scheme:c===null&&(c=D),s===void 0?s=this.authority:s===null&&(s=D),o===void 0?o=this.path:o===null&&(o=D),l===void 0?l=this.query:l===null&&(l=D),v===void 0?v=this.fragment:v===null&&(v=D),c===this.scheme&&s===this.authority&&o===this.path&&l===this.query&&v===this.fragment?this:new S(c,s,o,l,v)}static parse(a,c=!1){const s=p.exec(a);return s?new S(s[2]||D,r(s[4]||D),r(s[5]||D),r(s[7]||D),r(s[9]||D),c):new S(D,D,D,D,D)}static file(a){let c=D;if(t.isWindows&&(a=a.replace(/\\/g,E)),a[0]===E&&a[1]===E){const s=a.indexOf(E,2);s===-1?(c=a.substring(2),a=E):(c=a.substring(2,s),a=a.substring(s)||E)}return new S("file",c,a,D,D)}static from(a){const c=new S(a.scheme,a.authority,a.path,a.query,a.fragment);return I(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&a.scheme==="file"?s=C.file(k.win32.join(g(a,!0),...c)).path:s=k.posix.join(a.path,...c),a.with({path:s})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof C)return a;{const c=new S(a);return c._formatted=a.external,c._fsPath=a._sep===d?a.fsPath:null,c}}else return a}}e.URI=C;const d=t.isWindows?1:void 0;class S extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,a){let c,s=-1;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||a&&l===47)s!==-1&&(c+=encodeURIComponent(i.substring(s,o)),s=-1),c!==void 0&&(c+=i.charAt(o));else{c===void 0&&(c=i.substr(0,o));const v=w[l];v!==void 0?(s!==-1&&(c+=encodeURIComponent(i.substring(s,o)),s=-1),c+=v):s===-1&&(s=o)}}return s!==-1&&(c+=encodeURIComponent(i.substring(s))),c!==void 0?c:i}function m(i){let a;for(let c=0;c<i.length;c++){const s=i.charCodeAt(c);s===35||s===63?(a===void 0&&(a=i.substr(0,c)),a+=w[s]):a!==void 0&&(a+=i[c])}return a!==void 0?a:i}function g(i,a){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,t.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function f(i,a){const c=a?m:h;let s="",{scheme:o,authority:l,path:v,query:y,fragment:O}=i;if(o&&(s+=o,s+=":"),(l||o==="file")&&(s+=E,s+=E),l){let _=l.indexOf("@");if(_!==-1){const N=l.substr(0,_);l=l.substr(_+1),_=N.indexOf(":"),_===-1?s+=c(N,!1):(s+=c(N.substr(0,_),!1),s+=":",s+=c(N.substr(_+1),!1)),s+="@"}l=l.toLowerCase(),_=l.indexOf(":"),_===-1?s+=c(l,!1):(s+=c(l.substr(0,_),!1),s+=l.substr(_))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const _=v.charCodeAt(1);_>=65&&_<=90&&(v=`/${String.fromCharCode(_+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const _=v.charCodeAt(0);_>=65&&_<=90&&(v=`${String.fromCharCode(_+32)}:${v.substr(2)}`)}s+=c(v,!0)}return y&&(s+="?",s+=c(y,!1)),O&&(s+="#",s+=a?O:h(O,!1)),s}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,a=>u(a)):i}}),define(re[128],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(P){const D=P;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=t;function T(P){const D=[];let E;try{const p=JSON.parse(P.arguments),C=p[p.length-1];C&&C.__$stack&&(p.pop(),E=C.__$stack),D.push(...p)}catch{D.push("Unable to log remote console arguments",P.arguments)}return{args:D,stack:E}}e.parse=T;function L(P){if(typeof P!="string")return L(T(P).stack);const D=P;if(D){const E=A(D),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(p&&p.length===4)return{uri:k.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function A(P){if(!P)return P;const D=P.indexOf(`
`);return D===-1?P:P.substring(0,D)}function I(P,D){const{args:E,stack:p}=T(P),C=typeof E[0]=="string"&&E.length===1;let d=A(p);d&&(d=`(${d.trim()})`);let S=[];if(typeof E[0]=="string"?d&&C?S=[`%c[${D}] %c${E[0]} %c${d}`,b("blue"),b(""),b("grey")]:S=[`%c[${D}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:S=[`%c[${D}]%`,b("blue"),...E],d&&!C&&S.push(d),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,S)}e.log=I;function b(P){return`color: ${P}`}}),define(re[64],se([0,1,16,26,8]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(P){return JSON.stringify(P,I)}e.stringify=L;function A(P){let D=JSON.parse(P);return D=b(D),D}e.parse=A;function I(P,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,t.regExpFlags)(D)}:D}function b(P,D=0){if(!P||D>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return T.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=b(P[E],D+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=b(P[E],D+1))}return P}e.revive=b}),define(re[20],se([0,1,4,8]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var T;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(T=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${T.vscodeRemoteResource}`}set(b,P,D){this._hosts[b]=P,this._ports[b]=D}setConnectionToken(b,P){this._connectionTokens[b]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const P=b.authority;let D=this._hosts[P];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const E=this._ports[P],p=this._connectionTokens[P];let C=`path=${encodeURIComponent(b.path)}`;return typeof p=="string"&&(C+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${D}:${E}`,path:this._remoteResourcesPath,query:C})}}e.RemoteAuthorities=new L;class A{asBrowserUri(b,P){const D=this.toUri(b,P);return D.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===T.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${T.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?D.with({scheme:T.vscodeFileResource,authority:D.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(b,P){const D=this.toUri(b,P);return D.scheme===T.vscodeFileResource?D.with({scheme:T.file,authority:D.authority!==A.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(b,P){return t.URI.isUri(b)?b:t.URI.parse(P.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(re[19],se([0,1,42,20,12,4,26,8]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(C){return(0,I.uriToFsPath)(C,!0)}e.originalFSPath=b;class P{constructor(d){this._ignorePathCasing=d}compare(d,S,w=!1){return d===S?0:(0,A.compare)(this.getComparisonKey(d,w),this.getComparisonKey(S,w))}isEqual(d,S,w=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,w)===this.getComparisonKey(S,w)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,w=!1){if(d.scheme===S.scheme){if(d.scheme===t.Schemas.file)return k.isEqualOrParent(b(d),b(S),this._ignorePathCasing(d))&&d.query===S.query&&(w||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return k.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(w||d.fragment===S.fragment)}return!1}joinPath(d,...S){return I.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===t.Schemas.file?S=I.URI.file(T.dirname(b(d))).path:(S=T.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===t.Schemas.file?S=I.URI.file(T.normalize(b(d))).path:S=T.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===t.Schemas.file){const m=T.relative(b(d),b(S));return L.isWindows?k.toSlashes(m):m}let w=d.path||"/";const h=S.path||"/";if(this._ignorePathCasing(d)){let m=0;for(const g=Math.min(w.length,h.length);m<g&&!(w.charCodeAt(m)!==h.charCodeAt(m)&&w.charAt(m).toLowerCase()!==h.charAt(m).toLowerCase());m++);w=h.substr(0,m)+w.substr(m)}return T.posix.relative(w,h)}resolvePath(d,S){if(d.scheme===t.Schemas.file){const w=I.URI.file(T.resolve(b(d),S));return d.with({authority:w.authority,path:w.path})}return S=k.toPosixPath(S),d.with({path:T.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=T.sep){if(d.scheme===t.Schemas.file){const w=b(d);return w.length>k.getRoot(w).length&&w[w.length-1]===S}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=T.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=T.sep){let w=!1;if(d.scheme===t.Schemas.file){const h=b(d);w=h!==void 0&&h.length===k.getRoot(h).length&&h[h.length-1]===S}else{S="/";const h=d.path;w=h.length===1&&h.charCodeAt(h.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(C=>C.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new P(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(C,d){const S=[];for(let w=0;w<C.length;w++){const h=d(C[w]);C.some((m,g)=>g===w?!1:(0,e.isEqualOrParent)(h,d(m)))||S.push(C[w])}return S}e.distinctParents=D;var E;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function d(S){const w=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(g=>{const[f,u]=g.split(":");f&&u&&w.set(f,u)});const m=S.path.substring(0,S.path.indexOf(";"));return m&&w.set(C.META_DATA_MIME,m),w}C.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function p(C,d,S){if(d){let w=C.path;return w&&w[0]!==T.posix.sep&&(w=T.posix.sep+w),C.with({scheme:S,authority:d,path:w})}return C.with({scheme:S})}e.toLocalResource=p}),define(re[6],se([0,1,23,9,3,2,19,4]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(B){return!!B&&typeof B.then=="function"}e.isThenable=b;function P(B){const U=new k.CancellationTokenSource,$=B(U.token),V=new Promise((J,H)=>{const ee=U.token.onCancellationRequested(()=>{ee.dispose(),U.dispose(),H(new t.CancellationError)});Promise.resolve($).then(ne=>{ee.dispose(),U.dispose(),J(ne)},ne=>{ee.dispose(),U.dispose(),H(ne)})});return new class{cancel(){U.cancel()}then(J,H){return V.then(J,H)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.createCancelablePromise=P;function D(B,U,$){return new Promise((V,J)=>{const H=U.onCancellationRequested(()=>{H.dispose(),V($)});B.then(V,J).finally(()=>H.dispose())})}e.raceCancellation=D;function E(B,U){return new Promise(($,V)=>{const J=U.onCancellationRequested(()=>{J.dispose(),V(new t.CancellationError)});B.then($,V).finally(()=>J.dispose())})}e.raceCancellationError=E;async function p(B){let U=-1;const $=B.map((J,H)=>J.then(ee=>(U=H,ee))),V=await Promise.race($);return B.forEach((J,H)=>{H!==U&&J.cancel()}),V}e.raceCancellablePromises=p;function C(B,U,$){let V;const J=setTimeout(()=>{V?.(void 0),$?.()},U);return Promise.race([B.finally(()=>clearTimeout(J)),new Promise(H=>V=H)])}e.raceTimeout=C;function d(B){return new Promise((U,$)=>{const V=B();b(V)?V.then(U,$):U(V)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then($,$).then(V)})}return new Promise(($,V)=>{this.queuedPromise.then($,V)})}return this.activePromise=U(),new Promise(($,V)=>{this.activePromise.then(J=>{this.activePromise=null,$(J)},J=>{this.activePromise=null,V(J)})})}}e.Throttler=S;class w{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=w;class h{constructor(){this.promiseMap=new Map}queue(U,$){const J=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(U)===J&&this.promiseMap.delete(U)});return this.promiseMap.set(U,J),J}}e.SequencerByKey=h;const m=(B,U)=>{let $=!0;const V=setTimeout(()=>{$=!1,U()},B);return{isTriggered:()=>$,dispose:()=>{clearTimeout(V),$=!1}}},g=B=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,B())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,$=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,H)=>{this.doResolve=J,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=$===e.MicrotaskDelay?g(V):m($,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class u{constructor(U){this.delayer=new f(U),this.throttler=new S}trigger(U,$){return this.delayer.trigger(()=>this.throttler.queue(U),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class n{constructor(){this._isOpen=!1,this._promise=new Promise((U,$)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(B,U){return U?new Promise(($,V)=>{const J=setTimeout(()=>{H.dispose(),$()},B),H=U.onCancellationRequested(()=>{clearTimeout(J),H.dispose(),V(new t.CancellationError)})}):P($=>i(B,$))}e.timeout=i;function a(B,U=0){const $=setTimeout(B,U);return(0,L.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=a;function c(B){const U=[];let $=0;const V=B.length;function J(){return $<V?B[$++]():null}function H(ee){ee!=null&&U.push(ee);const ne=J();return ne?ne.then(H):Promise.resolve(U)}return Promise.resolve(null).then(H)}e.sequence=c;function s(B,U=V=>!!V,$=null){let V=0;const J=B.length,H=()=>{if(V>=J)return Promise.resolve($);const ee=B[V++];return Promise.resolve(ee()).then(ae=>U(ae)?Promise.resolve(ae):H())};return H()}e.first=s;function o(B,U=V=>!!V,$=null){if(B.length===0)return Promise.resolve($);let V=B.length;const J=()=>{V=-1;for(const H of B)H.cancel?.()};return new Promise((H,ee)=>{for(const ne of B)ne.then(ae=>{--V>=0&&U(ae)?(J(),H(ae)):V===0&&H($)}).catch(ae=>{--V>=0&&(J(),ee(ae))})})}e.firstParallel=o;class l{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(U){return this._size++,new Promise(($,V)=>{this.outstandingPromises.push({factory:U,c:$,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const $=U.factory();$.then(U.c,U.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class v extends l{constructor(){super(1)}}e.Queue=v;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new G;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,$=A.extUri){const V=$.getComparisonKey(U);let J=this.queues.get(V);return J||(J=new v,T.Event.once(J.onDrained)(()=>{J?.dispose(),this.queues.delete(V),this.onDidQueueDrain()}),this.queues.set(V,J)),J}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class O{constructor(U,$){this._token=-1,typeof U=="function"&&typeof $=="number"&&this.setIfNotSet(U,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},$)}setIfNotSet(U,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},$))}}e.TimeoutTimer=O;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,$){this.cancel(),this._token=setInterval(()=>{U()},$)}}e.IntervalTimer=_;class N{constructor(U,$){this.timeoutToken=-1,this.runner=U,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class R{constructor(U,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=R;class M extends N{constructor(U,$){super(U,$);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner?.(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class F extends L.Disposable{constructor(U,$){super();this.options=U,this.handler=$,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,I.setTimeout0)(()=>{if(U)return;const $=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(B,U)=>{const $=requestIdleCallback(B,typeof U=="number"?{timeout:U}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback($))}}}}();class j{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function W(B,U,$){let V;for(let J=0;J<$;J++)try{return await B()}catch(H){V=H,await i(U)}throw V}e.retry=W;class z{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,$,V){return this._pending={taskId:U,cancel:()=>V?.(),promise:$},$.then(()=>this.donePending(U),()=>this.donePending(U)),$}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let $,V;const J=new Promise((H,ee)=>{$=H,V=ee});this._next={run:U,promise:J,promiseResolve:$,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=z;class te{constructor(U,$=()=>Date.now()){this.interval=U,this.nowFn=$,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,$)=>{this.completeCallback=U,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise($=>{this.completeCallback(U),this.resolved=!0,$()})}error(U){return new Promise($=>{this.errorCallback(U),this.rejected=!0,$()})}cancel(){new Promise(U=>{this.errorCallback(new t.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=G;var K;(function(B){async function U(V){let J;const H=await Promise.all(V.map(ee=>ee.then(ne=>ne,ne=>{J||(J=ne)})));if(typeof J!="undefined")throw J;return H}B.settled=U;function $(V){return new Promise(async(J,H)=>{try{await V(J,H)}catch(ee){H(ee)}})}B.withAsyncBody=$})(K=e.Promises||(e.Promises={}));var X;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(X||(X={}));class Y{constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const $={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(U($)),this.resolve()}catch(V){this.reject(V)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}static fromArray(U){return new Y($=>{$.emitMany(U)})}static fromPromise(U){return new Y(async $=>{$.emitMany(await U)})}static fromPromises(U){return new Y(async $=>{await Promise.all(U.map(async V=>$.emitOne(await V)))})}static merge(U){return new Y(async $=>{await Promise.all(U.map(async V=>{for await(const J of V)$.emitOne(J)}))})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,$){return new Y(async V=>{for await(const J of U)V.emitOne($(J))})}map(U){return Y.map(this,U)}static filter(U,$){return new Y(async V=>{for await(const J of U)$(J)&&V.emitOne(J)})}filter(U){return Y.filter(this,U)}static coalesce(U){return Y.filter(U,$=>!!$)}coalesce(){return Y.coalesce(this)}static async toPromise(U){const $=[];for await(const V of U)$.push(V);return $}toPromise(){return Y.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class q extends Y{constructor(U,$){super($);this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=q;function x(B){const U=new k.CancellationTokenSource,$=B(U.token);return new q(U,async V=>{const J=U.token.onCancellationRequested(()=>{J.dispose(),U.dispose(),V.reject(new t.CancellationError)});try{for await(const H of $){if(U.token.isCancellationRequested)return;V.emitOne(H)}J.dispose(),U.dispose()}catch(H){J.dispose(),U.dispose(),V.reject(H)}})}e.createCancelableAsyncIterable=x}),define(re[82],se([0,1,17,6,42,38,12,4,26]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",E="[^/\\\\]",p=/\//g;function C(G,K){switch(G){case 0:return"";case 1:return`${E}*?`;default:return`(?:${D}|${E}+${D}${K?`|${D}${E}+`:""})*?`}}function d(G,K){if(!G)return[];const X=[];let Y=!1,q=!1,x="";for(const B of G){switch(B){case K:if(!Y&&!q){X.push(x),x="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":q=!0;break;case"]":q=!1;break}x+=B}return x&&X.push(x),X}e.splitGlobAware=d;function S(G){if(!G)return"";let K="";const X=d(G,e.GLOB_SPLIT);if(X.every(Y=>Y===e.GLOBSTAR))K=".*";else{let Y=!1;X.forEach((q,x)=>{if(q===e.GLOBSTAR){if(Y)return;K+=C(2,x===X.length-1)}else{let B=!1,U="",$=!1,V="";for(const J of q){if(J!=="}"&&B){U+=J;continue}if($&&(J!=="]"||!V)){let H;J==="-"?H=J:(J==="^"||J==="!")&&!V?H="^":J===e.GLOB_SPLIT?H="":H=(0,b.escapeRegExpCharacters)(J),V+=H;continue}switch(J){case"{":B=!0;continue;case"[":$=!0;continue;case"}":{K+=`(?:${d(U,",").map(ne=>S(ne)).join("|")})`,B=!1,U="";break}case"]":{K+="["+V+"]",$=!1,V="";break}case"?":K+=E;continue;case"*":K+=C(1);continue;default:K+=(0,b.escapeRegExpCharacters)(J)}}x<X.length-1&&(X[x+1]!==e.GLOBSTAR||x+2<X.length)&&(K+=D)}Y=q===e.GLOBSTAR})}return K}const w=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(G,K){if(!G)return i;let X;typeof G!="string"?X=G.pattern:X=G,X=X.trim();const Y=`${X}_${!!K.trimForExclusions}`;let q=n.get(Y);if(q)return c(q,G);let x;return w.test(X)?q=o(X.substr(4),X):(x=h.exec(s(X,K)))?q=l(x[1],X):(K.trimForExclusions?g:m).test(X)?q=v(X,K):(x=f.exec(s(X,K)))?q=y(x[1].substr(1),X,!0):(x=u.exec(s(X,K)))?q=y(x[1],X,!1):q=O(X),n.set(Y,q),c(q,G)}function c(G,K){if(typeof K=="string")return G;const X=function(Y,q){return(0,T.isEqualOrParent)(Y,K.base,!I.isLinux)?G(Y.substr(K.base.length+1),q):null};return X.allBasenames=G.allBasenames,X.allPaths=G.allPaths,X.basenames=G.basenames,X.patterns=G.patterns,X}function s(G,K){return K.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function o(G,K){return function(X,Y){return typeof X=="string"&&X.endsWith(G)?K:null}}function l(G,K){const X=`/${G}`,Y=`\\${G}`,q=function(B,U){return typeof B!="string"?null:U?U===G?K:null:B===G||B.endsWith(X)||B.endsWith(Y)?K:null},x=[G];return q.basenames=x,q.patterns=[K],q.allBasenames=x,q}function v(G,K){const X=z(G.slice(1,-1).split(",").map(U=>a(U,K)).filter(U=>U!==i),G),Y=X.length;if(!Y)return i;if(Y===1)return X[0];const q=function(U,$){for(let V=0,J=X.length;V<J;V++)if(X[V](U,$))return G;return null},x=X.find(U=>!!U.allBasenames);x&&(q.allBasenames=x.allBasenames);const B=X.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return B.length&&(q.allPaths=B),q}function y(G,K,X){const Y=A.sep===A.posix.sep,q=Y?G:G.replace(p,A.sep),x=A.sep+q,B=A.posix.sep+G;let U;return X?U=function($,V){return typeof $=="string"&&($===q||$.endsWith(x)||!Y&&($===G||$.endsWith(B)))?K:null}:U=function($,V){return typeof $=="string"&&($===q||!Y&&$===G)?K:null},U.allPaths=[(X?"*/":"./")+G],U}function O(G){try{const K=new RegExp(`^${S(G)}$`);return function(X){return K.lastIndex=0,typeof X=="string"&&K.test(X)?G:null}}catch{return i}}function _(G,K,X){return!G||typeof K!="string"?!1:N(G)(K,void 0,X)}e.match=_;function N(G,K={}){if(!G)return r;if(typeof G=="string"||R(G)){const X=a(G,K);if(X===i)return r;const Y=function(q,x){return!!X(q,x)};return X.allBasenames&&(Y.allBasenames=X.allBasenames),X.allPaths&&(Y.allPaths=X.allPaths),Y}return j(G,K)}e.parse=N;function R(G){const K=G;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=R;function M(G){return G.allBasenames||[]}e.getBasenameTerms=M;function F(G){return G.allPaths||[]}e.getPathTerms=F;function j(G,K){const X=z(Object.getOwnPropertyNames(G).map(U=>W(U,G[U],K)).filter(U=>U!==i)),Y=X.length;if(!Y)return i;if(!X.some(U=>!!U.requiresSiblings)){if(Y===1)return X[0];const U=function(J,H){let ee;for(let ne=0,ae=X.length;ne<ae;ne++){const ue=X[ne](J,H);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(ee||(ee=[]),ee.push(ue))}return ee?(async()=>{for(const ne of ee){const ae=await ne;if(typeof ae=="string")return ae}return null})():null},$=X.find(J=>!!J.allBasenames);$&&(U.allBasenames=$.allBasenames);const V=X.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return V.length&&(U.allPaths=V),U}const q=function(U,$,V){let J,H;for(let ee=0,ne=X.length;ee<ne;ee++){const ae=X[ee];ae.requiresSiblings&&V&&($||($=(0,A.basename)(U)),J||(J=$.substr(0,$.length-(0,A.extname)(U).length)));const ue=ae(U,$,J,V);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(H||(H=[]),H.push(ue))}return H?(async()=>{for(const ee of H){const ne=await ee;if(typeof ne=="string")return ne}return null})():null},x=X.find(U=>!!U.allBasenames);x&&(q.allBasenames=x.allBasenames);const B=X.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return B.length&&(q.allPaths=B),q}function W(G,K,X){if(K===!1)return i;const Y=a(G,X);if(Y===i)return i;if(typeof K=="boolean")return Y;if(K){const q=K.when;if(typeof q=="string"){const x=(B,U,$,V)=>{if(!V||!Y(B,U))return null;const J=q.replace("$(basename)",$),H=V(J);return(0,t.isThenable)(H)?H.then(ee=>ee?G:null):H?G:null};return x.requiresSiblings=!0,x}}return Y}function z(G,K){const X=G.filter(U=>!!U.basenames);if(X.length<2)return G;const Y=X.reduce((U,$)=>{const V=$.basenames;return V?U.concat(V):U},[]);let q;if(K){q=[];for(let U=0,$=Y.length;U<$;U++)q.push(K)}else q=X.reduce((U,$)=>{const V=$.patterns;return V?U.concat(V):U},[]);const x=function(U,$){if(typeof U!="string")return null;if(!$){let J;for(J=U.length;J>0;J--){const H=U.charCodeAt(J-1);if(H===47||H===92)break}$=U.substr(J)}const V=Y.indexOf($);return V!==-1?q[V]:null};x.basenames=Y,x.patterns=q,x.allBasenames=Y;const B=G.filter(U=>!U.basenames);return B.push(x),B}function te(G,K){return(0,k.equals)(G,K,(X,Y)=>typeof X=="string"&&typeof Y=="string"?X===Y:typeof X!="string"&&typeof Y!="string"?X.base===Y.base&&X.pattern===Y.pattern:!1)}e.patternsEquals=te}),define(re[129],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(D){return D.toJSON()}class T{constructor(E){this._uriTransformer=E}transformIncoming(E){const p=this._uriTransformer.transformIncoming(E);return p===E?E:t(k.URI.from(p))}transformOutgoing(E){const p=this._uriTransformer.transformOutgoing(E);return p===E?E:t(k.URI.from(p))}transformOutgoingURI(E){const p=this._uriTransformer.transformOutgoing(E);return p===E?E:k.URI.from(p)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function L(D,E,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof k.URI)return E.transformOutgoing(D);for(const C in D)if(Object.hasOwnProperty.call(D,C)){const d=L(D[C],E,p+1);d!==null&&(D[C]=d)}}return null}function A(D,E){const p=L(D,E,0);return p===null?D:p}e.transformOutgoingURIs=A;function I(D,E,p,C){if(!D||C>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?k.URI.revive(E.transformIncoming(D)):E.transformIncoming(D);for(const d in D)if(Object.hasOwnProperty.call(D,d)){const S=I(D[d],E,p,C+1);S!==null&&(D[d]=S)}}return null}function b(D,E){const p=I(D,E,!1,0);return p===null?D:p}e.transformIncomingURIs=b;function P(D,E){const p=I(D,E,!0,0);return p===null?D:p}e.transformAndReviveIncomingURIs=P}),define(re[130],se([0,1,35,9,38,31,116]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,E=0;const p=(0,k.networkInterfaces)();for(const C in p){const d=p[C];if(d)for(const{mac:S,internal:w}of d)w||(E+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(D+=1))}this._value=E>0?D/E:0}return this._value}};let I;async function b(){return I||(I=(async()=>await P()||L.generateUuid())()),I}e.getMachineId=b;async function P(){try{const D=await new Promise((p,C)=>{Z(["crypto"],p,C)}),E=(0,A.getMac)();return D.createHash("sha256").update(E,"utf8").digest("hex")}catch(D){t.onUnexpectedError(D);return}}}),define(re[27],se([0,1,54,35,267,6,42,80,12,4,19,8]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function C(F,j=p.UNLINK){if((0,A.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return j===p.UNLINK?S(F):d(F)}async function d(F){try{const j=(0,A.randomPath)((0,t.tmpdir)());try{await k.promises.rename(F,j)}catch{return S(F)}S(j).catch(W=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function S(F){return(0,T.promisify)(k.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function w(F){if((0,A.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function h(F,j){return f(await(j?m(F):(0,T.promisify)(k.readdir)(F)))}async function m(F){try{return await(0,T.promisify)(k.readdir)(F,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const j=[],W=await h(F);for(const z of W){let te=!1,G=!1,K=!1;try{const X=await e.Promises.lstat((0,b.join)(F,z));te=X.isFile(),G=X.isDirectory(),K=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}j.push({name:z,isFile:()=>te,isDirectory:()=>G,isSymbolicLink:()=>K})}return j}function g(F){return f(k.readdirSync(F))}e.readdirSync=g;function f(F){return F.map(j=>typeof j=="string"?P.isMacintosh?(0,I.normalizeNFC)(j):j:(j.name=P.isMacintosh?(0,I.normalizeNFC)(j.name):j.name,j))}async function u(F){const j=await h(F),W=[];for(const z of j)await r.existsDirectory((0,b.join)(F,z))&&W.push(z);return W}function n(F,j=1e3){return new Promise(W=>{let z=!1;const te=setInterval(()=>{z||(z=!0,k.access(F,G=>{z=!1,G&&(clearInterval(te),W(void 0))}))},j)})}e.whenDeleted=n;var r;(function(F){async function j(te){let G;try{if(G=await e.Promises.lstat(te),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(P.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw X}throw K}}F.stat=j;async function W(te){try{const{stat:G,symbolicLink:K}=await F.stat(te);return G.isFile()&&K?.dangling!==!0}catch{}return!1}F.existsFile=W;async function z(te){try{const{stat:G,symbolicLink:K}=await F.stat(te);return G.isDirectory()&&K?.dangling!==!0}catch{}return!1}F.existsDirectory=z})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function a(F,j,W){return i.queueFor(E.URI.file(F),D.extUriBiasedIgnorePathCase).queue(()=>{const z=l(W);return new Promise((te,G)=>s(F,j,z,K=>K?G(K):te()))})}let c=!0;function s(F,j,W,z){if(!c)return k.writeFile(F,j,{mode:W.mode,flag:W.flag},z);k.open(F,W.flag,W.mode,(te,G)=>{if(te)return z(te);k.writeFile(G,j,K=>{if(K)return k.close(G,()=>z(K));k.fdatasync(G,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),c=!1),k.close(G,Y=>z(Y))))})})}function o(F,j,W){const z=l(W);if(!c)return k.writeFileSync(F,j,{mode:z.mode,flag:z.flag});const te=k.openSync(F,z.flag,z.mode);try{k.writeFileSync(te,j);try{k.fdatasyncSync(te)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),c=!1}}finally{k.closeSync(te)}}e.writeFileSync=o;function l(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function v(F,j){if(F!==j)try{await e.Promises.rename(F,j)}catch(W){if(F.toLowerCase()!==j.toLowerCase()&&W.code==="EXDEV"||F.endsWith("."))await y(F,j,{preserveSymlinks:!1}),await C(F,p.MOVE);else throw W}}async function y(F,j,W){return _(F,j,{root:{source:F,target:j},options:W,handledSourcePaths:new Set})}const O=511;async function _(F,j,W){if(W.handledSourcePaths.has(F))return;W.handledSourcePaths.add(F);const{stat:z,symbolicLink:te}=await r.stat(F);if(te){if(W.options.preserveSymlinks)try{return await M(F,j,W)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(te.dangling)return}return z.isDirectory()?N(F,j,z.mode&O,W):R(F,j,z.mode&O)}async function N(F,j,W,z){await e.Promises.mkdir(j,{recursive:!0,mode:W});const te=await h(F);for(const G of te)await _((0,b.join)(F,G),(0,b.join)(j,G),z)}async function R(F,j,W){await e.Promises.copyFile(F,j),await e.Promises.chmod(j,W)}async function M(F,j,W){let z=await e.Promises.readlink(F);(0,A.isEqualOrParent)(z,W.root.source,!P.isLinux)&&(z=(0,b.join)(W.root.target,z.substr(W.root.source.length+1))),await e.Promises.symlink(z,j)}e.Promises=new class{get access(){return(0,T.promisify)(k.access)}get stat(){return(0,T.promisify)(k.stat)}get lstat(){return(0,T.promisify)(k.lstat)}get utimes(){return(0,T.promisify)(k.utimes)}get read(){return(F,j,W,z,te)=>new Promise((G,K)=>{k.read(F,j,W,z,te,(X,Y,q)=>X?K(X):G({bytesRead:Y,buffer:q}))})}get readFile(){return(0,T.promisify)(k.readFile)}get write(){return(F,j,W,z,te)=>new Promise((G,K)=>{k.write(F,j,W,z,te,(X,Y,q)=>X?K(X):G({bytesWritten:Y,buffer:q}))})}get appendFile(){return(0,T.promisify)(k.appendFile)}get fdatasync(){return(0,T.promisify)(k.fdatasync)}get truncate(){return(0,T.promisify)(k.truncate)}get rename(){return(0,T.promisify)(k.rename)}get copyFile(){return(0,T.promisify)(k.copyFile)}get open(){return(0,T.promisify)(k.open)}get close(){return(0,T.promisify)(k.close)}get symlink(){return(0,T.promisify)(k.symlink)}get readlink(){return(0,T.promisify)(k.readlink)}get chmod(){return(0,T.promisify)(k.chmod)}get mkdir(){return(0,T.promisify)(k.mkdir)}get unlink(){return(0,T.promisify)(k.unlink)}get rmdir(){return(0,T.promisify)(k.rmdir)}get realpath(){return(0,T.promisify)(k.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return u}get writeFile(){return a}get rm(){return C}get move(){return v}get copy(){return y}}}),define(re[131],se([0,1,54,12,4,26,27]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(p){if(T.isLinux)return p;const C=(0,t.dirname)(p);if(p===C)return p;const d=((0,t.basename)(p)||p).toLowerCase();try{const w=(0,A.readdirSync)(C).filter(h=>h.toLowerCase()===d);if(w.length===1){const h=I(C);if(h)return(0,t.join)(h,w[0])}else if(w.length>1){const h=w.indexOf(d);if(h>=0){const m=I(C);if(m)return(0,t.join)(m,w[h])}}}catch{}return null}e.realcaseSync=I;async function b(p){if(T.isLinux)return p;const C=(0,t.dirname)(p);if(p===C)return p;const d=((0,t.basename)(p)||p).toLowerCase();try{const w=(await A.Promises.readdir(C)).filter(h=>h.toLowerCase()===d);if(w.length===1){const h=await b(C);if(h)return(0,t.join)(h,w[0])}else if(w.length>1){const h=w.indexOf(d);if(h>=0){const m=await b(C);if(m)return(0,t.join)(m,w[h])}}}catch{}return null}e.realcase=b;async function P(p){try{return await A.Promises.realpath(p)}catch{const d=E(p);return await A.Promises.access(d,k.constants.R_OK),d}}e.realpath=P;function D(p){try{return k.realpathSync(p)}catch{const d=E(p);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=D;function E(p){return(0,L.rtrim)((0,t.normalize)(p),t.sep)}}),define(re[83],se([0,1,35,12,27]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(b||(b={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class E{constructor(u,n,r){this.exePath=u,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await T.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?P===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function C({useAlternateBitness:f=!1,findPreview:u=!1}={}){const n=p({useAlternateBitness:f});if(!n)return null;const r=t.join(n,"PowerShell");if(!await T.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const o of await T.Promises.readdir(r)){let l=-1;if(u){const y=o.indexOf("-");if(y<0)continue;const O=o.substring(0,y);if(!L.test(O)||o.substring(y+1)!=="preview")continue;l=parseInt(O,10)}else{if(!L.test(o))continue;l=parseInt(o,10)}if(l<=i)continue;const v=t.join(r,o,"pwsh.exe");!await T.SymlinkSupport.existsFile(v)||(a=v,i=l)}if(!a)return null;const c=n.includes("x86")?" (x86)":"",s=u?" Preview":"";return new E(a,`PowerShell${s}${c}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await T.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await T.Promises.readdir(u))if(n.test(i)){const a=t.join(u,i,"pwsh.exe");return new E(a,r)}return null}function S(){const f=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(f,".NET Core PowerShell Global Tool")}function w(){const f=t.join(process.env.windir,P===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(f,"Windows PowerShell",!0)}async function*h(){let f=await C();f&&(yield f),f=await C({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=S(),f&&(yield f),f=await C({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await C({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*m(){for await(const f of h())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=m;async function g(){for await(const f of m())return f;return null}e.getFirstAvailablePowerShellInstallation=g}),define(re[132],se([0,1,48,20]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function T(A){return new Promise((I,b)=>{let P;const D=new Map;function E(C,d,S,w,h){const m=D.get(d);if(C===A||m){const g={name:p(S),cmd:S,pid:C,ppid:d,load:w,mem:h};D.set(C,g),C===A&&(P=g),m&&(m.children||(m.children=[]),m.children.push(g),m.children.length>1&&(m.children=m.children.sort((f,u)=>f.pid-u.pid)))}}function p(C){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,m=/--crashes-directory/,g=/\\pipe\\winpty-control/,f=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(m.exec(C))return"electron-crash-reporter";if(g.exec(C))return"winpty-process";if(f.exec(C))return"console-window-host (Windows internal process)";let n=u.exec(C);if(n&&n.length===2)return n[1]==="renderer"?d.exec(C)?"shared-process":S.exec(C)?"issue-reporter":w.exec(C)?"process-explorer":"window":n[1]==="utility"&&h.exec(C)?"utility-network-service":n[1];const r=/[a-zA-Z-]+\.js/g;let i="";do n=r.exec(C),n&&(i+=n+" ");while(n);return i&&C.indexOf("node ")<0&&C.indexOf("node.exe")<0?`electron_node ${i}`:C}if(process.platform==="win32"){const C=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{Z(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(A,S=>{if(!S){b(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(S,w=>{const h=new Map;w.forEach(m=>{const g=C(m.commandLine||"");h.set(m.pid,{name:p(g),cmd:g,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),P=h.get(A),P?(h.forEach(m=>{const g=h.get(m.ppid);g&&(g.children||(g.children=[]),g.children.push(m))}),h.forEach(m=>{m.children&&(m.children=m.children.sort((g,f)=>g.pid-f.pid))}),I(P)):b(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let C=function(){let d=[P];const S=[];for(;d.length;){const h=d.shift();h&&(S.push(h.pid),h.children&&(d=d.concat(h.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Z).fsPath);w+=" "+S.join(" "),(0,k.exec)(w,{},(h,m,g)=>{if(h||g)b(h||new Error(g.toString()));else{const f=m.toString().split(`
`);for(let u=0;u<S.length;u++){const n=D.get(S[u]);n.load=parseFloat(f[u])}if(!P){b(new Error(`Root process ${A} not found`));return}I(P)}})};(0,k.exec)("which ps",{},(d,S,w)=>{if(d||w)if(process.platform!=="linux")b(d||new Error(w.toString()));else{const h=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Z).fsPath);(0,k.exec)(h,{},(m,g,f)=>{m||f?b(m||new Error(f.toString())):(L(g,E),C())})}else{const h=S.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${h} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,f,u)=>{g||u&&!u.includes("screen size is bogus")?b(g||new Error(u.toString())):(L(f,E),process.platform==="linux"?C():P?I(P):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=T;function L(A,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=A.toString().split(`
`);for(const D of P){const E=b.exec(D.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var me=this&&this.__decorate||function(Z,e,k,t){var T=arguments.length,L=T<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Z,e,k,t);else for(var I=Z.length-1;I>=0;I--)(A=Z[I])&&(L=(T<3?A(L):T>3?A(e,k,L):A(e,k))||L);return T>3&&L&&Object.defineProperty(e,k,L),L};define(re[39],se([0,1,17,6,16,23,60,9,3,2,64,26,14]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var C;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(C=e.RequestType||(e.RequestType={}));function d(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function w(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(h||(h={}));class m{constructor(K){this.buffer=K,this.pos=0}read(K){const X=this.buffer.slice(this.pos,this.pos+K);return this.pos+=X.byteLength,X}}class g{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var f;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(f||(f={}));function u(G){const K=T.VSBuffer.alloc(4);return K.writeUInt32BE(G,0),K}function n(G){return G.read(4).readUInt32BE(0)}function r(G){const K=T.VSBuffer.alloc(1);return K.writeUInt8(G,0),K}const i={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},a=typeof Buffer!="undefined";function c(G,K){if(typeof K=="undefined")G.write(i.Undefined);else if(typeof K=="string"){const X=T.VSBuffer.fromString(K);G.write(i.String),G.write(u(X.byteLength)),G.write(X)}else if(a&&Buffer.isBuffer(K)){const X=T.VSBuffer.wrap(K);G.write(i.Buffer),G.write(u(X.byteLength)),G.write(X)}else if(K instanceof T.VSBuffer)G.write(i.VSBuffer),G.write(u(K.byteLength)),G.write(K);else if(Array.isArray(K)){G.write(i.Array),G.write(u(K.length));for(const X of K)c(G,X)}else{const X=T.VSBuffer.fromString(JSON.stringify(K));G.write(i.Object),G.write(u(X.byteLength)),G.write(X)}}function s(G){switch(G.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return G.read(n(G)).toString();case f.Buffer:return G.read(n(G)).buffer;case f.VSBuffer:return G.read(n(G));case f.Array:{const X=n(G),Y=[];for(let q=0;q<X;q++)Y.push(s(G));return Y}case f.Object:return JSON.parse(G.read(n(G)).toString())}}class o{constructor(K,X,Y=null,q=1e3){this.protocol=K,this.ctx=X,this.logger=Y,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel(K,X){this.channels.set(K,X),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const X=this.send([K.type]);this.logger?.logOutgoing(X,0,1,w(K.type));return}case 201:case 202:case 204:case 203:{const X=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(X,K.id,1,w(K.type),K.data);return}}}send(K,X=void 0){const Y=new g;return c(Y,K),c(Y,X),this.sendBuffer(Y.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const X=new m(K),Y=s(X),q=s(X),x=Y[0];switch(x){case 100:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${d(x)}: ${Y[2]}.${Y[3]}`,q),this.onPromise({type:x,id:Y[1],channelName:Y[2],name:Y[3],arg:q});case 102:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${d(x)}: ${Y[2]}.${Y[3]}`,q),this.onEventListen({type:x,id:Y[1],channelName:Y[2],name:Y[3],arg:q});case 101:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${d(x)}`),this.disposeActiveRequest({type:x,id:Y[1]});case 103:return this.logger?.logIncoming(K.byteLength,Y[1],1,`${d(x)}`),this.disposeActiveRequest({type:x,id:Y[1]})}}onPromise(K){const X=this.channels.get(K.channelName);if(!X){this.collectPendingRequest(K);return}const Y=new L.CancellationTokenSource;let q;try{q=X.call(this.ctx,K.name,K.arg,Y.token)}catch(U){q=Promise.reject(U)}const x=K.id;q.then(U=>{this.sendResponse({id:x,data:U,type:201}),this.activeRequests.delete(K.id)},U=>{U instanceof Error?this.sendResponse({id:x,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:x,data:U,type:203}),this.activeRequests.delete(K.id)});const B=(0,P.toDisposable)(()=>Y.cancel());this.activeRequests.set(K.id,B)}onEventListen(K){const X=this.channels.get(K.channelName);if(!X){this.collectPendingRequest(K);return}const Y=K.id,x=X.listen(this.ctx,K.name,K.arg)(B=>this.sendResponse({id:Y,data:B,type:204}));this.activeRequests.set(K.id,x)}disposeActiveRequest(K){const X=this.activeRequests.get(K.id);X&&(X.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let X=this.pendingRequests.get(K.channelName);X||(X=[],this.pendingRequests.set(K.channelName,X));const Y=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:K,timeoutTimer:Y})}flushPendingRequests(K){const X=this.pendingRequests.get(K);if(X){for(const Y of X)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var l;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(K,X=null){this.protocol=K,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=X}getChannel(K){const X=this;return{call(Y,q,x){return X.isDisposed?Promise.reject(I.canceled()):X.requestPromise(K,Y,q,x)},listen(Y,q){return X.isDisposed?b.Event.None:X.requestEvent(K,Y,q)}}}requestPromise(K,X,Y,q=L.CancellationToken.None){const x=this.lastRequestId++,U={id:x,type:100,channelName:K,name:X,arg:Y};if(q.isCancellationRequested)return Promise.reject(I.canceled());let $;return new Promise((J,H)=>{if(q.isCancellationRequested)return H(I.canceled());const ee=()=>{const Se=fe=>{switch(fe.type){case 201:this.handlers.delete(x),J(fe.data);break;case 202:{this.handlers.delete(x);const pe=new Error(fe.data.message);pe.stack=fe.data.stack,pe.name=fe.data.name,H(pe);break}case 203:this.handlers.delete(x),H(fe.data);break}};this.handlers.set(x,Se),this.sendRequest(U)};let ne=null;this.state===h.Idle?ee():(ne=(0,t.createCancelablePromise)(Se=>this.whenInitialized()),ne.then(()=>{ne=null,ee()}));const ae=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:x,type:101}),H(I.canceled())},ue=q.onCancellationRequested(ae);$=(0,P.combinedDisposable)((0,P.toDisposable)(ae),ue),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(K,X,Y){const q=this.lastRequestId++,B={id:q,type:102,channelName:K,name:X,arg:Y};let U=null;const $=new b.Emitter({onFirstListenerAdd:()=>{U=(0,t.createCancelablePromise)(J=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add($),this.sendRequest(B)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete($),this.sendRequest({id:q,type:103}))}}),V=J=>$.fire(J.data);return this.handlers.set(q,V),$.event}sendRequest(K){switch(K.type){case 100:case 102:{const X=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger?.logOutgoing(X,K.id,0,`${d(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const X=this.send([K.type,K.id]);this.logger?.logOutgoing(X,K.id,0,d(K.type));return}}}send(K,X=void 0){const Y=new g;return c(Y,K),c(Y,X),this.sendBuffer(Y.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const X=new m(K),Y=s(X),q=s(X),x=Y[0];switch(x){case 200:return this.logger?.logIncoming(K.byteLength,0,0,w(x)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(K.byteLength,Y[1],0,w(x),q),this.onResponse({type:Y[0],id:Y[1],data:q})}}onResponse(K){if(K.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(K.id)?.(K)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}me([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class y{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:X,onDidClientDisconnect:Y})=>{b.Event.once(X.onMessage)(x=>{const B=new m(x),U=s(B),$=new o(X,U),V=new v(X);this.channels.forEach((H,ee)=>$.registerChannel(ee,H));const J={channelServer:$,channelClient:V,ctx:U};this._connections.add(J),this._onDidAddConnection.fire(J),Y(()=>{$.dispose(),V.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const K=[];return this._connections.forEach(X=>K.push(X)),K}getChannel(K,X){const Y=this;return{call(q,x,B){let U;if((0,p.isFunction)(X)){const V=(0,k.getRandomElement)(Y.connections.filter(X));U=V?Promise.resolve(V):b.Event.toPromise(b.Event.filter(Y.onDidAddConnection,X))}else U=X.routeCall(Y,q,x);const $=U.then(V=>V.channelClient.getChannel(K));return _($).call(q,x,B)},listen(q,x){if((0,p.isFunction)(X))return Y.getMulticastEvent(K,X,q,x);const B=X.routeEvent(Y,q,x).then(U=>U.channelClient.getChannel(K));return _(B).listen(q,x)}}}getMulticastEvent(K,X,Y,q){const x=this;let B=new P.DisposableStore;const U=new b.Emitter({onFirstListenerAdd:()=>{B=new P.DisposableStore;const $=new b.EventMultiplexer,V=new Map,J=ee=>{const ae=ee.channelClient.getChannel(K).listen(Y,q),ue=$.add(ae);V.set(ee,ue)},H=ee=>{const ne=V.get(ee);!ne||(ne.dispose(),V.delete(ee))};x.connections.filter(X).forEach(J),b.Event.filter(x.onDidAddConnection,X)(J,void 0,B),x.onDidRemoveConnection(H,void 0,B),$.event(U.fire,U,B),B.add($)},onLastListenerRemove:()=>{B.dispose()}});return U.event}registerChannel(K,X){this.channels.set(K,X),this._connections.forEach(Y=>{Y.channelServer.registerChannel(K,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class O{constructor(K,X,Y=null){const q=new g;c(q,X),K.send(q.buffer),this.channelClient=new v(K,Y),this.channelServer=new o(K,X,Y)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,X){this.channelServer.registerChannel(K,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function _(G){return{call(K,X,Y){return G.then(q=>q.call(K,X,Y))},listen(K,X){const Y=new b.Relay;return G.then(q=>Y.input=q.listen(K,X)),Y.event}}}e.getDelayedChannel=_;function N(G){let K=!1;return{call(X,Y,q){return K?G.call(X,Y,q):(0,t.timeout)(0).then(()=>K=!0).then(()=>G.call(X,Y,q))},listen(X,Y){if(K)return G.listen(X,Y);const q=new b.Relay;return(0,t.timeout)(0).then(()=>K=!0).then(()=>q.input=G.listen(X,Y)),q.event}}}e.getNextTickChannel=N;class R{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const X of K.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=R;var M;(function(G){function K(x,B){const U=x,$=B&&B.disableMarshalling,V=new Map;for(const J in U)Y(J)&&V.set(J,b.Event.buffer(U[J],!0));return new class{listen(J,H,ee){const ne=V.get(H);if(ne)return ne;if(q(H)){const ae=U[H];if(typeof ae=="function")return ae.call(U,ee)}throw new Error(`Event not found: ${H}`)}call(J,H,ee){const ne=U[H];if(typeof ne=="function"){if(!$&&Array.isArray(ee))for(let ae=0;ae<ee.length;ae++)ee[ae]=(0,D.revive)(ee[ae]);return ne.apply(U,ee)}throw new Error(`Method not found: ${H}`)}}}G.fromService=K;function X(x,B){const U=B&&B.disableMarshalling;return new Proxy({},{get($,V){if(typeof V=="string")return B?.properties?.has(V)?B.properties.get(V):q(V)?function(J){return x.listen(V,J)}:Y(V)?x.listen(V):async function(...J){let H;B&&!(0,p.isUndefinedOrNull)(B.context)?H=[B.context,...J]:H=J;const ee=await x.call(V,H);return U?ee:(0,D.revive)(ee)};throw new Error(`Property not found: ${String(V)}`)}})}G.toService=X;function Y(x){return x[0]==="o"&&x[1]==="n"&&E.isUpperAsciiLetter(x.charCodeAt(2))}function q(x){return/^onDynamic/.test(x)&&E.isUpperAsciiLetter(x.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const K=G.toString();if(K!=="[object Object]")return K}return G}function W(G){return Array.isArray(G)?G.map(j):j(G)}function z(G,K,X,Y,q,x,B){B=W(B);const U=F[q],$=U[Y%U.length];let V=[`%c[${G}]%c[${String(K).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(x)?(V=V.concat(B),V.push(")")):V.push(B),console.log.apply(console,V)}e.logWithColors=z;class te{constructor(K,X){this._outgoingPrefix=K,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,X,Y,q,x){this._totalOutgoing+=K,z(this._outgoingPrefix,this._totalOutgoing,K,X,Y,q,x)}logIncoming(K,X,Y,q,x){this._totalIncoming+=K,z(this._incomingPrefix,this._totalIncoming,K,X,Y,q,x)}}e.IPCLogger=te}),define(re[133],se([0,1,16,3,39]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(b){this.port=b,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",P=>k.VSBuffer.wrap(P.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends T.IPCClient{constructor(b,P){const D=new L(b);super(D,P);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=A}),define(re[84],se([0,1,16,3,2,39]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(a){a.enableDiagnostics=!1,a.records=[];const c=new WeakMap;let s=0;function o(v,y){if(!c.has(v)){const O=String(++s);c.set(v,O)}return c.get(v)}function l(v,y,O,_){if(!a.enableDiagnostics)return;const N=o(v,y);if(_ instanceof k.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const R=k.VSBuffer.alloc(_.byteLength);R.set(_),a.records.push({timestamp:Date.now(),id:N,label:y,type:O,buff:R})}else a.records.push({timestamp:Date.now(),id:N,label:y,type:O,data:_})}a.traceSocketEvent=l})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function D(){return P||(P=k.VSBuffer.alloc(0)),P}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,s){if(c===0)return D();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const y=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=c),y}if(this._chunks[0].byteLength>c){const y=this._chunks[0].slice(0,c);return s&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),y}const o=k.VSBuffer.alloc(c);let l=0,v=0;for(;c>0;){const y=this._chunks[v];if(y.byteLength>c){const O=y.slice(0,c);o.set(O,l),l+=c,s&&(this._chunks[v]=y.slice(c),this._totalLength-=c),c-=c}else o.set(y,l),l+=y.byteLength,s?(this._chunks.shift(),this._totalLength-=y.byteLength):v++,c-=y.byteLength}return o}}e.ChunkStream=E;var p;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume"})(p||(p={}));function C(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(c,s,o,l){this.type=c,this.id=s,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends T.Disposable{constructor(c){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,l=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new S(o,l,v,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(c.type,0),s.writeUInt32BE(c.id,1),s.writeUInt32BE(c.ack,5),s.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(s,c.data)}_bufferAdd(c,s){const o=this._totalLength===0;return this._data.push(c,s),this._totalLength+=c.byteLength+s.byteLength,o}_bufferTake(){const c=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,s){this._bufferAdd(c,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class m extends T.Disposable{constructor(c){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new S(1,0,0,c))}}e.Protocol=m;class g extends L.IPCClient{constructor(c,s,o=null){super(c,s,o);this.protocol=c}static fromSocket(c,s){return new g(new m(c),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=g;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class u{constructor(c){this.data=c,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const c=[];let s=0,o=this._first;for(;o;)c[s++]=o.data,o=o.next;return c}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const s=new u(c);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class r{constructor(){this.lastRuns=[];const c=Date.now();for(let s=0;s<r._HISTORY_LENGTH;s++)this.lastRuns[s]=c-1e3*s;setInterval(()=>{for(let s=r._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const c=Date.now(),s=(1+r._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<r._HISTORY_LENGTH;l++)c-this.lastRuns[l]<=s&&o++;return 1-o/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(c,s=null,o=r.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=c,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new S(5,0,0,D());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new S(7,0,0,D());this._socketWriter.write(c)}sendResume(){const c=new S(8,0,0,D());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,s){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new S(3,0,this._incomingAckId,D());this._socketWriter.write(c);const s=this._outgoingUnackMsg.toArray();for(let o=0,l=s.length;o<l;o++)this._socketWriter.write(s[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new S(6,0,0,D())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let o=0,l=s.length;o<l;o++)this._socketWriter.write(s[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new S(1,s,this._incomingAckId,c);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(c){const s=new S(2,0,0,c);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),s=Date.now()-c.writtenTime,o=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&o>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-s,2e4-o,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new S(3,0,this._incomingAckId,D());this._socketWriter.write(c)}}e.PersistentProtocol=i}),define(re[134],se([0,1,85,3,39,133]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends T.IPCServer{static getOnDidClientConnect(){const b=t.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(P,D)=>D);return t.Event.map(b,P=>{const{port1:D,port2:E}=new MessageChannel,C={protocol:new L.Protocol(D),onDidClientDisconnect:t.Event.fromDOMEventEmitter(D,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",P,[E]),C})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(re[86],se([0,1,6,3,2,14]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function I(E){const p=E;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b=e.StorageState||(e.StorageState={}));class P extends T.Disposable{constructor(p,C=Object.create(null)){super();this.database=p,this.options=C,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((C,d)=>this.accept(d,C)),p.deleted?.forEach(C=>this.accept(C,void 0))}accept(p,C){if(this.state===b.Closed)return;let d=!1;(0,L.isUndefinedOrNull)(C)?d=this.cache.delete(p):this.cache.get(p)!==C&&(this.cache.set(p,C),d=!0),d&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,C){const d=this.cache.get(p);return(0,L.isUndefinedOrNull)(d)?C:d}getBoolean(p,C){const d=this.get(p);return(0,L.isUndefinedOrNull)(d)?C:d==="true"}getNumber(p,C){const d=this.get(p);return(0,L.isUndefinedOrNull)(d)?C:parseInt(d,10)}async set(p,C){if(this.state===b.Closed)return;if((0,L.isUndefinedOrNull)(C))return this.delete(p);const d=String(C);if(this.cache.get(p)!==d)return this.cache.set(p,d),this.pendingInserts.set(p,d),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===b.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((C,d)=>this.items.set(d,C)),p.delete?.forEach(C=>this.items.delete(C))}async close(){}}e.InMemoryStorageDatabase=D}),define(re[135],se([10,11]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(re[87],se([0,1,48,42,20,29,12,4,36,78,14,115,27,135]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(u,n){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};n&&(r.cwd=n);const i=k.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],r);return new Promise(a=>{i.once("error",c=>{a({success:!1,error:c})}),i.once("exit",(c,s)=>{a(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?d(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=T.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{k.execFile(r,[u.pid.toString()],{encoding:"utf8",shell:!0},(a,c,s)=>{i(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function w(u=b.env){return u.comspec||"cmd.exe"}e.getWindowsShell=w;class h{constructor(n,r,i,a){if(r!==void 0&&i!==void 0&&a!==void 0)this.cmd=n,this.args=r,this.shell=i,this.options=a;else{const c=n;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(b.env).forEach(s=>{c[s]=b.env[s]}),Object.keys(this.options.env).forEach(s=>{c[s]=this.options.env[s]}),this.options.env=c}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const r=n.lastIndexOf(A.sep);return r!==-1&&(n=n.substring(r+1)),h.WellKnowCommands[n]?n:"other"}start(n){return I.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(b.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(r=>{let i,a;const c=new Promise((s,o)=>{i=s,a=o});if(r){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=k.exec(s,this.options,(o,l,v)=>{this.childProcess=null;const y=o;y&&y.killed?a({killed:this.terminateRequested,stdout:l.toString(),stderr:v.toString()}):this.handleExec(i,n,o,l,v)})}else{let s=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,i,n,a);const v={terminated:this.terminateRequested};D.isNumber(l)&&(v.cmdCode=l),i(v)};if(this.shell&&I.isWindows){const l=L.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let v=!1,y=!1;const O=[];let _=this.ensureQuotes(this.cmd);O.push(_.value),v=_.quoted,this.args&&this.args.forEach(R=>{_=this.ensureQuotes(R),O.push(_.value),y=y&&_.quoted});const N=["/s","/c"];v?y?N.push('"'+O.join(" ")+'"'):O.length>1?N.push('"'+O[0]+'" '+O.slice(1).join(" ")):N.push('"'+O[0]+'"'):N.push(O.join(" ")),s=k.spawn(w(),N,l)}else this.cmd&&(s=k.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(D.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",l=>{this.childProcess=null,a({terminated:this.terminateRequested,error:l})}),s.pid&&(this.childProcess.on("close",o),this.handleSpawn(s,i,n,a,!0)))}return c})}handleClose(n,r,i,a){}ensureQuotes(n){return h.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,S(n,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!I.isWindows)return n(!1);const r=k.spawn(w(),["/s","/c"]);r.on("error",i=>n(!0)),r.on("exit",i=>n(!1))})}}e.AbstractProcess=h,h.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},h.regexp=/^[^"].* .*[^"]/;class m extends h{constructor(n,r,i,a){super(n,r,i,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,r,i,a,c){[a,c].forEach((s,o)=>{const l=new E.LineDecoder;l.write(s).forEach(O=>{r({line:O,source:o===0?0:1})});const y=l.end();y&&r({line:y,source:o===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,r,i,a,c){const s=new E.LineDecoder,o=new E.LineDecoder;n.stdout.on("data",l=>{s.write(l).forEach(y=>i({line:y,source:0}))}),n.stderr.on("data",l=>{o.write(l).forEach(y=>i({line:y,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(n,r,i,a){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}}e.LineProcess=m;function g(u){let n=[],r=!1;const i=function(a){if(r){n.push(a);return}(!u.send(a,s=>{if(s&&console.error(s),r=!1,n.length>0){const o=n.slice(0);n=[],o.forEach(l=>i(l))}})||I.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=g;var f;(function(u){async function n(r,i,a){if(A.isAbsolute(r))return r;if(i===void 0&&(i=b.cwd()),A.dirname(r)!=="."||(a===void 0&&D.isString(b.env.PATH)&&(a=b.env.PATH.split(A.delimiter)),a===void 0||a.length===0))return A.join(i,r);async function s(o){if(await p.Promises.exists(o)){let l;try{l=await p.Promises.stat(o)}catch(v){v.message.startsWith("EACCES")&&(l=await p.Promises.lstat(o))}return l?!l.isDirectory():!1}return!1}for(const o of a){let l;if(A.isAbsolute(o)?l=A.join(o,r):l=A.join(i,o,r),await s(l))return l;let v=l+".com";if(await s(v)||(v=l+".exe",await s(v)))return v}return A.join(i,r)}u.findExecutable=n})(f=e.win32||(e.win32={}))}),define(re[136],se([0,1,35,4,83,87]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(C,d){return C===1?t.isWindows?E():L.getWindowsShell(d):P(C,d)}e.getSystemShell=A;function I(C,d){return C===1?t.isWindows?p(d):L.getWindowsShell(d):P(C,d)}e.getSystemShellSync=I;let b=null;function P(C,d){if(t.isLinux&&C===2||t.isMacintosh&&C===3)return"/bin/bash";if(!b){let S;if(t.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,k.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}b=S}return b}let D=null;async function E(){return D||(D=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),D}function p(C){if(D)return D;const d=t.isWindows&&parseFloat((0,k.release)())>=10,S=C.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${C.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?w:L.getWindowsShell(C)}}),define(re[65],se([0,1,48,6,16,23,128,9,3,2,29,87,78,39]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends C.ChannelServer{constructor(h){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>T.VSBuffer.wrap(Buffer.from(m,"base64")))},h);process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(h,m){this.modulePath=h,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(g),this.child=null,this._client=null}getChannel(h){const m=this;return{call(g,f,u){return m.requestPromise(h,g,f,u)},listen(g,f){return m.requestEvent(h,g,f)}}}requestPromise(h,m,g,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(h),n=(0,t.createCancelablePromise)(a=>u.call(m,g,a)),r=f.onCancellationRequested(()=>n.cancel()),i=(0,P.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(h,m,g){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let f;const u=new b.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(h).listen(m,g)(u.fire,u),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),(0,p.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,h,m);const g=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,A.isRemoteConsoleLog)(c)){(0,A.log)(c,`IPC Library: ${this.options.serverName}`);return}g.fire(T.VSBuffer.wrap(Buffer.from(c,"base64")))});const u=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,n=c=>this.child&&this.child.connected&&u.send(c.buffer.toString("base64")),r=g.event,i={send:n,onMessage:r};this._client=new C.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,s)=>{process.removeListener("exit",a),this.activeRequests.forEach(o=>(0,P.dispose)(o)),this.activeRequests.clear(),c!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:s})})}return this._client}getCachedChannel(h){let m=this.channels.get(h);return m||(m=this.client.getChannel(h),this.channels.set(h,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(re[137],se([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(re[138],se([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[139],se([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(re[140],se([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(re[141],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[142],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[143],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[144],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[145],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[146],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[147],se([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[148],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(re[149],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(re[150],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(re[151],se([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[152],se([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[153],se([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(re[154],se([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(re[155],se([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[156],se([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[157],se([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[158],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[159],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[160],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[161],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[162],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[163],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[164],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[88],se([0,1,62,60,20,12,36,19,8]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(S,w,h){this._args=S,this.paths=w,this.productService=h,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(T.FileAccess.asFileUri("",Z).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(b.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?b.URI.file((0,L.join)(S,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(T.FileAccess.asFileUri("",Z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const h=A.env.VSCODE_PORTABLE;return h?(0,L.join)(h,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(w=>/^[^:/?#]+?:\/\//.test(w)?b.URI.parse(w):b.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?b.URI.parse(S):b.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return b.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?b.URI.file((0,L.join)(S,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}me([t.memoize],P.prototype,"appRoot",null),me([t.memoize],P.prototype,"userHome",null),me([t.memoize],P.prototype,"userDataPath",null),me([t.memoize],P.prototype,"appSettingsHome",null),me([t.memoize],P.prototype,"tmpDir",null),me([t.memoize],P.prototype,"cacheHome",null),me([t.memoize],P.prototype,"stateResource",null),me([t.memoize],P.prototype,"userRoamingDataHome",null),me([t.memoize],P.prototype,"userDataSyncHome",null),me([t.memoize],P.prototype,"userDataSyncLogResource",null),me([t.memoize],P.prototype,"sync",null),me([t.memoize],P.prototype,"machineSettingsResource",null),me([t.memoize],P.prototype,"workspaceStorageHome",null),me([t.memoize],P.prototype,"localHistoryHome",null),me([t.memoize],P.prototype,"keyboardLayoutResource",null),me([t.memoize],P.prototype,"argvResource",null),me([t.memoize],P.prototype,"isExtensionDevelopment",null),me([t.memoize],P.prototype,"untitledWorkspacesHome",null),me([t.memoize],P.prototype,"installSourcePath",null),me([t.memoize],P.prototype,"builtinExtensionsPath",null),me([t.memoize],P.prototype,"extensionsPath",null),me([t.memoize],P.prototype,"extensionDevelopmentLocationURI",null),me([t.memoize],P.prototype,"extensionDevelopmentKind",null),me([t.memoize],P.prototype,"extensionTestsLocationURI",null),me([t.memoize],P.prototype,"debugExtensionHost",null),me([t.memoize],P.prototype,"serviceMachineIdResource",null),me([t.memoize],P.prototype,"telemetryLogResource",null),me([t.memoize],P.prototype,"disableWorkspaceTrust",null),me([t.memoize],P.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=P;function D(d,S){return C(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=D;function E(d,S){return C(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=E;function p(d,S){return C(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=p;function C(d,S,w,h,m,g){const u=Number(S||d)||(h?null:w),n=u?Boolean(!!S):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:u,break:n,debugId:m,env:r}}}),define(re[165],se([0,1,268,4,139]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,T.localize)(0,null),e:(0,T.localize)(1,null),t:(0,T.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,T.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,T.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,T.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,T.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,T.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,T.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,T.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,T.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,T.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,T.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,T.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,T.localize)(14,null)},category:{type:"string",cat:"e",description:(0,T.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,T.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,T.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,T.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,T.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,T.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,T.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,T.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,T.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,T.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,T.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,T.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,T.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,T.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,T.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,T.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,T.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,T.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(d,S,w=A){const h={},m=["_"],g=[];for(const r in S){const i=S[r];i.alias&&(h[r]=i.alias),i.type==="string"||i.type==="string[]"?(m.push(r),i.deprecates&&m.push(...i.deprecates)):i.type==="boolean"&&(g.push(r),i.deprecates&&g.push(...i.deprecates))}const f=k(d,{string:m,boolean:g,alias:h}),u={},n=f;u._=f._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in S){const i=S[r];i.alias&&delete n[i.alias];let a=n[r];if(i.deprecates)for(const c of i.deprecates)n.hasOwnProperty(c)&&(a||(a=n[c],a&&w.onDeprecatedOption(c,i.deprecationMessage||(0,T.localize)(33,null,r))),delete n[c]);if(typeof a!="undefined"){if(i.type==="string[]"){if(Array.isArray(a)||(a=[a]),!i.allowEmptyValue){const c=a.filter(s=>s.length>0);c.length!==a.length&&(w.onEmptyValue(r),a=c.length>0?c:void 0)}}else i.type==="string"&&(Array.isArray(a)?(a=a.pop(),w.onMultipleValues(r,a)):!a&&!i.allowEmptyValue&&(w.onEmptyValue(r),a=void 0));u[r]=a,i.deprecationMessage&&w.onDeprecatedOption(r,i.deprecationMessage)}delete n[r]}for(const r in n)w.onUnknownOption(r);return u}e.parseArgs=I;function b(d,S){let w="";return S.args&&(Array.isArray(S.args)?w=` <${S.args.join("> <")}>`:w=` <${S.args}>`),S.alias?`-${S.alias} --${d}${w}`:`--${d}${w}`}function P(d,S){let w=0;const h=[];for(const u in d){const n=d[u],r=b(u,n);w=Math.max(w,r.length),h.push([r,n.description])}const m=w+2+1;if(S-m<25)return h.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=S-m-1,f=[];for(const u of h){const n=u[0],r=E(u[1],g),i=D(m-n.length-2);f.push("  "+n+i+r[0]);for(let a=1;a<r.length;a++)f.push(D(m)+r[a])}return f}e.formatOptions=P;function D(d){return" ".repeat(d)}function E(d,S){const w=[];for(;d.length;){const h=d.length<S?d.length:d.lastIndexOf(" ",S),m=d.slice(0,h).trim();d=d.slice(h),w.push(m)}return w}function p(d,S,w,h,m){const g=process.stdout.isTTY&&process.stdout.columns||80,f=m?.noInputFiles!==!0?`[${(0,T.localize)(34,null)}...]`:"",u=[`${d} ${w}`];u.push(""),u.push(`${(0,T.localize)(35,null)}: ${S} [${(0,T.localize)(36,null)}]${f}`),u.push(""),m?.noPipe!==!0&&(t.isWindows?u.push((0,T.localize)(37,null,S)):u.push((0,T.localize)(38,null,S)),u.push(""));const n={};for(const r in h){const i=h[r];if(i.description&&i.cat){let a=n[i.cat];a||(n[i.cat]=a={}),a[r]=i}}for(const r in n){const i=r,a=n[i];a&&(u.push(L[i]),u.push(...P(a,g)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=p;function C(d,S){return`${d||(0,T.localize)(39,null)}
${S||(0,T.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=C}),define(re[166],se([0,1,269,140,165]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(p,C){const d={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,h)=>{console.warn((0,t.localize)(1,null,w,h))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,h)=>{console.warn((0,t.localize)(3,null,w,h))}},S=(0,T.parseArgs)(p,T.OPTIONS,C?d:void 0);return S.goto&&S._.forEach(w=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),S["max-memory"]&&k(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function I(p){const C=p.findIndex(d=>!/^-/.test(d));if(C>-1)return[...p.slice(0,C),...p.slice(C+1)]}function b(p){let[,...C]=p;process.env.VSCODE_DEV&&(C=I(C)||[]);const d=!E(process.env);return A(C,d)}e.parseMainProcessArgv=b;function P(p){const[,,...C]=p;return A(C,!0)}e.parseCLIProcessArgv=P;function D(p,...C){const d=p.indexOf("--");return d===-1?p.push(...C):p.splice(d,0,...C),p}e.addArg=D;function E(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function Z(e,k,t,T){function L(I){const b=A(I),P=[b];return e.isAbsolute(b)||P.unshift(T),e.resolve(...P)}function A(I){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,t);const D=I["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(E,"AppData","Roaming")}break;case"darwin":P=e.join(k.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,t)}return{getUserDataPath:L}}if(typeof define=="function")define(re[167],se([0,270,35,20,19,36]),function(e,k,t,T,L,A){const I=L.dirname(T.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(L.joinPath(I,"package.json").fsPath);return Z(k,t,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=Z(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[168],se([0,1,35,88,167]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(I,b){super(I,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,T.getUserDataPath)(I)},b)}}e.NativeEnvironmentService=L}),define(re[169],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,T=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function P(w){const h=w.match(A);return h?h[1]:null}function D(w){if(w.indexOf("://")===-1){const h=w.match(t);return h?P(h[2]):null}try{const h=k.URI.parse(w);if(h.authority)return P(h.authority)}catch{}return null}function E(w,h){const m=new Set;let g;for(;g=I.exec(w);){const u=D(g[1]);u&&m.add(u)}const f=new Set(h);return Array.from(m).map(u=>f.has(u)?u:u.replace(b,"a"))}e.getDomainsOfRemotes=E;function p(w){const h=w.match(L);return h?h[2]:null}function C(w,h,m){return w&&h?(m&&h.endsWith(".git")&&(h=h.substr(0,h.length-4)),h.indexOf("/")===0?`${w}${h}`:`${w}/${h}`):null}function d(w,h){if(w.indexOf("://")===-1){const m=w.match(T);if(m)return C(m[2],m[3],h)}try{const m=k.URI.parse(w);if(m.authority)return C(p(m.authority),m.path,h)}catch{}return null}function S(w,h=!1){const m=[];let g;for(;g=I.exec(w);){const f=d(g[1],h);f&&m.push(f)}return m}e.getRemotes=S}),define(re[170],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,I,b){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,I,b])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class t{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(re[66],se([0,1,19,81,147,55]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function b(h){return h=h.trim(),h==="*"||A.test(h)}e.isValidVersionStr=b;function P(h){if(!b(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=h.match(A);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=P;function D(h){if(!h)return null;const m=h.majorBase,g=h.majorMustEqual,f=h.minorBase;let u=h.minorMustEqual;const n=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(m===0||(u=!1),r=!1);let i=0;if(h.preRelease){const a=I.exec(h.preRelease);if(a){const[,c,s,o]=a;i=Date.UTC(Number(c),Number(s)-1,Number(o))}}return{majorBase:m,majorMustEqual:g,minorBase:f,minorMustEqual:u,patchBase:n,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=D;function E(h,m,g){let f;typeof h=="string"?f=D(P(h)):f=h;let u;m instanceof Date?u=m.getTime():typeof m=="string"&&(u=new Date(m).getTime());let n;if(typeof g=="string"?n=D(P(g)):n=g,!f||!n)return!1;const r=f.majorBase,i=f.minorBase,a=f.patchBase;let c=n.majorBase,s=n.minorBase,o=n.patchBase;const l=n.notBefore;let v=n.majorMustEqual,y=n.minorMustEqual,O=n.patchMustEqual;return n.isMinimum?r>c?!0:r<c?!1:i>s?!0:i<s||u&&u<l?!1:a>=o:(r===1&&c===0&&(!v||!y||!O)&&(c=1,s=0,o=0,v=!0,y=!1,O=!1),r<c?!1:r>c?!v:i<s?!1:i>s?!y:a<o?!1:a>o?!O:!(u&&u<l))}e.isValidVersion=E;function p(h,m,g,f,u){const n=[];if(typeof f.publisher!="undefined"&&typeof f.publisher!="string")return n.push([t.default.Error,T.localize(0,null)]),n;if(typeof f.name!="string")return n.push([t.default.Error,T.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([t.default.Error,T.localize(2,null,"version")]),n;if(!f.engines)return n.push([t.default.Error,T.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([t.default.Error,T.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies!="undefined"&&!w(f.extensionDependencies))return n.push([t.default.Error,T.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents!="undefined"){if(!w(f.activationEvents))return n.push([t.default.Error,T.localize(6,null,"activationEvents")]),n;if(typeof f.main=="undefined"&&typeof f.browser=="undefined")return n.push([t.default.Error,T.localize(7,null,"activationEvents","main")]),n}if(typeof f.extensionKind!="undefined"&&typeof f.main=="undefined"&&n.push([t.default.Warning,T.localize(8,null,"extensionKind")]),typeof f.main!="undefined"){if(typeof f.main!="string")return n.push([t.default.Error,T.localize(9,null,"main")]),n;{const a=(0,k.joinPath)(g,f.main);(0,k.isEqualOrParent)(a,g)||n.push([t.default.Warning,T.localize(10,null,a.path,g.path)])}if(typeof f.activationEvents=="undefined")return n.push([t.default.Error,T.localize(11,null,"activationEvents","main")]),n}if(typeof f.browser!="undefined"){if(typeof f.browser!="string")return n.push([t.default.Error,T.localize(12,null,"browser")]),n;{const a=(0,k.joinPath)(g,f.browser);(0,k.isEqualOrParent)(a,g)||n.push([t.default.Warning,T.localize(13,null,a.path,g.path)])}if(typeof f.activationEvents=="undefined")return n.push([t.default.Error,T.localize(14,null,"activationEvents","browser")]),n}if(!L.valid(f.version))return n.push([t.default.Error,T.localize(15,null)]),n;const r=[];if(!C(h,m,f,u,r))for(const a of r)n.push([t.default.Error,a]);return n}e.validateExtensionManifest=p;function C(h,m,g,f,u){return f||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:S(h,m,g.engines.vscode,u)}e.isValidExtensionVersion=C;function d(h,m,g){return h==="*"||S(m,g,h)}e.isEngineValid=d;function S(h,m,g,f=[]){const u=D(P(g));if(!u)return f.push(T.localize(16,null,g)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return f.push(T.localize(17,null,g)),!1}else if(!u.majorMustEqual)return f.push(T.localize(18,null,g)),!1;return E(h,m,u)?!0:(f.push(T.localize(19,null,h,g)),!1)}function w(h){if(!Array.isArray(h))return!1;for(let m=0,g=h.length;m<g;m++)if(typeof h[m]!="string")return!1;return!0}}),define(re[49],se([0,1,16,31]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function T(L,A,I){let b=I&&I.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const D=(await A.readFile(L.serviceMachineIdResource)).value.toString();b=(0,t.isUUID)(D)?D:null}catch{b=null}if(!b){b=(0,t.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(b))}catch{}}return I?.store("storage.serviceMachineId",b,-1,1),b}e.getServiceMachineId=T}),define(re[56],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(T,L=[],A=!1){this.ctor=T,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(re[89],se([0,1,56]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function T(A,I,b){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],b)),t.push([A,I])}e.registerSingleton=T;function L(){return t}e.getSingletonServiceDescriptors=L}),define(re[171],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=k;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const I=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(L),I)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(const I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let I=this._nodes.get(A);return I||(I=new k(L),this._nodes.set(A,I)),I}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[A,I]of this._nodes)L.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this._nodes){const I=new Set([L]),b=this._findCycle(A,I);if(b)return b}}_findCycle(L,A){for(const[I,b]of L.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const P=this._findCycle(b,A);if(P)return P;A.delete(I)}}}e.Graph=t}),define(re[5],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(k=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function t(A,I,b){I[k.DI_TARGET]===I?I[k.DI_DEPENDENCIES].push({id:A,index:b}):(I[k.DI_DEPENDENCIES]=[{id:A,index:b}],I[k.DI_TARGET]=I)}function T(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const I=function(b,P,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,b,D)};return I.toString=()=>A,k.serviceIds.set(A,I),I}e.createDecorator=T;function L(A){return A}e.refineServiceDecorator=L}),define(re[172],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(re[18],se([0,1,14,8,5]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=L;function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||k.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function P(h,m){const g=Object.create(null);for(const f in h)D(g,f,h[f],m);return g}e.toValuesTree=P;function D(h,m,g,f){const u=m.split("."),n=u.pop();let r=h;for(let i=0;i<u.length;i++){const a=u[i];let c=r[a];switch(typeof c){case"undefined":c=r[a]=Object.create(null);break;case"object":break;default:f(`Ignoring ${m} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[n]=g}catch{f(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=D;function E(h,m){const g=m.split(".");p(h,g)}e.removeFromValueTree=E;function p(h,m){const g=m.shift();if(m.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const f=h[g];typeof f=="object"&&!Array.isArray(f)&&(p(f,m),Object.keys(f).length===0&&delete h[g])}}function C(h,m,g){function f(r,i){let a=r;for(const c of i){if(typeof a!="object"||a===null)return;a=a[c]}return a}const u=m.split("."),n=f(h,u);return typeof n=="undefined"?g:n}e.getConfigurationValue=C;function d(h,m,g){Object.keys(m).forEach(f=>{f!=="__proto__"&&(f in h?k.isObject(h[f])&&k.isObject(m[f])?d(h[f],m[f],g):g&&(h[f]=m[f]):h[f]=m[f])})}e.merge=d;function S(h,m,g){const f=h.inspect(m),u=h.inspect(g);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:f.defaultValue}e.getMigratedSettingValue=S;function w(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(re[173],se([0,1,4,26,5]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",k.isMacintosh),L.set("isLinux",k.isLinux),L.set("isWindows",k.isWindows),L.set("isWeb",k.isWeb),L.set("isMacNative",k.isMacintosh&&!k.isWeb),L.set("isEdge",k.isEdge),L.set("isFirefox",k.isFirefox),L.set("isChrome",k.isChrome),L.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return E.INSTANCE}static true(){return p.INSTANCE}static has(R){return C.create(R)}static equals(R,M){return d.create(R,M)}static notEquals(R,M){return h.create(R,M)}static regex(R,M){return i.create(R,M)}static in(R,M){return S.create(R,M)}static not(R){return m.create(R)}static and(...R){return s.create(R,null)}static or(...R){return o.create(R,null,!0)}static greater(R,M){return f.create(R,M)}static greaterEquals(R,M){return u.create(R,M)}static smaller(R,M){return n.create(R,M)}static smallerEquals(R,M){return r.create(R,M)}static deserialize(R,M=!1){if(!!R)return this._deserializeOrExpression(R,M)}static _deserializeOrExpression(R,M){const F=R.split("||");return o.create(F.map(j=>this._deserializeAndExpression(j,M)),null,!0)}static _deserializeAndExpression(R,M){const F=R.split("&&");return s.create(F.map(j=>this._deserializeOne(j,M)),null)}static _deserializeOne(R,M){if(R=R.trim(),R.indexOf("!=")>=0){const F=R.split("!=");return h.create(F[0].trim(),this._deserializeValue(F[1],M))}if(R.indexOf("==")>=0){const F=R.split("==");return d.create(F[0].trim(),this._deserializeValue(F[1],M))}if(R.indexOf("=~")>=0){const F=R.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],M))}if(R.indexOf(" in ")>=0){const F=R.split(" in ");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const F=R.split(">=");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const F=R.split(">");return f.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const F=R.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const F=R.split("<");return n.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(R)?m.create(R.substr(1).trim()):C.create(R)}static _deserializeValue(R,M){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const F=/^'([^']*)'$/.exec(R);return F?F[1].trim():R}static _deserializeRegexValue(R,M){if((0,t.isFalsyOrWhitespace)(R)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=R.indexOf("/"),j=R.lastIndexOf("/");if(F===j||F<0){if(M)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const W=R.slice(F+1,j),z=R[j+1]==="i"?"i":"";try{return new RegExp(W,z)}catch(te){if(M)throw new Error(`bad regexp-value '${R}', parse error: ${te}`);return console.warn(`bad regexp-value '${R}', parse error: ${te}`),null}}}e.ContextKeyExpr=b;function P(N,R){const M=N?N.substituteConstants():void 0,F=R?R.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=P;function D(N,R){return N.cmp(R)}class E{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class p{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class C{constructor(R,M){this.key=R,this.negated=M,this.type=2}static create(R,M=null){const F=L.get(R);return typeof F=="boolean"?F?p.INSTANCE:E.INSTANCE:new C(R,M)}cmp(R){return R.type!==this.type?this.type-R.type:v(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?p.INSTANCE:E.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class d{constructor(R,M,F){this.key=R,this.value=M,this.negated=F,this.type=4}static create(R,M,F=null){if(typeof M=="boolean")return M?C.create(R,F):m.create(R,F);const j=L.get(R);return typeof j=="boolean"?M===(j?"true":"false")?p.INSTANCE:E.INSTANCE:new d(R,M,F)}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const M=R?"true":"false";return this.value===M?p.INSTANCE:E.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(R,M){this.key=R,this.valueKey=M,this.type=10,this.negated=null}static create(R,M){return new S(R,M)}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const M=R.getValue(this.valueKey),F=R.getValue(this.key);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?A.call(M,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=S;class w{constructor(R){this._actual=R,this.type=11}static create(R){return new w(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new w(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class h{constructor(R,M,F){this.key=R,this.value=M,this.negated=F,this.type=5}static create(R,M,F=null){if(typeof M=="boolean")return M?m.create(R,F):C.create(R,F);const j=L.get(R);return typeof j=="boolean"?M===(j?"true":"false")?E.INSTANCE:p.INSTANCE:new h(R,M,F)}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const M=R?"true":"false";return this.value===M?E.INSTANCE:p.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class m{constructor(R,M){this.key=R,this.negated=M,this.type=3}static create(R,M=null){const F=L.get(R);return typeof F=="boolean"?F?E.INSTANCE:p.INSTANCE:new m(R,M)}cmp(R){return R.type!==this.type?this.type-R.type:v(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?E.INSTANCE:p.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function g(N,R){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?R(N):E.INSTANCE}class f{constructor(R,M,F){this.key=R,this.value=M,this.negated=F,this.type=12}static create(R,M,F=null){return g(M,j=>new f(R,j,F))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class u{constructor(R,M,F){this.key=R,this.value=M,this.negated=F,this.type=13}static create(R,M,F=null){return g(M,j=>new u(R,j,F))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class n{constructor(R,M,F){this.key=R,this.value=M,this.negated=F,this.type=14}static create(R,M,F=null){return g(M,j=>new n(R,j,F))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class r{constructor(R,M,F){this.key=R,this.value=M,this.negated=F,this.type=15}static create(R,M,F=null){return g(M,j=>new r(R,j,F))}cmp(R){return R.type!==this.type?this.type-R.type:y(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(R,M){this.key=R,this.regexp=M,this.type=7,this.negated=null}static create(R,M){return new i(R,M)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const M=this.regexp?this.regexp.source:"",F=R.regexp?R.regexp.source:"";return M<F?-1:M>F?1:0}equals(R){if(R.type===this.type){const M=this.regexp?this.regexp.source:"",F=R.regexp?R.regexp.source:"";return this.key===R.key&&M===F}return!1}substituteConstants(){return this}evaluate(R){const M=R.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class a{constructor(R){this._actual=R,this.type=8}static create(R){return new a(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new a(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function c(N){let R=null;for(let M=0,F=N.length;M<F;M++){const j=N[M].substituteConstants();if(N[M]!==j&&R===null){R=[];for(let W=0;W<M;W++)R[W]=N[W]}R!==null&&(R[M]=j)}return R===null?N:R}class s{constructor(R,M){this.expr=R,this.negated=M,this.type=6}static create(R,M){return s._normalizeArr(R,M)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const j=D(this.expr[M],R.expr[M]);if(j!==0)return j}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(R.expr[M]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:s.create(R,this.negated)}evaluate(R){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(R))return!1;return!0}static _normalizeArr(R,M){const F=[];let j=!1;for(const W of R)if(!!W){if(W.type===1){j=!0;continue}if(W.type===0)return E.INSTANCE;if(W.type===6){F.push(...W.expr);continue}F.push(W)}if(F.length===0&&j)return p.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(D);for(let W=1;W<F.length;W++)F[W-1].equals(F[W])&&(F.splice(W,1),W--);if(F.length===1)return F[0];for(;F.length>1;){const W=F[F.length-1];if(W.type!==9)break;F.pop();const z=F.pop(),te=F.length===0,G=o.create(W.expr.map(K=>s.create([K,z],null)),null,te);G&&(F.push(G),F.sort(D))}return F.length===1?F[0]:new s(F,M)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const M of this.expr)R.push(...M.keys());return R}map(R){return new s(this.expr.map(M=>M.map(R)),null)}negate(){if(!this.negated){const R=[];for(const M of this.expr)R.push(M.negate());this.negated=o.create(R,this,!0)}return this.negated}}class o{constructor(R,M){this.expr=R,this.negated=M,this.type=9}static create(R,M,F){return o._normalizeArr(R,M,F)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const j=D(this.expr[M],R.expr[M]);if(j!==0)return j}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(R.expr[M]))return!1;return!0}return!1}substituteConstants(){const R=c(this.expr);return R===this.expr?this:o.create(R,this.negated,!1)}evaluate(R){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(R))return!0;return!1}static _normalizeArr(R,M,F){let j=[],W=!1;if(R){for(let z=0,te=R.length;z<te;z++){const G=R[z];if(!!G){if(G.type===0){W=!0;continue}if(G.type===1)return p.INSTANCE;if(G.type===9){j=j.concat(G.expr);continue}j.push(G)}}if(j.length===0&&W)return E.INSTANCE;j.sort(D)}if(j.length!==0){if(j.length===1)return j[0];for(let z=1;z<j.length;z++)j[z-1].equals(j[z])&&(j.splice(z,1),z--);if(j.length===1)return j[0];if(F){for(let z=0;z<j.length;z++)for(let te=z+1;te<j.length;te++)O(j[z],j[te])&&(j.splice(te,1),te--);if(j.length===1)return j[0]}return new o(j,M)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const M of this.expr)R.push(...M.keys());return R}map(R){return new o(this.expr.map(M=>M.map(R)),null)}negate(){if(!this.negated){const R=[];for(const M of this.expr)R.push(M.negate());for(;R.length>1;){const M=R.shift(),F=R.shift(),j=[];for(const z of _(M))for(const te of _(F))j.push(s.create([z,te],null));const W=R.length===0;R.unshift(o.create(j,null,W))}this.negated=R[0]}return this.negated}}class l extends C{constructor(R,M,F){super(R,null);this._defaultValue=M,typeof F=="object"?l._info.push({...F,key:R}):F!==!0&&l._info.push({key:R,description:F,type:M!=null?typeof M:void 0})}static all(){return l._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return d.create(this.key,R)}notEqualsTo(R){return h.create(this.key,R)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(N,R){return N<R?-1:N>R?1:0}function y(N,R,M,F){return N<M?-1:N>M?1:R<F?-1:R>F?1:0}function O(N,R){if(R.type===6&&N.type!==9&&N.type!==6){for(const j of R.expr)if(N.equals(j))return!0}const M=N.negate(),F=_(M).concat(_(R));F.sort(D);for(let j=0;j<F.length;j++){const z=F[j].negate();for(let te=j+1;te<F.length;te++){const G=F[te];if(z.equals(G))return!0}}return!1}e.implies=O;function _(N){return N.type===9?N.expr:[N]}}),define(re[90],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class T{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=T}),define(re[91],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(re[15],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(re[30],se([0,1,142,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(h,m){switch(h){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function I(h,m){return m==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function b(h,m,g){return I(m,g)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===g?!0:P(g).includes(h)}e.isTargetPlatformCompatible=b;function P(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var C;(function(h){h.Install="install",h.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var S;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(m,g){super(m);this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(re[174],se([0,1,3,2,64,29,8,129,30]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(w,h){return A.URI.revive(h?h.transformIncoming(w):w)}function D(w,h){return h?h.transformOutgoingURI(w):w}function E(w,h){h=h||I.DefaultURITransformer;const m=w.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...w,manifest:void 0},h),manifest:m}}function p(w,h){return h?(0,L.cloneAndChange)(w,m=>m instanceof A.URI?h.transformOutgoingURI(m):void 0):w}class C{constructor(h,m){this.service=h,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(h.onDidUninstallExtension,!0)}listen(h,m){const g=this.getUriTransformer(h);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,f=>f.map(u=>({...u,local:u.local?p(u.local,g):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(h,m,g){const f=this.getUriTransformer(h);switch(m){case"zip":return this.service.zip(E(g[0],f)).then(u=>D(u,f));case"unzip":return this.service.unzip(P(g[0],f));case"install":return this.service.install(P(g[0],f),(0,T.revive)(g[1]));case"getManifest":return this.service.getManifest(P(g[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],(0,T.revive)(g[1]));case"uninstall":return this.service.uninstall(E(g[0],f),(0,T.revive)(g[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(E(g[0],f));case"getInstalled":return this.service.getInstalled(g[0],A.URI.revive(g[1])).then(u=>u.map(n=>p(n,f)));case"getMetadata":return this.service.getMetadata(E(g[0],f));case"updateMetadata":return this.service.updateMetadata(E(g[0],f),g[1]).then(u=>p(u,f));case"updateExtensionScope":return this.service.updateExtensionScope(E(g[0],f),g[1]).then(u=>p(u,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=C;class d extends t.Disposable{constructor(h){super();this.channel=h,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(g=>({...g,local:g.local?E(g.local,null):g.local,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:A.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:A.URI.revive(m.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const m=await this.getTargetPlatform();return h.allTargetPlatforms.some(g=>(0,b.isTargetPlatformCompatible)(g,h.allTargetPlatforms,m))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(m=>A.URI.revive(m)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,m){return Promise.resolve(this.channel.call("install",[h,m])).then(g=>E(g,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,m){return Promise.resolve(this.channel.call("installFromGallery",[h,m])).then(g=>E(g,null))}uninstall(h,m){return Promise.resolve(this.channel.call("uninstall",[h,m]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h]))}getInstalled(h=null,m){return Promise.resolve(this.channel.call("getInstalled",[h,m])).then(g=>g.map(f=>E(f,null)))}getMetadata(h){return Promise.resolve(this.channel.call("getMetadata",[h]))}updateMetadata(h,m){return Promise.resolve(this.channel.call("updateMetadata",[h,m])).then(g=>E(g,null))}updateExtensionScope(h,m){return Promise.resolve(this.channel.call("updateExtensionScope",[h,m])).then(g=>E(g,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class S{constructor(h){this.service=h}listen(h,m){throw new Error("Invalid listen")}call(h,m,g){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(re[92],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function T(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=T;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[13],se([0,1,38,12,26,14,8,149,5]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function P(z){return z.create===!0}e.isFileOpenForWriteOptions=P;var D;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var E;(function(z){z[z.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var p;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=C;function d(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=d;function S(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=S;function w(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function h(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=h;function m(z){return C(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var g;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(te,G){super(te);this.code=G}}e.FileSystemProviderError=f;function u(z,te){const G=new f(z.toString(),te);return r(G,te),G}e.createFileSystemProviderError=u;function n(z){return z||u((0,I.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=n;function r(z,te){return z.name=te?`${te} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function i(z){if(!z)return g.Unknown;if(z instanceof f)return z.code;const te=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!te)return g.Unknown;switch(te[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function a(z){if(z instanceof y)return z.fileOperationResult;switch(i(z)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var c;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class s{constructor(te,G,K){this.resource=te,this.operation=G,this.target=K}isOperation(te){return this.operation===te}}e.FileOperationEvent=s;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(te,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=te;const K=new Map;for(const X of te){const Y=K.get(X.type);switch(Y?Y.push([X.resource,X]):K.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,Y]of K)switch(X){case 1:this.added=k.TernarySearchTree.forUris(()=>G),this.added.fill(Y);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>G),this.updated.fill(Y);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>G),this.deleted.fill(Y);break}}contains(te,...G){return this.doContains(te,{includeChildren:!1},...G)}affects(te,...G){return this.doContains(te,{includeChildren:!0},...G)}doContains(te,G,...K){if(!te)return!1;const X=K.length>0;return!!((!X||K.includes(1))&&(this.added?.get(te)||G.includeChildren&&this.added?.findSuperstr(te))||(!X||K.includes(0))&&(this.updated?.get(te)||G.includeChildren&&this.updated?.findSuperstr(te))||(!X||K.includes(2))&&(this.deleted?.findSubstr(te)||G.includeChildren&&this.deleted?.findSuperstr(te)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function v(z,te,G){return!z||!te||z===te||te.length>z.length?!1:(te.charAt(te.length-1)!==t.sep&&(te+=t.sep),G?(0,T.startsWithIgnoreCase)(z,te):z.indexOf(te)===0)}e.isParent=v;class y extends Error{constructor(te,G,K){super(te);this.fileOperationResult=G,this.options=K}}e.FileOperationError=y;class O extends y{constructor(te,G,K){super(te,2,K);this.stat=G}}e.NotModifiedSinceFileOperationError=O;var _;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=R;async function M(z,te){if(!te.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(G=>{const K=te.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===z.scheme&&X.added&&(K.dispose(),G())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(te){return(0,L.isNumber)(te)||(te=0),te<F.KB?(0,I.localize)(1,null,te.toFixed(0)):te<F.MB?(0,I.localize)(2,null,(te/F.KB).toFixed(2)):te<F.GB?(0,I.localize)(3,null,(te/F.MB).toFixed(2)):te<F.TB?(0,I.localize)(4,null,(te/F.GB).toFixed(2)):(0,I.localize)(5,null,(te/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var j;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function W(z){return{maxFileSize:z===0?300*F.MB:16*F.GB,maxHeapSize:z===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=W});var Q=this&&this.__param||function(Z,e){return function(k,t){e(k,t,Z)}};define(re[175],se([0,1,93,41,13]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(I){this.fileService=I}async checksum(I){const b=(await this.fileService.readFileStream(I)).value;return new Promise((P,D)=>{const E=(0,k.createHash)("md5");(0,t.listenStream)(b,{onData:p=>E.update(p.buffer),onError:p=>D(p),onEnd:()=>P(E.digest("base64").replace(/=+$/,""))})})}};L=me([Q(0,T.IFileService)],L),e.ChecksumService=L}),define(re[176],se([0,1,16,37,9,3,2,41,8,31,13]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends A.Disposable{constructor(C,d){super();this.channel=C,this.extraCapabilities=d,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(C){return this.channel.call("stat",[C])}readdir(C){return this.channel.call("readdir",[C])}async readFile(C,d){const{buffer:S}=await this.channel.call("readFile",[C,d]);return S}readFileStream(C,d,S){const w=(0,I.newWriteableStream)(m=>k.VSBuffer.concat(m.map(g=>k.VSBuffer.wrap(g))).buffer),h=this.channel.listen("readFileStream",[C,d])(m=>{if(m instanceof k.VSBuffer)w.write(m.buffer);else{if(m==="end")w.end();else{let g=m;g instanceof Error||(g=(0,D.createFileSystemProviderError)((0,t.toErrorMessage)(g),D.FileSystemProviderErrorCode.Unknown)),w.error(g),w.end()}h.dispose()}});return S.onCancellationRequested(()=>{w.error((0,T.canceled)()),w.end(),h.dispose()}),w}writeFile(C,d,S){return this.channel.call("writeFile",[C,k.VSBuffer.wrap(d),S])}open(C,d){return this.channel.call("open",[C,d])}close(C){return this.channel.call("close",[C])}async read(C,d,S,w,h){const[m,g]=await this.channel.call("read",[C,d,h]);return S.set(m.buffer.slice(0,g),w),g}write(C,d,S,w,h){return this.channel.call("write",[C,d,k.VSBuffer.wrap(S),w,h])}mkdir(C){return this.channel.call("mkdir",[C])}delete(C,d){return this.channel.call("delete",[C,d])}rename(C,d,S){return this.channel.call("rename",[C,d,S])}copy(C,d,S){return this.channel.call("copy",[C,d,S])}cloneFile(C,d){return this.channel.call("cloneFile",[C,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(C=>{if(Array.isArray(C)){const d=C;this._onDidChange.fire(d.map(S=>({resource:b.URI.revive(S.resource),type:S.type})))}else{const d=C;this._onDidWatchError.fire(d)}}))}watch(C,d){const S=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,S,C,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=E}),define(re[94],se([0,1,16,9,150,13]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(D,E,p,C,d,S){let w;try{await I(D,E,p,C,d,S)}catch(h){w=h}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w!="undefined"&&p.error(w),p.end()}}e.readFileIntoStream=A;async function I(D,E,p,C,d,S){b(S);const w=await D.open(E,{create:!1});try{b(S);let h=0,m=0,g=d&&typeof d.length=="number"?d.length:void 0,f=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),u=d&&typeof d.position=="number"?d.position:0,n=0;do m=await D.read(w,u,f.buffer,n,f.byteLength-n),u+=m,n+=m,h+=m,typeof g=="number"&&(g-=m),n===f.byteLength&&(await p.write(C(f)),f=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),n=0);while(m>0&&(typeof g!="number"||g>0)&&b(S)&&P(h,d));if(n>0){let r=n;typeof g=="number"&&(r=Math.min(n,g)),p.write(C(f.slice(0,r)))}}catch(h){throw(0,L.ensureFileSystemProviderError)(h)}finally{await D.close(w)}}function b(D){if(D.isCancellationRequested)throw(0,t.canceled)();return!0}function P(D,E){if(E?.limits){if(typeof E.limits.memory=="number"&&D>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,T.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&D>E.limits.size)throw(0,L.createFileSystemProviderError)((0,T.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[57],se([0,1,82,2,12,4,8,13]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(h){return h.recursive===!0}e.isRecursiveWatchRequest=b;class P extends t.Disposable{constructor(m,g,f,u){super();this.onFileChanges=m,this.onLogMessage=g,this.verboseLogging=f,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),m.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),m.add(this.watcher.onDidError(g=>this.onError(g)))}onError(m){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class D extends P{constructor(m,g,f){super(m,g,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class E extends P{constructor(m,g,f){super(m,g,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function p(h){return h.map(m=>({type:m.type,resource:A.URI.file(m.path)}))}e.toFileChanges=p;function C(h){const m=new w;for(const g of h)m.processEvent(g);return m.coalesce()}e.coalesceEvents=C;function d(h,m){return typeof m=="string"&&!m.startsWith(k.GLOBSTAR)&&!(0,T.isAbsolute)(m)?{base:h,pattern:m}:m}e.normalizeWatcherPattern=d;function S(h,m){const g=[];for(const f of m)g.push((0,k.parse)(d(h,f)));return g}e.parseWatcherPatterns=S;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return L.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const g=this.mapPathToChange.get(this.toKey(m));let f=!1;if(g){const u=g.type,n=m.type;g.path!==m.path&&(m.type===2||m.type===1)?f=!0:u===1&&n===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(g)):u===2&&n===1?g.type=0:u===1&&n===0||(g.type=n)}else f=!0;f&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],g=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(m.push(f),!1):!0).sort((f,u)=>f.path.length-u.path.length).filter(f=>g.some(u=>(0,I.isParent)(f.path,u,!L.isLinux))?!1:(g.push(f.path),!0)).concat(m)}}}),define(re[177],se([0,1,54,6,23,42,2,80,12,4,131,27,57]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class C extends A.Disposable{constructor(w,h,m,g){super();this.request=w,this.onDidFilesChange=h,this.onLogMessage=m,this.verboseLogging=g,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(C.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new T.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await E.Promises.stat(w);this._register(await this.doWatch(w,h.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let h=w.path;try{h=await E.Promises.realpath(w.path),w.path===h&&(h=await(0,D.realcase)(w.path)??w.path),w.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${h})`)}catch{}return h}async doWatch(w,h){if(P.isMacintosh&&(0,L.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const m=new T.CancellationTokenSource(this.cts.token),g=new A.DisposableStore;try{const f=(0,b.basename)(w),u=(0,k.watch)(w);g.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${w}'`);const n=new Set;if(h)try{for(const i of await E.Promises.readdir(w))n.add(i)}catch(i){this.error(i)}const r=new Map;g.add((0,A.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),u.on("error",(i,a)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),u.on("change",(i,a)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${a}`);let c="";if(a&&(c=a.toString(),P.isMacintosh&&(c=(0,I.normalizeNFC)(c))),!(!c||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){r.get(c)?.dispose();const s=setTimeout(async()=>{if(r.delete(c),c===f&&!await E.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,b.join)(w,c));if(m.token.isCancellationRequested)return;let l;o?n.has(c)?l=0:(l=1,n.add(c)):(n.delete(c),l=2),this.onFileChange({path:(0,b.join)(this.request.path,c),type:l})},C.FILE_DELETE_HANDLER_DELAY);r.set(c,(0,A.toDisposable)(()=>clearTimeout(s)))}else{let s;n.has(c)?s=0:(s=1,n.add(c)),this.onFileChange({path:(0,b.join)(this.request.path,c),type:s})}else if(i==="rename"||c!==f){const s=setTimeout(async()=>{const o=await E.Promises.exists(w);m.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},C.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,A.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await E.Promises.exists(w)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{m.dispose(!0),g.dispose()})}async onFileChange(w,h=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!h&&this.excludes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,p.coalesceEvents)(m);if(g.length>0){if(this.verboseLogging)for(const u of g)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(P.isLinux)return E.Promises.exists(w);try{const h=(0,b.basename)(w);return(await E.Promises.readdir((0,b.dirname)(w))).some(g=>g===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=C,C.FILE_DELETE_HANDLER_DELAY=100,C.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,w,h,m,g=512){const f=await E.Promises.open(S,"r"),u=Buffer.allocUnsafe(g),n=new T.CancellationTokenSource(m);let r,i=!1;const a={path:S,excludes:[],recursive:!1},c=new C(a,s=>{(async()=>{for(const{type:o}of s)if(o===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:l}=await E.Promises.read(f,u,0,g,null);if(!l||n.token.isCancellationRequested)break;w(u.slice(0,l))}}catch(l){r=new Error(l),n.dispose(!0)}finally{i=!1}}})()});return await c.ready,h(),new Promise((s,o)=>{n.token.onCancellationRequested(async()=>{c.dispose();try{await E.Promises.close(f)}catch(l){r=new Error(l)}r?o(r):s()})})}e.watchFileContents=d}),define(re[178],se([0,1,3,82,2,4,177]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends T.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const D=this.normalizeRequests(P),E=D.filter(C=>{const d=this.watchers.get(C.path);return d?!(0,t.patternsEquals)(d.request.excludes,C.excludes)||!(0,t.patternsEquals)(d.request.includes,C.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:C})=>!D.find(d=>d.path===C.path&&(0,t.patternsEquals)(d.excludes,C.excludes)&&(0,t.patternsEquals)(d.includes,C.includes))).map(({request:C})=>C.path);E.length&&this.trace(`Request to start watching: ${E.map(C=>`${C.path} (excludes: ${C.excludes.length>0?C.excludes:"<none>"}, includes: ${C.includes&&C.includes.length>0?JSON.stringify(C.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const C of p)this.stopWatching(C);for(const C of E)this.startWatching(C)}startWatching(P){const D=new A.NodeJSFileWatcherLibrary(P,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),E={request:P,instance:D};this.watchers.set(P.path,E)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const D=this.watchers.get(P);D&&(this.watchers.delete(P),D.instance.dispose())}normalizeRequests(P){const D=new Map;for(const E of P){const p=L.isLinux?E.path:E.path.toLowerCase();D.set(p,E)}return Array.from(D.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,D]of this.watchers)D.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,D){return D?`[File Watcher (node.js)] ${P} (path: ${D.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=I}),define(re[179],se([0,1,57,178]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class T extends k.AbstractNonRecursiveWatcherClient{constructor(A,I,b){super(A,I,b);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=T}),define(re[180],se([0,1,20,39,65,57]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(b,P,D){super(b,P,D);this.init()}createWatcher(b){const P=b.add(new T.Client(k.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(P.onDidProcessExit(({code:D,signal:E})=>this.onError(`terminated by itself with code ${D}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(re[95],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...T){this._entries=new Map;for(const[L,A]of T)this.set(L,A)}set(T,L){const A=this._entries.get(T);return this._entries.set(T,L),A}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=k}),define(re[181],se([0,1,6,9,56,171,5,95]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class P extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class D{constructor(d=new I.ServiceCollection,S=!1,w){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=w,this._services.set(A.IInstantiationService,this)}createChild(d){return new D(d,this._strict,this)}invokeFunction(d,...S){const w=p.traceInvocation(d);let h=!1;try{return d({get:g=>{if(h)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(g,w);if(!f)throw new Error(`[invokeFunction] unknown service '${g}'`);return f}},...S)}finally{h=!0,w.stop()}}createInstance(d,...S){let w,h;return d instanceof T.SyncDescriptor?(w=p.traceCreation(d.ctor),h=this._createInstance(d.ctor,d.staticArguments.concat(S),w)):(w=p.traceCreation(d),h=this._createInstance(d,S,w)),w.stop(),h}_createInstance(d,S=[],w){const h=A._util.getServiceDependencies(d).sort((f,u)=>f.index-u.index),m=[];for(const f of h){const u=this._getOrCreateServiceInstance(f.id,w);u||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`,!1),m.push(u)}const g=h.length>0?h[0].index:S.length;if(S.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${S.length} static arguments`);const f=g-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,g)}return new d(...[...S,...m])}_setServiceInstance(d,S){if(this._services.get(d)instanceof T.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const w=this._getServiceInstanceOrDescriptor(d);return w instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,w,S.branch(d,!0)):(S.branch(d,!1),w)}_safeCreateAndCacheServiceInstance(d,S,w){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,w)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,w){const h=new L.Graph(f=>f.id.toString());let m=0;const g=[{id:d,desc:S,_trace:w}];for(;g.length;){const f=g.pop();if(h.lookupOrInsertNode(f),m++>1e3)throw new P(h);for(const u of A._util.getServiceDependencies(f.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(u.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),n instanceof T.SyncDescriptor){const r={id:u.id,desc:n,_trace:f._trace.branch(u.id,!0)};h.insertEdge(f,r),g.push(r)}}}for(;;){const f=h.roots();if(f.length===0){if(!h.isEmpty())throw new P(h);break}for(const{data:u}of f){if(this._getServiceInstanceOrDescriptor(u.id)instanceof T.SyncDescriptor){const r=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,r)}h.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,w=[],h,m){if(this._services.get(d)instanceof T.SyncDescriptor)return this._createServiceInstance(S,w,h,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,w,h,m);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],w,h){if(w){const m=new k.IdleValue(()=>this._createInstance(d,S,h));return new Proxy(Object.create(null),{get(g,f){if(f in g)return g[f];const u=m.value;let n=u[f];return typeof n!="function"||(n=n.bind(u),g[f]=n),n},set(g,f,u){return m.value[f]=u,!0}})}else return this._createInstance(d,S,h)}_throwIfStrict(d,S){if(S&&console.warn(S),this._strict)throw new Error(d)}}e.InstantiationService=D;var E;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(E||(E={}));class p{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return b?new p(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(d){return b?new p(0,d.name):p._None}branch(d,S){const w=new p(2,d.toString());return this._dep.push([d,S,w]),w}stop(){const d=Date.now()-this._start;p._totals+=d;let S=!1;function w(m,g){const f=[],u=new Array(m+1).join("	");for(const[n,r,i]of g._dep)if(r&&i){S=!0,f.push(`${u}CREATES -> ${n}`);const a=w(m+1,i);a&&f.push(a)}else f.push(`${u}uses -> ${n}`);return f.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(h.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(re[182],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(T,L){this.server=T,this.router=L}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,L){this.server.registerChannel(T,L)}}e.MessagePortMainProcessService=k}),define(re[96],se([0,1,39,56,89,5]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(C,d,S){const w=S.getChannel(C);return I(d)?new d.channelClientCtor(w):k.ProxyChannel.toService(w,d?.proxyOptions)}}function I(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let b=class extends A{constructor(C,d,S){super(C,d,S)}};b=me([Q(2,e.IMainProcessService)],b);function P(p,C,d){(0,T.registerSingleton)(p,new t.SyncDescriptor(b,[C,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=P,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let D=class extends A{constructor(C,d,S){super(C,d,S)}};D=me([Q(2,e.ISharedProcessService)],D);function E(p,C,d){(0,T.registerSingleton)(p,new t.SyncDescriptor(D,[C,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(re[67],se([0,1,23,2,4,152,30,5]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let b=class extends t.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new k.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let E;try{E=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const C=E.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],w=d.tags.find(m=>m.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:w,label:S}),extensionId:d.identifier.id,galleryExtension:d}});return C.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),C}createQuickPickItem(D){const E=D.label??D.locale;let p=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===T.language.toLowerCase()&&(p||(p=""),p+=(0,L.localize)(0,null)),{id:D.locale,label:E,description:p}}};b=me([Q(0,A.IExtensionGalleryService)],b),e.LanguagePackBaseService=b}),define(re[183],se([0,1,2,67]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let T=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};T=me([Q(0,t.ILanguagePackService)],T),e.LocalizationsUpdater=T}),define(re[7],se([0,1,37,3,2,4,5]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var b;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function P(r,i,a){switch(i){case b.Trace:r.trace(a);break;case b.Debug:r.debug(a);break;case b.Info:r.info(a);break;case b.Warning:r.warn(a);break;case b.Error:r.error(a);break;case b.Critical:r.critical(a);break;default:throw new Error("Invalid log level")}}e.log=P;function D(r){let i="";for(let a=0;a<r.length;a++){let c=r[a];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}i+=(a>0?" ":"")+c}return i}e.format=D;class E extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class p extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(b.Trace)&&this.log(b.Trace,D([i,...a]))}debug(i,...a){this.checkLogLevel(b.Debug)&&this.log(b.Debug,D([i,...a]))}info(i,...a){this.checkLogLevel(b.Info)&&this.log(b.Info,D([i,...a]))}warn(i,...a){this.checkLogLevel(b.Warning)&&this.log(b.Warning,D([i,...a]))}error(i,...a){if(this.checkLogLevel(b.Error))if(i instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=i.stack,this.log(b.Error,D(c))}else this.log(b.Error,D([i,...a]))}critical(i,...a){this.checkLogLevel(b.Critical)&&this.log(b.Critical,D([i,...a]))}flush(){}}e.AbstractMessageLogger=p;class C extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...a){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}debug(i,...a){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}info(i,...a){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}warn(i,...a){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...a):console.warn(`[main ${I()}]`,i,...a))}error(i,...a){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...a):console.error(`[main ${I()}]`,i,...a))}critical(i,...a){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...a):console.error(`[main ${I()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class d extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends E{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class w extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const c of this.logServices)c.trace(i,...a)}debug(i,...a){for(const c of this.logServices)c.debug(i,...a)}info(i,...a){for(const c of this.logServices)c.info(i,...a)}warn(i,...a){for(const c of this.logServices)c.warn(i,...a)}error(i,...a){for(const c of this.logServices)c.error(i,...a)}critical(i,...a){for(const c of this.logServices)c.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=w;class h extends T.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=h;class m extends T.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(c))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let c=this.loggers.get(i.toString());return c||(c=this.doCreateLogger(i,a?.always?b.Trace:this.logLevel,a),this.loggers.set(i.toString(),c),a?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=g;function f(r){if(r.verbose)return b.Trace;if(typeof r.logLevel=="string"){const i=u(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function u(r){switch(r){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=u;function n(r){switch(r){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=n}),define(re[184],se([0,1,6,9,2,12,27,15,7]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let P=class extends T.Disposable{constructor(E,p){super();this.environmentService=E,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(p)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==E),w=S.slice(0,Math.max(0,S.length-9));w.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(h=>A.Promises.rm((0,L.join)(p,h)))))}catch(E){(0,t.onUnexpectedError)(E)}}};P=me([Q(0,I.IEnvironmentService),Q(1,b.ILogService)],P),e.LogsDataCleaner=P}),define(re[185],se([0,1,6,9,2,12,27,15,7]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let P=class mt extends T.Disposable{constructor(E,p,C){super();this.backupWorkspacesPath=E,this.environmentService=p,this.logService=C,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),C=JSON.parse(E).emptyWorkspaceInfos.map(S=>S.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async S=>{S.length===mt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===mt.EXTENSION_DEV_EMPTY_WINDOW_ID||C.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(E){(0,t.onUnexpectedError)(E)}}};P.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,P.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",P=me([Q(1,I.INativeEnvironmentService),Q(2,b.ILogService)],P),e.StorageDataCleaner=P}),define(re[186],se([0,1,17,6,9,3,2,12,57,7]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends A.Disposable{constructor(p,C){super();this.logService=p,this.options=C,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(p,C){return C.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,C):this.watchNonRecursive(p,C)}watchUniversal(p,C){const d={path:this.toFilePath(p),excludes:C.excludes,includes:C.includes,recursive:C.recursive},S=(0,k.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,T.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(C=>this._onDidChangeFile.fire((0,b.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const C of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(C)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const C of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(C)&&p.includes(C.path)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,C){const d={path:this.toFilePath(p),excludes:C.excludes,includes:C.includes,recursive:!1},S=(0,k.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,T.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,b.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,I.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(re[187],se([0,1,17,6,16,23,3,63,52,2,38,20,188,19,41,148,13,94,7]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends P.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,n){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${u}`);const r=new P.DisposableStore;return this.provider.set(u,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:n}),r.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:u}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:n}),this.provider.delete(u),(0,P.dispose)(r)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(r){n.push(r)}}),!this.provider.has(u)&&await t.Promises.settled(n)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,n){const r=this.provider.get(u.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return b.Iterable.map(this.provider,([u,n])=>({scheme:u,capabilities:n.capabilities}))}async withProvider(u){if(!(0,C.isAbsolutePath)(u))throw new w.FileOperationError((0,S.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const n=this.provider.get(u.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,S.localize)(1,null,u.toString()),r}return n}async withReadProvider(u){const n=await this.withProvider(u);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const n=await this.withProvider(u);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,n){try{return await this.doResolveFile(u,n)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,S.localize)(2,null,this.resourceForError(u)),1):(0,w.ensureFileSystemProviderError)(r)}}async doResolveFile(u,n){const r=await this.withProvider(u),i=this.isPathCaseSensitive(r),a=n?.resolveTo,c=n?.resolveSingleChildDescendants,s=n?.resolveMetadata,o=await r.stat(u);let l;return this.toFileStat(r,u,o,void 0,!!s,(v,y)=>(l||(l=D.TernarySearchTree.forUris(()=>!i),l.set(u,!0),a&&l.fill(!0,a)),l.get(v.resource)||l.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&c?y===1:!1))}async toFileStat(u,n,r,i,a,c){const{providerExtUri:s}=this.getExtUri(u),o={resource:n,name:s.basename(n),isFile:(r.type&w.FileType.File)!=0,isDirectory:(r.type&w.FileType.Directory)!=0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&c(o,i)){try{const l=await u.readdir(n),v=await t.Promises.settled(l.map(async([y,O])=>{try{const _=s.joinPath(n,y),N=a?await u.stat(_):{type:O};return await this.toFileStat(u,_,N,l.length,a,c)}catch(_){return this.logService.trace(_),null}}));o.children=(0,k.coalesce)(v)}catch(l){this.logService.trace(l),o.children=[]}return o}return o}async resolveAll(u){return t.Promises.settled(u.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(u){const n=await this.withProvider(u),r=await n.stat(u);return this.toFileStat(n,u,r,void 0,!0,()=>!1)}async exists(u){const n=await this.withProvider(u);try{return!!await n.stat(u)}catch{return!1}}async canCreateFile(u,n){try{await this.doValidateCreateFile(u,n)}catch(r){return r}return!0}async doValidateCreateFile(u,n){if(!n?.overwrite&&await this.exists(u))throw new w.FileOperationError((0,S.localize)(3,null,this.resourceForError(u)),3,n)}async createFile(u,n=T.VSBuffer.fromString(""),r){await this.doValidateCreateFile(u,r);const i=await this.writeFile(u,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(u,0,i)),i}async writeFile(u,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:a}=this.getExtUri(i);try{await this.validateWriteFile(i,u,r)||await this.mkdirp(i,a.dirname(u));let s;if((0,w.hasReadWriteCapability)(i)&&!(n instanceof T.VSBuffer))if((0,d.isReadableStream)(n)){const o=await(0,d.peekStream)(n,3);o.ended?s=T.VSBuffer.concat(o.buffer):s=o}else s=(0,d.peekReadable)(n,o=>T.VSBuffer.concat(o),3);else s=n;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&s instanceof T.VSBuffer?await this.doWriteUnbuffered(i,u,r,s):await this.doWriteBuffered(i,u,r,s instanceof T.VSBuffer?(0,T.bufferToReadable)(s):s),this._onDidRunOperation.fire(new w.FileOperationEvent(u,4))}catch(c){throw new w.FileOperationError((0,S.localize)(4,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),r)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,n,r){if(!!r?.unlock&&!(u.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(n)));let a;try{a=await u.stat(n)}catch{return}if((a.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,S.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:a.size}))throw new w.FileOperationError((0,S.localize)(7,null),3,r);return a}async readFile(u,n,r){const i=await this.withReadProvider(u);return n?.atomic?this.doReadFileAtomic(i,u,n,r):this.doReadFile(i,u,n,r)}async doReadFileAtomic(u,n,r,i){return new Promise((a,c)=>{this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(u,n,r,i);a(s)}catch(s){c(s)}})})}async doReadFile(u,n,r,i){const a=await this.doReadFileStream(u,n,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,T.streamToBuffer)(a.value)}}async readFileStream(u,n,r){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,n,r)}async doReadFileStream(u,n,r,i){const a=new L.CancellationTokenSource(i),c=this.validateReadFile(n,r).then(o=>o,o=>{throw a.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await c,r?.atomic&&(0,w.hasFileAtomicReadCapability)(u)||!((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasFileReadStreamCapability)(u))||(0,w.hasReadWriteCapability)(u)&&r?.preferUnbuffered?s=this.readFileUnbuffered(u,n,r):(0,w.hasFileReadStreamCapability)(u)?s=this.readFileStreamed(u,n,a.token,r):s=this.readFileBuffered(u,n,a.token,r),{...await c,value:s}}catch(o){s&&await(0,d.consumeStream)(s);const l=(0,S.localize)(8,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(o).toString());throw o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(l,o.stat,r):new w.FileOperationError(l,(0,w.toFileOperationResult)(o),r)}}readFileStreamed(u,n,r,i=Object.create(null)){const a=u.readFileStream(n,i,r);return(0,d.transform)(a,{data:c=>c instanceof T.VSBuffer?c:T.VSBuffer.wrap(c),error:c=>new w.FileOperationError((0,S.localize)(9,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),i)},c=>T.VSBuffer.concat(c))}readFileBuffered(u,n,r,i=Object.create(null)){const a=(0,T.newWriteableBufferStream)();return(0,h.readFileIntoStream)(u,n,a,c=>c,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new w.FileOperationError((0,S.localize)(10,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(c).toString()),(0,w.toFileOperationResult)(c),i)},r),a}readFileUnbuffered(u,n,r){const i=(0,d.newWriteableStream)(a=>T.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,w.hasFileAtomicReadCapability)(u)?a=await u.readFile(n,{atomic:!0}):a=await u.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.validateReadFileLimits(n,a.byteLength,r),i.end(T.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async validateReadFile(u,n){const r=await this.resolve(u,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,S.localize)(11,null,this.resourceForError(u)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,S.localize)(12,null),r,n);return this.validateReadFileLimits(u,r.size,n),r}validateReadFileLimits(u,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,S.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,n,r){return this.doCanMoveCopy(u,n,"move",r)}async canCopy(u,n,r){return this.doCanMoveCopy(u,n,"copy",r)}async doCanMoveCopy(u,n,r,i){if(u.toString()!==n.toString())try{const a=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(a,u,c,n,r,i)}catch(a){return a}return!0}async move(u,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),c=await this.doMoveCopy(i,u,a,n,"move",!!r),s=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,c==="move"?2:3,s)),s}async copy(u,n,r){const i=await this.withReadProvider(u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),c=await this.doMoveCopy(i,u,a,n,"copy",!!r),s=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,c==="copy"?3:2,s)),s}async doMoveCopy(u,n,r,i,a,c){if(n.toString()===i.toString())return a;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(u,n,r,i,a,c);if(s&&!o&&c&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),a==="copy"){if(u===r&&(0,w.hasFileFolderCopyCapability)(u))await u.copy(n,i,{overwrite:c});else{const l=await this.resolve(n);l.isDirectory?await this.doCopyFolder(u,l,r,i):await this.doCopyFile(u,n,r,i)}return a}else return u===r?(await u.rename(n,i,{overwrite:c}),a):(await this.doMoveCopy(u,n,r,i,"copy",c),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(u,n,r,i){if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(u,n,r,i);if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(u,n,r,i);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(u,n,r,i);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasReadWriteCapability)(r))return this.doPipeUnbuffered(u,n,r,i)}async doCopyFolder(u,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async a=>{const c=this.getExtUri(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.doCopyFolder(u,await this.resolve(a.resource),r,c):this.doCopyFile(u,a.resource,r,c)}))}async doValidateMoveCopy(u,n,r,i,a,c){let s=!1;if(u===r){const{providerExtUri:l,isPathCaseSensitive:v}=this.getExtUri(u);if(v||(s=l.isEqual(n,i)),s&&a==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!s&&l.isEqualOrParent(i,n))throw new Error((0,S.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const o=await this.exists(i);if(o&&!s){if(!c)throw new w.FileOperationError((0,S.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(u===r){const{providerExtUri:l}=this.getExtUri(u);if(l.isEqualOrParent(n,i))throw new Error((0,S.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(u){const n=this.isPathCaseSensitive(u);return{providerExtUri:n?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(n,u);const r=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,0,r)),r}async mkdirp(u,n){const r=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(n,i.dirname(n));)try{if(((await u.stat(n)).type&w.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(n)));break}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(n)),n=i.dirname(n)}for(let a=r.length-1;a>=0;a--){n=i.joinPath(n,r[a]);try{await u.mkdir(n)}catch(c){if((0,w.toFileSystemProviderErrorCode)(c)!==w.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(u,n){try{await this.doValidateDelete(u,n)}catch(r){return r}return!0}async doValidateDelete(u,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(u)));let a;try{a=await r.stat(u)}catch{}if(a)this.throwIfFileIsReadonly(u,a);else throw new w.FileOperationError((0,S.localize)(20,null,this.resourceForError(u)),1);if(!!!n?.recursive){const s=await this.resolve(u);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(u)))}return r}async del(u,n){const r=await this.doValidateDelete(u,n),i=!!n?.useTrash,a=!!n?.recursive;await r.delete(u,{recursive:a,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(u,1))}async cloneFile(u,n){const r=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(u,n))return;if(r===i&&(0,w.hasFileCloneCapability)(r))return r.cloneFile(u,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const a=this.writeQueue.queueFor(u,this.getExtUri(r).providerExtUri);return r===i&&(0,w.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(u,n,{overwrite:!0})):a.queue(()=>this.doCopyFile(r,u,i,n))}watch(u,n={recursive:!1,excludes:[]}){const r=new P.DisposableStore;let i=!1,a=()=>{i=!0};return r.add((0,P.toDisposable)(()=>a())),(async()=>{try{const c=await this.doWatch(u,n);i?(0,P.dispose)(c):a=()=>(0,P.dispose)(c)}catch(c){this.logService.error(c)}})(),r}async doWatch(u,n){const r=await this.withProvider(u),i=(0,I.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(u),n]);let a=this.activeWatchers.get(i);return a||(a={count:0,disposable:r.watch(u,n)},this.activeWatchers.set(i,a)),a.count+=1,(0,P.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,P.dispose)(a.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,P.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(async()=>{const a=await u.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,a,i):await this.doWriteReadableBufferedQueued(u,a,i)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await u.close(a)}})}async doWriteStreamBufferedQueued(u,n,r){let i=0,a;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const c=T.VSBuffer.concat(r.buffer);await this.doWriteBuffer(u,n,c,c.byteLength,i,0),i+=c.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((c,s)=>{(0,d.listenStream)(a,{onData:async o=>{a.pause();try{await this.doWriteBuffer(u,n,o,o.byteLength,i,0)}catch(l){return s(l)}i+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>s(o),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(u,n,r){let i=0,a;for(;(a=r.read())!==null;)await this.doWriteBuffer(u,n,a,a.byteLength,i,0),i+=a.byteLength}async doWriteBuffer(u,n,r,i,a,c){let s=0;for(;s<i;)s+=await u.write(n,a+s,r.buffer,c+s,i-s)}async doWriteUnbuffered(u,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,n,r,i))}async doWriteUnbufferedQueued(u,n,r,i){let a;i instanceof T.VSBuffer?a=i:(0,d.isReadableStream)(i)?a=await(0,T.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?a=await(0,T.bufferedStreamToBuffer)(i):a=(0,T.readableToBuffer)(i),await u.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(u,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,n,r,i))}async doPipeBufferedQueued(u,n,r,i){let a,c;try{a=await u.open(n,{create:!1}),c=await r.open(i,{create:!0,unlock:!1});const s=T.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,v=0;do v=await u.read(a,o,s.buffer,l,s.byteLength-l),await this.doWriteBuffer(r,c,s,v,o,l),o+=v,l+=v,l===s.byteLength&&(l=0);while(v>0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof a=="number"?u.close(a):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async doPipeUnbuffered(u,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,n,r,i))}async doPipeUnbufferedQueued(u,n,r,i){return r.writeFile(i,await u.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,n,r,i))}async doPipeUnbufferedToBufferedQueued(u,n,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const c=await u.readFile(n);await this.doWriteBuffer(r,a,T.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await r.close(a)}}async doPipeBufferedToUnbuffered(u,n,r,i){const a=await(0,T.streamToBuffer)(this.readFileBuffered(u,n,L.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,a)}throwIfFileSystemIsReadonly(u,n){if(u.capabilities&2048)throw new w.FileOperationError((0,S.localize)(22,null,this.resourceForError(n)),6);return u}throwIfFileIsReadonly(u,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,S.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===E.Schemas.file?u.fsPath:u.toString(!0)}};g=me([Q(0,m.ILogService)],g),e.FileService=g}),define(re[189],se([0,1,54,271,6,38,16,3,42,2,12,4,19,41,27,151,13,94,186,37,180,179]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new L.ResourceMap(c=>p.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:c}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async s=>{try{let o;s.isSymbolicLink()?o=(await this.stat((0,p.joinPath)(i,s.name))).type:o=this.toType(s),c.push([s.name,o])}catch(o){this.logService.trace(o)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let c;return a?.dangling?c=w.FileType.Unknown:i.isFile()?c=w.FileType.File:i.isDirectory()?c=w.FileType.Directory:c=w.FileType.Unknown,a&&(c|=w.FileType.SymbolicLink),c}async createResourceLock(i){const a=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let c;for(;c=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await c.wait();const s=new T.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),s.open()})}async readFile(i,a){let c;try{a?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),c=await this.createResourceLock(i));const s=this.toFilePath(i);return await d.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{c?.dispose()}}readFileStream(i,a,c){const s=(0,C.newWriteableStream)(o=>A.VSBuffer.concat(o.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,h.readFileIntoStream)(this,i,s,o=>o.buffer,{...a,bufferSize:256*1024},c),s}async writeFile(i,a,c){let s;try{const o=this.toFilePath(i);if(!c.create||!c.overwrite){if(await d.Promises.exists(o)){if(!c.overwrite)throw(0,w.createFileSystemProviderError)((0,S.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,w.createFileSystemProviderError)((0,S.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(s,0,a,0,a.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(i,o)}finally{typeof s=="number"&&await this.close(s)}}async open(i,a){const c=this.toFilePath(i);let s;(0,w.isFileOpenForWriteOptions)(a)&&(s=await this.createResourceLock(i));let o;try{if((0,w.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:v}=await d.SymlinkSupport.stat(c);v.mode&128||await d.Promises.chmod(c,v.mode|128)}catch(v){this.logService.trace(v)}let l;if((0,w.isFileOpenForWriteOptions)(a)){if(E.isWindows)try{await d.Promises.truncate(c,0),l="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}l||(l="w")}else l="r";o=await d.Promises.open(c,l)}catch(l){throw s?.dispose(),(0,w.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(o,0),(0,w.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(o,i),s){const l=this.mapHandleToLock.get(o);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${c})`),this.mapHandleToLock.set(o,s),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${c})`),l.dispose())}return o}async close(i){const a=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(c){this.canFlush=!1,this.logService.error(c)}return await d.Promises.close(i)}catch(c){throw this.toFileSystemProviderError(c)}finally{a&&(this.mapHandleToLock.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,c,s,o){const l=this.normalizePos(i,a);let v=null;try{v=(await d.Promises.read(i,c,s,o,l)).bytesRead}catch(y){throw this.toFileSystemProviderError(y)}finally{this.updatePos(i,l,v)}return v}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,c){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,s+c):this.mapHandleToPos.delete(i)))}async write(i,a,c,s,o){return(0,T.retry)(()=>this.doWrite(i,a,c,s,o),100,3)}async doWrite(i,a,c,s,o){const l=this.normalizePos(i,a);let v=null;try{v=(await d.Promises.write(i,c,s,o,l)).bytesWritten}catch(y){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),y)}finally{this.updatePos(i,l,v)}return v}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const c=this.toFilePath(i);a.recursive?await d.Promises.rm(c,d.RimRafMode.MOVE):await d.Promises.unlink(c)}catch(c){throw this.toFileSystemProviderError(c)}}async rename(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a);if(s!==o)try{await this.validateTargetDeleted(i,a,"move",c.overwrite),await d.Promises.move(s,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(2,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a);if(s!==o)try{await this.validateTargetDeleted(i,a,"copy",c.overwrite),await d.Promises.copy(s,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(3,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(i,a,c,s){const o=this.toFilePath(i),l=this.toFilePath(a);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.isEqual)(o,l,!0)),v&&c==="copy")throw(0,w.createFileSystemProviderError)((0,S.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!v&&await d.Promises.exists(l)){if(!s)throw(0,w.createFileSystemProviderError)((0,S.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.doCloneFile(i,a,!1)}async doCloneFile(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a),l=!!(this.capabilities&1024);if((0,b.isEqual)(s,o,!l))return;const v=new P.DisposableStore;try{const[y,O]=await Promise.all([this.createResourceLock(i),this.createResourceLock(a)]);v.add(y),v.add(O),c&&await d.Promises.mkdir((0,D.dirname)(o),{recursive:!0}),await d.Promises.copyFile(s,o)}catch(y){if(y.code==="ENOENT"&&!c)return this.doCloneFile(i,a,!0);throw this.toFileSystemProviderError(y)}finally{v.dispose()}}createUniversalWatcher(i,a,c){return new f.UniversalWatcherClient(s=>i(s),s=>a(s),c)}createNonRecursiveWatcher(i,a,c){return new u.NodeJSWatcherClient(s=>i(s),s=>a(s),c)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=w.FileSystemProviderErrorCode.NoPermissions;break;default:a=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let c=this.toFileSystemProviderError(a);if(i&&c.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(c=(0,w.createFileSystemProviderError)(a,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return c}}e.DiskFileSystemProvider=n}),define(re[97],se([0,1,3,8,7]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p){this.service=p,this.onDidChangeLogLevel=k.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,C){switch(C){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${C}`)}async call(p,C,d){switch(C){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${C}`)}}e.LogLevelChannel=L;class A{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){A.setLevel(this.channel,p)}static setLevel(p,C){return p.call("setLevel",C)}}e.LogLevelChannelClient=A;class I{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,C){throw new Error(`Event not found: ${C}`)}async call(p,C,d){switch(C){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${C}`)}createLogger(p,C){this.loggers.set(p.toString(),this.loggerService.createLogger(p,C))}consoleLog(p,C){let d=console.log;switch(p){case T.LogLevel.Error:d=console.error;break;case T.LogLevel.Warning:d=console.warn;break;case T.LogLevel.Info:d=console.info;break}d.call(console,...C)}log(p,C){const d=this.loggers.get(p.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,w]of C)(0,T.log)(d,S,w)}}e.LoggerChannel=I;class b extends T.AbstractLoggerService{constructor(p,C,d){super(p,C);this.channel=d}createConsoleMainLogger(){return new T.AdapterLogger({log:(p,C)=>{this.channel.call("consoleLog",[p,C])}})}doCreateLogger(p,C,d){return new P(this.channel,p,C,d)}}e.LoggerChannelClient=b;class P extends T.AbstractMessageLogger{constructor(p,C,d,S){super(S?.always);this.channel=p,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[C,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,C){const d=[[p,C]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(p){this.channel.call("log",[this.file,p])}}class D extends T.LogService{constructor(p,C){super(C);this.parent=p,this._register(p.onDidChangeLogLevel(d=>C.setLevel(d)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=D}),define(re[68],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(re[58],se([0,1,3,52,2,5]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class A extends T.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(P){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...P,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(P),t.Iterable.reduce(this.policies.entries(),(E,[p,C])=>({...E,[p]:C}),{})}getPolicyValue(P){return this.policies.get(P)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(P,[D,E])=>({...P,[D]:{definition:E,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=A;class I{constructor(){this.onDidChange=k.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(re[190],se([0,1,3,2,58]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(b){this.service=b,this.disposables=new t.DisposableStore}listen(b,P){switch(P){case"onDidChange":return k.Event.map(this.service.onDidChange,D=>D.reduce((E,p)=>({...E,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${P}`)}call(b,P,D){switch(P){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(D)}throw new Error(`Call not found: ${P}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class A extends T.AbstractPolicyService{constructor(b,P){super();this.channel=P;for(const D in b){const{definition:E,value:p}=b[D];this.policyDefinitions[D]=E,p!==void 0&&this.policies.set(D,p)}this.channel.listen("onDidChange")(D=>{for(const E in D){const p=D[E];p===null?this.policies.delete(E):this.policies.set(E,p)}this._onDidChange.fire(Object.keys(D))})}async initializePolicies(b){const P=await this.channel.call("registerPolicyDefinitions",b);for(const D in P)this.policies.set(D,P[D])}}e.PolicyChannelClient=A}),define(re[98],se([0,1,20,4,36,19]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const I=t.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const I=(0,L.dirname)(k.FileAccess.asFileUri("",Z));A=Z.__$__nodeRequire((0,L.joinPath)(I,"product.json").fsPath);const b=Z.__$__nodeRequire((0,L.joinPath)(I,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[24],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[191],se([0,1,6,9,2,12,27,7,24]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let P=class extends T.Disposable{constructor(E,p,C){super();this.productService=p,this.logService=C,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),C=(0,L.dirname)(E),d=(0,L.basename)(E),S=await A.Promises.readdir(C);await Promise.all(S.map(async w=>{if(w===d)return;const h=(0,L.join)(C,w),m=await A.Promises.stat(h);if(m.isDirectory()&&p-m.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),A.Promises.rm(h)}))}catch(p){(0,t.onUnexpectedError)(p)}}};P=me([Q(1,b.IProductService),Q(2,I.ILogService)],P),e.CodeCacheCleaner=P}),define(re[192],se([0,1,6,9,2,12,27,15,7,24]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends T.Disposable{constructor(p,C,d){super();this.environmentService=p,this.logService=C,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),C=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(C)){const g=C[m];p[`${g.hash}.${m}`]=!0}const d=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const w=await A.Promises.readdir(d);for(const m of w){if(p[m]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await A.Promises.rm((0,L.join)(d,m))}const h=Date.now();for(const m of Object.keys(p)){const g=(0,L.join)(d,m),f=await A.Promises.readdir(g);for(const u of f){if(u==="tcf.json")continue;const n=(0,L.join)(g,u),r=await A.Promises.stat(n);r.isDirectory()&&h-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(m,u)}`),await A.Promises.rm(n))}}}catch(p){(0,t.onUnexpectedError)(p)}}};D=me([Q(0,I.INativeEnvironmentService),Q(1,b.ILogService),Q(2,P.IProductService)],D),e.LanguagePackCachedDataCleaner=D}),define(re[193],se([0,1,12,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var T;(function(L){function A(I,b="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,k.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(P.callFrame.url))&&(P.callFrame.url=(0,k.join)(b,(0,k.basename)(P.callFrame.url)));return I}L.rewriteAbsolutePaths=A})(T=e.Utils||(e.Utils={}))}),define(re[194],se([0,1,31]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(L){const I=await(await new Promise((P,D)=>{Z(["v8-inspect-profiler"],P,D)})).startProfiling({port:L.port,checkForPaused:!0}),b=(0,k.generateUuid)();return this._sessions.set(b,I),b}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const I=await A.stop();return this._sessions.delete(L),I.profile}}e.InspectProfilingService=t}),define(re[40],se([0,1,111,14]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(A,I){k.ok(t.isString(A)),k.ok(t.isObject(I)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new T}),define(re[99],se([0,1,3,40]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,P){this.schemasById[T(b)]=P,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;t.Registry.add(e.Extensions.JSONContribution,A)}),define(re[43],se([0,1,17,3,14,138,18,99,40]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=b.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.doRegisterConfigurations(n,r);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=this.doDeregisterConfigurations(n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(n,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:a,source:c}of n)for(const s in a)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o=this.configurationDefaultsOverrides.get(s),l=o?.valuesSources??new Map;if(c)for(const _ of Object.keys(a[s]))l.set(_,c);const v={...o?.value||{},...a[s]};this.configurationDefaultsOverrides.set(s,{source:c,value:v,valuesSources:l});const y=(0,A.getLanguageTagSettingPlainKey)(s),O={type:"object",default:v,description:L.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:T.isString(c)?void 0:c,defaultValueSource:c};i.push(...S(s)),this.configurationProperties[s]=O,this.defaultLanguageConfigurationOverridesNode.properties[s]=O}else{this.configurationDefaultsOverrides.set(s,{value:a[s],source:c});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:a}of n)for(const c in i){const s=this.configurationDefaultsOverrides.get(c),o=T.isString(a)?a:a?.id,l=T.isString(s?.source)?s?.source:s?.source?.id;if(o===l)if(r.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const v=this.configurationProperties[c];v&&(this.updatePropertyDefaultValue(c,v),this.updateSchema(c,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r){const i=[];return n.forEach(a=>{i.push(...this.validateAndRegisterProperties(a,r,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),i}doDeregisterConfigurations(n){const r=[],i=a=>{if(a.properties)for(const c in a.properties){r.push(c);const s=this.configurationProperties[c];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,a.properties[c])}a.allOf?.forEach(c=>i(c))};for(const a of n){i(a);const c=this.configurationContributors.indexOf(a);c!==-1&&this.configurationContributors.splice(c,1)}return r}validateAndRegisterProperties(n,r=!0,i,a,c=3){c=T.isUndefinedOrNull(n.scope)?c:n.scope;const s=[],o=n.properties;if(o)for(const v in o){const y=o[v];if(r&&g(v,y)){delete o[v];continue}if(y.source=i,y.defaultDefaultValue=o[v].default,this.updatePropertyDefaultValue(v,y),e.OVERRIDE_PROPERTY_REGEX.test(v)?y.scope=void 0:(y.scope=T.isUndefinedOrNull(y.scope)?c:y.scope,y.restricted=T.isUndefinedOrNull(y.restricted)?!!a?.includes(v):y.restricted),o[v].hasOwnProperty("included")&&!o[v].included){this.excludedConfigurationProperties[v]=o[v],delete o[v];continue}else this.configurationProperties[v]=o[v],o[v].policy?.name&&this.policyConfigurations.set(o[v].policy.name,v);!o[v].deprecationMessage&&o[v].markdownDeprecationMessage&&(o[v].deprecationMessage=o[v].markdownDeprecationMessage),s.push(v)}const l=n.allOf;if(l)for(const v of l)s.push(...this.validateAndRegisterProperties(v,r,i,a,c));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const a=i.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let a=i?.value,c=i?.source;T.isUndefined(a)&&(a=r.defaultDefaultValue,c=void 0),T.isUndefined(a)&&(a=h(r.type)),r.default=a,r.defaultValueSource=c}}const C="\\[([^\\]]+)\\]",d=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(u){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let r=d.exec(u);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=d.exec(u)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=S;function w(u){return u.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function h(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const m=new p;b.Registry.add(e.Extensions.Configuration,m);function g(u,n){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?L.localize(7,null,u):m.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,u,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=g;function f(){const u=[],n=m.getConfigurationProperties();for(const r of Object.keys(n))u.push([r,n[r].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=f}),define(re[69],se([0,1,17,3,34,2,38,29,14,8,18,43,40]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(r={},i=[],a=[]){this._contents=r,this._keys=i,this._overrides=a,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,D.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const a=this.getContentsForOverrideIdentifer(i);return a?r?(0,D.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return k.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return k.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),a=I.deepClone(this.overrides),c=[...this.keys];for(const s of r)if(!s.isEmpty()){this.mergeContents(i,s.contents);for(const o of s.overrides){const[l]=a.filter(v=>k.equals(v.identifiers,o.identifiers));l?(this.mergeContents(l.contents,o.contents),l.keys.push(...o.keys),l.keys=k.distinct(l.keys)):a.push(I.deepClone(o))}for(const o of s.keys)c.indexOf(o)===-1&&c.push(o)}return new C(i,c,a)}freeze(){return this.frozen=!0,this}clone(){return new C(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const c of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[c];const o=i[c];o&&(typeof s=="object"&&typeof o=="object"?(s=I.deepClone(s),this.mergeContents(s,o)):s=o),a[c]=s}return new C(a,this.keys,this.overrides)}mergeContents(r,i){for(const a of Object.keys(i)){if(a in r&&b.isObject(r[a])&&b.isObject(i[a])){this.mergeContents(r[a],i[a]);continue}r[a]=I.deepClone(i[a])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,a=null;const c=s=>{s&&(a?this.mergeContents(a,s):a=I.deepClone(s))};for(const s of this.overrides)k.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&c(s.contents);return c(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,D.addToValueTree)(this.contents,r,i,a=>{throw new Error(a)})}removeValue(r){this.removeKey(r)&&(0,D.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let a=0;a<i;a++)r.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=C;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!b.isUndefinedOrNull(r)){const a=this.doParseContent(r);this.parseRaw(a,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:a,keys:c,overrides:s,restricted:o}=this.doParseRaw(r,i);this._configurationModel=new C(a,c,s),this._restrictedConfigurations=o||[]}doParseContent(r){let i={},a=null,c=[];const s=[],o=[];function l(y){Array.isArray(c)?c.push(y):a!==null&&(c[a]=y)}const v={onObjectBegin:()=>{const y={};l(y),s.push(c),c=y,a=null},onObjectProperty:y=>{a=y},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const y=[];l(y),s.push(c),c=y,a=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:l,onError:(y,O,_)=>{o.push({error:y,offset:O,length:_})}};if(r)try{T.visit(r,v),i=c[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return i}doParseRaw(r,i){const a=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),c=this.filter(r,a,!0,i);r=c.raw;const s=(0,D.toValuesTree)(r,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),o=Object.keys(r),l=this.toOverrides(r,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:s,keys:o,overrides:l,restricted:c.restricted}}filter(r,i,a,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[]};const s={},o=[];for(const l in r)if(E.OVERRIDE_PROPERTY_REGEX.test(l)&&a){const v=this.filter(r[l],i,!1,c);s[l]=v.raw,o.push(...v.restricted)}else{const v=i[l],y=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&o.push(l),(y===void 0||c.scopes===void 0||c.scopes.includes(y))&&(c.skipRestricted&&v?.restricted||(s[l]=r[l]))}return{raw:s,restricted:o}}toOverrides(r,i){const a=[];for(const c of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(c)){const s={};for(const o in r[c])s[o]=r[c][o];a.push({identifiers:(0,E.overrideIdentifiersFromKey)(c),keys:Object.keys(s),contents:(0,D.toValuesTree)(s,i)})}return a}}e.ConfigurationModelParser=d;class S extends L.Disposable{constructor(r,i,a,c){super();this.userSettingsResource=r,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&a.isEqual(s.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(r,i,a,c,s=new C,o=new C,l=new A.ResourceMap,v=new C,y=new A.ResourceMap,O=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=a,this._localUserConfiguration=c,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=v,this._memoryConfigurationByResource=y,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,i,a){return this.getConsolidatedConfigurationModel(r,i,a).getValue(r)}updateValue(r,i,a={}){let c;a.resource?(c=this._memoryConfigurationByResource.get(a.resource),c||(c=new C,this._memoryConfigurationByResource.set(a.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(r):c.setValue(r,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,a){const c=this.getConsolidatedConfigurationModel(r,i,a),s=this.getFolderConfigurationModelForResource(i.resource,a),o=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),v=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),y=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),_=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),R=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,M=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(r):s.freeze().getValue(r):void 0,F=i.overrideIdentifier?o.override(i.overrideIdentifier).getValue(r):o.getValue(r),j=c.getValue(r),W=k.distinct(c.overrides.map(z=>z.identifiers).flat()).filter(z=>c.getOverrideValue(r,z)!==void 0);return{defaultValue:l,policyValue:v,applicationValue:y,userValue:O,userLocalValue:_,userRemoteValue:N,workspaceValue:R,workspaceFolderValue:M,memoryValue:F,value:j,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:v!==void 0?{value:v}:void 0,application:y!==void 0?{value:y,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:s?.freeze().getValue(r),override:i.overrideIdentifier?s?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:o.getValue(r),override:i.overrideIdentifier?o.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:c,updated:s,removed:o}=f(this._defaultConfiguration,r);i=[...c,...s,...o]}for(const c of i)for(const s of(0,E.overrideIdentifiersFromKey)(c)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=r.getKeysForOverrideIdentifier(s),v=[...l.filter(y=>o.indexOf(y)===-1),...o.filter(y=>l.indexOf(y)===-1),...o.filter(y=>!I.equals(this._defaultConfiguration.override(s).getValue(y),r.override(s).getValue(y)))];a.push([s,v])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:c}=f(this._policyConfiguration,r),s=[...i,...a,...c];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=f(this.applicationConfiguration,r),o=[...i,...a,...c];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=f(this.localUserConfiguration,r),o=[...i,...a,...c];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=f(this.remoteUserConfiguration,r),o=[...i,...a,...c];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=f(this.workspaceConfiguration,r),o=[...i,...a,...c];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const a=this.folderConfigurations.get(r),{added:c,updated:s,removed:o,overrides:l}=f(a,i),v=[...c,...s,...o];return(v.length||!a)&&this.updateFolderConfiguration(r,i),{keys:v,overrides:l}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:c,removed:s,overrides:o}=f(i,void 0);return{keys:[...a,...c,...s],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,a){let c=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:r},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const c=i.getFolder(r);c&&(a=this.getFolderConsolidatedConfiguration(c.uri)||a);const s=this._memoryConfigurationByResource.get(r);s&&(a=a.merge(s))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(r);c?(i=a.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=a}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:a,overrides:c,keys:s}=this._folderConfigurations.get(i);return r.push([i,{contents:a,overrides:c,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),a=this.parseConfigurationModel(r.policy),c=this.parseConfigurationModel(r.application),s=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),l=r.folders.reduce((v,y)=>(v.set(P.URI.revive(y[0]),this.parseConfigurationModel(y[1])),v),new A.ResourceMap);return new w(i,a,c,s,new C,o,l,new C,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new C(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=w;function h(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const c of n)c.keys.forEach(s=>r.add(s)),c.overrides.forEach(([s,o])=>{const l=(0,A.getOrSet)(i,s,new Set);o.forEach(v=>l.add(v))});const a=[];return i.forEach((c,s)=>a.push([s,[...c.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=h;class m{constructor(r,i,a,c){this.change=r,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=c,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(l=>s.add(l)),r.overrides.forEach(([,l])=>l.forEach(v=>s.add(v))),this.affectedKeys=[...s.values()];const o=new C;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(a,c)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let a=(0,D.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof a=="object"&&(c=Object.keys(a)[0]);){if(r=r[c],!r)return!1;a=a[c]}return!0}}e.ConfigurationChangeEvent=m;class g extends m{constructor(r,i,a,c){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=a,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=g;function f(n,r){const{added:i,removed:a,updated:c}=u(r,n),s=[],o=n?.getAllOverrideIdentifiers()||[],l=r?.getAllOverrideIdentifiers()||[];if(r){const v=l.filter(y=>!o.includes(y));for(const y of v)s.push([y,r.getKeysForOverrideIdentifier(y)])}if(n){const v=o.filter(y=>!l.includes(y));for(const y of v)s.push([y,n.getKeysForOverrideIdentifier(y)])}if(r&&n){for(const v of o)if(l.includes(v)){const y=u({contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)},{contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)});s.push([v,[...y.added,...y.removed,...y.updated]])}}return{added:i,removed:a,updated:c,overrides:s}}function u(n,r){const i=n?r?n.keys.filter(s=>r.keys.indexOf(s)===-1):[...n.keys]:[],a=r?n?r.keys.filter(s=>n.keys.indexOf(s)===-1):[...r.keys]:[],c=[];if(n&&r){for(const s of r.keys)if(n.keys.indexOf(s)!==-1){const o=(0,D.getConfigurationValue)(r.contents,s),l=(0,D.getConfigurationValue)(n.contents,s);I.equals(o,l)||c.push(s)}}return{added:i,removed:a,updated:c}}}),define(re[195],se([0,1,17,3,2,29,14,18,69,43,7,58,40]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class C extends T.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:g})=>this.onDidUpdateConfiguration(m,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=C;class d extends b.ConfigurationModel{constructor(m={}){const g=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(g),u=Object.create(null),n=[];for(const r in g){const i=m[r],a=i!==void 0?i:g[r].default;(0,I.addToValueTree)(u,r,a,c=>console.error(`Conflict in default settings: ${c}`))}for(const r of Object.keys(u))P.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(u[r]),contents:(0,I.toValuesTree)(u[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(u,f,n)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let w=class extends T.Disposable{constructor(m,g,f){super();this.defaultConfiguration=m,this.policyService=g,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const g={},f=[],u=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const n of m){const r=u[n];if(!r){f.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}f.push(n),g[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),f}onDidChangePolicies(m){const g=p.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),f=(0,k.coalesce)(m.map(u=>g.get(u)));this.update(f,!0)}update(m,g){const f=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),u=[],n=this._configurationModel.isEmpty();for(const r of m){const i=f[r]?.policy?.name;if(i){const a=this.policyService.getPolicyValue(i);(n?a!==void 0:!(0,L.equals)(this._configurationModel.getValue(r),a))&&u.push([r,a])}else this._configurationModel.getValue(r)!==void 0&&u.push([r,void 0])}if(u.length){const r=this._configurationModel;this._configurationModel=new b.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,a]of u)a===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,a);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=me([Q(1,E.IPolicyService),Q(2,D.ILogService)],w),e.PolicyConfiguration=w}),define(re[196],se([0,1,6,3,2,19,18,69,195,58]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends T.Disposable{constructor(p,C,d,S){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new b.DefaultConfiguration),this.policyConfiguration=d instanceof P.NullPolicyService?new b.NullPolicyConfiguration:this._register(new b.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,C)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:h})=>this.onDidDefaultConfigurationChange(w,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,C,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(p,C,new I.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(p,C){const d=typeof p=="string"?p:void 0,S=(0,A.isConfigurationOverrides)(p)?p:(0,A.isConfigurationOverrides)(C)?C:{};return this.configuration.getValue(d,S,void 0)}updateValue(p,C,d,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const C=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(d,C,1)}onDidDefaultConfigurationChange(p,C){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,C);this.trigger(S,d,6)}onDidPolicyConfigurationChange(p){const C=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(d,C,6)}trigger(p,C,d){const S=new I.ConfigurationChangeEvent(p,{data:C},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(re[197],se([0,1,9,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends k.ErrorNoTelemetry{constructor(I,b=T.Unknown,P){super(I);this._message=I,this._code=b,this._detail=P,this.isHandled=b===T.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(I){return I instanceof L&&I._code===T.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof L&&I._code===T.NoResolverFound}static isHandled(I){return I instanceof L&&I.isHandled}}e.RemoteAuthorityResolverError=L}),define(re[100],se([0,1,20]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===k.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function T(P){if(!P)return;const D=P.indexOf("+");return D<0?P:P.substr(0,D)}e.getRemoteName=T;function L(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(P){const{host:D,port:E}=b(P);if(typeof E=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:E}}e.parseAuthorityWithPort=A;function I(P,D){let{host:E,port:p}=b(P);return typeof p=="undefined"&&(p=D),{host:E,port:p}}e.parseAuthorityWithOptionalPort=I;function b(P){const D=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const p=P.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:P,port:void 0}}}),define(re[50],se([0,1,26,5,100]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=L;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var b;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,w){if(typeof S=="undefined"||S===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof S=="string"||typeof w=="string"){const h=typeof S=="string"?S:S.value,m=typeof w=="string"?w:w.value;return k.equalsIgnoreCase(h,m)}return S._lower===w._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=P;function D(d){return E(d)}e.isApplicationScopedExtension=D;function E(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function C(d,S){if(S){const w=`onResolveRemoteAuthority:${(0,T.getRemoteName)(S)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[32],se([0,1,26,30,50,4,8,9,36]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,a){return i.uuid&&a.uuid?i.uuid===a.uuid:i.id===a.id?!0:(0,k.compareIgnoreCase)(i.id,a.id)===0}e.areSameExtensions=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(a,c,s="undefined"){this.version=c,this.targetPlatform=s,this.id=a.id}static create(a){const c=a.manifest?a.manifest.version:a.version,s=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new E(a.identifier,c,s)}static parse(a){const c=D.exec(a);return c&&c[1]&&c[2]?new E({id:c[1]},c[2],c[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof E?P(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=E;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(i){const a=p.exec(i);return a&&a[1]?[S(a[1]),a[2]]:[S(i),void 0]}e.getIdAndVersion=C;function d(i,a){return`${i}.${a}`}e.getExtensionId=d;function S(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function w(i,a){return S(d(i,a))}e.getGalleryExtensionId=w;function h(i,a){const c=[],s=o=>{for(const l of c)if(l.some(v=>P(a(v),a(o))))return l;return null};for(const o of i){const l=s(o);l?l.push(o):c.push([o])}return c}e.groupByExtension=h;function m(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function g(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function f(i){const a=new Set;if(i.malicious)for(const c of i.malicious)a.add(c.id);return a}e.getMaliciousExtensionsSet=f;function u(i,a){const c=[],s=a.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const o=s.shift();if(o&&c.every(l=>!P(l.identifier,{id:o}))){const l=i.filter(v=>P(v.identifier,{id:o}));l.length===1&&(c.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=u;async function n(i,a){if(!L.isLinux)return!1;let c;try{c=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){a.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(o))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function r(i,a){const c=await n(i,a),s=(0,t.getTargetPlatform)(c?"alpine":L.platform,b.arch);return a.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(re[198],se([0,1,23,32]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function T(L,A,I,b,P){try{const D=await L.getExtensionsControlManifest();if(!D.deprecated)return;const E=await L.getInstalled(1);for(const[p,C]of Object.entries(D.deprecated)){if(!C?.extension)continue;const{id:d,autoMigrate:S,preRelease:w}=C.extension;if(!S)continue;const h=E.find(g=>(0,t.areSameExtensions)(g.identifier,{id:p}));if(!h)continue;const m=(await A.getExtensions([{id:d,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!m){P.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{P.info(`Migrating '${h.identifier.id}' extension to '${d}' extension...`);const g=!b.getDisabledExtensions().some(u=>(0,t.areSameExtensions)(u,h.identifier));await L.uninstall(h),P.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let f=E.find(u=>(0,t.areSameExtensions)(u.identifier,{id:d}));(!f||!f.isPreReleaseVersion&&g)&&(f=await L.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),P.info(`Installed the pre-release extension '${f.identifier.id}'`),g||(await b.disableExtension(f.identifier),P.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),S.storage&&(I.addToMigrationList((0,t.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,t.getExtensionId)(f.manifest.publisher,f.manifest.name)),P.info("Added pre-release extension to the storage migration list"))),P.info(`Migrated '${h.identifier.id}' extension to '${d}' extension.`)}catch(g){P.error(g)}}}catch(D){P.error(D)}}e.migrateUnsupportedExtensions=T}),define(re[199],se([0,1,6,9,2,4,19,55,8,31,27,15,30,32,13,7]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class extends T.Disposable{constructor(m,g,f,u){super();this.fileService=g,this.extensionGalleryService=f,this.logService=u,this.extensionsDownloadDir=b.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,g){await this.cleanUpPromise;const f=this.getName(m),u=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(u)){const n=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(m,n,g);try{await this.rename(n,u,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,n.path),r}}return u}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,g,f){try{await D.Promises.rename(m.fsPath,g.fsPath)}catch(u){if(L.isWindows&&u&&u.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${m} to ${g} with 'EPERM' error. Trying again...`),this.rename(m,g,f);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const g=[],f=[];for(const r of m.children){const i=C.ExtensionKey.parse(r.name);i&&f.push([i,r])}const u=(0,C.groupByExtension)(f,([r])=>r),n=[];for(const r of u)r.sort((i,a)=>I.rcompare(i[0].version,a[0].version)),g.push(...r.slice(1).map(i=>i[1].resource)),n.push(r[0][1]);n.sort((r,i)=>r.mtime-i.mtime),g.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(r=>r.resource)),await k.Promises.settled(g.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?C.ExtensionKey.create(m).toString().toLowerCase():(0,P.generateUuid)()}};w=me([Q(0,E.INativeEnvironmentService),Q(1,d.IFileService),Q(2,p.IExtensionGalleryService),Q(3,S.ILogService)],w),e.ExtensionsDownloader=w}),define(re[200],se([0,1,2,12,27,50]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(b,P){super();this.environmentService=b,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(P.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(b){b.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(re[201],se([0,1,93,17,6,2,20,12,27,15,30,32,7,67]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends C.LanguagePackBaseService{constructor(m,g,f,u){super(f);this.extensionManagementService=m,this.logService=u,this.cache=this._register(new S(g,u)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getInstalledLanguages(){const m=await this.cache.getLanguagePacks(),g=Object.keys(m).map(f=>{const u=m[f];return{...this.createQuickPickItem({locale:f,label:u.label}),extensionId:u.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),g}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const g=await this.cache.getLanguagePacks();Object.keys(g).some(f=>g[f]&&g[f].extensions.some(u=>(0,E.areSameExtensions)(u.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(g);return!(0,t.equals)(Object.keys(m),Object.keys(f))}};d=me([Q(0,D.IExtensionManagementService),Q(1,P.INativeEnvironmentService),Q(2,D.IExtensionGalleryService),Q(3,p.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends L.Disposable{constructor(m,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new T.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(g=>{Object.keys(g).forEach(f=>delete g[f]),this.createLanguagePacksFromExtensions(g,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...g){for(const f of g)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,g){const f=g.identifier,u=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const n of u)if(g.location.scheme===A.Schemas.file&&w(n)){let r=m[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},m[n.languageId]=r);const i=r.extensions.filter(a=>(0,E.areSameExtensions)(a.extensionIdentifier,f))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:f,version:g.manifest.version});for(const a of n.translations)r.translations[a.id]=(0,I.join)(g.location.fsPath,a.path)}}updateHash(m){if(m){const g=(0,k.createHash)("md5");for(const f of m.extensions)g.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=g.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(g=m(f),f)).then(f=>{for(const n of Object.keys(f))f[n]||delete f[n];this.languagePacks=f,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),b.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>g,f=>this.logService.error(f))})}};S=me([Q(0,P.INativeEnvironmentService),Q(1,p.ILogService)],S);function w(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const m of h.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(re[202],se([0,1,6,16,23,9,3,2,31,84,197,100]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var C;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(C=e.ConnectionType||(e.ConnectionType={}));function d(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(q){const x=new T.CancellationTokenSource;return setTimeout(()=>x.cancel(),q),x.token}function w(q,x){if(q.isCancellationRequested||x.isCancellationRequested)return T.CancellationToken.Cancelled;const B=new T.CancellationTokenSource;return q.onCancellationRequested(()=>B.cancel()),x.onCancellationRequested(()=>B.cancel()),B.token}class h{constructor(x){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((B,U)=>{this._resolvePromise=B,this._rejectPromise=U}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function m(q,x){const B=new h(x);return B.registerDisposable(q.onControlMessage(U=>{const $=JSON.parse(U.toString()),V=te($);V?B.reject(V):B.resolve($)})),B.promise}function g(q,x,B,U,$,V,J,H){const ee=new h(H);return x.connect(B,U,$,V,J,(ne,ae)=>{ee.didTimeout?(ne&&q.error(ne),ae?.dispose()):ne||!ae?ee.reject(ne):ee.resolve(ae)}),ee.promise}function f(q,x){const B=new h(x);return q.then(U=>{B.didTimeout||B.resolve(U)},U=>{B.didTimeout||B.reject(U)}),B.promise}async function u(q,x,B,U){const $=X(q,x);q.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let V;try{V=await g(q.logService,q.socketFactory,q.host,q.port,(0,E.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${d(x)}-${q.reconnectionToken}`,U)}catch(ae){throw q.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ae),ae}q.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let J,H;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(V,null),J=q.reconnectionProtocol,H=!1):(J=new P.PersistentProtocol(V,null),H=!0),q.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const ee=await f(q.signService.createNewMessage((0,b.generateUuid)()),U),ne={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ee.data};J.sendControl(t.VSBuffer.fromString(JSON.stringify(ne)));try{const ae=await m(J,w(U,S(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(q.logService.trace(`${$} 4/6. received SignRequest control message.`),!await f(q.signService.validate(ee,ae.signedData),U)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const Se=await f(q.signService.sign(ae.data),U),fe={type:"connectionType",commit:q.commit,signedData:Se,desiredConnectionType:x};return B&&(fe.args=B),q.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(t.VSBuffer.fromString(JSON.stringify(fe))),{protocol:J,ownsProtocol:H}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(q.logService.error(`${$} the handshake timed out. Error:`),q.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${$} received error control message when negotiating connection. Error:`),q.logService.error(ae)),H&&z(J),ae}}async function n(q,x,B,U){const $=Date.now(),V=X(q,x),{protocol:J,ownsProtocol:H}=await u(q,x,B,U),ee=new h(U);return ee.registerDisposable(J.onControlMessage(ne=>{const ae=JSON.parse(ne.toString()),ue=te(ae);ue?(q.logService.error(`${V} received error control message when negotiating connection. Error:`),q.logService.error(ue),H&&z(J),ee.reject(ue)):(q.reconnectionProtocol&&q.reconnectionProtocol.endAcceptReconnection(),q.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${Y($)}!`),ee.resolve({protocol:J,firstMessage:ae}))})),ee.promise}async function r(q,x){const{protocol:B}=await n(q,1,void 0,x);return{protocol:B}}async function i(q,x,B){const{protocol:U,firstMessage:$}=await n(q,2,x,B),V=$&&$.debugPort;return{protocol:U,debugPort:V}}async function a(q,x,B){const U=Date.now(),$=X(q,3),{protocol:V}=await u(q,3,x,B);return q.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(U)}!`),V}async function c(q,x,B){const{host:U,port:$,connectionToken:V}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,host:U,port:$,connectionToken:V,reconnectionToken:x,reconnectionProtocol:B,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function s(q,x,B){try{const U=(0,b.generateUuid)(),$=await c(q,U,null),{protocol:V}=await r($,T.CancellationToken.None);return new j(q,x,B,U,V)}catch(U){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(U),F.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentManagement=s;async function o(q,x){try{const B=(0,b.generateUuid)(),U=await c(q,B,null),{protocol:$,debugPort:V}=await i(U,x,T.CancellationToken.None);return new W(q,x,B,$,V)}catch(B){throw q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),q.logService.error(B),F.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=o;async function l(q,x,B){const U=await c(q,(0,b.generateUuid)(),null);return await a(U,{host:x,port:B},T.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function v(q){return(0,k.createCancelablePromise)(x=>new Promise((B,U)=>{const $=setTimeout(B,q*1e3);x.onCancellationRequested(()=>{clearTimeout($),B()})}))}var y;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(y=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(x,B){this.reconnectionToken=x,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=O;class _{constructor(x,B,U,$){this.reconnectionToken=x,this.millisSinceLastIncomingData=B,this.durationSeconds=U,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class N{constructor(x,B,U){this.reconnectionToken=x,this.millisSinceLastIncomingData=B,this.attempt=U,this.type=2}}e.ReconnectionRunningEvent=N;class R{constructor(x,B,U){this.reconnectionToken=x,this.millisSinceLastIncomingData=B,this.attempt=U,this.type=4}}e.ConnectionGainEvent=R;class M{constructor(x,B,U,$){this.reconnectionToken=x,this.millisSinceLastIncomingData=B,this.attempt=U,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class F extends I.Disposable{constructor(x,B,U,$,V){super();this._connectionType=x,this._options=B,this.reconnectionToken=U,this.protocol=$,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new R(this.reconnectionToken,0,0)),this._register($.onSocketClose(J=>{const H=K(this._connectionType,this.reconnectionToken,!0);J?J.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${J.hadError}).`),J.error&&this._options.logService.error(J.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this._options.logService.error(J.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(()=>{const J=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${J} received socket timeout event.`),this._beginReconnecting()})),F._instances.push(this),this._register((0,I.toDisposable)(()=>{const J=F._instances.indexOf(this);J>=0&&F._instances.splice(J,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}static triggerPermanentFailure(x,B,U){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=B,this._permanentFailureHandled=U,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(x=>x._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(x=>x._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||F._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const x=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const $=U<B.length?B[U]:B[B.length-1];try{if($>0){const J=v($);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,J)),this._options.logService.info(`${x} waiting for ${$} seconds before reconnecting...`);try{await J}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this._options.logService.info(`${x} resolving connection...`);const V=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,S(p)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(D.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,L.isCancellationError)(V)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof D.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,D.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(x,B,U){this._reconnectionFailureIsFatal?F.triggerPermanentFailure(x,B,U):this._gotoPermanentFailure(x,B,U)}_gotoPermanentFailure(x,B,U){this._onDidStateChange.fire(new M(this.reconnectionToken,x,B,U)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=F,F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class j extends F{constructor(x,B,U,$,V){super(1,x,$,V,!0);this.client=this._register(new P.Client(V,{remoteAuthority:B,clientId:U},x.ipcLogger))}async _reconnect(x,B){await r(x,B)}}e.ManagementPersistentConnection=j;class W extends F{constructor(x,B,U,$,V){super(2,x,U,$,!1);this._startArguments=B,this.debugPort=V}async _reconnect(x,B){await i(x,this._startArguments,B)}}e.ExtensionHostPersistentConnection=W;function z(q){try{q.acceptDisconnect();const x=q.getSocket();q.dispose(),x.dispose()}catch(x){(0,L.onUnexpectedError)(x)}}function te(q){if(q&&q.type==="error"){const x=new Error(`Connection error: ${q.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function G(q,x){for(;q.length<x;)q+=" ";return q}function K(q,x,B){return`[remote-connection][${G(d(q),13)}][${x.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function X(q,x){return`${K(x,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function Y(q){return`${Date.now()-q} ms`}}),define(re[203],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[204],se([0,1,119,18,7]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(I,b){this.configurationService=I,this.logService=b}async request(I,b){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const P=await(0,k.request)(I,b);return this.logService.trace("RequestService#request (browser) - success",I.url),P}catch(P){throw this.logService.error("RequestService#request (browser) - error",I.url,P),P}}async resolveProxy(I){}};L=me([Q(0,t.IConfigurationService),Q(1,T.ILogService)],L),e.RequestService=L}),define(re[44],se([0,1,16,153,43,5,40]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function I(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=I;function b(S){return S.res.statusCode===204}async function P(S){return b(S)?null:(await(0,k.streamToBuffer)(S.stream)).toString()}e.asText=P;async function D(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);return P(S)}e.asTextOrError=D;async function E(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);if(b(S))return null;const h=(await(0,k.streamToBuffer)(S.stream)).toString();try{return JSON.parse(h)}catch(m){throw m.message+=`:
`+h,m}}e.asJson=E;function p(S){d(S)}e.updateProxyConfigurationsScope=p;let C;function d(S){const w=A.Registry.as(T.Extensions.Configuration),h=C;C={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[C],remove:h?[h]:[]})}d(2)}),define(re[205],se([0,1,23,20,13,44]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,P){this.requestService=b,this.fileService=P}async download(b,P,D=k.CancellationToken.None){if(b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(b,P);return}const E={type:"GET",url:b.toString(!0)},p=await this.requestService.request(E,D);if(p.res.statusCode===200)await this.fileService.writeFile(P,p.stream);else{const C=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${C}`)}}};A=me([Q(0,L.IRequestService),Q(1,T.IFileService)],A),e.DownloadService=A}),define(re[206],se([0,1,17,23,75,2,19,169,13,7,24,44]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let p=class extends L.Disposable{constructor(d,S,w,h){super();this.fileService=d,this.productService=S,this.requestService=w,this.logService=h,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,T.forEach)(this.productService.configBasedExtensionTips,({value:m})=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const S=[];for(const[w,h]of this.allConfigBasedTips)if(!(h.configScheme&&h.configScheme!==d.scheme))try{const m=await this.fileService.readFile((0,A.joinPath)(d,w)),g=new Map;(0,T.forEach)(h.recommendations,({key:u,value:n})=>{if((0,k.isNonEmptyArray)(n.remotes))for(const r of n.remotes)g.set(r,{extensionId:u,extensionName:n.name,configName:h.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled});else S.push({extensionId:u,extensionName:n.name,configName:h.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})});const f=(0,I.getDomainsOfRemotes)(m.value.toString(),[...g.keys()]);for(const u of f){const n=g.get(u);n&&S.push(n)}}catch{}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(d.res.statusCode!==200)return[];const S=await(0,E.asJson)(d);return S?S.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};p=me([Q(0,b.IFileService),Q(1,D.IProductService),Q(2,E.IRequestService),Q(3,P.ILogService)],p),e.ExtensionTipsService=p}),define(re[101],se([0,1,63,5]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function T(L){return(0,k.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=T,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[207],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[208],se([0,1,85,6,23,3,2,20,31,7,101,207]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const w=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${w})`);const h=(0,D.hash)(S);this.processeDisposables.has(h)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.doDisposeWorker(S));const m=new T.CancellationTokenSource;let g,f,u;this.processeDisposables.set(h,a=>{m.dispose(!0),g?.terminate(S,T.CancellationToken.None),f?.close(),u?.close(),this.processeDisposables.delete(h);const c=this.processResolvers.get(h);c&&(this.processResolvers.delete(h),c({reason:a}))}),g=await this.getOrCreateWebWorker(S);const n=new Promise(a=>{this.processResolvers.set(h,a)});if(m.token.isCancellationRequested)return n;const{port1:r,port2:i}=new MessageChannel;return f=r,u=i,await g.spawn(S,u,m.token),m.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${w})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),n}getOrCreateWebWorker(S){let w=this.workers.get(S.process.moduleId);if(!w){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const h=new C(S.process.type,this.logService);w=h.init(),h.onDidProcessSelfTerminate(({configuration:m,reason:g})=>{this.doDisposeWorker(m,g)}),this.workers.set(S.process.moduleId,w)}return w}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,w){const h=this.processeDisposables.get((0,D.hash)(S));h&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),h(w))}};p=me([Q(0,P.ILogService)],p),e.SharedProcessWorkerService=p;class C extends A.Disposable{constructor(S,w){super();this.type=S,this.logService=w,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new t.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return w.onerror=h=>{this.logService.error(`SharedProcess: worker error (${this.type})`,h.message)},w.onmessageerror=h=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,h)},w.onmessage=h=>{const{id:m,message:g,configuration:f,nonce:u}=h.data;switch(m){case E.SharedProcessWorkerMessages.Ready:S.complete(w);break;case E.SharedProcessWorkerMessages.Ack:if(u){const n=this.mapMessageNonceToPendingMessageResolve.get(u);n&&(this.mapMessageNonceToPendingMessageResolve.delete(u),n())}break;case E.SharedProcessWorkerMessages.SelfTerminated:f&&g&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(g)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Info:g&&this.logService.info(g);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,g);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,h)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,w,h){const m=await this.workerReady;if(!w.isCancellationRequested)return new Promise(g=>{const f=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,g);const u={...S,nonce:f};h?m.postMessage(u,[h]):m.postMessage(u),w.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&g()})})}spawn(S,w,h){const m={id:E.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Z).fsPath}};return this.send(m,h,w)}terminate(S,w){const h={id:E.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(h,w)}}}),define(re[209],se([0,1,60,20,168]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends T.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.vscodeUserData})}}me([k.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(re[210],se([0,1,48,12,154,23,37,9,4,31,136,166,6]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const C=1e4;let d;async function S(h,m,g){return m["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!m["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=p.Promises.withAsyncBody(async(f,u)=>{const n=new L.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),u(new Error((0,T.localize)(0,null)))},C);try{f(await w(h,n.token))}catch(i){!(0,I.isCancellationError)(i)&&!n.token.isCancellationRequested?u(new Error((0,T.localize)(1,null,(0,A.toErrorMessage)(i)))):f({})}finally{clearTimeout(r),n.dispose()}})),d)}e.getResolvedShellEnv=S;async function w(h,m){const g=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",g);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",f);const u=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"(.*)"+u),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",r);const i=await(0,D.getSystemShell)(b.OS,r);return h.trace("getUnixShellEnvironment#shell",i),new Promise((a,c)=>{if(m.isCancellationRequested)return c((0,I.canceled)());const s=(0,t.basename)(i);let o,l;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(o=`& '${process.execPath}' ${v} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${v} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,s==="tcsh"?l=["-ic"]:l=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const y=(0,k.spawn)(i,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(y.kill(),c((0,I.canceled)()))),y.on("error",N=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(N)),c(N)});const O=[];y.stdout.on("data",N=>O.push(N));const _=[];y.stderr.on("data",N=>_.push(N)),y.on("close",(N,R)=>{const M=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",M);const F=Buffer.concat(_).toString("utf8");if(F.trim()&&h.trace("getUnixShellEnvironment#stderr",F),N||R)return c(new Error((0,T.localize)(2,null,N,R)));const j=n.exec(M),W=j?j[1]:"{}";try{const z=JSON.parse(W);g?z.ELECTRON_RUN_AS_NODE=g:delete z.ELECTRON_RUN_AS_NODE,f?z.ELECTRON_NO_ATTACH_CONSOLE=f:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",z),a(z)}catch(z){h.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(z)),c(z)}})})}}),define(re[102],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[211],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((T,L)=>Z(["vsda"],T,L))}async createNewMessage(T){try{const L=await this.vsda(),A=new L.validator;if(A){const I=String(k._nextId++);return this.validators.set(I,A),{id:I,data:A.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,L){if(!T.id)return!0;const A=this.validators.get(T.id);if(!A)return!1;this.validators.delete(T.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(T){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(T)}catch{}return T}}e.SignService=k,k._nextId=1}),define(re[212],se([0,1,3,2]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class T extends t.Disposable{constructor(D,E,p){super();this.channel=D,this.profile=E,this.workspace=p}async getItems(){const D={profile:this.profile,workspace:this.workspace},E=await this.channel.call("getItems",D);return new Map(E)}updateItems(D){const E={profile:this.profile,workspace:this.workspace};return D.insert&&(E.insert=Array.from(D.insert.entries())),D.delete&&(E.delete=Array.from(D.delete.values())),this.channel.call("updateItems",E)}}class L extends T{constructor(D,E){super(D,E,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(D=>this.onDidChangeStorage(D)))}onDidChangeStorage(D){(Array.isArray(D.changed)||Array.isArray(D.deleted))&&this._onDidChangeItemsExternal.fire({changed:D.changed?new Map(D.changed):void 0,deleted:D.deleted?new Set(D.deleted):void 0})}}class A extends L{constructor(D){super(D,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class I extends L{constructor(D,E){super(D,E)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class b extends T{constructor(D,E){super(D,void 0,E);this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=b}),define(re[213],se([0,1,4,36,8,31]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(k.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function I(P,D,E,p,C,d,S,w,h,m){const g=Object.create(null);g["common.machineId"]=S,g.sessionID=(0,L.generateUuid)()+Date.now(),g.commitHash=C,g.version=d,g["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,k.PlatformToString)(k.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=p,g["common.product"]=m||"desktop";const f=b(w||[]);f&&(g["common.msftInternal"]=f);let u=0;const n=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),k.isLinuxSnap&&(g["common.snap"]="true");const r=A(E);r&&(g["common.platformDetail"]=r);try{const i=await P.readFile(T.URI.file(h));g["common.source"]=i.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=I;function b(P){const D=t.env.USERDNSDOMAIN;if(!D)return!1;const E=D.toLowerCase();return P.some(p=>E===p)}e.verifyMicrosoftInternalDomain=b}),define(re[21],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[214],se([0,1,35,52,6,34,20,12,4,8,130,27,132,90,13,24,21]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function m(r,i){const a=`${r}::${i.join(":")}`,c=h.get(a);if(c)return c;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,v=2e4;function y(_,N,R,M){const F=N.substring(_.length+1);return T.Promises.withAsyncBody(async j=>{let W;try{W=await E.Promises.readdir(N,{withFileTypes:!0})}catch{j();return}if(M.count>=v){M.count+=W.length,M.maxReached=!0,j();return}let z=W.length;if(z===0){j();return}let te=W;M.count+W.length>v&&(M.maxReached=!0,z=v-M.count,te=W.slice(0,z)),M.count+=W.length;for(const G of te)if(G.isDirectory()){if(R.includes(G.name)||await y(_,(0,I.join)(N,G.name),R,M),--z==0){j();return}}else{const K=G.name.lastIndexOf(".");if(K>=0){const X=G.name.substring(K+1);X&&o.set(X,(o.get(X)??0)+1)}for(const X of s)X.relativePathPattern?.test(F)!==!1&&X.filePattern.test(G.name)&&l.set(X.tag,(l.get(X.tag)??0)+1);if(--z==0){j();return}}})}const O=T.Promises.withAsyncBody(async _=>{const N={count:0,maxReached:!1};await y(r,r,i,N);const R=await u(r);_({configFiles:g(l),fileTypes:g(o),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:R})});return h.set(a,O),O}e.collectWorkspaceStats=m;function g(r){return[...t.Iterable.map(r.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function f(){const r={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=f;async function u(r){try{const i=new Map,a=(0,I.join)(r,".vscode","launch.json"),c=await E.Promises.readFile(a),s=[],o=(0,L.parse)(c.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const v=l.type;v&&(i.has(v)?i.set(v,i.get(v)+1):i.set(v,1))}return g(i)}catch{return[]}}e.collectLaunchConfigs=u;let n=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const c=k.cpus();return c&&c.length>0&&a.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),a.push(`Memory (System):  ${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||a.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,p.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async c=>{let[s,o]=c,l=this.formatProcessList(i,s);return a.forEach(v=>{if((0,C.isRemoteDiagnosticError)(v))l+=`
${v.errorMessage}`,o+=`
${v.errorMessage}`;else if(l+=`

Remote: ${v.hostName}`,v.processes&&(l+=`
${this.formatProcessList(i,v.processes)}`),v.workspaceMetadata){o+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const O=v.workspaceMetadata[y];let _=`${O.fileCount} files`;O.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${y}): ${_}`,o+=this.formatWorkspaceStats(O)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(i,a){const{memory:c,vmHint:s,os:o,cpus:l}=f(),v={os:o,memory:c,cpus:l,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return b.isWindows||(v.load=`${k.loadavg().map(y=>Math.round(y)).join(", ")}`),b.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(i,a){const c=[];return(0,p.listProcesses)(i.mainPID).then(async s=>(c.push(""),c.push(this.formatEnvironment(i)),c.push(""),c.push(this.formatProcessList(i,s)),i.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(i))),a.forEach(o=>{if((0,C.isRemoteDiagnosticError)(o))c.push(`
${o.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${o.hostName}`),c.push(this.formatMachineInfo(o.machineInfo)),o.processes&&c.push(this.formatProcessList(i,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const v=o.workspaceMetadata[l];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),c.push(`Folder (${l}): ${y}`),c.push(this.formatWorkspaceStats(v))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(i){const a=[],c=60;let s=0;const o=(O,_)=>{const N=` ${O}(${_})`;s+N.length>c?(a.push(l),l="|                 ",s=l.length):s+=N.length,l+=N};let l="|      File types:";const v=10,y=i.fileTypes.length>v?v:i.fileTypes.length;for(let O=0;O<y;O++){const _=i.fileTypes[O];o(_.name,_.count)}if(a.push(l),i.configFiles.length>=0&&(l="|      Conf files:",s=0,i.configFiles.forEach(O=>{o(O.name,O.count)}),a.push(l)),i.launchConfigFiles.length>0){let O="|      Launch Configs:";i.launchConfigFiles.forEach(_=>{O+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),a.push(O)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(c=>c.length));return Object.keys(i).map(c=>`${c}:  ${" ".repeat(a-c.length)}  ${i[c]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],c=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const l=P.URI.revive(o);if(l.scheme===A.Schemas.file){const v=l.fsPath;c.push(m(v,["node_modules",".git"]).then(y=>{let O=`${y.fileCount} files`;y.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.basename)(v)}): ${O}`),a.push(this.formatWorkspaceStats(y))}).catch(y=>{a.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else a.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const c=new Map;i.windows.forEach(o=>c.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,c,s,a,0),s.join(`
`)}formatProcessItem(i,a,c,s,o){const l=o===0;let v;l?v=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(v=`${v} (${a.get(s.pid)})`));const y=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);c.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(s.children)&&s.children.forEach(O=>this.formatProcessItem(i,a,c,O,o+1))}async getWorkspaceFileExtensions(i){const a=new Set;for(const{uri:c}of i.folders){const s=P.URI.revive(c);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(v=>a.add(v.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const c=P.URI.revive(a);if(c.scheme!==A.Schemas.file)continue;const s=c.fsPath;try{const o=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};n=me([Q(0,w.ITelemetryService),Q(1,S.IProductService)],n),e.DiagnosticsService=n}),define(re[103],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:I,data:b}){return this.appenders.forEach(P=>P.log(I,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class t{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(re[45],se([0,1,29,79,14,18,21]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(f,u){return Promise.resolve(void 0)}publicLog2(f,u){return this.publicLog(f,u)}publicLogError(f,u){return Promise.resolve(void 0)}publicLogError2(f,u){return this.publicLogError(f,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class b{async publicLog(f,u,n){}async publicLogError(f,u,n){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(g,f){return f.onDidChangeConfiguration(u=>{u.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(u.source),configurationKeys:w(u.sourceConfig)})})}e.configurationTelemetry=P;function D(g,f){return!(f.disableTelemetry||!g.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=D;function E(g){const f=g.getValue(A.TELEMETRY_SETTING_ID),u=g.getValue("telemetry.enableCrashReporter");if(g.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function p(g){const f={},u={},n={};S(g,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const i=n[r];typeof i=="number"?u[r]=i:typeof i=="boolean"?u[r]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${i.length}`),f[r]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(f[r]=i)}return{properties:f,measurements:u}}e.validateTelemetryData=p;const C=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(g){if(!g)return"none";for(const f of C)if(g.startsWith(`${f}+`))return f;return"other"}e.cleanRemoteAuthority=d;function S(g,f,u=0,n){if(!!g)for(const r of Object.getOwnPropertyNames(g)){const i=g[r],a=n?n+r:r;Array.isArray(i)?f[a]=(0,k.safeStringify)(i):i instanceof Date?f[a]=i.toISOString():(0,T.isObject)(i)?u<2?S(i,f,u+1,a+"."):f[a]=(0,k.safeStringify)(i):f[a]=i}}function w(g){if(!g)return[];const f=[];return h(f,"",g),f}function h(g,f,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(n=>h(g,f?`${f}.${n}`:n,u[n])):g.push(f)}function m(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}e.getPiiPathsFromEnvironment=m}),define(re[215],se([0,1,49,45]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function T(L,A,I,b,P,D,E){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},C=await(0,k.getServiceMachineId)(I,P,D),{sessionId:d}=await E.getTelemetryInfo();return(0,t.supportsTelemetry)(A,I)&&(0,t.getTelemetryLevel)(b)===3&&(p["X-Market-User-Id"]=C,p["VSCode-SessionId"]=d),p}e.resolveMarketplaceHeaders=T}),define(re[216],se([0,1,9,29,45]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(b,P,D){const E=await new Promise((w,h)=>{Z(["@microsoft/1ds-core-js"],w,h)}),p=await new Promise((w,h)=>{Z(["@microsoft/1ds-post-js"],w,h)}),C=new E.AppInsightsCore,d=new p.PostChannel,S={instrumentationKey:b,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(D){S.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:D};S.extensionConfig[d.identifier]=w}return C.initialize(S,[]),C.addTelemetryInitializer(w=>{P&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),C}class I{constructor(P,D,E,p,C){this._configurationService=P,this._eventPrefix=D,this._defaultData=E,this._xhrOverride=C,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}if(!this._asyncAiCore){const D=this._configurationService.getValue("telemetry.internalTesting");this._asyncAiCore=A(this._aiCoreOrKey,D,this._xhrOverride)}this._asyncAiCore.then(D=>{P(D)},D=>{(0,k.onUnexpectedError)(D),console.error(D)})}}log(P,D){if(!this._aiCoreOrKey)return;D=(0,t.mixin)(D,this._defaultData),D=(0,T.validateTelemetryData)(D);const E=this._eventPrefix+"/"+P;try{this._withAIClient(p=>p.track({name:E,baseData:{name:E,properties:D?.properties,measurements:D?.measurements}}))}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(D=>{D.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[217],se([0,1,216]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemWebAppender=void 0;class t extends k.AbstractOneDataSystemAppender{constructor(L,A,I,b){super(L,A,I,b);fetch(this.endPointUrl,{method:"POST"}).catch(P=>{this._aiCoreOrKey=void 0})}}e.OneDataSystemWebAppender=t}),define(re[104],se([0,1,2,15,7,45]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(b,P,D=""){super();this.prefix=D;const E=b.getLogger(P.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(P.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,P){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,L.validateTelemetryData)(P))}};A=me([Q(0,T.ILoggerService),Q(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(re[105],se([0,1,2,29,79,4,26,155,18,43,98,24,40,21,45]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(m,g,f){this._configurationService=g,this._productService=f,this._experimentProperties={},this.telemetryLevel=new T.MutableObservableValue(3),this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,g){this._experimentProperties[m]=g}_updateTelemetryLevel(){let m=(0,d.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const f=g.usage?3:g.error?2:0;m=Math.min(m,f)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,g=m.sessionID,f=m["common.machineId"],u=m["common.firstSessionDate"],n=m["common.msftInternal"];return{sessionId:g,machineId:f,firstSessionDate:u,msftInternal:n}}dispose(){this._disposables.dispose()}_log(m,g,f,u){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(n=>{f=(0,t.mixin)(f,n),f=(0,t.mixin)(f,this._experimentProperties),f=(0,t.cloneAndChange)(f,r=>{if(typeof r=="string")return this._cleanupInfo(r,u)}),this._appenders.forEach(r=>r.log(m,f))},n=>{console.error(n)})}publicLog(m,g,f){return this._log(m,3,g,f)}publicLog2(m,g,f){return this.publicLog(m,g,f)}publicLogError(m,g){return this._sendErrorTelemetry?this._log(m,2,g,!0):Promise.resolve(void 0)}publicLogError2(m,g){return this.publicLogError(m,g)}_anonymizeFilePaths(m){let g=m;const f=[];for(const i of this._cleanupPatterns)for(;;){const a=i.exec(m);if(!a)break;f.push([a.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(g="";;){const i=n.exec(m);if(!i)break;!u.test(i[0])&&f.every(([a,c])=>i.index<a||i.index>=c)&&(g+=m.substring(r,i.index)+"<REDACTED: user-file-path>",r=n.lastIndex)}return r<m.length&&(g+=m.substr(r)),g}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const g=m.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of f)if(u.regex.test(g))return`<REDACTED: ${u.label}>`;return m}_cleanupInfo(m,g){let f=m;g&&(f=this._anonymizeFilePaths(f));for(const u of this._cleanupPatterns)f=f.replace(u,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=me([Q(1,b.IConfigurationService),Q(2,E.IProductService)],S),e.TelemetryService=S;function w(){const h=(0,I.localize)(0,null,D.default.nameLong),m=D.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.isWeb?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),u=(0,I.localize)(5,null),n=(0,I.localize)(6,null),r=(0,I.localize)(7,null),i=`
|       | ${f} | ${u} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,I.localize)(8,null);return`
${h} ${m} ${g}

&nbsp;

${r}
${i}

&nbsp;

${a}
`}p.Registry.as(P.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(P.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,I.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,I.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[218],se([0,1,9,29,45]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(I){const b=await new Promise((D,E)=>{Z(["applicationinsights"],D,E)});let P;return b.defaultClient?(P=new b.TelemetryClient(I),P.channel.setUseDiskRetryCaching(!0)):(b.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=b.defaultClient),I.indexOf("AIF-")===0&&(P.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),P}class A{constructor(b,P,D){this._eventPrefix=b,this._defaultData=P,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(P=>{b(P)},P=>{(0,k.onUnexpectedError)(P),console.error(P)})}}log(b,P){if(!!this._aiClient){P=(0,t.mixin)(P,this._defaultData),P=(0,T.validateTelemetryData)(P);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+b,properties:P.properties,measurements:P.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(P=>{try{P.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(re[219],se([0,1,20,65,18,15,7,24,21,103,104,105]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(d,S,w,h,m){this.configurationService=d,this.telemetryService=S,this.loggerService=w,this.environmentService=h,this.productService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:S,sessionId:w}=await this.telemetryService.getTelemetryInfo(),h=Object.create(null);h["common.vscodemachineid"]=S,h["common.vscodesessionid"]=w;const m=[d.id,JSON.stringify(h),d.aiKey],f=new t.Client(k.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new P.TelemetryAppenderClient(f),new D.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new E.TelemetryService({appenders:u,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,S,w){await(await this.getCustomTelemetryService(d)).publicLog(S,w)}async publicLogError(d,S,w){await(await this.getCustomTelemetryService(d)).publicLogError(S,w)}};p=me([Q(0,T.IConfigurationService),Q(1,b.ITelemetryService),Q(2,A.ILoggerService),Q(3,L.IEnvironmentService),Q(4,I.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(re[220],se([0,1,6,23,3,2,7]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends L.Disposable{constructor(P,D){super();this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new T.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((D,E)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,D),this._onCreateRequest.fire({requestId:p,...P});const C=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,C.token).then(()=>E(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>C.cancel())])})}acceptReply(P,D){const E=this._pendingRequests.get(P);E?(this._pendingRequests.delete(P),(0,L.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),E(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};I=me([Q(1,A.ILogService)],I),e.RequestStore=I}),define(re[106],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var T;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",h.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",h.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(T=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(h){h.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var I;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var b;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(b=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var D;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(h){h.TerminalView="view",h.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}))}),define(re[221],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(re[222],se([0,1,35,20,29,12,4,36,26,14,27]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let u=0;return f&&f.length===4&&(u=parseInt(f[3])),u}e.getWindowsBuildNumber=E;async function p(f,u,n,r=I.env,i=D.Promises.exists){if(L.isAbsolute(f))return await i(f)?f:void 0;if(u===void 0&&(u=I.cwd()),L.dirname(f)!=="."){const o=L.join(u,f);return await i(o)?o:void 0}const c=(0,T.getCaseInsensitive)(r,"PATH");if(n===void 0&&(0,P.isString)(c)&&(n=c.split(L.delimiter)),n===void 0||n.length===0){const o=L.join(u,f);return await i(o)?o:void 0}for(const o of n){let l;if(L.isAbsolute(o)?l=L.join(o,f):l=L.join(u,o,f),await i(l))return l;if(A.isWindows){let v=l+".com";if(await i(v)||(v=l+".exe",await i(v)))return v}}const s=L.join(u,f);return await i(s)?s:void 0}e.findExecutable=p;function C(f,u,n){if(!u.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const r=f.args,i=I.platform==="win32"?L.basename(f.executable).toLowerCase():L.basename(f.executable),a=L.dirname(t.FileAccess.asFileUri("",Z).fsPath);let c;const s={VSCODE_INJECTION:"1"};if(A.isWindows){if(i==="pwsh.exe")return!r||m(r)?c=e.shellIntegrationArgs.get(d.WindowsPwsh):h(r)&&(c=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),c?(c&&(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a,"")),{newArgs:c,envMixin:s}):void 0;n.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(i){case"bash":return!r||r.length===0?c=e.shellIntegrationArgs.get(d.Bash):g(r)&&(s.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(d.Bash)),c?(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a),{newArgs:c,envMixin:s}):void 0;case"pwsh":return!r||m(r)?c=e.shellIntegrationArgs.get(d.Pwsh):h(r)&&(c=e.shellIntegrationArgs.get(d.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a,""),{newArgs:c,envMixin:s}):void 0;case"zsh":{if(!r||r.length===0?c=e.shellIntegrationArgs.get(d.Zsh):g(r)?c=e.shellIntegrationArgs.get(d.ZshLogin):(r===e.shellIntegrationArgs.get(d.Zsh)||r===e.shellIntegrationArgs.get(d.ZshLogin))&&(c=r),!c)return;c=[...c],c[c.length-1]=(0,b.format)(c[c.length-1],a);const o=L.join(k.tmpdir(),"vscode-zsh");s.ZDOTDIR=o;const l=[];return l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(o,".zshrc")}),l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(o,".zprofile")}),l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(o,".zshenv")}),l.push({source:L.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(o,".zlogin")}),{newArgs:c,envMixin:s,filesToCopy:l}}}n.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=C;var d;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],w=["-nol","-nologo"];function h(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(w.includes(f[0].toLowerCase())||w.includes(f[1].toLowerCase()))}function m(f){return typeof f=="string"?w.includes(f.toLowerCase()):f.length===0||f?.length===1&&w.includes(f[0].toLowerCase())}function g(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(re[223],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function t(L){return L===k.HIGH_CONTRAST_DARK||L===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function T(L){return L===k.DARK||L===k.HIGH_CONTRAST_DARK}e.isDark=T}),define(re[107],se([0,1,51,3,2,5,40,223]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var b;(function(w){function h(m){return m&&typeof m=="object"&&typeof m.id=="string"}w.isThemeColor=h})(b=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var D;(function(w){function h(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||b.isThemeColor(a.color))}w.isThemeIcon=h;const m=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function g(a){const c=m.exec(a);if(!c)return;const[,s]=c;return{id:s}}w.fromString=g;function f(a){return{id:a}}w.fromId=f;function u(a,c){let s=a.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),c&&(s=`${s}~${c}`),{id:s}}w.modify=u;function n(a){const c=a.id.lastIndexOf("~");if(c!==-1)return a.id.substring(c+1)}w.getModifier=n;function r(a,c){return a.id===c.id&&a.color?.id===c.color?.id}w.isEqual=r;function i(a,c){return{id:a.id,color:c?P(c):void 0}}w.asThemeIcon=i,w.asClassNameArray=k.CSSIcon.asClassNameArray,w.asClassName=k.CSSIcon.asClassName,w.asCSSSelector=k.CSSIcon.asCSSSelector})(D=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(w){switch(w){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,T.toDisposable)(()=>{const m=this.themingParticipants.indexOf(h);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const C=new p;A.Registry.add(e.Extensions.ThemingContribution,C);function d(w){return C.onColorThemeChange(w)}e.registerThemingParticipant=d;class S extends T.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,m){let g=this.theme.getColor(h);return g&&m&&(g=m(g,this.theme)),g?g.toString():null}}e.Themable=S}),define(re[224],se([0,1,51,8,157,107]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(p,C){const d=[{name:null,description:(0,T.localize)(0,null)}];return d.push(...p.map(S=>({name:S.profileName,description:I(S)}))),C&&d.push(...C.map(S=>({name:S.title,description:b(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=A;function I(p){let C=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?C+=`
- args: "${p.args}"`:C+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(C+=`
- overrideName: ${p.overrideName}`),p.color&&(C+=`
- color: ${p.color}`),p.env&&(C+=`
- env: ${JSON.stringify(p.env)}`),C}function b(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:k.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function P(p,C){if(!p&&!C)return!0;if(typeof p=="string"&&typeof C=="string")return p===C;if(Array.isArray(p)&&Array.isArray(C)){if(p.length!==C.length)return!1;for(let d=0;d<p.length;d++)if(p[d]!==C[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=P;function D(p,C){if(!p&&!C)return!0;if(!p||!C)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(C))return p.id===C.id&&p.color===C.color;if(typeof p=="object"&&p&&"light"in p&&"dark"in p&&typeof C=="object"&&C&&"light"in C&&"dark"in C){const d=p,S=C;if((t.URI.isUri(d.light)||E(d.light))&&(t.URI.isUri(d.dark)||E(d.dark))&&(t.URI.isUri(S.light)||E(S.light))&&(t.URI.isUri(S.dark)||E(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(t.URI.isUri(p)&&t.URI.isUri(C)||E(p)||E(C)){const d=p,S=C;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=D;function E(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=E}),define(re[225],se([0,1,51,156,43,40,224]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const I={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),f=>`$(${f.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},P={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...I}},D=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),C=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){L.Registry.as(T.Extensions.Configuration).registerConfiguration(w),g()}e.registerTerminalPlatformConfiguration=h;let m;function g(f,u){const n=L.Registry.as(T.Extensions.Configuration);let r;f&&(r=(0,A.createProfileSchemaEnums)(f?.profiles,u));const i=m;m={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?r?.values:void 0,markdownEnumDescriptions:f?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?r?.values:void 0,markdownEnumDescriptions:f?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?r?.values:void 0,markdownEnumDescriptions:f?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[m],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(re[226],se([0,1,48,51,12,4,27,83,222,107]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D,E=!0;function p(r,i,a,c,s=process.env,o,l,v,y){return o=o||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?C(a,o,s,l,c.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:c.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:c.getValue("terminal.integrated.defaultProfile.windows"),y,v):f(o,l,a,r&&typeof r=="object"?{...r}:c.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:c.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),y,v,s)}e.detectAvailableProfiles=p;async function C(r,i,a,c,s,o,l,v,y){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,b.getWindowsBuildNumber)()>=16299&&(N=!0),await w(v);const R=new Map;r&&(R.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),R.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),R.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(o,R);const M=await d(R.entries(),l,i,a,c,y);if(r||!r&&s)try{const F=await m(`${_}\\${N?"wsl":"bash"}.exe`,l);for(const j of F)(!o||!(j.profileName in o))&&M.push(j)}catch{E&&(c?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return M}async function d(r,i,a,c=process.env,s,o){const l=[];for(const[v,y]of r){if(y===null)continue;let O,_,N;if("source"in y){const F=D?.get(y.source);if(!F)continue;O=F.paths,_=y.args||F.args,y.icon?N=S(y.icon):F.icon&&(N=F.icon)}else O=Array.isArray(y.path)?y.path:[y.path],_=L.isWindows||Array.isArray(y.args)?y.args:void 0,N=S(y.icon);const R=await o?.(O)||O.slice(),M=await n(v,i,R,a,c,_,y.env,y.overrideName,y.isAutoDetected,s);M?(M.isAutoDetected=y.isAutoDetected,M.icon=N,M.color=y.color,l.push(M)):s?.debug("Terminal profile not validated",v,O)}return s?.debug("Validated terminal profiles",l),l}function S(r){return typeof r=="string"?{id:r}:r}async function w(r){D&&!r||(D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),D.set("PowerShell",{profileName:"PowerShell",paths:r||await h(),icon:P.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function h(){const r=[];for await(const i of(0,I.enumeratePowerShellInstallations)())r.push(i.exePath);return r}async function m(r,i){const a=[],c=await new Promise((l,v)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(y,O)=>{if(y)return v("Problem occurred when getting wsl distros");l(O)})});if(!c)return[];const s=new RegExp(/[\r?\n]/),o=c.split(s).filter(l=>l.trim().length>0&&l!=="");for(const l of o){if(l===""||l.startsWith("docker-desktop"))continue;const v=`${l} (WSL)`,y={profileName:v,path:r,args:["-d",`${l}`],isDefault:v===i,icon:g(l),isAutoDetected:!1};a.push(y)}return a}function g(r){return r.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):r.includes("Debian")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function f(r,i,a,c,s,o,l,v){const y=new Map;if(a){const O=(await r.readFile("/etc/shells")).toString(),_=o||O.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),N=new Map;for(const R of _){let M=(0,T.basename)(R),F=N.get(M)||0;F++,F>1&&(M=`${M} (${F})`),N.set(M,F),y.set(M,{path:R,isAutoDetected:!0})}}return u(c,y),await d(y.entries(),s,r,v,i,l)}function u(r,i){if(!!r)for(const[a,c]of Object.entries(r))c===null||!("path"in c)&&!("source"in c)?i.delete(a):(c.icon=c.icon||i.get(a)?.icon,i.set(a,c))}async function n(r,i,a,c,s,o,l,v,y,O){if(a.length===0)return Promise.resolve(void 0);const _=a.shift();if(_==="")return n(r,i,a,c,s,o,l,v,y);const N={profileName:r,path:_,args:o,env:l,overrideName:v,isAutoDetected:y,isDefault:r===i};if((0,T.basename)(_)===_){const M=s.PATH?s.PATH.split(T.delimiter):void 0,F=await(0,b.findExecutable)(_,void 0,M,void 0,c.existsFile);return F?(N.path=F,N.isFromPath=!0,N):n(r,i,a,c,s,o)}return await c.existsFile((0,T.normalize)(_))?N:n(r,i,a,c,s,o,l,v,y)}}),define(re[227],se([0,1,3,2,20,4,39,65,18,15,88,210,7,97,220,106,225,226]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let g=0,f=class extends t.Disposable{constructor(n,r,i,a){super();this._reconnectConstants=n,this._configurationService=r,this._environmentService=i,this._logService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,D.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const i=new I.Client(T.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,n);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const c=i.getChannel(S.TerminalIpcChannels.Log);C.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{C.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const s=A.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(o=>this._onProcessData.fire(o))),this._register(s.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(s.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(s.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(s.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(s.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(s.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,r,i,a,c,s,o,l,v,y,O){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(n,r,i,a,c,s,o,l,v,y,O);return clearTimeout(_),g=Math.max(g,N),N}updateTitle(n,r,i){return this._proxy.updateTitle(n,r,i)}updateIcon(n,r,i){return this._proxy.updateIcon(n,r,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n){return this._proxy.detachFromProcess(n)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,r){return this._proxy.shutdown(n,r)}input(n,r){return this._proxy.input(n,r)}processBinary(n,r){return this._proxy.processBinary(n,r)}resize(n,r,i){return this._proxy.resize(n,r,i)}acknowledgeDataEvent(n,r){return this._proxy.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this._proxy.setUnicodeVersion(n,r)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,r){return this._proxy.installAutoReply(n,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,r,i,a=!1){const c=await this._shellEnv;return(0,h.detectAvailableProfiles)(r,i,a,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this._proxy.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this._proxy.acceptDetachInstanceReply(n,r)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this._proxy.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this._proxy.refreshProperty(n,r)}async updateProperty(n,r,i){return this._proxy.updateProperty(n,r,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this._resolveVariablesRequestStore.acceptReply(n,r)}};f=me([Q(1,b.IConfigurationService),Q(2,P.IEnvironmentService),Q(3,p.ILogService)],f),e.PtyHostService=f}),define(re[70],se([0,1,3,4,5,7]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=E;function p(S,w){return w?w!==1&&S<1024:!t.isWindows&&S<1024}e.isPortPrivileged=p;class C{constructor(w,h,m){this.remoteAddress=w,this.localAddress=h,this._dispose=m,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=C;let d=class{constructor(w){this.logService=w,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],h=Array.from(this._tunnels.values());for(const m of h){const g=Array.from(m.values());for(const f of g){const u=await f.value;u&&w.push(u)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:h}of w.values())await h.then(m=>m?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,h,m,g,f=!1,u,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${m} on local port ${g}.`),!w)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(w,h,m,g,f,u,n);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const h=this._tunnels.get(w.tunnelRemoteHost);if(h){const m=h.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,h,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${h}.`);const g=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(h),g}}async closeTunnel(w,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${h} `);const m=this._tunnels.get(w);if(m&&m.has(h)){const g=m.get(h);g.refcount=0,await this.tryDisposeTunnel(w,h,g)}}addTunnelToMap(w,h,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(h,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,h){const m=this._tunnels.get(w);m&&(await m.get(h)||m.delete(h),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,h){const m=[w];D(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const g=m.map(f=>this._tunnels.get(f));for(const f of g){const u=f?.get(h);if(u)return u}}canTunnel(w){return!!P(w)}createWithProvider(w,h,m,g,f,u,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${m} on local port ${g}.`);const r=m;this._factoryInProgress.add(r);const a={elevationRequired:f?p(g===void 0?m:g):!1},c={remoteAddress:{host:h,port:m},localAddressPort:g,privacy:u,public:u?u!==I.Private:void 0,protocol:n},s=w.forwardPort(c,a);return s?(this.addTunnelToMap(h,m,s),s.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),s}};d=me([Q(0,L.ILogService)],d),e.AbstractTunnelService=d}),define(re[228],se([0,1,7,70,2,9,6]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends T.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(D){this._address=D,this._addressPromise&&(this._addressPromise.complete(D),this._addressPromise=null)}setTunnel(D){this._register(D)}}let b=class Pt extends T.Disposable{constructor(D,E){super();this._tunnelService=D,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(D=>D.dispose())}async createTunnel(){return{id:String(++Pt._lastId)}}async startTunnel(D,E,p,C,d,S){const w=new I,h=await Promise.resolve(this._tunnelService.openTunnel(D,w,p,C,d,S));if(!h)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${C} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),w.dispose(),await h.dispose(),(0,L.canceled)();return w.setTunnel(h),this._tunnels.set(E,w),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${h.localAddress} (local) to ${p}:${C} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(D,E){const p=this._tunnels.get(D);!p||p.setAddress(E)}async destroyTunnel(D){const E=this._tunnels.get(D);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${D}.`),this._tunnels.delete(D),await E.dispose();return}this._disposedTunnels.add(D)}};b._lastId=0,b=me([Q(0,t.ISharedTunnelsService),Q(1,k.ILogService)],b),e.SharedProcessTunnelService=b}),define(re[33],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(re[229],se([0,1,3,2,8,15,32,13,7,33]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends t.Disposable{constructor(p,C,d,S,w){super();this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(m=>this.onInstallExtension(m))),this._register(p.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(p.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const h=T.URI.file(d.extensionsPath);this._register(C.watch(h)),this._register(k.Event.filter(C.onDidFilesChange,m=>m.rawChanges.some(g=>this.doesChangeAffects(g,h)))(()=>this.onDidChange()))}doesChangeAffects(p,C){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),C)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(C,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const C of p)this.removeInstallingExtension(C.identifier),C.local&&this.addInstalledExtension(C.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(C=>!(0,A.areSameExtensions)(C,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(C=>!(0,A.areSameExtensions)(C,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),C=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,A.areSameExtensions)(w,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(w=>(0,A.areSameExtensions)(w,S))?!1:p.every(w=>!(0,A.areSameExtensions)(w.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(C.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:C,removed:d})}}};D=me([Q(1,I.IFileService),Q(2,L.INativeEnvironmentService),Q(3,b.ILogService),Q(4,P.IUriIdentityService)],D),e.ExtensionsWatcher=D}),define(re[230],se([0,1,33,89,13,19,114,3,2]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(p){this.uri=p,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let D=class{constructor(p){this._fileService=p,this._dispooables=new b.DisposableStore,this._limit=2**16;const C=new Map,d=S=>{let w=C.get(S.scheme);return w===void 0&&(w=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),C.set(S.scheme,w)),w};this._dispooables.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{C.delete(S.scheme)})),this.extUri=new L.ExtUri(d),this._canonicalUris=new A.SkipList((S,w)=>this.extUri.compare(S,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const C=this._canonicalUris.get(p);return C?C.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new P(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const C=this._limit*.5;for(let d=0;d<C;d++)this._canonicalUris.set(p[d][0],p[d][1].touch())}};D=me([Q(0,T.IFileService)],D),e.UriIdentityService=D,(0,t.registerSingleton)(k.IUriIdentityService,D,!0)}),define(re[231],se([0,1,3,2,13,41,38,16]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class b extends t.Disposable{constructor(D,E,p,C){super();this.fileSystemScheme=D,this.fileSystemProvider=E,this.userDataScheme=p,this.logService=C,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(D,E){this.watchResources.set(D,D);const p=this.fileSystemProvider.watch(this.toFileSystemResource(D),E);return(0,t.toDisposable)(()=>{this.watchResources.delete(D),p.dispose()})}stat(D){return this.fileSystemProvider.stat(this.toFileSystemResource(D))}mkdir(D){return this.fileSystemProvider.mkdir(this.toFileSystemResource(D))}rename(D,E,p){return this.fileSystemProvider.rename(this.toFileSystemResource(D),this.toFileSystemResource(E),p)}readFile(D){return this.fileSystemProvider.readFile(this.toFileSystemResource(D),{atomic:!0})}readFileStream(D,E,p){const C=(0,L.newWriteableStream)(d=>I.VSBuffer.concat(d.map(S=>I.VSBuffer.wrap(S))).buffer);return(async()=>{try{const d=await this.readFile(D);C.end(d)}catch(d){C.error(d),C.end()}})(),C}readdir(D){return this.fileSystemProvider.readdir(this.toFileSystemResource(D))}writeFile(D,E,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(D),E,p)}delete(D,E){return this.fileSystemProvider.delete(this.toFileSystemResource(D),E)}copy(D,E,p){if((0,T.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(D),this.toFileSystemResource(E),p);throw new Error("copy not supported")}handleFileChanges(D){const E=[];for(const p of D){if(p.resource.scheme!==this.fileSystemScheme)continue;const C=this.toUserDataResource(p.resource);this.watchResources.findSubstr(C)&&E.push({resource:C,type:p.type})}E.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(E))}toFileSystemResource(D){return D.with({scheme:this.fileSystemScheme})}toUserDataResource(D){return D.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=b}),define(re[28],se([0,1,63,3,2,19,14,8,158,15,13,5,7]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function C(h){const m=h;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&typeof m.isDefault=="boolean"&&typeof m.name=="string"&&I.URI.isUri(m.location)&&I.URI.isUri(m.globalStorageHome)&&I.URI.isUri(m.settingsResource)&&I.URI.isUri(m.keybindingsResource)&&I.URI.isUri(m.tasksResource)&&I.URI.isUri(m.snippetsHome)&&((0,A.isUndefined)(m.extensionsResource)||I.URI.isUri(m.extensionsResource)))}e.isUserDataProfile=C,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function d(h,m){return{id:h.id,isDefault:h.isDefault,name:h.name,location:I.URI.revive(h.location).with({scheme:m}),globalStorageHome:I.URI.revive(h.globalStorageHome).with({scheme:m}),settingsResource:I.URI.revive(h.settingsResource).with({scheme:m}),keybindingsResource:I.URI.revive(h.keybindingsResource).with({scheme:m}),tasksResource:I.URI.revive(h.tasksResource).with({scheme:m}),snippetsHome:I.URI.revive(h.snippetsHome).with({scheme:m}),extensionsResource:I.URI.revive(h.extensionsResource)?.with({scheme:m})}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function S(h,m,g){return{id:(0,k.hash)(m.toString()).toString(16),name:h,location:m,isDefault:!1,globalStorageHome:(0,L.joinPath)(m,"globalStorage"),settingsResource:(0,L.joinPath)(m,"settings.json"),keybindingsResource:(0,L.joinPath)(m,"keybindings.json"),tasksResource:(0,L.joinPath)(m,"tasks.json"),snippetsHome:(0,L.joinPath)(m,"snippets"),extensionsResource:(0,L.joinPath)(m,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:g}}e.toUserDataProfile=S;let w=class extends T.Disposable{constructor(m,g,f){super();this.environmentService=m,this.fileService=g,this.logService=f,this._defaultProfile=this.createDefaultUserDataProfile(!1),this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]??this._defaultProfile}get profiles(){return[]}newProfile(m,g){return S(m,(0,L.joinPath)(this.profilesHome,(0,k.hash)(m).toString(16)),g)}createDefaultUserDataProfile(m){const g=S((0,b.localize)(0,null),this.environmentService.userRoamingDataHome);return{...g,isDefault:!0,extensionsResource:m?g.extensionsResource:void 0}}createProfile(m,g){throw new Error("Not implemented")}setProfileForWorkspace(m,g){throw new Error("Not implemented")}getProfile(m){throw new Error("Not implemented")}removeProfile(m){throw new Error("Not implemented")}};w=me([Q(0,P.IEnvironmentService),Q(1,D.IFileService),Q(2,p.ILogService)],w),e.UserDataProfilesService=w}),define(re[46],se([0,1,6,16,2,38,8,32,13,5,7,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let C=class extends T.Disposable{constructor(S,w,h,m){super();this.fileService=S,this.uriIdentityService=w,this.userDataProfilesService=h,this.logService=m,this.resourcesAccessQueueMap=new L.ResourceMap,this.migratePromise=this.migrate()}async migrate(){await Promise.all(this.userDataProfilesService.profiles.map(async S=>{if(!!S.extensionsResource)try{let w=!1;const h=JSON.parse((await this.fileService.readFile(S.extensionsResource)).value.toString());for(const m of h)if(!!m.location&&!m.version)try{const g=(await this.fileService.readFile(this.uriIdentityService.extUri.joinPath(A.URI.revive(m.location),"package.json"))).value.toString();m.version=JSON.parse(g).version,w=!0}catch{}w&&await this.fileService.writeFile(S.extensionsResource,t.VSBuffer.fromString(JSON.stringify(h)))}catch{}}))}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,w){return this.withProfileExtensions(w,h=>(h=h.filter(m=>S.some(([g])=>!(0,I.areSameExtensions)(m.identifier,g.identifier))),h.push(...S.map(([m,g])=>({identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:g}))),h))}removeExtensionFromProfile(S,w){return this.withProfileExtensions(w,h=>h.filter(m=>!(0,I.areSameExtensions)(m.identifier,S)))}async withProfileExtensions(S,w){return await this.migratePromise,this.getResourceAccessQueue(S).queue(async()=>{let h=[];try{const m=await this.fileService.readFile(S),g=JSON.parse(m.value.toString());for(const f of g){if(!f.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",f);continue}if(!f.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",f);continue}if(!f.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",f);continue}h.push({identifier:f.identifier,location:A.URI.revive(f.location),version:f.version,metadata:f.metadata})}}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}if(w){h=w(h);const m=h.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),metadata:g.metadata}));await this.fileService.writeFile(S,t.VSBuffer.fromString(JSON.stringify(m)))}return h})}getResourceAccessQueue(S){let w=this.resourcesAccessQueueMap.get(S);return w||(w=new k.Queue,this.resourcesAccessQueueMap.set(S,w)),w}};C=me([Q(0,b.IFileService),Q(1,E.IUriIdentityService),Q(2,p.IUserDataProfilesService),Q(3,D.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(re[232],se([0,1,17,6,23,9,3,2,4,8,141,30,32,46,7,24,21,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends I.Disposable{constructor(s,o,l,v,y,O,_){super();this.userDataProfilesService=s,this.uriIdenityService=o,this.galleryService=l,this.extensionsProfileScannerService=v,this.telemetryService=y,this.logService=O,this.productService=_,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(N=>N.cancel()),this.uninstallingExtensions.forEach(N=>N.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,E.isTargetPlatformCompatible)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(D.localize(0,null),E.ExtensionManagementErrorCode.Internal);const l=await this.checkAndGetCompatibleVersion(s,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(l.manifest,l.extension,o)}catch(l){throw n(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(s),error:l}),this.logService.error("Failed to install extension.",s.identifier.id),this.logService.error(l),u(l)}}async uninstall(s,o={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,o)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const o=await this.getTargetPlatform(),[l]=await this.galleryService.getExtensions([{...s.identifier,preRelease:s.preRelease}],{targetPlatform:o,compatible:!0},T.CancellationToken.None);if(!l)throw new Error(D.localize(2,null));await this.createDefaultUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(l)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.extensionsControlManifest||s-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=s),this.extensionsControlManifest}registerParticipant(s){this.participants.push(s)}async installExtension(s,o,l){if(!P.URI.isUri(o)){const N=this.installingExtensions.get(p.ExtensionKey.create(o).toString());if(N){this.logService.info("Extensions is already requested to install",o.identifier.id);const R=this.createWaitUntilInstallExtensionTaskIsFinishedTask(N,l),{local:M}=await R.waitUntilTaskIsFinished();return M}l={...l,installOnlyNewlyAddedFromExtensionPack:!0}}const v=[],y=[],O=this.createInstallExtensionTask(s,o,l);P.URI.isUri(o)||this.installingExtensions.set(p.ExtensionKey.create(o).toString(),O),this._onInstallExtension.fire({identifier:O.identifier,source:o,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",O.identifier.id),v.push({task:O,manifest:s});let _=!1;try{if(l.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(O.identifier,s,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation);for(const{gallery:M,manifest:F}of R){_=_||!!F.extensionDependencies?.some(W=>(0,p.areSameExtensions)({id:W},O.identifier));const j=p.ExtensionKey.create(M).toString();if(this.installingExtensions.has(j))this.logService.info("Extension is already requested to install",M.identifier.id);else{const W=this.createInstallExtensionTask(F,M,{...l,donotIncludePackAndDependencies:!0});this.installingExtensions.set(j,W),this._onInstallExtension.fire({identifier:W.identifier,source:M,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),v.push({task:W,manifest:F})}}}catch(R){if(P.URI.isUri(O.source))(0,k.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",O.identifier.id,R.message),(0,k.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",O.identifier.id,R.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),R}const N=v.reduce((R,{task:M,manifest:F})=>(R.set(M.identifier.id.toLowerCase(),{task:M,manifest:F}),R),new Map);for(;N.size;){let R;const M=[...N.values()].filter(({manifest:F})=>!F.extensionDependencies?.some(j=>N.has(j.toLowerCase())));M.length?R=N.size===1?M:M.filter(({task:F})=>!(F===O&&!_)):(this.logService.info("Found extensions with circular dependencies",M.map(({task:F})=>F.identifier.id)),R=[...N.values()]),await this.joinAllSettled(R.map(async({task:F})=>{const j=new Date().getTime();try{const{local:W}=await F.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(W,F.source,l,T.CancellationToken.None))),!P.URI.isUri(F.source)){const z=F.operation===3,te=z?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(n(this.telemetryService,z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-j,durationSinceUpdate:te}),b.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}y.push({local:W,identifier:F.identifier,operation:F.operation,source:F.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw P.URI.isUri(F.source)||n(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-j,error:W}),this.logService.error("Error while installing the extension:",F.identifier.id),W}finally{N.delete(F.identifier.id.toLowerCase())}}))}return y.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(y),y.filter(({identifier:R})=>(0,p.areSameExtensions)(R,O.identifier))[0].local}catch(N){if(v.forEach(({task:R})=>R.cancel()),y.length)try{const R=await Promise.allSettled(y.map(({local:M})=>this.createUninstallExtensionTask(M,{versionOnly:!0},l.profileLocation).run()));for(let M=0;M<R.length;M++){const F=R[M],{identifier:j}=y[M];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",j.id):this.logService.warn("Rollback: Error while uninstalling extension",j.id,(0,L.getErrorMessage)(F.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(R),y.map(({identifier:M})=>M.id))}throw this._onDidInstallExtensions.fire(v.map(({task:R})=>({identifier:R.identifier,operation:2,source:R.source,context:l.context,profileLocation:l.profileLocation}))),N}finally{for(const{task:N}of v)if(!P.URI.isUri(N.source)){const R=p.ExtensionKey.create(N.source).toString();this.installingExtensions.delete(R)||this.logService.warn("Installation task is not found in the cache",R)}}}async joinAllSettled(s){const o=[],l=[],v=await Promise.allSettled(s);for(const y of v)y.status==="fulfilled"?o.push(y.value):l.push(y.reason);if(l.length)throw f(l);return o}async getAllDepsAndPackExtensionsToInstall(s,o,l,v,y){if(!this.galleryService.isEnabled())return[];let O=await this.getInstalled(void 0,y);const _=[s,...O.map(M=>M.identifier)],N=[],R=async(M,F)=>{const j=F.extensionDependencies||[],W=[...j];if(F.extensionPack){const z=l?O.find(te=>(0,p.areSameExtensions)(te.identifier,M)):void 0;for(const te of F.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(G=>(0,p.areSameExtensions)({id:G},{id:te}))||W.every(G=>!(0,p.areSameExtensions)({id:G},{id:te}))&&W.push(te)}if(W.length){const z=[..._,...N.map(G=>G.gallery.identifier)],te=W.filter(G=>z.every(K=>!(0,p.areSameExtensions)(K,{id:G})));if(te.length){const G=await this.galleryService.getExtensions(te.map(K=>({id:K,preRelease:v})),T.CancellationToken.None);for(const K of G){if(z.find(q=>(0,p.areSameExtensions)(q,K.identifier)))continue;const X=j.some(q=>(0,p.areSameExtensions)({id:q},K.identifier));let Y;try{Y=await this.checkAndGetCompatibleVersion(K,!1,v)}catch(q){if(q instanceof E.ExtensionManagementError&&q.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.logService.info("Skipping the packed extension as it cannot be installed",K.identifier.id);continue}else throw q}N.push({gallery:Y.extension,manifest:Y.manifest}),await R(Y.extension.identifier,Y.manifest)}}}};return await R(s,o),O=await this.getInstalled(void 0,y),N.filter(M=>!O.some(F=>(0,p.areSameExtensions)(F.identifier,M.gallery.identifier)))}async checkAndGetCompatibleVersion(s,o,l){const v=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(v).has(s.identifier.id))throw new E.ExtensionManagementError(D.localize(3,null,s.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(s)){const _=await this.getTargetPlatform();throw new E.ExtensionManagementError(D.localize(4,null,s.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(_)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.getCompatibleVersion(s,o,l);if(y){if(l&&!o&&s.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(D.localize(5,null,s.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&s.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([s.identifier],T.CancellationToken.None))[0]?new E.ExtensionManagementError(D.localize(6,null,s.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(D.localize(7,null,s.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",y.identifier.id);const O=await this.galleryService.getManifest(y,T.CancellationToken.None);if(O===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(O.version!==y.version)throw new E.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:O}}async getCompatibleVersion(s,o,l){const v=await this.getTargetPlatform();let y=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(y=(await this.galleryService.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:v,compatible:!0},T.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(s,l,v)&&(y=s),y||(o?y=(await this.galleryService.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:v,compatible:!0},T.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(s,l,v)),y}async unininstallExtension(s,o){const l=R=>`${R.id.toLowerCase()}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,v=this.uninstallingExtensions.get(l(s.identifier));if(v)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),v.waitUntilTaskIsFinished();const y=(R,M)=>{const F=this.createUninstallExtensionTask(R,M,o.profileLocation);return this.uninstallingExtensions.set(l(F.extension.identifier),F),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${R.identifier.id}@${R.manifest.version}`),this._onUninstallExtension.fire({identifier:R.identifier,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped}),F},O=(R,M)=>{M?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${R.identifier.id}@${R.manifest.version}`,M.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${R.identifier.id}@${R.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(R),error:M}),this._onDidUninstallExtension.fire({identifier:R.identifier,version:R.manifest.version,error:M?.code,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped})},_=[],N=[];try{_.push(y(s,o));const R=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(s,R);for(const F of M)this.uninstallingExtensions.has(l(F.identifier))?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):_.push(y(F,o))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.checkForDependents(_.map(M=>M.extension),R,s),await this.joinAllSettled(_.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(M.extension,o,T.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}O(M.extension)}catch(F){const j=F instanceof E.ExtensionManagementError?F:new E.ExtensionManagementError((0,L.getErrorMessage)(F),E.ExtensionManagementErrorCode.Internal);throw O(M.extension,j),j}finally{N.push(M)}}))}catch(R){const M=R instanceof E.ExtensionManagementError?R:new E.ExtensionManagementError((0,L.getErrorMessage)(R),E.ExtensionManagementErrorCode.Internal);for(const F of _){try{F.cancel()}catch{}N.includes(F)||O(F.extension,M)}throw M}finally{for(const R of _)this.uninstallingExtensions.delete(l(R.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}checkForDependents(s,o,l){for(const v of s){const y=this.getDependents(v,o);if(y.length){const O=y.filter(_=>!s.some(N=>(0,p.areSameExtensions)(N.identifier,_.identifier)));if(O.length)throw new Error(this.getDependentsErrorMessage(v,O,l))}}}getDependentsErrorMessage(s,o,l){return l===s?o.length===1?D.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?D.localize(9,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):D.localize(10,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?D.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?D.localize(12,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):D.localize(13,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const v=s.manifest.extensionPack?s.manifest.extensionPack:[];if(v.length){const y=o.filter(_=>!_.isBuiltin&&v.some(N=>(0,p.areSameExtensions)({id:N},_.identifier))),O=[];for(const _ of y)O.push(...this.getAllPackExtensionsToUninstall(_,o,l));return[...y,...O]}return[]}getDependents(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(v=>(0,p.areSameExtensions)({id:v},s.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(s,o,l){const v=this.createDefaultInstallExtensionTask(s,o,l);return l.profileLocation&&this.userDataProfilesService.defaultProfile.extensionsResource?new i(v,l.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService):v}createWaitUntilInstallExtensionTaskIsFinishedTask(s,o){return!o.profileLocation||!this.userDataProfilesService.defaultProfile.extensionsResource||s instanceof i&&this.uriIdenityService.extUri.isEqual(s.profileLocation,o.profileLocation)?s:new i(s,o.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService)}createUninstallExtensionTask(s,o,l){return l&&this.userDataProfilesService.defaultProfile.extensionsResource?new a(s,l,this.userDataProfilesService,this.extensionsProfileScannerService):this.createDefaultUninstallExtensionTask(s,o)}};g=me([Q(0,m.IUserDataProfilesService),Q(1,h.IUriIdentityService),Q(2,E.IExtensionGalleryService),Q(3,C.IExtensionsProfileScannerService),Q(4,w.ITelemetryService),Q(5,d.ILogService),Q(6,S.IProductService)],g),e.AbstractExtensionManagementService=g;function f(c){const s=Array.isArray(c)?c:[c];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=f;function u(c){if(c instanceof E.ExtensionManagementError)return c;const s=new E.ExtensionManagementError(c.message,E.ExtensionManagementErrorCode.Internal);return s.stack=c.stack,s}function n(c,s,{extensionData:o,duration:l,error:v,durationSinceUpdate:y}){const O=v?v instanceof E.ExtensionManagementError?v.code:E.ExtensionManagementErrorCode.Internal:void 0;c.publicLog(s,{...o,success:!v,duration:l,errorcode:O,durationSinceUpdate:y})}e.reportTelemetry=n;class r{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(s=>new Promise((o,l)=>{const v=s.onCancellationRequested(()=>{v.dispose(),l(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r;class i{constructor(s,o,l,v){this.task=s,this.profileLocation=o,this.defaultProfileLocation=l,this.extensionsProfileScannerService=v,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const s=await this.task.waitUntilTaskIsFinished(),o=s.local.isApplicationScoped?this.defaultProfileLocation:this.profileLocation;return await this.extensionsProfileScannerService.addExtensionsToProfile([[s.local,s.metadata]],o),s}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class a extends r{constructor(s,o,l,v){super();this.extension=s,this.profileLocation=o,this.userDataProfilesService=l,this.extensionsProfileScannerService=v}async doRun(s){const o=[];o.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)),this.extension.isApplicationScoped&&this.userDataProfilesService.defaultProfile.extensionsResource&&o.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.userDataProfilesService.defaultProfile.extensionsResource)),await Promise.all(o)}}}),define(re[71],se([0,1,17,6,29,16,9,34,123,2,20,12,4,19,55,81,14,8,143,15,32,50,66,13,5,7,24,3,64,46,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n,r,i,a,c,s,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var y;(function(j){function W(z,te){if(z===te)return!0;const G=Object.keys(z),K=new Set;for(const X of Object.keys(te))K.add(X);if(G.length!==K.size)return!1;for(const X of G){if(z[X]!==te[X])return!1;K.delete(X)}return K.size===0}j.equals=W})(y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let O=class extends P.Disposable{constructor(W,z,te,G,K,X,Y,q,x,B){super();this.systemExtensionsLocation=W,this.userExtensionsLocation=z,this.extensionsControlLocation=te,this.cacheLocation=G,this.userDataProfilesService=K,this.extensionsProfileScannerService=X,this.fileService=Y,this.logService=q,this.environmentService=x,this.productService=B,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,C.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(new R((0,C.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new R((0,C.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.extensionsScanner=this._register(new N(this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,z){const[te,G]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(z)]),K=await this.scanExtensionsUnderDevelopment(W,[...te,...G]);return this.dedupExtensions(te,G,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const z=[];z.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),z.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[te,G]=await Promise.all(z);return this.applyScanOptions([...te,...G],0,W,!1)}async scanUserExtensions(W){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(W.profileLocation??this.userExtensionsLocation,!!W.profileLocation,1,!W.includeUninstalled,W.language);let G=await(W.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return G=await this.applyScanOptions(G,1,W,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(W,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const te=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(G=>G.scheme===D.Schemas.file).map(async G=>{const K=await this.createExtensionScannerInput(G,!1,1,!0,W.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(K)).map(Y=>(Y.type=z.find(q=>(0,f.areSameExtensions)(q.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,K)))}))).flat();return this.applyScanOptions(te,"development",W,!0)}return[]}async scanExistingExtension(W,z,te){const G=await this.createExtensionScannerInput(W,!1,z,!0,te.language),K=await this.extensionsScanner.scanExtension(G);return!K||!te.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(W,z,te){const G=await this.createExtensionScannerInput(W,!1,z,!0,te.language),K=await this.extensionsScanner.scanOneOrMultipleExtensions(G);return this.applyScanOptions(K,z,te,!0)}async scanMetadata(W){const z=(0,C.joinPath)(W,"package.json"),te=(await this.fileService.readFile(z)).value.toString();return JSON.parse(te).__metadata}async updateMetadata(W,z){const te=(0,C.joinPath)(W,"package.json"),G=(await this.fileService.readFile(te)).value.toString(),K=JSON.parse(G);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,K.__metadata={...K.__metadata,...z},await this.fileService.writeFile((0,C.joinPath)(W,"package.json"),L.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async applyScanOptions(W,z,te,G){return te.includeAllVersions||(W=this.dedupExtensions(z===0?W:void 0,z===1?W:void 0,z==="development"?W:void 0,await this.getTargetPlatform(),G)),te.includeInvalid||(W=W.filter(K=>K.isValid)),W.sort((K,X)=>{const Y=E.basename(K.location.fsPath),q=E.basename(X.location.fsPath);return Y<q?-1:Y>q?1:0})}dedupExtensions(W,z,te,G,K){const X=(q,x)=>{if(q.isValid&&!x.isValid)return!1;if(q.isValid===x.isValid){if(K&&d.gt(q.manifest.version,x.manifest.version))return this.logService.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(d.eq(q.manifest.version,x.manifest.version)){if(q.type===0)return this.logService.debug(`Skipping extension ${x.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===G)return this.logService.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return q.type===0?this.logService.debug(`Overwriting system extension ${q.location.path} with ${x.location.path}.`):this.logService.warn(`Overwriting user extension ${q.location.path} with ${x.location.path}.`),!0},Y=new Map;return W?.forEach(q=>{const x=u.ExtensionIdentifier.toKey(q.identifier.id),B=Y.get(x);(!B||X(B,q))&&Y.set(x,q)}),z?.forEach(q=>{const x=u.ExtensionIdentifier.toKey(q.identifier.id),B=Y.get(x);if(!B&&W&&q.type===0){this.logService.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!B||X(B,q))&&Y.set(x,q)}),te?.forEach(q=>{const x=u.ExtensionIdentifier.toKey(q.identifier.id),B=Y.get(x);(!B||X(B,q))&&Y.set(x,q),Y.set(x,q)}),[...Y.values()]}async scanDefaultSystemExtensions(W,z){this.logService.trace("Started scanning system extensions");const te=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),K=await(W&&!te.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(te);return this.logService.trace("Scanned system extensions:",K.length),K}async scanDevSystemExtensions(W,z){const te=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!te?.length)return[];this.logService.trace("Started scanning dev system extensions");const G=z?await this.getBuiltInExtensionControl():{},K=[],X=h.URI.file(E.normalize(E.join(D.FileAccess.asFileUri("",Z).fsPath,"..",".build","builtInExtensions")));for(const q of te){const x=G[q.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":K.push((0,C.joinPath)(X,q.name));break;default:K.push(h.URI.file(x));break}}const Y=await Promise.all(K.map(async q=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(q,!1,0,!0,W))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,k.coalesce)(Y)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,z,te,G,K,X=!0){const Y=await this.getTranslations(K??p.language),q=await this.getMtime(W),x=this.userDataProfilesService.defaultProfile.extensionsResource,B=x?await this.getMtime(x):void 0;return new _(W,q,x,B,z,te,G,X,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,K,Y)}async getMtime(W){try{const z=await this.fileService.stat(W);if(typeof z.mtime=="number")return z.mtime}catch{}}};O=me([Q(4,v.IUserDataProfilesService),Q(5,l.IExtensionsProfileScannerService),Q(6,r.IFileService),Q(7,a.ILogService),Q(8,g.IEnvironmentService),Q(9,c.IProductService)],O),e.AbstractExtensionsScannerService=O;class _{constructor(W,z,te,G,K,X,Y,q,x,B,U,$,V,J){this.location=W,this.mtime=z,this.applicationExtensionslocation=te,this.applicationExtensionslocationMtime=G,this.profile=K,this.type=X,this.excludeObsolete=Y,this.validate=q,this.productVersion=x,this.productDate=B,this.productCommit=U,this.devMode=$,this.language=V,this.translations=J}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,z){return(0,C.isEqual)(W.location,z.location)&&W.mtime===z.mtime&&(0,C.isEqual)(W.applicationExtensionslocation,z.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&W.profile===z.profile&&W.type===z.type&&W.excludeObsolete===z.excludeObsolete&&W.validate===z.validate&&W.productVersion===z.productVersion&&W.productDate===z.productDate&&W.productCommit===z.productCommit&&W.devMode===z.devMode&&W.language===z.language&&y.equals(W.translations,z.translations)}}class N extends P.Disposable{constructor(W,z,te,G){super();this.obsoleteFile=W,this.extensionsProfileScannerService=z,this.fileService=te,this.logService=G}async scanExtensions(W){const z=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let te={};if(W.excludeObsolete&&W.type===1)try{const G=(await this.fileService.readFile(this.obsoleteFile)).value.toString();te=JSON.parse(G)}catch{}return(0,w.isEmptyObject)(te)?z:z.filter(G=>!te[f.ExtensionKey.create(G).toString()])}async scanExtensionsFromLocation(W){const z=await this.fileService.resolve(W.location);if(!z.children?.length)return[];const te=await Promise.all(z.children.map(async G=>{if(!G.isDirectory||W.type===1&&(0,C.basename)(G.resource).indexOf(".")===0)return null;const K=new _(G.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(K)}));return(0,k.coalesce)(te)}async scanExtensionsFromProfile(W){const z=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W),te=await this.scanApplicationExtensions(W);return[...z,...te]}async scanApplicationExtensions(W){return W.applicationExtensionslocation?this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,W):[]}async scanExtensionsFromProfileResource(W,z,te){const G=await this.extensionsProfileScannerService.scanProfileExtensions(W);if(!G.length)return[];const K=await Promise.all(G.map(async X=>{if(z(X)){const Y=new _(X.location,te.mtime,te.applicationExtensionslocation,te.applicationExtensionslocationMtime,te.profile,te.type,te.excludeObsolete,te.validate,te.productVersion,te.productDate,te.productCommit,te.devMode,te.language,te.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,k.coalesce)(K)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,C.joinPath)(W.location,"package.json"))){const z=await this.scanExtension(W);return z?[z]:[]}else return await this.scanExtensions(W)}catch(z){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,A.getErrorMessage)(z)),[]}}async scanExtension(W,z){try{let te=await this.scanExtensionManifest(W.location);if(te){te.publisher||(te.publisher=u.UNDEFINED_PUBLISHER),z=z??te.__metadata,delete te.__metadata;const G=(0,f.getGalleryExtensionId)(te.publisher,te.name),K=z?.id?{id:G,uuid:z.id}:{id:G},X=z?.isSystem?0:W.type,Y=X===0||!!z?.isBuiltin;te=await this.translateManifest(W.location,te,_.createNlsConfiguration(W));const q={type:X,identifier:K,manifest:te,location:W.location,isBuiltin:Y,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return W.validate?this.validate(q,W):q}}catch(te){W.type!==0&&this.logService.error(te)}return null}validate(W,z){let te=!0;const G=(0,n.validateExtensionManifest)(z.productVersion,z.productDate,z.location,W.manifest,W.isBuiltin);for(const[K,X]of G)K===S.default.Error&&(te=!1,this.logService.error(this.formatMessage(z.location,X)));return W.isValid=te,W.validations=G,W}async scanExtensionManifest(W){const z=(0,C.joinPath)(W,"package.json");let te;try{te=(await this.fileService.readFile(z)).value.toString()}catch(K){return(0,r.toFileOperationResult)(K)!==1&&this.logService.error(this.formatMessage(W,(0,m.localize)(0,null,z.path,K.message))),null}let G;try{G=JSON.parse(te)}catch{const X=[];(0,I.parse)(te,X);for(const Y of X)this.logService.error(this.formatMessage(W,(0,m.localize)(1,null,z.path,Y.offset,Y.length,(0,b.getParseErrorMessage)(Y.error))));return null}return(0,I.getNodeType)(G)!=="object"?(this.logService.error(this.formatMessage(W,(0,m.localize)(2,null,z.path))),null):G}async translateManifest(W,z,te){const G=await this.getLocalizedMessages(W,z,te);if(G)try{const K=[],X=await this.resolveOriginalMessageBundle(G.default,K);if(K.length>0)return K.forEach(q=>{this.logService.error(this.formatMessage(W,(0,m.localize)(3,null,G.default?.path,(0,b.getParseErrorMessage)(q.error))))}),z;if((0,I.getNodeType)(G)!=="object")return this.logService.error(this.formatMessage(W,(0,m.localize)(4,null,G.default?.path))),z;const Y=G.values||Object.create(null);this.replaceNLStrings(te.pseudo,z,Y,X,W)}catch{}return z}async getLocalizedMessages(W,z,te){const G=(0,C.joinPath)(W,"package.nls.json"),K=(x,B)=>{B.forEach(U=>{this.logService.error(this.formatMessage(W,(0,m.localize)(5,null,x?.path,(0,b.getParseErrorMessage)(U.error))))})},X=x=>{this.logService.error(this.formatMessage(W,(0,m.localize)(6,null,x?.path)))},Y=`${z.publisher}.${z.name}`,q=te.translations[Y];if(q)try{const x=h.URI.file(q),B=(await this.fileService.readFile(x)).value.toString(),U=[],$=(0,I.parse)(B,U);return U.length>0?(K(x,U),{values:void 0,default:G}):(0,I.getNodeType)($)!=="object"?(X(x),{values:void 0,default:G}):{values:$.contents?$.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.fileService.exists(G))return;let B;try{B=await this.findMessageBundles(W,te)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const U=(await this.fileService.readFile(B.localized)).value.toString(),$=[],V=(0,I.parse)(U,$);return $.length>0?(K(B.localized,$),{values:void 0,default:B.original}):(0,I.getNodeType)(V)!=="object"?(X(B.localized),{values:void 0,default:B.original}):{values:V,default:B.original}}catch{return{values:void 0,default:B.original}}}}async resolveOriginalMessageBundle(W,z){if(W)try{const te=(await this.fileService.readFile(W)).value.toString();return(0,I.parse)(te,z)}catch{return null}else return null}findMessageBundles(W,z){return new Promise((te,G)=>{const K=X=>{const Y=(0,C.joinPath)(W,`package.nls.${X}.json`);this.fileService.exists(Y).then(q=>{q&&te({localized:Y,original:(0,C.joinPath)(W,"package.nls.json")});const x=X.lastIndexOf("-");x===-1?te({localized:(0,C.joinPath)(W,"package.nls.json"),original:null}):(X=X.substring(0,x),K(X))})};if(z.devMode||z.pseudo||!z.language)return te({localized:(0,C.joinPath)(W,"package.nls.json"),original:null});K(z.language)})}replaceNLStrings(W,z,te,G,K){const X=(Y,q,x)=>{const B=Y[q];if((0,w.isString)(B)){const U=B,$=U.length;if($>1&&U[0]==="%"&&U[$-1]==="%"){const V=U.substr(1,$-2);let J=te[V];J===void 0&&G&&(J=G[V]);let H=typeof J=="string"?J:typeof J?.message=="string"?J.message:void 0;H!==void 0?(W&&(H="\uFF3B"+H.replace(/[aouei]/g,"$&$&")+"\uFF3D"),Y[q]=x&&(q==="title"||q==="category")&&G?{value:H,original:G[V]}:H):this.logService.warn(this.formatMessage(K,(0,m.localize)(7,null,V)))}}else if((0,w.isObject)(B))for(const U in B)B.hasOwnProperty(U)&&(U==="commands"?X(B,U,!0):X(B,U,x));else if((0,w.isArray)(B))for(let U=0;U<B.length;U++)X(B,U,x)};for(const Y in z)z.hasOwnProperty(Y)&&X(z,Y)}formatMessage(W,z){return`[${W.path}]: ${z}`}}class R extends N{constructor(W,z,te,G,K){super(z,te,G,K);this.cacheFile=W,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const z=await this.readExtensionCache();if(this.input=W,z&&z.input&&_.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(G=>(G.location=h.URI.revive(G.location),G));const te=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:te}),te}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),z=JSON.parse(W.value.toString());return{result:z.result,input:(0,o.revive)(z.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(W)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const z=W.result,te=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!T.equals(te,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(G){this.logService.error(G)}}}function M(j,W){const z=(0,f.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:z,identifier:new u.ExtensionIdentifier(z),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:W,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=M;class F extends O{constructor(W,z,te,G,K,X,Y,q,x,B){super(W,z,(0,C.joinPath)(te,".vscode-oss-dev","extensions","control.json"),(0,C.joinPath)(G,u.MANIFEST_CACHE_FOLDER),K,X,Y,q,x,B);this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const U=await this.fileService.readFile(h.URI.file(p.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=F}),define(re[233],se([0,1,48,6,37,3,2,20,12,27,7,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(d,S){super();this.userDataProfilesService=d,this.logService=S,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${w}`)))),P.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(d,S){const w=`vscode:${S}`;if(d.location.scheme===I.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[w]=="string"){const h=d.manifest.scripts[w].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${w} should be a node script`),null):{script:(0,b.join)(d.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(d,S,w,h,m){return new Promise((g,f)=>{const u=this.start(d,S,w,m);let n;const r=i=>{n&&(clearTimeout(n),n=null),i?f(i):g(void 0)};u.on("error",i=>{r((0,T.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,a)=>{r(i?`post-${S} process exited with code ${i}`:void 0)}),h&&(n=setTimeout(()=>{n=null,u.kill(),f("timed out")},5e3))})}start(d,S,w,h){const m={silent:!0,execArgv:void 0},g=(0,k.fork)(d,[`--type=extension-post-${S}`,...w],m);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(g.stdout,"data"),u=L.Event.fromNodeEventEmitter(g.stderr,"data");f(i=>this.logService.info(h.identifier.id,h.manifest.version,`post-${S}`,i)),u(i=>this.logService.error(h.identifier.id,h.manifest.version,`post-${S}`,i));const n=L.Event.any(L.Event.map(f,i=>({data:`%c${i}`,format:[""]})),L.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(n,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(d){return(0,b.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};p=me([Q(0,E.IUserDataProfilesService),Q(1,D.ILogService)],p),e.ExtensionsLifecycle=p}),define(re[234],se([0,1,8,15,46,71,13,7,24,28]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let D=class extends L.NativeExtensionsScannerService{constructor(p,C,d,S,w,h){super(k.URI.file(w.builtinExtensionsPath),k.URI.file(w.extensionsPath),w.userHome,k.URI.file(w.userDataPath),p,C,d,S,w,h)}};D=me([Q(0,P.IUserDataProfilesService),Q(1,T.IExtensionsProfileScannerService),Q(2,A.IFileService),Q(3,I.ILogService),Q(4,t.INativeEnvironmentService),Q(5,b.IProductService)],D),e.ExtensionsScannerService=D}),define(re[22],se([0,1,6,3,2,188,14,86,5,28]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var C;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class d extends T.Disposable{constructor(g={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,f){if(f===D){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:f,target:this.getKeyTargets(g)[f]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,f,u){return this.getStorage(f)?.get(g,u)}getBoolean(g,f,u){return this.getStorage(f)?.getBoolean(g,u)}getNumber(g,f,u){return this.getStorage(f)?.getNumber(g,u)}store(g,f,u,n){if((0,A.isUndefinedOrNull)(f)){this.remove(g,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,u,n),this.getStorage(u)?.set(g,f)})}remove(g,f){this.withPausedEmitters(()=>{this.updateKeyTarget(g,f,void 0),this.getStorage(f)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,f){const u=[],n=this.getKeyTargets(g);for(const r of Object.keys(n))n[r]===f&&u.push(r);return u}updateKeyTarget(g,f,u){const n=this.getKeyTargets(f);typeof u=="number"?n[g]!==u&&(n[g]=u,this.getStorage(f)?.set(D,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.getStorage(f)?.set(D,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const f=this.get(D,g);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=E.NONE){this._onWillSaveState.fire({reason:g});const f=this.getStorage(-1),u=this.getStorage(0),n=this.getStorage(1);switch(g){case E.NONE:await k.Promises.settled([f?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await k.Promises.settled([f?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return h(g,f,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,f){return this.emitWillSaveState(E.NONE),(0,P.isUserDataProfile)(g)?this.switchToProfile(g,f):this.switchToWorkspace(g,f)}canSwitchProfile(g,f){return!(g.id===f.id||S(f)&&S(g))}switchData(g,f,u,n){this.withPausedEmitters(()=>{if(n)for(const[r,i]of g)f.set(r,i);else{const r=new Set;for(const[i,a]of g)r.add(i),f.get(i)!==a&&this.emitDidChangeValue(u,i);for(const[i]of f.items)r.has(i)||this.emitDidChangeValue(u,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class w extends d{constructor(){super();this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=w;async function h(m,g,f,u,n,r){const i=_=>{try{return JSON.parse(_)}catch{return _}},a=new Map,c=new Map;m.forEach((_,N)=>{a.set(N,_),c.set(N,i(_))});const s=new Map,o=new Map;g.forEach((_,N)=>{s.set(N,_),o.set(N,i(_))});const l=new Map,v=new Map;f.forEach((_,N)=>{l.set(N,_),v.set(N,i(_))}),console.group(u!==n?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const y=[];if(a.forEach((_,N)=>{y.push({key:N,value:_})}),console.table(y),console.groupEnd(),console.log(c),u!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const _=[];s.forEach((N,R)=>{_.push({key:R,value:N})}),console.table(_),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const O=[];l.forEach((_,N)=>{O.push({key:N,value:_})}),console.table(O),console.groupEnd(),console.log(v)}e.logStorage=h}),define(re[235],se([0,1,3,2,14,30,32,22]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends t.Disposable{constructor(E,p){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new P(E)),this._register(this.storageManger.onDidChange(C=>this._onDidChangeEnablement.fire({extensions:C,source:"storage"}))),this._register(p.onDidInstallExtensions(C=>C.forEach(({local:d,operation:S})=>{d&&S===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(E,p){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:p}),!0):!1}async disableExtension(E,p){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){const p=this.getDisabledExtensions();return p.every(C=>!(0,A.areSameExtensions)(C,E))?(p.push(E),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(E){const p=this.getDisabledExtensions();for(let C=0;C<p.length;C++){const d=p[C];if((0,A.areSameExtensions)(d,E))return p.splice(C,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(E){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,p){this.storageManger.set(E,p,0)}};b=me([Q(0,I.IStorageService),Q(1,L.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class P extends t.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(E,p){let C;return p===0?((0,T.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,p)),C=this.storage[E]):C=this._get(E,p),JSON.parse(C)}set(E,p,C){const d=JSON.stringify(p.map(({id:w,uuid:h})=>({id:w,uuid:h})));this._get(E,C)!==d&&(C===0&&(p.length?this.storage[E]=d:delete this.storage[E]),this._set(E,p.length?d:void 0,C))}onDidStorageChange(E){if(E.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const C=this.get(E.key,E.scope);delete this.storage[E.key];const d=this.get(E.key,E.scope),S=C.filter(h=>!d.some(m=>(0,A.areSameExtensions)(h,m))),w=d.filter(h=>!C.some(m=>(0,A.areSameExtensions)(m,h)));(S.length||w.length)&&this._onDidChange.fire([...S,...w])}}_get(E,p){return this.storageService.get(E,p,"[]")}_set(E,p,C){p?this.storageService.store(E,p,C,1):this.storageService.remove(E,C)}}e.StorageManager=P}),define(re[236],se([0,1,17,23,9,4,36,14,8,18,15,30,32,66,13,7,24,44,215,22,21]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=L.isWeb?"web":(0,E.getTargetPlatform)(L.platform,A.arch);var n;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...U){return String(U.reduce(($,V)=>$|V,0))}var i;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class l{constructor($=o){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,V=this.state.pageSize){return new l({...this.state,pageNumber:$,pageSize:V})}withFilter($,...V){const J=[...this.state.criteria,...V.length?V.map(H=>({filterType:$,value:H})):[{filterType:$}]];return new l({...this.state,criteria:J})}withSortBy($){return new l({...this.state,sortBy:$})}withSortOrder($){return new l({...this.state,sortOrder:$})}withFlags(...$){return new l({...this.state,flags:$.reduce((V,J)=>V|J,0)})}withAssetTypes(...$){return new l({...this.state,assetTypes:$})}withSource($){return new l({...this.state,source:$})}get raw(){const{criteria:$,pageNumber:V,pageSize:J,sortBy:H,sortOrder:ee,flags:ne,assetTypes:ae}=this.state;return{filters:[{criteria:$,pageNumber:V,pageSize:J,sortBy:H,sortOrder:ee}],assetTypes:ae,flags:ne}}get searchText(){const $=this.state.criteria.filter(V=>V.filterType===i.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function v(U,$){const V=(U||[]).filter(J=>J.statisticName===$)[0];return V?V.value:0}function y(U){const $="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf($)===0).reduce((J,H)=>{const ee=N(U,H.assetType);return ee&&J.push([H.assetType.substring($.length),ee]),J},[])}function O(U){if(U.properties){const $=U.properties.filter(H=>H.key===a.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=$.filter(H=>V.test(H.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return N(U,a.Repository)}function _(U){return{uri:`${U.fallbackAssetUri}/${a.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${a.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function N(U,$){return U.files.filter(J=>J.assetType===$)[0]?{uri:`${U.assetUri}/${$}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${$}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function R(U,$){const V=U.properties?U.properties.filter(H=>H.key===$):[],J=V.length>0&&V[0].value;return J?J.split(",").map(H=>(0,p.adoptToGalleryExtensionId)(H)):[]}function M(U){const $=U.properties?U.properties.filter(V=>V.key===c.Engine):[];return $.length>0&&$[0].value||""}function F(U){const $=U.properties?U.properties.filter(V=>V.key===c.PreRelease):[];return $.length>0&&$[0].value==="true"}function j(U){const $=U.properties?U.properties.filter(J=>J.key===c.LocalizedLanguages):[],V=$.length>0&&$[0].value||"";return V?V.split(","):[]}function W(U){return U.properties?.find($=>$.key===c.SponsorLink)?.value}function z(U){return U.indexOf("preview")!==-1}function te(U){return U.targetPlatform?(0,E.toTargetPlatform)(U.targetPlatform):"undefined"}function G(U){const $=(0,k.distinct)(U.versions.map(te)),V=!!U.tags?.includes(E.WEB_EXTENSION_TAG),J=$.indexOf("web");return V?J===-1&&$.push("web"):J!==-1&&$.splice(J,1),$}function K(U,$){const V=(0,E.getFallbackTargetPlarforms)($);for(let J=0;J<U.length;J++){const H=U[J];if(H.version===U[J-1]?.version){let ee=J;const ne=te(H);if(ne===$)for(;ee>0&&U[ee-1].version===H.version;)ee--;else if(V.includes(ne))for(;ee>0&&U[ee-1].version===H.version&&te(U[ee-1])!==$;)ee--;ee!==J&&(U.splice(J,1),U.splice(ee,0,H))}}return U}e.sortExtensionVersions=K;function X(U,$,V){U.telemetryData={index:$,querySource:V}}function Y(U,$,V){const J=U.versions[0],H={manifest:N($,a.Manifest),readme:N($,a.Details),changelog:N($,a.Changelog),license:N($,a.License),repository:O($),download:_($),icon:N($,a.Icon),coreTranslations:y($)};return{identifier:{id:(0,p.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:$.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(J),description:U.shortDescription||"",installCount:v(U.statistics,"install"),rating:v(U.statistics,"averagerating"),ratingCount:v(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:V,assets:H,properties:{dependencies:R($,c.Dependency),extensionPack:R($,c.ExtensionPack),engine:M($),localizedLanguages:j($),targetPlatform:te($),isPreReleaseVersion:F($)},hasPreReleaseVersion:F(J),hasReleaseVersion:!0,preview:z(U.flags)}}let q=class{constructor($,V,J,H,ee,ne,ae,ue){this.requestService=V,this.logService=J,this.environmentService=H,this.telemetryService=ee,this.fileService=ne,this.productService=ae,this.configurationService=ue;const Se=ae.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(ae.version,ae,this.environmentService,this.configurationService,this.fileService,$,this.telemetryService)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,V,J){const H=t.CancellationToken.isCancellationToken(V)?{}:V,ee=t.CancellationToken.isCancellationToken(V)?V:J,ne=[],ae=[],ue=[],Se=[];let fe=!0;for(const be of $){be.uuid?ae.push(be.uuid):ne.push(be.id);const Ie=!!(be.version||be.preRelease);ue.push({id:be.id,uuid:be.uuid,includePreRelease:Ie}),be.version&&Se.push({id:be.id,uuid:be.uuid,version:be.version}),fe=fe&&!!be.hasPreRelease&&!Ie}if(!ae.length&&!ne.length)return[];let pe=new l().withPage(1,$.length);ae.length&&(pe=pe.withFilter(i.ExtensionId,...ae)),ne.length&&(pe=pe.withFilter(i.ExtensionName,...ne)),(H.queryAllVersions||fe)&&(pe=pe.withFlags(pe.flags,n.IncludeVersions)),H.source&&(pe=pe.withSource(H.source));const{extensions:Ce}=await this.queryGalleryExtensions(pe,{targetPlatform:H.targetPlatform??u,includePreRelease:ue,versions:Se,compatible:!!H.compatible},ee);return H.source&&Ce.forEach((be,Ie)=>X(be,Ie,H.source)),Ce}async getCompatibleExtension($,V,J){if((0,E.isNotWebExtensionInWebTargetPlatform)($.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible($,V,J))return $;const H=new l().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,$.identifier.uuid),{extensions:ee}=await this.queryGalleryExtensions(H,{targetPlatform:J,compatible:!0,includePreRelease:V},t.CancellationToken.None);return ee[0]||null}async isExtensionCompatible($,V,J){if(!(0,E.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,J)||!V&&$.properties.isPreReleaseVersion)return!1;let H=$.properties.engine;if(!H){const ee=await this.getManifest($,t.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");H=ee.engines.vscode}return(0,C.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion($,V,J,H,ee){if(!(0,E.isTargetPlatformCompatible)(te($),H,ee)||V!=="any"&&F($)!==(V==="prerelease"))return!1;if(J)try{const ne=await this.getEngine($);if(!(0,C.isEngineValid)(ne,this.productService.version,this.productService.date))return!1}catch(ne){return this.logService.error(`Error while getting the engine for the version ${$.version}.`,(0,T.getErrorMessage)(ne)),!1}return!0}async query($,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let J=$.text||"";const H=$.pageSize??50;let ee=new l().withPage(1,H);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,pe,Ce)=>(ee=ee.withFilter(i.Category,Ce||pe),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,pe,Ce)=>(ee=ee.withFilter(i.Tag,Ce||pe),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(i.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ee=ee.withFilter(i.SearchText,J)),ee=ee.withSortBy(0)):$.ids?ee=ee.withFilter(i.ExtensionId,...$.ids):$.names?ee=ee.withFilter(i.ExtensionName,...$.names):ee=ee.withSortBy(4),typeof $.sortBy=="number"&&(ee=ee.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(ee=ee.withSortOrder($.sortOrder)),$.source&&(ee=ee.withSource($.source));const ne=async(fe,pe)=>{const{extensions:Ce,total:be}=await this.queryGalleryExtensions(fe,{targetPlatform:u,compatible:!1,includePreRelease:!!$.includePreRelease},pe);return Ce.forEach((Ie,qe)=>X(Ie,(fe.pageNumber-1)*fe.pageSize+qe,$.source)),{extensions:Ce,total:be}},{extensions:ae,total:ue}=await ne(ee,V),Se=async(fe,pe)=>{if(pe.isCancellationRequested)throw new T.CancellationError;const{extensions:Ce}=await ne(ee.withPage(fe+1),pe);return Ce};return{firstPage:ae,total:ue,pageSize:ee.pageSize,getPage:Se}}async queryGalleryExtensions($,V,J){const H=$.flags;!!($.flags&n.IncludeLatestVersionOnly)&&!!($.flags&n.IncludeVersions)&&($=$.withFlags($.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!($.flags&n.IncludeLatestVersionOnly)&&!($.flags&n.IncludeVersions)&&($=$.withFlags($.flags,n.IncludeLatestVersionOnly)),V.versions?.length&&($=$.withFlags($.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),$=$.withFlags($.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ee,total:ne}=await this.queryRawGalleryExtensions($,J);if(!($.flags&n.IncludeLatestVersionOnly)){const fe=[];for(const pe of ee){const Ce=await this.toGalleryExtensionWithCriteria(pe,V);Ce&&fe.push(Ce)}return{extensions:fe,total:ne}}const ue=[],Se=new Map;for(let fe=0;fe<ee.length;fe++){const pe=ee[fe],Ce={id:(0,p.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,I.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(qe=>(0,p.areSameExtensions)(qe,Ce))?.includePreRelease;if(V.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(G(pe),V.targetPlatform))continue;const Ie=await this.toGalleryExtensionWithCriteria(pe,V);!Ie||Ie.properties.isPreReleaseVersion&&(!be||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==V.targetPlatform&&Ie.hasPreReleaseVersion?Se.set(pe.extensionId,fe):ue.push([fe,Ie])}if(Se.size){const fe=new Date().getTime(),pe=new l().withFlags(H&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,Se.size).withFilter(i.ExtensionId,...Se.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,V,J);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-fe,count:Se.size});for(const be of Ce){const Ie=Se.get(be.identifier.uuid);ue.push([Ie,be])}}return{extensions:ue.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:ne}}async toGalleryExtensionWithCriteria($,V){const J={id:(0,p.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},H=V.versions?.find(ue=>(0,p.areSameExtensions)(ue,J))?.version,ee=(0,I.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(ue=>(0,p.areSameExtensions)(ue,J))?.includePreRelease,ne=G($),ae=K($.versions,V.targetPlatform);if(V.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(ne,V.targetPlatform))return null;for(let ue=0;ue<ae.length;ue++){const Se=ae[ue];if(!(H&&Se.version!==H)){if(await this.isValidVersion(Se,ee?"any":"release",V.compatible,ne,V.targetPlatform))return Y($,Se,ne);if(H&&Se.version===H)return null}}return H||V.compatible?null:Y($,$.versions[0],ne)}async queryRawGalleryExtensions($,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const J=await this.commonHeadersPromise,H=JSON.stringify($.raw),ee={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ne=new Date().getTime();let ae,ue,Se=0;try{if(ae=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:ee},V),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:Se};const fe=await(0,h.asJson)(ae);if(fe){const pe=fe.results[0],Ce=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return Se=be&&be.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:Se}}return{galleryExtensions:[],total:Se}}catch(fe){throw ue=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-ne,success:!!ae&&(0,h.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:ue?(0,T.isCancellationError)(ue)?"canceled":(0,T.getErrorMessage)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic($,V,J,H){if(!this.isEnabled())return;const ee=L.isWeb?this.api(`/itemName/${$}.${V}/version/${J}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${V}/${J}/stats?statType=${H}`),ne=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ne};try{await this.requestService.request({type:"POST",url:ee,headers:ue},t.CancellationToken.None)}catch{}}async download($,V,J){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const H=(0,p.getGalleryExtensionTelemetryData)($),ee=new Date().getTime(),ne=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:fe}),ae=J===2?"install":J===3?"update":"",ue=ae?{uri:`${$.assets.download.uri}${b.URI.parse($.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${$.assets.download.fallbackUri}${b.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:$.assets.download,Se=await this.getAsset(ue);await this.fileService.writeFile(V,Se.stream),ne(new Date().getTime()-ee)}async getReadme($,V){if($.assets.readme){const J=await this.getAsset($.assets.readme,{},V);return await(0,h.asTextOrError)(J)||""}return""}async getManifest($,V){if($.assets.manifest){const J=await this.getAsset($.assets.manifest,{},V),H=await(0,h.asTextOrError)(J);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion($,V){const J=N($,a.Manifest);if(!J)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},ee=await this.getAsset(J,{headers:H});return await(0,h.asJson)(ee)}async getCoreTranslation($,V){const J=$.assets.coreTranslations.filter(H=>H[0]===V.toUpperCase())[0];if(J){const H=await this.getAsset(J[1]),ee=await(0,h.asTextOrError)(H);return ee?JSON.parse(ee):null}return null}async getChangelog($,V){if($.assets.changelog){const J=await this.getAsset($.assets.changelog,{},V);return await(0,h.asTextOrError)(J)||""}return""}async getAllCompatibleVersions($,V,J){let H=new l().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?H=H.withFilter(i.ExtensionId,$.identifier.uuid):H=H.withFilter(i.ExtensionName,$.identifier.id);const{galleryExtensions:ee}=await this.queryRawGalleryExtensions(H,t.CancellationToken.None);if(!ee.length)return[];const ne=G(ee[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(ne,J))return[];const ae=[];await Promise.all(ee[0].versions.map(async fe=>{try{await this.isValidVersion(fe,V?"any":"release",!0,ne,J)&&ae.push(fe)}catch{}}));const ue=[],Se=new Set;for(const fe of K(ae,J))Se.has(fe.version)||(Se.add(fe.version),ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:F(fe)}));return ue}async getAsset($,V={},J=t.CancellationToken.None){const H=await this.commonHeadersPromise,ee={type:"GET"},ne={...H,...V.headers||{}};V={...V,...ee,headers:ne};const ae=$.uri,ue=$.fallbackUri,Se={...V,url:ae};try{const fe=await this.requestService.request(Se,J);if(fe.res.statusCode===200)return fe;const pe=await(0,h.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${pe}`)}catch(fe){if((0,T.isCancellationError)(fe))throw fe;const pe=(0,T.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:pe});const Ce={...V,url:ue};return this.requestService.request(Ce,J)}}async getEngine($){let V=M($);if(!V){const J=await this.getManifestFromRawExtensionVersion($,t.CancellationToken.None);if(!J)throw new Error("Manifest was not found");V=J.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,h.asJson)($),J=[],H={};if(V){for(const ee of V.malicious)J.push({id:ee});if(V.migrateToPreRelease)for(const[ee,ne]of Object.entries(V.migrateToPreRelease))(!ne.engine||(0,C.isEngineValid)(ne.engine,this.productService.version,this.productService.date))&&(H[ee.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(V.deprecated)for(const[ee,ne]of Object.entries(V.deprecated))ne&&(H[ee.toLowerCase()]=(0,I.isBoolean)(ne)?{}:ne)}return{malicious:J,deprecated:H}}};q=me([Q(1,h.IRequestService),Q(2,S.ILogService),Q(3,D.IEnvironmentService),Q(4,f.ITelemetryService),Q(5,d.IFileService),Q(6,w.IProductService),Q(7,P.IConfigurationService)],q);let x=class extends q{constructor($,V,J,H,ee,ne,ae,ue){super($,V,J,H,ee,ne,ae,ue)}};x=me([Q(0,g.IStorageService),Q(1,h.IRequestService),Q(2,S.ILogService),Q(3,D.IEnvironmentService),Q(4,f.ITelemetryService),Q(5,d.IFileService),Q(6,w.IProductService),Q(7,P.IConfigurationService)],x),e.ExtensionGalleryService=x;let B=class extends q{constructor($,V,J,H,ee,ne,ae){super(void 0,$,V,J,H,ee,ne,ae)}};B=me([Q(0,h.IRequestService),Q(1,S.ILogService),Q(2,D.IEnvironmentService),Q(3,f.ITelemetryService),Q(4,d.IFileService),Q(5,w.IProductService),Q(6,P.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B}),define(re[72],se([0,1,5,3,2,22,32,24,17,7,14]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Je extends T.Disposable{constructor(d,S,w){super();this.storageService=d,this.productService=S,this.logService=w,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=E.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(d,S){const w=await d.getInstalled(),h=[];for(const[m,g]of Je.readAllExtensionsWithKeysForSync(S)){const f=w.find(u=>(0,A.areSameExtensions)(u.identifier,{id:m}))?.manifest.version;for(const u of g)f!==u&&h.push(Je.toKey({id:m,version:u}))}for(const m of h)S.remove(m,0)}static readAllExtensionsWithKeysForSync(d){const S=new Map,w=d.keys(0,1);for(const h of w){const m=Je.fromKey(h);if(m){let g=S.get(m.id.toLowerCase());g||S.set(m.id.toLowerCase(),g=[]),g.push(m.version)}}return S}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Je.fromKey(d.key);if(S){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let w=this.extensionsWithKeysForSync.get(S.id.toLowerCase());w||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),w=[]),w.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,D.isString)(d))return d;const S=d.manifest?d.manifest.publisher:d.publisher,w=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(S,w)}getExtensionState(d,S){const w=this.getExtensionId(d),h=this.storageService.get(w,S?0:1);if(h)try{return JSON.parse(h)}catch(m){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${S}): ${m}`)}}setExtensionState(d,S,w){const h=this.getExtensionId(d);S===void 0?this.storageService.remove(h,w?0:1):this.storageService.store(h,JSON.stringify(S),w?0:1,1)}setKeysForSync(d,S){this.storageService.store(Je.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],w=this.storageService.get(Je.toKey(d),0),h=w?JSON.parse(w):void 0;return h&&S?(0,b.distinct)([...h,...S]):h||S}addToMigrationList(d,S){if(d!==S){const w=this.migrationList.filter(h=>!h.includes(d)&&!h.includes(S));w.push([d,S]),this.migrationList=w}}getSourceExtensionToMigrate(d){const S=this.migrationList.find(([,w])=>d===w);return S?S[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(d);if((0,D.isArray)(S))return S}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=me([Q(0,L.IStorageService),Q(1,I.IProductService),Q(2,P.ILogService)],p),e.ExtensionStorageService=p}),define(re[237],se([0,1,17,6,75,3,12,4,36,8,144,15,30,32,206,92,13,7,68,24,44,22,21]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let a=class extends d.ExtensionTipsService{constructor(s,o,l,v,y,O,_,N,R,M){super(_,N,R,M);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=l,this.storageService=v,this.nativeHostService=y,this.extensionRecommendationNotificationService=O,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,N.exeBasedExtensionTips&&(0,T.forEach)(N.exeBasedExtensionTips,({key:F,value:j})=>{const W=[],z=[],te=[];(0,T.forEach)(j.recommendations,({key:G,value:K})=>{K.important?j.important?W.push({extensionId:G,extensionName:K.name,isExtensionPack:!!K.isExtensionPack}):z.push({extensionId:G,extensionName:K.name,isExtensionPack:!!K.isExtensionPack}):te.push({extensionId:G,extensionName:K.name,isExtensionPack:!!K.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:W}),z.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:z}),te.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:te})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,l)}groupImportantTipsByExe(s,o){const l=new Map;s.forEach(N=>l.set(N.extensionId.toLowerCase(),N));const{installed:v,uninstalled:y}=this.groupByInstalled([...l.keys()],o);for(const N of v){const R=l.get(N);R&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:N,exeName:R.exeName})}for(const N of y){const R=l.get(N);R&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:N,exeName:R.exeName})}const O=this.getPromptedExecutableTips(),_=new Map;for(const N of y){const R=l.get(N);if(R&&(!O[R.exeName]||!O[R.exeName].includes(R.extensionId))){let M=_.get(R.exeName);M||(M=[],_.set(R.exeName,M)),M.push(R)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const v=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(v(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const v=this._register((0,t.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,l=7*24*60*60*1e3;if(o<l){const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l-o));return}const[v,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(O=>{switch(O){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(v),this.addToRecommendedExecutables(y[0].exeName,y);const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(v),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const o=await this.extensionManagementService.getInstalled(1),l=s.filter(y=>!y.whenNotInstalled||y.whenNotInstalled.every(O=>o.every(_=>!(0,C.areSameExtensions)(_.identifier,{id:O})))).map(({extensionId:y})=>y.toLowerCase()),v=(0,D.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,v,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(i,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(i,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,-1,"{}"))}addToRecommendedExecutables(s,o){const l=this.getPromptedExecutableTips();l[s]=o.map(({extensionId:v})=>v.toLowerCase()),this.storageService.store(r,JSON.stringify(l),-1,0)}groupByInstalled(s,o){const l=[],v=[],y=o.reduce((O,_)=>(O.add(_.identifier.id.toLowerCase()),O),new Set);return s.forEach(O=>{y.has(O.toLowerCase())?l.push(O):v.push(O)}),{installed:l,uninstalled:v}}async getValidExecutableBasedExtensionTips(s){const o=[],l=new Map;for(const v of s.keys()){const y=s.get(v);if(!y||!(0,k.isNonEmptyArray)(y.recommendations))continue;const O=[];I.isWindows?y.windowsPath&&O.push(y.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(O.push((0,A.join)("/usr/local/bin",v)),O.push((0,A.join)("/usr/bin",v)),O.push((0,A.join)(this.environmentService.userHome.fsPath,v)));for(const _ of O){let N=l.get(_);if(N===void 0&&(N=await this.fileService.exists(P.URI.file(_)),l.set(_,N)),N)for(const{extensionId:R,extensionName:M,isExtensionPack:F,whenNotInstalled:j}of y.recommendations)o.push({extensionId:R,extensionName:M,isExtensionPack:F,exeName:v,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath,whenNotInstalled:j})}}return o}};a=me([Q(0,E.INativeEnvironmentService),Q(1,n.ITelemetryService),Q(2,p.IExtensionManagementService),Q(3,u.IStorageService),Q(4,m.INativeHostService),Q(5,S.IExtensionRecommendationNotificationService),Q(6,w.IFileService),Q(7,g.IProductService),Q(8,f.IRequestService),Q(9,h.ILogService)],a),e.ExtensionTipsService=a}),define(re[238],se([0,1,6,2,19,86,22,212]),function(Z,e,k,t,T,L,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(D,{defaultProfile:E,currentProfile:p},C,d){super();this.mainProcessService=C,this.environmentService=d,this.profileStorageProfile=void 0,this.profileStorageDisposables=this._register(new t.DisposableStore),this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposables=this._register(new t.DisposableStore),this.applicationStorageProfile=E,this.applicationStorage=this.createApplicationStorage(),this.profileStorage=this.createProfileStorage(p),this.workspaceStorage=this.createWorkspaceStorage(D)}createApplicationStorage(){const D=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),E=this._register(new L.Storage(D));return this._register(E.onDidChangeStorage(p=>this.emitDidChangeValue(-1,p))),E}createProfileStorage(D){this.profileStorageDisposables.clear(),this.profileStorageProfile=D;let E;if((0,A.isProfileUsingDefaultStorage)(D))E=this.applicationStorage;else{const p=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),D));E=this.profileStorageDisposables.add(new L.Storage(p))}return this.profileStorageDisposables.add(E.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),E}createWorkspaceStorage(D){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=D?.id;let E;if(D){const p=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),D));E=this.workspaceStorageDisposables.add(new L.Storage(p)),this.workspaceStorageDisposables.add(E.onDidChangeStorage(C=>this.emitDidChangeValue(1,C)))}return E}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(D){switch(D){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(D){switch(D){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(D,E){if(this.profileStorageProfile&&!this.canSwitchProfile(this.profileStorageProfile,D))return;const p=this.profileStorage,C=p.items;p!==this.applicationStorage&&await p.close(),this.profileStorage=this.createProfileStorage(D),await this.profileStorage.init(),this.switchData(C,this.profileStorage,0,E)}async switchToWorkspace(D,E){const p=this.workspaceStorage,C=p?.items??new Map;await p?.close(),this.workspaceStorage=this.createWorkspaceStorage(D),await this.workspaceStorage.init(),this.switchData(C,this.workspaceStorage,1,E)}}e.NativeStorageService=b}),define(re[239],se([0,1,15,13,96,7,28]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends A.UserDataProfilesService{constructor(P,D,E,p,C){super(E,p,C);this._profiles=[],this.channel=D.getChannel("userDataProfiles"),this._profiles=P.map(d=>(0,A.reviveProfile)(d,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(d=>{const S=d.added.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme)),w=d.removed.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme));this._profiles=d.all.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:S,removed:w,all:this.profiles})}))}get profiles(){return this._profiles}async createProfile(P,D){const E=await this.channel.call("createProfile",[P,D]);return(0,A.reviveProfile)(E,this.profilesHome.scheme)}async setProfileForWorkspace(P,D){const E=await this.channel.call("setProfileForWorkspace",[P,D]);return(0,A.reviveProfile)(E,this.profilesHome.scheme)}removeProfile(P){return this.channel.call("removeProfile",[P])}};I=me([Q(1,T.IMainProcessService),Q(2,k.IEnvironmentService),Q(3,t.IFileService),Q(4,L.ILogService)],I),e.UserDataProfilesNativeService=I}),define(re[59],se([0,1,77]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,I,b,P){const D=(0,k.setProperty)(A,I,b,P)[0];return D&&(A=A.substring(0,D.offset)+D.content+A.substring(D.offset+D.length)),A}e.edit=t;function T(A,I,b){let P=b;for(;P>=0;){if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1)return P+1;if(P--,I.length===2&&P>=0&&A.charAt(P)===I.charAt(0))return P+2}return 0}e.getLineStartOffset=T;function L(A,I,b){let P=b;for(;P>=0;)if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1||(P++,I.length===2&&P>=0&&A.charAt(P)===I.charAt(1)))return P;return A.length-1}e.getLineEndOffset=L}),define(re[240],se([0,1,29,55,14]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(p,C,d,S,w){const h=[],m=[],g=[];if(!C){const _=p.filter(({identifier:N})=>w.every(R=>R.toLowerCase()!==N.id.toLowerCase()));return{local:{added:h,removed:m,updated:g},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}p=p.map(D),C=C.map(D),d=d?d.map(D):null;const f=new Map,u=_=>{_.uuid&&f.set(_.id.toLowerCase(),_.uuid)};p.forEach(({identifier:_})=>u(_)),C.forEach(({identifier:_})=>u(_)),d?.forEach(({identifier:_})=>u(_));const n=_=>{const N=_.identifier.uuid||f.get(_.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${_.identifier.id.toLowerCase()}`},r=(_,N)=>(_.set(n(N),N),_),i=p.reduce(r,new Map),a=C.reduce(r,new Map),c=C.reduce((_,N)=>{const R=n(N);N=(0,k.deepClone)(N);const M=i.get(R);return M&&(M.installed&&(N.installed=!0),N.version||(N.version=M.version)),r(_,N)},new Map),s=d?d.reduce(r,new Map):null,o=S.reduce(r,new Map),l=w.reduce((_,N)=>{const R=f.get(N.toLowerCase());return _.add(R?`uuid:${R}`:`id:${N.toLowerCase()}`)},new Set),v=A(i,a,l);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const _=A(s,i,l),N=A(s,a,l),R=(M,F)=>{const j=i.get(M);if(j){const W=a.get(M),z=F?W:j;return{...z,version:W.version&&(!j.installed||t.gt(W.version,j.version))?W.version:j.version,state:I(j,W,s?.get(M)),preRelease:(0,T.isUndefined)(z.preRelease)?j.preRelease:j.installed?z.preRelease:W.preRelease}}};for(const M of N.removed.values()){const F=i.get(M);F&&m.push(F.identifier)}for(const M of N.added.values())if(_.added.has(M)){if(v.updated.has(M)){const F=R(M,!0);F&&(g.push(E(F,M)),c.set(M,F))}}else{const F=a.get(M);F.installed&&h.push(E(F,M))}for(const M of N.updated.values()){const F=R(M,!0);F&&(g.push(E(F,M)),c.set(M,F))}for(const M of _.added.values())N.added.has(M)||c.set(M,i.get(M));for(const M of _.updated.values())if(!N.removed.has(M)&&!N.updated.has(M)){const F=R(M,!1);F&&(c.get(M)?.installed&&(F.installed=!0),c.set(M,F))}for(const M of _.removed.values())!o.has(M)&&!N.updated.has(M)&&s?.get(M)?.installed&&c.delete(M)}const y=[],O=A(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&c.forEach((_,N)=>y.push(E(_,N))),{local:{added:h,removed:m,updated:g},remote:y.length?{added:[...O.added].map(_=>c.get(_)),updated:[...O.updated].map(_=>c.get(_)),removed:[...O.removed].map(_=>a.get(_)),all:y}:null}}e.merge=L;function A(p,C,d,{checkInstalledProperty:S,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const h=p?[...p.keys()].filter(n=>!d.has(n)):[],m=[...C.keys()].filter(n=>!d.has(n)),g=m.filter(n=>h.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),f=h.filter(n=>m.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),u=new Set;for(const n of h){if(f.has(n))continue;const r=p.get(n),i=C.get(n);(!i||r.disabled!==i.disabled||r.installed&&i.installed&&r.preRelease!==i.preRelease||!P(r.state,i.state)||w&&r.version!==i.version||S&&r.installed!==i.installed)&&u.add(n)}return{added:g,removed:f,updated:u}}function I(p,C,d){const S=p.state,w=C.state,h=d?.state;if(!C.version||S&&t.gt(p.version,C.version))return S;if(w&&t.gt(C.version,p.version)||!S)return w;if(!w)return S;const m=(0,k.deepClone)(S),g=h?b(h,w):{added:Object.keys(w).reduce((u,n)=>(u.add(n),u),new Set),removed:new Set,updated:new Set},f=h?b(h,S):{added:Object.keys(S).reduce((u,n)=>(u.add(n),u),new Set),removed:new Set,updated:new Set};for(const u of[...g.added.values(),...g.updated.values()])m[u]=w[u];for(const u of g.removed.values())f.updated.has(u)||delete m[u];return m}function b(p,C){const d=Object.keys(p),S=Object.keys(C),w=S.filter(g=>d.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),h=d.filter(g=>S.indexOf(g)===-1).reduce((g,f)=>(g.add(f),g),new Set),m=new Set;for(const g of d){if(h.has(g))continue;const f=p[g],u=C[g];(0,k.equals)(f,u)||m.add(g)}return{added:w,removed:h,updated:m}}function P(p={},C={}){const{added:d,removed:S,updated:w}=b(p,C);return d.size===0&&S.size===0&&w.size===0}function D(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function E(p,C){const d={identifier:{id:p.identifier.id,uuid:C.startsWith("uuid:")?C.substring("uuid:".length):void 0},preRelease:!!p.preRelease};return p.version&&(d.version=p.version),p.disabled&&(d.disabled=!0),p.installed&&(d.installed=!0),p.state&&(d.state=p.state),d}}),define(re[108],se([0,1,17,18,5]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,T.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,b){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return P=P.filter(D=>D!==I&&D!==`-${I}`),b&&P.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,1)}updateSynchronizedExtensions(I,b){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return P=P.filter(D=>D!==I&&D!==`-${I}`),b&&P.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,1)}getIgnoredExtensions(I){const b=I.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),P=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),D=[],E=[];if(Array.isArray(P))for(const p of P)p.startsWith("-")?E.push(p.substring(1)):D.push(p);return(0,k.distinct)([...b,...D].filter(p=>E.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};L=me([Q(0,t.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(re[241],se([0,1,17,34,29,173,59]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(f){return(0,t.parse)(f)||[]}e.parseKeybindings=I;async function b(f,u,n,r,i){const a=I(f),c=I(u),s=n?I(n):null,o=[...a,...c,...s||[]].map(W=>W.key),l=await i.resolveUserBindings(o),v=D(a,c,s,l);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const y=p(a),O=p(c),_=s?p(s):null,N=d(y,O,l),R=_?d(_,y,l):{added:[...y.keys()].reduce((W,z)=>(W.add(z),W),new Set),removed:new Set,updated:new Set},M=_?d(_,O,l):{added:[...O.keys()].reduce((W,z)=>(W.add(z),W),new Set),removed:new Set,updated:new Set},F=P(N,R,M);let j=f;for(const W of F.removed.values())F.conflicts.has(W)||(j=m(j,W,r));for(const W of F.added.values()){if(F.conflicts.has(W))continue;const z=O.get(W);if(z.some(te=>te.command!==`-${W}`&&v.conflicts.has(l[te.key]))){F.conflicts.add(W);continue}j=h(j,z,r)}for(const W of F.updated.values()){if(F.conflicts.has(W))continue;const z=O.get(W);if(z.some(te=>te.command!==`-${W}`&&v.conflicts.has(l[te.key]))){F.conflicts.add(W);continue}j=g(j,W,z,r)}return{mergeContent:j,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=b;function P(f,u,n){const r=new Set,i=new Set,a=new Set,c=new Set;for(const s of u.removed.values())n.updated.has(s)&&c.add(s);for(const s of n.removed.values())c.has(s)||(u.updated.has(s)?c.add(s):i.add(s));for(const s of u.added.values())c.has(s)||n.added.has(s)&&f.updated.has(s)&&c.add(s);for(const s of n.added.values())c.has(s)||(u.added.has(s)?f.updated.has(s)&&c.add(s):r.add(s));for(const s of u.updated.values())c.has(s)||n.updated.has(s)&&f.updated.has(s)&&c.add(s);for(const s of n.updated.values())c.has(s)||(u.updated.has(s)?f.updated.has(s)&&c.add(s):a.add(s));return{added:r,removed:i,updated:a,conflicts:c}}function D(f,u,n,r){const i=new Set,a=E(f,r),c=E(u,r),s=n?E(n,r):null,o=C(a,c);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const l=s?C(s,a):{added:[...a.keys()].reduce((R,M)=>(R.add(M),R),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const v=s?C(s,c):{added:[...c.keys()].reduce((R,M)=>(R.add(M),R),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:y,removed:O,updated:_,conflicts:N}=P(o,l,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:y,removed:O,updated:_,conflicts:N}}function E(f,u){const n=new Map;for(const r of f){const i=u[r.key];let a=n.get(i);a||(a=[],n.set(i,a)),a.push(r)}return n}function p(f){const u=new Map;for(const n of f){const r=n.command[0]==="-"?n.command.substring(1):n.command;let i=u.get(r);i||(i=[],u.set(r,i)),i.push(n)}return u}function C(f,u){const n=[...f.keys()],r=[...u.keys()],i=r.filter(s=>n.indexOf(s)===-1).reduce((s,o)=>(s.add(o),s),new Set),a=n.filter(s=>r.indexOf(s)===-1).reduce((s,o)=>(s.add(o),s),new Set),c=new Set;for(const s of n){if(a.has(s))continue;const o=f.get(s).map(v=>({...v,key:s})),l=u.get(s).map(v=>({...v,key:s}));(0,k.equals)(o,l,(v,y)=>w(v,y))||c.add(s)}return{added:i,removed:a,updated:c}}function d(f,u,n){const r=[...f.keys()],i=[...u.keys()],a=i.filter(o=>r.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),c=r.filter(o=>i.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),s=new Set;for(const o of r){if(c.has(o))continue;const l=f.get(o).map(y=>({...y,key:n[y.key]})),v=u.get(o).map(y=>({...y,key:n[y.key]}));S(l,v)||s.add(o)}return{added:a,removed:c,updated:s}}function S(f,u){return!(!(0,k.equals)(f.filter(({command:n})=>n[0]!=="-"),u.filter(({command:n})=>n[0]!=="-"),(n,r)=>w(n,r))||!(0,k.equals)(f.filter(({command:n})=>n[0]==="-"),u.filter(({command:n})=>n[0]==="-"),(n,r)=>w(n,r)))}function w(f,u){if(f.command!==u.command||f.key!==u.key)return!1;const n=L.ContextKeyExpr.deserialize(f.when),r=L.ContextKeyExpr.deserialize(u.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!T.equals(f.args,u.args))}function h(f,u,n){for(const r of u)f=A.edit(f,[-1],r,n);return f}function m(f,u,n){const r=I(f);for(let i=r.length-1;i>=0;i--)(r[i].command===u||r[i].command===`-${u}`)&&(f=A.edit(f,[i],void 0,n));return f}function g(f,u,n,r){const i=I(f),a=i.findIndex(c=>c.command===u||c.command===`-${u}`);for(let c=i.length-1;c>=0;c--)(i[c].command===u||i[c].command===`-${u}`)&&(f=A.edit(f,[c],void 0,r));for(let c=n.length-1;c>=0;c--)f=A.edit(f,[a],n[c],r);return f}}),define(re[242],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(L,A,I){const b={},P={},D=new Set;if(!A)return{local:{added:b,updated:P,removed:[...D.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=t(L,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:P,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=t(I,L),C=t(I,A),d={},S={},w=new Set,h=new Set;for(const m of p.removed.values())C.updated.has(m)?b[m]=A[m]:w.add(m);for(const m of C.removed.values())h.has(m)||(p.updated.has(m)?h.add(m):D.add(m));for(const m of p.updated.values())h.has(m)||(C.updated.has(m)?E.updated.has(m)&&h.add(m):S[m]=L[m]);for(const m of C.updated.values())h.has(m)||(p.updated.has(m)?E.updated.has(m)&&h.add(m):L[m]!==void 0&&(P[m]=A[m]));for(const m of p.added.values())h.has(m)||(C.added.has(m)?E.updated.has(m)&&h.add(m):d[m]=L[m]);for(const m of C.added.values())h.has(m)||(p.added.has(m)?E.updated.has(m)&&h.add(m):b[m]=A[m]);return{local:{added:b,removed:[...D.values()],updated:P},remote:{added:d,removed:[...w.values()],updated:S},conflicts:[...h.values()]}}e.merge=k;function t(L,A){const I=L?Object.keys(L):[],b=A?Object.keys(A):[],P=b.filter(p=>I.indexOf(p)===-1).reduce((p,C)=>(p.add(C),p),new Set),D=I.filter(p=>b.indexOf(p)===-1).reduce((p,C)=>(p.add(C),p),new Set),E=new Set;for(const p of I){if(D.has(p))continue;const C=L[p],d=A[p];C!==d&&E.add(p)}return{added:P,removed:D,updated:E}}function T(L,A){const{added:I,removed:b,updated:P}=t(L,A);return I.size===0&&b.size===0&&P.size===0}e.areSame=T}),define(re[25],se([0,1,17,19,14,163,43,30,5,99,40]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const s=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function p(){const s=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(y=>!!s[y].ignoreSync),l=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),v=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...l,...v])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function C(){const s="vscode://schemas/ignoredSettings",o=D.Registry.as(A.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=D.Registry.as(P.Extensions.JSONContribution),v=()=>{const y=E(),O=p().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),_=Object.keys(A.allSettings.properties).filter(M=>O.indexOf(M)===-1),N=O.filter(M=>y.indexOf(M)===-1),R={items:{type:"string",enum:[..._,...N.map(M=>`-${M}`)]}};l.registerSchema(s,R)};return o.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=C;function d(s){return s&&(0,T.isObject)(s)&&(0,T.isString)(s.id)&&(0,T.isArray)(s.scopes)}e.isAuthenticationProvider=d;var S;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function w(s,o,l){return l.joinPath(o.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=h;var m;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(o,l,v,y){super(o);this.code=l,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class f extends g{constructor(o,l,v,y,O){super(o,v,void 0,O);this.url=l,this.serverCode=y}}e.UserDataSyncStoreError=f;class u extends g{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=u,function(s){function o(l){if(l instanceof s)return l;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new s(l.message,v[1],y,O)}return new s(l.message,"Unknown")}s.toUserDataSyncError=o}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(s){return`sync.enable.${s}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(s,o){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:o.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,t.isEqualOrParent)(s,(0,t.joinPath)(o.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(re[47],se([0,1,17,6,16,23,3,34,2,26,14,8,159,18,15,13,7,49,22,21,33,25,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let i=class extends b.Disposable{constructor(l,v,y,O,_,N,R,M,F,j,W){super();this.resource=l,this.fileService=v,this.environmentService=y,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=N,this.userDataSyncEnablementService=R,this.telemetryService=M,this.logService=F,this.configurationService=j,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,P.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(y.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(l,y,this.extUri),this.currentMachineIdPromise=(0,h.getServiceMachineId)(y,v,O)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const v=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(v)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?await this.hasRemoteChanged(l):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){this._status!==l&&(this._status=l,this._onDidChangStatus.fire(l))}async sync(l,v={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),v)}async preview(l,v,y={}){return this._sync(l,!1,v,y)}async apply(l,v={}){try{this.syncHeaders={...v};const y=await this.doApply(l);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,v,y,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const N=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(l,N);return _=await this.performSync(R,N,v,y),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(l){const v=await this.resolveContent(l);if(!v)return!1;const y=this.parseSyncData(v);if(!y)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const O=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,O),N=await this.isRemoteDataFromCurrentMachine(_),R=await this.generateSyncPreview({ref:_.ref,syncData:y},O,N,this.getUserDataSyncConfiguration(),L.CancellationToken.None),M=[];for(const F of R){const j=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);M.push([F,{...j,remoteChange:W!==0?W:2}])}await this.applyResult(_,O,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const v=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===v}async getLatestRemoteUserData(l,v){if(v){const y=l&&l.latest?l.latest[this.resource]:void 0;if(v.ref===y||y===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async performSync(l,v,y,O){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,v,y,O)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,v,y,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.performSync(l,v,y,O)}throw _}}async doSync(l,v,y,O){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(N=>this.doGenerateSyncResourcePreview(l,v,y,O,N)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:N})=>N==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(l){return await this.updateSyncResourcePreview(l,async v=>{const y=await this.getMergeResult(v,L.CancellationToken.None);await this.fileService.writeFile(v.previewResource,T.VSBuffer.fromString(y?.content||""));const O=y&&!y.hasConflicts?await this.getAcceptResult(v,v.previewResource,void 0,L.CancellationToken.None):void 0;return v.acceptResult=O,v.mergeState=y.hasConflicts?"conflict":O?"accepted":"preview",v.localChange=O?O.localChange:y.localChange,v.remoteChange=O?O.remoteChange:y.remoteChange,v}),this.syncPreviewPromise}async accept(l,v){return await this.updateSyncResourcePreview(l,async y=>{const O=await this.getAcceptResult(y,l,v,L.CancellationToken.None);return y.acceptResult=O,y.mergeState="accepted",y.localChange=O.localChange,y.remoteChange=O.remoteChange,y}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async v=>{const y=await this.getMergeResult(v,L.CancellationToken.None);return await this.fileService.writeFile(v.previewResource,T.VSBuffer.fromString(y.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=y.localChange,v.remoteChange=y.remoteChange,v}),this.syncPreviewPromise}async updateSyncResourcePreview(l,v){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const O=y.resourcePreviews.findIndex(({localResource:_,remoteResource:N,previewResource:R})=>this.extUri.isEqual(_,l)||this.extUri.isEqual(N,l)||this.extUri.isEqual(R,l));O!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const N=[...y.resourcePreviews];return N[O]=await v(N[O]),{...y,resourcePreviews:N}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const v=await this.syncPreviewPromise;return v.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(y=>[y,y.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(l){const v=l.filter(({mergeState:y})=>y==="conflict");(0,k.equals)(this._conflicts,v,(y,O)=>this.extUri.isEqual(y.previewResource,O.previewResource))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}async hasPreviouslySynced(){const l=await this.getLastSyncUserData();return!!l&&l.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:v,ref:y})=>({created:v,uri:this.toRemoteBackupResource(y)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:v,ref:y})=>({created:v,uri:this.toLocalBackupResource(y)}))}toRemoteBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const v=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(v))){const{content:y}=await this.getUserData(v);if(y)return this.parseSyncData(y)?.machineId}}async resolveContent(l){const v=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(v))){const{content:y}=await this.getUserData(v);return y}return this.extUri.isEqual(l,this.toLocalBackupResource(v))?this.userDataSyncBackupStoreService.resolveContent(this.resource,v):null}async resolvePreviewContent(l){const v=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(v)for(const y of v.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,l))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,l))return y.remoteContent;if(this.extUri.isEqual(y.localResource,l))return y.localContent;if(this.extUri.isEqual(y.baseResource,l))return y.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(l,v,y,O,_){const N=await this.isRemoteDataFromCurrentMachine(l),R=await this.generateSyncPreview(l,v,N,O,_),M=[];for(const F of R){const j=F.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)M.push({...F,acceptedResource:j,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=y?await this.getMergeResult(F,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,T.VSBuffer.fromString(W?.content||""));const z=W&&!W.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,_):void 0;M.push({...F,acceptResult:z,mergeState:W?.hasConflicts?"conflict":z?"accepted":"preview",localChange:z?z.localChange:W?W.localChange:F.localChange,remoteChange:z?z.remoteChange:W?W.remoteChange:F.remoteChange})}}return{remoteUserData:l,lastSyncUserData:v,resourcePreviews:M,isLastSyncFromCurrentMachine:N}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),v=JSON.parse(l.value.toString()),y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=v.version&&y&&v.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;const O=v;if(O.content===null)return{ref:v.ref,syncData:null};const _=JSON.parse(O.content);if(r(_))return{...v,syncData:_,content:void 0}}catch(l){l instanceof S.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,v={}){if(v.ref||v.content||v.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:y,...v};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(O)))}async getRemoteUserData(l){const{ref:v,content:y}=await this.getUserData(l);let O=null;return y!==null&&(O=this.parseSyncData(y)),{ref:v,syncData:O}}parseSyncData(l){try{const v=JSON.parse(l);if(r(v))return v}catch(v){this.logService.error(v)}throw new u.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,D.isString)(l)){const v=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:v}}else{const v=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,v,this.syncHeaders)}}async updateRemoteUserData(l,v){const y=await this.currentMachineIdPromise,O={version:this.version,machineId:y,content:l};return v=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(O),v,this.syncHeaders),{ref:v,syncData:O}}async backupLocal(l){const v={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=me([Q(1,S.IFileService),Q(2,d.IEnvironmentService),Q(3,m.IStorageService),Q(4,u.IUserDataSyncStoreService),Q(5,u.IUserDataSyncBackupStoreService),Q(6,u.IUserDataSyncEnablementService),Q(7,g.ITelemetryService),Q(8,u.IUserDataSyncLogService),Q(9,C.IConfigurationService),Q(10,f.IUriIdentityService)],i),e.AbstractSynchroniser=i;let a=class extends i{constructor(l,v,y,O,_,N,R,M,F,j,W,z){super(v,y,O,_,N,R,M,F,j,W,z);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(te=>this.onFileChanges(te)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(l,v,y){try{v?await this.fileService.writeFile(this.file,T.VSBuffer.fromString(l),y?void 0:v):await this.fileService.createFile(this.file,T.VSBuffer.fromString(l),{overwrite:y})}catch(O){throw O instanceof S.FileOperationError&&O.fileOperationResult===1||O instanceof S.FileOperationError&&O.fileOperationResult===3?new u.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};a=me([Q(2,S.IFileService),Q(3,d.IEnvironmentService),Q(4,m.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,g.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,C.IConfigurationService),Q(11,f.IUriIdentityService)],a),e.AbstractFileSynchroniser=a;let c=class extends a{constructor(l,v,y,O,_,N,R,M,F,j,W,z,te){super(l,v,y,O,_,N,R,M,F,j,z,te);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(l,v){const y=[],O=(0,I.parse)(l,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,D.isUndefined)(O)&&v!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};c=me([Q(2,S.IFileService),Q(3,d.IEnvironmentService),Q(4,m.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,g.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,u.IUserDataSyncUtilService),Q(11,C.IConfigurationService),Q(12,f.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let s=class{constructor(l,v,y,O,_,N){this.resource=l,this.userDataProfilesService=v,this.environmentService=y,this.logService=O,this.fileService=_,this.extUri=N.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,y,this.extUri)}async initialize({ref:l,content:v}){if(!v){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(v);if(!!y)try{await this.doInitialize({ref:l,syncData:y})}catch(O){this.logService.error(O)}}parseSyncData(l){try{const v=JSON.parse(l);if(r(v))return v}catch(v){this.logService.error(v)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,v={}){const y={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...v};await this.fileService.writeFile(this.lastSyncResource,T.VSBuffer.fromString(JSON.stringify(y)))}};s=me([Q(1,n.IUserDataProfilesService),Q(2,d.IEnvironmentService),Q(3,w.ILogService),Q(4,S.IFileService),Q(5,f.IUriIdentityService)],s),e.AbstractInitializer=s}),define(re[243],se([0,1,6,23,9,3,53,26,8,18,15,30,32,72,13,7,22,21,33,28,47,240,108,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function i(s,o){const l=JSON.parse(s.content);if(s.version===1||s.version===2){const v=(await o.getInstalled(0)).filter(y=>y.isBuiltin);for(const y of l)s.version===1&&(y.enabled===!1&&(y.disabled=!0),delete y.enabled),s.version===2&&v.every(O=>!(0,p.areSameExtensions)(O.identifier,y.identifier))&&(y.installed=!0)}return l}let a=class vt extends f.AbstractSynchroniser{constructor(o,l,v,y,O,_,N,R,M,F,j,W,z,te,G){super("extensions",l,o,v,y,O,W,z,M,j,G);this.extensionManagementService=_,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=R,this.extensionGalleryService=F,this.extensionStorageService=te,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,K=>K.some(({local:X})=>!!X)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,K=>!K.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,l){const v=o.syncData?await i(o.syncData,this.extensionManagementService):null,y=l?.skippedExtensions||[],O=l?.syncData?await i(l.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0),N=this.getLocalExtensions(_),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:F}=(0,u.merge)(N,v,O,y,R),j={local:M,remote:F,content:this.getPreviewContent(N,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:F!==null?2:0},W=this.stringify(N,!1);return[{skippedExtensions:y,baseResource:this.baseResource,baseContent:O?this.stringify(O,!1):W,localResource:this.localResource,localContent:W,localExtensions:N,remoteResource:this.remoteResource,remoteContent:v?this.stringify(v,!1):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const l=o.syncData?await i(o.syncData,this.extensionManagementService):null,v=await this.extensionManagementService.getInstalled(void 0),y=this.getLocalExtensions(v),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),{remote:_}=(0,u.merge)(y,l,l,o.skippedExtensions||[],O);return _!==null}getPreviewContent(o,l,v,y){const O=[...l,...v],_=new Set,N=R=>{_.add(R.id.toLowerCase()),R.uuid&&_.add(R.uuid)};O.forEach(({identifier:R})=>N(R)),y.forEach(N);for(const R of o)_.has(R.identifier.id.toLowerCase())||R.identifier.uuid&&_.has(R.identifier.uuid)||O.push(R);return this.stringify(O,!1)}async getMergeResult(o,l){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,l,v,y){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(o){const l=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),y=(0,u.merge)(o.localExtensions,null,null,o.skippedExtensions,v),{local:O,remote:_}=y;return{content:o.localContent,local:O,remote:_,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const l=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),y=o.remoteContent?JSON.parse(o.remoteContent):null;if(y!==null){const O=(0,u.merge)(o.localExtensions,y,o.localExtensions,[],v),{local:_,remote:N}=O;return{content:o.remoteContent,local:_,remote:N,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,l,v,y){let{skippedExtensions:O,localExtensions:_}=v[0][0];const{local:N,remote:R,localChange:M,remoteChange:F}=v[0][1];if(M===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(_)),O=await this.updateLocalExtensions(N.added,N.removed,N.updated,O)),R){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const j=JSON.stringify(R.all);o=await this.updateRemoteUserData(j,y?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${R.added.length?` Added: ${JSON.stringify(R.added.map(W=>W.identifier.id))}.`:""}${R.updated.length?` Updated: ${JSON.stringify(R.updated.map(W=>W.identifier.id))}.`:""}${R.removed.length?` Removed: ${JSON.stringify(R.removed.map(W=>W.identifier.id))}.`:""}`)}l?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(j=>j.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,vt.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),O=this.getLocalExtensions(v).filter(_=>!y.some(N=>(0,p.areSameExtensions)({id:N},_.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const v=await this.resolvePreviewContent(o);return v&&this.stringify(JSON.parse(v),!0)}let l=await super.resolveContent(o);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(o)),l){const v=this.parseSyncData(l);if(v)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(v),!0)}}return null}stringify(o,l){return o.sort((v,y)=>!v.identifier.uuid&&y.identifier.uuid?-1:v.identifier.uuid&&!y.identifier.uuid?1:(0,I.compare)(v.identifier.id,y.identifier.id)),l?(0,A.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(v=>v.installed||v.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,l,v,y){const O=[],_=[],N=await this.extensionManagementService.getInstalled();if(l.length){const M=N.filter(({identifier:F,isBuiltin:j})=>!j&&l.some(W=>(0,p.areSameExtensions)(F,W)));await k.Promises.settled(M.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),O.push(F.identifier)}))}(o.length||v.length)&&await k.Promises.settled([...o,...v].map(async M=>{const F=N.find(W=>(0,p.areSameExtensions)(W.identifier,M.identifier));if(F&&F.isBuiltin){M.state&&F.manifest.version===M.version&&this.updateExtensionState(M.state,F,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(z=>(0,p.areSameExtensions)(z,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),O.push(M.identifier);return}const j=(await this.extensionGalleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],t.CancellationToken.None))[0];if(M.state&&(F?F.manifest.version===M.version:!!j)&&this.updateExtensionState(M.state,F||j,F?.manifest.version),j)try{this.extensionEnablementService.getDisabledExtensions().some(z=>(0,p.areSameExtensions)(z,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,j.version),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,j.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,j.version),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,j.version))),(!F||F.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(j)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,j.version),await this.extensionManagementService.installFromGallery(j,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,j.version),O.push(j.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),_.push(M)))}catch(W){_.push(M),W instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(W.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,j.displayName||j.identifier.id):(this.logService.error(W),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,j.displayName||j.identifier.id))}else _.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const R=[];for(const M of y)O.some(F=>(0,p.areSameExtensions)(F,M.identifier))||R.push(M);for(const M of _)R.some(F=>(0,p.areSameExtensions)(F.identifier,M.identifier))||R.push(M);return R}updateExtensionState(o,l,v){const y=this.extensionStorageService.getExtensionState(l,!0)||{},O=v?this.extensionStorageService.getKeysForSync({id:l.identifier.id,version:v}):void 0;O?O.forEach(_=>{y[_]=o[_]}):Object.keys(o).forEach(_=>y[_]=o[_]),this.extensionStorageService.setExtensionState(l,y,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const l=this.extensionEnablementService.getDisabledExtensions();return o.map(v=>{const{identifier:y,isBuiltin:O,manifest:_,preRelease:N}=v,R={identifier:y,preRelease:N,version:_.version};l.some(M=>(0,p.areSameExtensions)(M,y))&&(R.disabled=!0),O||(R.installed=!0);try{const M=this.extensionStorageService.getKeysForSync({id:y.id,version:_.version});if(M){const F=this.extensionStorageService.getExtensionState(v,!0)||{};R.state=Object.keys(F).reduce((j,W)=>(M.includes(W)&&(j[W]=F[W]),j),{})}}catch(M){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,T.getErrorMessage)(M))}return R})}};a.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),a=me([Q(0,D.IEnvironmentService),Q(1,d.IFileService),Q(2,w.IStorageService),Q(3,r.IUserDataSyncStoreService),Q(4,r.IUserDataSyncBackupStoreService),Q(5,E.IExtensionManagementService),Q(6,E.IGlobalExtensionEnablementService),Q(7,n.IIgnoredExtensionsManagementService),Q(8,r.IUserDataSyncLogService),Q(9,E.IExtensionGalleryService),Q(10,P.IConfigurationService),Q(11,r.IUserDataSyncEnablementService),Q(12,h.ITelemetryService),Q(13,C.IExtensionStorageService),Q(14,m.IUriIdentityService)],a),e.ExtensionsSynchroniser=a;let c=class extends f.AbstractInitializer{constructor(o,l,v,y,O,_,N){super("extensions",y,O,_,v,N);this.extensionManagementService=o,this.ignoredExtensionsManagementService=l}async parseExtensions(o){return o.syncData?await i(o.syncData,this.extensionManagementService):null}generatePreview(o,l){const v=[],y=[],O=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const N=l.find(R=>(0,p.areSameExtensions)(R.identifier,_.identifier));N?(v.push(N),_.disabled&&O.push(_.identifier)):_.installed&&(y.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&O.push(_.identifier))}return{installedExtensions:v,newExtensions:y,disabledExtensions:O,remoteExtensions:o}}};c=me([Q(0,E.IExtensionManagementService),Q(1,n.IIgnoredExtensionsManagementService),Q(2,d.IFileService),Q(3,g.IUserDataProfilesService),Q(4,D.IEnvironmentService),Q(5,S.ILogService),Q(6,m.IUriIdentityService)],c),e.AbstractExtensionsInitializer=c}),define(re[244],se([0,1,29,25]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(I,b,P,D,E){if(!b)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const p=L(I,b);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const C=P?L(P,b):{added:Object.keys(b).reduce((m,g)=>(m.add(g),m),new Set),removed:new Set,updated:new Set},d=P?L(P,I):{added:Object.keys(I).reduce((m,g)=>(m.add(g),m),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},w=k.deepClone(b),h=!P;for(const m of d.added.values())m!==t.SYNC_SERVICE_URL_TYPE&&h&&C.added.has(m)||(w[m]=I[m]);for(const m of d.updated.values())w[m]=I[m];for(const m of d.removed.values())D.unregistered.includes(m)||delete w[m];for(const m of C.added.values()){const g=b[m];if(D.machine.includes(m)){E.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(P&&d.added.has(m))continue;const f=I[m];f&&f.value===g.value||m===t.SYNC_SERVICE_URL_TYPE&&h&&d.added.has(m)||(f?S.updated[m]=g:S.added[m]=g)}for(const m of C.updated.values()){const g=b[m];if(D.machine.includes(m)){E.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(m)||d.removed.has(m))continue;const f=I[m];f&&f.value===g.value||(S.updated[m]=g)}for(const m of C.removed.values()){if(D.machine.includes(m)){E.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}d.updated.has(m)||d.removed.has(m)||S.removed.push(m)}return{local:S,remote:A(w,b)?null:w}}e.merge=T;function L(I,b){const P=Object.keys(I),D=Object.keys(b),E=D.filter(d=>P.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),p=P.filter(d=>D.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),C=new Set;for(const d of P){if(p.has(d))continue;const S=I[d],w=b[d];k.equals(S,w)||C.add(d)}return{added:E,removed:p,updated:C}}function A(I,b){const{added:P,removed:D,updated:E}=L(I,b);return P.size===0&&D.size===0&&E.size===0}}),define(re[245],se([0,1,16,9,3,34,53,4,8,31,18,15,13,7,49,22,21,33,47,59,244,25,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",i=["locale"];function a(v,y){const O=v.storage?Object.keys(v.storage).sort():[],_={};return O.forEach(N=>_[N]=v.storage[N]),v.storage=_,y?(0,A.toFormattedString)(v,{}):JSON.stringify(v)}const c=1;let s=class pt extends m.AbstractSynchroniser{constructor(y,O,_,N,R,M,F,j,W,z){super("globalState",y,R,W,O,_,M,F,N,j,z);this.storageService=W,this.version=c,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(y.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(y.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),T.Event.filter(W.onDidChangeValue,te=>te.scope===0&&te.target!==void 0?te.target===0:W.keys(0,0).includes(te.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(y,O,_){const N=y.syncData?JSON.parse(y.syncData.content):null;O=O===null&&_?y:O;const R=O&&O.syncData?JSON.parse(O.syncData.content):null,M=await this.getLocalGlobalState();N?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(R),{local:j,remote:W}=(0,f.merge)(M.storage,N?N.storage:null,R?R.storage:null,F,this.logService),z={content:null,local:j,remote:W,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:W!==null?2:0},te=a(M,!1);return[{baseResource:this.baseResource,baseContent:R?a(R,!1):te,localResource:this.localResource,localContent:te,localUserData:M,remoteResource:this.remoteResource,remoteContent:N?a(N,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async hasRemoteChanged(y){const O=y.syncData?JSON.parse(y.syncData.content):null;if(O===null)return!0;const _=await this.getLocalGlobalState(),N=this.getStorageKeys(O),{remote:R}=(0,f.merge)(_.storage,O.storage,O.storage,N,this.logService);return R!==null}async getMergeResult(y,O){return{...y.previewResult,hasConflicts:!1}}async getAcceptResult(y,O,_,N){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(y);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(y);if(this.extUri.isEqual(O,this.previewResource))return y.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(y){return{content:y.localContent,local:{added:{},removed:[],updated:{}},remote:y.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(y){if(y.remoteContent!==null){const O=JSON.parse(y.remoteContent),{local:_,remote:N}=(0,f.merge)(y.localUserData.storage,O.storage,null,y.storageKeys,this.logService);return{content:y.remoteContent,local:_,remote:N,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:y.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(y,O,_,N){const{localUserData:R}=_[0][0],{local:M,remote:F,localChange:j,remoteChange:W}=_[0][1];if(j===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),j!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(R)),await this.writeLocalGlobalState(M),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:F});y=await this.updateRemoteUserData(z,N?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(y),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:y}){return[{resource:this.extUri.joinPath(y,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(y){if(this.extUri.isEqual(y,pt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return a(_,!0)}if(this.extUri.isEqual(this.remoteResource,y)||this.extUri.isEqual(this.baseResource,y)||this.extUri.isEqual(this.localResource,y)||this.extUri.isEqual(this.acceptedResource,y)){const _=await this.resolvePreviewContent(y);return _&&a(JSON.parse(_),!0)}let O=await super.resolveContent(y);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(y)),O){const _=this.parseSyncData(O);if(_)switch(this.extUri.basename(y)){case"globalState.json":return a(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:y}=await this.getLocalGlobalState();if(Object.keys(y).length>1||y[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const y={},O=await this.getLocalArgvContent(),_=(0,L.parse)(O);for(const N of i)_[N]!==void 0&&(y[`${r}${N}`]={version:1,value:_[N]});for(const N of this.storageService.keys(0,0)){const R=this.storageService.get(N,0);R&&(y[N]={version:1,value:R})}return{storage:y}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const y=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),y.value.toString()}catch(y){this.logService.debug((0,t.getErrorMessage)(y))}return"{}"}async writeLocalGlobalState({added:y,removed:O,updated:_}){const N={},R={},M=(j,W)=>{for(const z of j){if(z.startsWith(r)){N[z.substring(r.length)]=W?W[z].value:void 0;continue}if(W){const te=W[z];te.value!==String(this.storageService.get(z,0))&&(R[z]=te.value)}else this.storageService.get(z,0)!==void 0&&(R[z]=void 0)}};if(M(Object.keys(y),y),M(Object.keys(_),_),M(O),Object.keys(N).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(N),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(R).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const j of Object.keys(R))this.storageService.store(j,R[j],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(R))}}async updateArgv(y){const O=await this.getLocalArgvContent();let _=O;for(const N of Object.keys(y))_=(0,g.edit)(_,[N],y[N],{});O!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(y){const O=this.storageService.keys(0,0),_=this.storageService.keys(0,1),N=[...O,..._],R=y?.storage?Object.keys(y.storage).filter(M=>!M.startsWith(r)&&!N.includes(M)&&this.storageService.get(M,0)!==void 0):[];if(!I.isWeb){const M=[...u.ALL_SYNC_RESOURCES.map(F=>(0,u.getEnablementKey)(F)),u.SYNC_SERVICE_URL_TYPE];R.push(...M),_.push(...M)}return{user:O,machine:_,unregistered:R}}};s.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=me([Q(0,p.IFileService),Q(1,u.IUserDataSyncStoreService),Q(2,u.IUserDataSyncBackupStoreService),Q(3,u.IUserDataSyncLogService),Q(4,E.IEnvironmentService),Q(5,u.IUserDataSyncEnablementService),Q(6,w.ITelemetryService),Q(7,D.IConfigurationService),Q(8,S.IStorageService),Q(9,h.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends m.AbstractInitializer{constructor(y,O,_,N,R,M){super("globalState",_,N,R,O,M);this.storageService=y}async doInitialize(y){const O=y.syncData?JSON.parse(y.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},N={};for(const R of Object.keys(O.storage))R.startsWith(r)?_[R.substring(r.length)]=O.storage[R].value:this.storageService.get(R,0)===void 0&&(N[R]=O.storage[R].value);if(Object.keys(_).length){let R="{}";try{R=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const M of Object.keys(_))R=(0,g.edit)(R,[M],_[M],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(R))}if(Object.keys(N).length)for(const R of Object.keys(N))this.storageService.store(R,N[R],0,0)}};o=me([Q(0,S.IStorageService),Q(1,p.IFileService),Q(2,n.IUserDataProfilesService),Q(3,E.IEnvironmentService),Q(4,u.IUserDataSyncLogService),Q(5,h.IUriIdentityService)],o),e.GlobalStateInitializer=o;let l=class{constructor(y,O,_,N,R){this.userDataSyncStoreClient=y,this.storageService=O,this.environmentService=_,this.fileService=N,this.logService=R}getSyncStoreType(y){return this.parseGlobalState(y)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(y){const O=(0,u.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(y,O)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(y,O)}throw _}}async doSync(y,O){const _=await this.userDataSyncStoreClient.read("globalState",null,O),N=this.parseGlobalState(_)||{storage:{}};N.storage[u.SYNC_SERVICE_URL_TYPE]={value:y,version:c};const R=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),M={version:c,machineId:R,content:a(N,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(M),_.ref,O)}parseGlobalState({content:y}){if(!y)return null;const O=JSON.parse(y);if((0,m.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};l=me([Q(1,S.IStorageService),Q(2,E.IEnvironmentService),Q(3,p.IFileService),Q(4,C.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(re[246],se([0,1,17,16,3,34,4,14,160,18,15,13,22,21,33,28,47,241,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(n,r,i){try{const a=JSON.parse(n);if(!r)return(0,I.isUndefined)(a.all)?null:a.all;switch(A.OS){case 2:return(0,I.isUndefined)(a.mac)?null:a.mac;case 3:return(0,I.isUndefined)(a.linux)?null:a.linux;case 1:return(0,I.isUndefined)(a.windows)?null:a.windows}}catch(a){return i.error(a),null}}e.getKeybindingsContentFromSyncContent=g;let f=class extends w.AbstractJsonFileSynchroniser{constructor(r,i,a,c,s,o,l,v,y,O,_,N){super(l.defaultProfile.keybindingsResource,"keybindings",o,v,y,r,i,s,_,a,O,c,N);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.filter(c.onDidChangeConfiguration,R=>R.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,i,a,c){const s=r.syncData?g(r.syncData.content,c.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;i=i===null&&a?r:i;const o=i?this.getKeybindingsContentFromLastSyncUserData(i):null,l=await this.getLocalFileContent(),v=await this.getFormattingOptions();let y=null,O=!1,_=!1,N=!1;if(s){let F=l?l.value.toString():"[]";if(F=F||"[]",this.hasErrors(F,!0))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==F||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,h.merge)(F,s,o,v,this.userDataSyncUtilService);j.hasChanges&&(y=j.mergeContent,N=j.hasConflicts,O=N||j.mergeContent!==F,_=N||j.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=l.value.toString(),_=!0);const R={content:y,localChange:O?l?2:1:0,remoteChange:_?2:0,hasConflicts:N},M=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:o!==null?o:M,localResource:this.localResource,localContent:M,localChange:R.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:R.remoteChange,previewResource:this.previewResource,previewResult:R,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const i=this.getKeybindingsContentFromLastSyncUserData(r);if(i===null)return!0;const a=await this.getLocalFileContent(),c=a?a.value.toString():"",s=await this.getFormattingOptions(),o=await(0,h.merge)(c||"[]",i,i,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==i}async getMergeResult(r,i){return r.previewResult}async getAcceptResult(r,i,a,c){if(this.extUri.isEqual(i,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(r,i,a,c){const{fileContent:s}=a[0][0];let{content:o,localChange:l,remoteChange:v}=a[0][1];if(l===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o,!0)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,c),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),v!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const y=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(y,c?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const i=(0,L.parse)(r.value.toString());if((0,k.isNonEmptyArray)(i))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:i}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let i=await super.resolveContent(r);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(r)),i){const a=this.parseSyncData(i);if(a)switch(this.extUri.basename(r)){case"keybindings.json":return g(a.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:g(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,i){let a={};try{a=JSON.parse(i||"{}")}catch(c){this.logService.error(c)}switch(this.syncKeybindingsPerPlatform()?delete a.all:a.all=r,A.OS){case 2:a.mac=r;break;case 3:a.linux=r;break;case 1:a.windows=r;break}return JSON.stringify(a)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=me([Q(0,m.IUserDataSyncStoreService),Q(1,m.IUserDataSyncBackupStoreService),Q(2,m.IUserDataSyncLogService),Q(3,P.IConfigurationService),Q(4,m.IUserDataSyncEnablementService),Q(5,E.IFileService),Q(6,S.IUserDataProfilesService),Q(7,D.IEnvironmentService),Q(8,p.IStorageService),Q(9,m.IUserDataSyncUtilService),Q(10,C.ITelemetryService),Q(11,d.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let u=class extends w.AbstractInitializer{constructor(r,i,a,c,s){super("keybindings",i,a,c,r,s)}async doInitialize(r){const i=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!i){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,t.VSBuffer.fromString(i)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),i=(0,L.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(i)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return g(r,!0,this.logService)}catch(i){return this.logService.error(i),null}}};u=me([Q(0,E.IFileService),Q(1,S.IUserDataProfilesService),Q(2,D.IEnvironmentService),Q(3,m.IUserDataSyncLogService),Q(4,d.IUriIdentityService)],u),e.KeybindingsInitializer=u}),define(re[247],se([0,1,17,34,77,53,29,59,25]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function P(o,l,v){let y=[];v?y=E(v):y=D(l);const O=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(y))for(const N of y)N.startsWith("-")?_.push(N.substring(1)):O.push(N);return(0,k.distinct)([...o,...O].filter(N=>_.indexOf(N)===-1))}e.getIgnoredSettings=P;function D(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const l=(0,t.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function p(o,l){const v=(0,t.parse)(o)||{};let y="{}";for(const O of Object.keys(v)){const _=(0,T.setProperty)(y,[O],v[O],l);y=(0,T.applyEdits)(y,_)}return y}e.removeComments=p;function C(o,l,v,y){if(v.length){const O=s(l),_=(0,t.parse)(l)||{},N=(0,t.parse)(o);if(!N)return o;const R=[];for(const M of v){const F=_[M],j=N[M];F===void 0?o=I.edit(o,[M],void 0,y):j!==void 0?o=I.edit(o,[M],F,y):R.push(n(M,O))}R.sort((M,F)=>M.startOffset-F.startOffset),R.forEach(M=>o=m(M.setting.key,l,o,y))}return o}e.updateIgnoredSettings=C;function d(o,l,v,y,O,_){const N=C(o,l,y,_),R=v!==N,M=v!==l;if(!R&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(R&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!R)return{conflictsSettings:[],localContent:C(l,o,y,_),remoteContent:null,hasConflicts:!1};if(v===null&&w(o)){const J=S(o,l,y)?null:C(l,o,y,_);return{conflictsSettings:[],localContent:J,remoteContent:null,hasConflicts:!1}}let F=o,j=l;const W=(0,t.parse)(o),z=(0,t.parse)(l),te=v?(0,t.parse)(v):null,G=y.reduce((J,H)=>(J.add(H),J),new Set),K=h(W,z,G),X=h(te,W,G),Y=h(te,z,G),q=new Map,x=new Set,B=J=>{x.add(J);const H=O.filter(({key:ee})=>ee===J)[0];H?(F=I.edit(F,[J],H.value,_),j=I.edit(j,[J],H.value,_)):q.set(J,{key:J,localValue:W[J],remoteValue:z[J]})};for(const J of X.removed.values())Y.updated.has(J)?B(J):j=I.edit(j,[J],void 0,_);for(const J of Y.removed.values())x.has(J)||(X.updated.has(J)?B(J):F=I.edit(F,[J],void 0,_));for(const J of X.updated.values())x.has(J)||(Y.updated.has(J)?K.updated.has(J)&&B(J):j=I.edit(j,[J],W[J],_));for(const J of Y.updated.values())x.has(J)||(X.updated.has(J)?K.updated.has(J)&&B(J):F=I.edit(F,[J],z[J],_));for(const J of X.added.values())x.has(J)||(Y.added.has(J)?K.updated.has(J)&&B(J):j=m(J,F,j,_));for(const J of Y.added.values())x.has(J)||(X.added.has(J)?K.updated.has(J)&&B(J):F=m(J,j,F,_));const U=q.size>0||!S(F,j,y),$=U||!S(F,o,[]),V=U||!S(j,l,[]);return{localContent:$?F:null,remoteContent:V?j:null,conflictsSettings:[...q.values()],hasConflicts:U}}e.merge=d;function S(o,l,v){if(o===l)return!0;const y=(0,t.parse)(o),O=(0,t.parse)(l),_=v.reduce((M,F)=>(M.add(F),M),new Set),N=s(o).filter(M=>!(M.setting&&_.has(M.setting.key))),R=s(l).filter(M=>!(M.setting&&_.has(M.setting.key)));if(N.length!==R.length)return!1;for(let M=0;M<N.length;M++){const F=N[M],j=R[M];if(F.setting&&j.setting){if(F.setting.key!==j.setting.key||!A.equals(y[F.setting.key],O[F.setting.key]))return!1}else if(!F.setting&&!j.setting){if(F.value!==j.value)return!1}else return!1}return!0}e.areSame=S;function w(o){return o?s(o).length===0:!0}e.isEmpty=w;function h(o,l,v){const y=o?Object.keys(o).filter(M=>!v.has(M)):[],O=Object.keys(l).filter(M=>!v.has(M)),_=O.filter(M=>y.indexOf(M)===-1).reduce((M,F)=>(M.add(F),M),new Set),N=y.filter(M=>O.indexOf(M)===-1).reduce((M,F)=>(M.add(F),M),new Set),R=new Set;if(o)for(const M of y){if(N.has(M))continue;const F=o[M],j=l[M];A.equals(F,j)||R.add(M)}return{added:_,removed:N,updated:R}}function m(o,l,v,y){const O=(0,t.parse)(l),_=s(l),N=s(v),R=g(o,_,N);return f(v,o,O[o],R,N,y)}e.addSetting=m;function g(o,l,v){const y=l.findIndex(_=>_.setting?.key===o),O=l[y-1];if(O){if(O.setting){const N=n(O.setting.key,v);if(N)return{index:v.indexOf(N),insertAfter:!0}}else{const N=r(y,l);if(N){const R=n(N.setting.key,v);if(R){const M=i(v.indexOf(R),v),F=a(l,N,l[y]);if(M){const j=a(v,R,M),W=c(F,j);return W?{index:v.indexOf(W),insertAfter:!0}:{index:v.indexOf(M),insertAfter:!1}}else{const j=a(v,R,v[v.length-1]),W=c(F,j);return W?{index:v.indexOf(W),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const _=l[y+1];if(_)if(_.setting){const N=n(_.setting.key,v);if(N)return{index:v.indexOf(N),insertAfter:!1}}else{const N=i(y,l);if(N){const R=n(N.setting.key,v);if(R){const M=r(v.indexOf(R),v),F=a(l,l[y],N);if(M){const j=a(v,M,R),W=c(F.reverse(),j.reverse());return W?{index:v.indexOf(W),insertAfter:!1}:{index:v.indexOf(M),insertAfter:!0}}else{const j=a(v,v[0],R),W=c(F.reverse(),j.reverse());return W?{index:v.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function f(o,l,v,y,O,_){let N;return y.index===-1?N=(0,T.setProperty)(o,[l],v,_):N=u(o,l,v,y,O,_).map(R=>(0,T.withFormatting)(o,R,_)[0]),(0,T.applyEdits)(o,N)}function u(o,l,v,y,O,_){const N=`${JSON.stringify(l)}: ${JSON.stringify(v)}`,R=(0,L.getEOL)(_,o),M=O[y.index];if(y.insertAfter){const F=[];if(M.setting)F.push({offset:M.endOffset,length:0,content:","+N});else{const j=i(y.index,O),W=r(y.index,O),z=W?.setting?.commaOffset;W&&z===void 0&&F.push({offset:W.endOffset,length:0,content:","});const te=z!==void 0&&z>M.endOffset;F.push({offset:te?z+1:M.endOffset,length:0,content:j?R+N+",":R+N})}return F}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const F=(O[y.index-1]&&!O[y.index-1].setting?R:"")+N+(i(y.index,O)?",":"")+R;return[{offset:M.startOffset,length:0,content:F}]}}function n(o,l){return l.filter(v=>v.setting?.key===o)[0]}function r(o,l){for(let v=o-1;v>=0;v--)if(l[v].setting)return l[v]}function i(o,l){for(let v=o+1;v<l.length;v++)if(l[v].setting)return l[v]}function a(o,l,v){const y=o.indexOf(l),O=o.indexOf(v);return o.filter((_,N)=>y<N&&N<O)}function c(o,l){if(o.length&&l.length){let v=0;for(;v<l.length&&v<o.length;v++)if(o[v].value!==l[v].value)return l[v-1];return l[v-1]}}function s(o){const l=[];let v=-1,y,O;const _={onObjectBegin:N=>{v++},onObjectProperty:(N,R,M)=>{v===0&&(y=R,O=N)},onObjectEnd:(N,R)=>{v--,v===0&&l.push({startOffset:y,endOffset:N+R,value:o.substring(y,N+R),setting:{key:O,commaOffset:void 0}})},onArrayBegin:(N,R)=>{v++},onArrayEnd:(N,R)=>{v--,v===0&&l.push({startOffset:y,endOffset:N+R,value:o.substring(y,N+R),setting:{key:O,commaOffset:void 0}})},onLiteralValue:(N,R,M)=>{v===0&&l.push({startOffset:y,endOffset:R+M,value:o.substring(y,R+M),setting:{key:O,commaOffset:void 0}})},onSeparator:(N,R,M)=>{if(v===0&&N===","){let F=l.length-1;for(;F>=0&&!l[F].setting;F--);const j=l[F];j&&l.splice(F,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:R}})}},onComment:(N,R)=>{v===0&&l.push({startOffset:N,endOffset:N+R,value:o.substring(N,N+R)})}};return(0,t.visit)(o,_),l}}),define(re[248],se([0,1,16,3,161,18,69,15,30,13,22,21,33,28,47,59,247,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function g(n){const r=JSON.parse(n);return m(r)?r:{settings:n}}e.parseSettingsSyncContent=g;let f=class extends d.AbstractJsonFileSynchroniser{constructor(r,i,a,c,s,o,l,v,y,O,_,N,R){super(i.defaultProfile.settingsResource,"settings",r,a,c,s,o,O,_,l,v,y,R);this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const i=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(r,i),c=this.getSettingsSyncContent(a),s=new A.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return c?.settings&&s.parse(c.settings),s.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,i,a){const c=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);i=i===null&&a?r:i;const l=i?this.getSettingsSyncContent(i):null,v=await this.getIgnoredSettings();let y=null,O=!1,_=!1,N=!1;if(o){let F=c?c.value.toString().trim():"{}";F=F||"{}",this.validateContent(F),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,w.merge)(F,o.settings,l?l.settings:null,v,[],s);y=j.localContent||j.remoteContent,O=j.localContent!==null,_=j.remoteContent!==null,N=j.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),y=c.value.toString().trim()||"{}",this.validateContent(y),_=!0);const R={content:y,localChange:O?2:0,remoteChange:_?2:0,hasConflicts:N},M=c?c.value.toString():null;return[{fileContent:c,baseResource:this.baseResource,baseContent:l?l.settings:M,localResource:this.localResource,localContent:M,localChange:R.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:R.remoteChange,previewResource:this.previewResource,previewResult:R,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const i=this.getSettingsSyncContent(r);if(i===null)return!0;const a=await this.getLocalFileContent(),c=a?a.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,w.merge)(c||"{}",i.settings,i.settings,s,[],o).remoteContent!==null}async getMergeResult(r,i){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,w.updateIgnoredSettings)(r.previewResult.content,"{}",c,a):null}}async getAcceptResult(r,i,a,c){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:r.fileContent?(0,w.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:r.remoteContent!==null?(0,w.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,w.updateIgnoredSettings)(a,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(r,i,a,c){const{fileContent:s}=a[0][0];let{content:o,localChange:l,remoteChange:v}=a[0][1];if(l===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,c),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const y=await this.getFormattingOptions(),O=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(o);o=(0,w.updateIgnoredSettings)(o,O?O.settings:"{}",_,y),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),c?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const i=await this.getFormattingOptions(),a=(0,S.edit)(r.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,w.isEmpty)(a)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:i}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r))return this.resolvePreviewContent(r);let i=await super.resolveContent(r);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(r)),i){const a=this.parseSyncData(i);if(a){const c=this.parseSettingsSyncContent(a.content);if(c)switch(this.extUri.basename(r)){case"settings.json":return c.settings}}}return null}async resolvePreviewContent(r){let i=await super.resolvePreviewContent(r);if(i){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();i=(0,w.updateIgnoredSettings)(i,"{}",c,a)}return i}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return g(r)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,c=>c.some(({local:s})=>!!s)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,c=>!c.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(i,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new h.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}};f=me([Q(0,P.IFileService),Q(1,C.IUserDataProfilesService),Q(2,I.IEnvironmentService),Q(3,D.IStorageService),Q(4,h.IUserDataSyncStoreService),Q(5,h.IUserDataSyncBackupStoreService),Q(6,h.IUserDataSyncLogService),Q(7,h.IUserDataSyncUtilService),Q(8,L.IConfigurationService),Q(9,h.IUserDataSyncEnablementService),Q(10,E.ITelemetryService),Q(11,b.IExtensionManagementService),Q(12,p.IUriIdentityService)],f),e.SettingsSynchroniser=f;let u=class extends d.AbstractInitializer{constructor(r,i,a,c,s){super("settings",i,a,c,r,s)}async doInitialize(r){const i=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return g(r)}catch(i){this.logService.error(i)}return null}};u=me([Q(0,P.IFileService),Q(1,C.IUserDataProfilesService),Q(2,I.IEnvironmentService),Q(3,h.IUserDataSyncLogService),Q(4,p.IUriIdentityService)],u),e.SettingsInitializer=u}),define(re[249],se([0,1,16,3,29,18,15,13,22,21,33,28,47,242,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(m,g,f,u,n,r,i,a,c,s,o){super("snippets",g,m,u,n,r,c,s,i,a,o);this.version=1,this.snippetsFolder=f.defaultProfile.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,g,f){const u=await this.getSnippetsFileContents(),n=this.toSnippetsContents(u),r=m.syncData?this.parseSnippets(m.syncData):null;g=g===null&&f?m:g;const i=g&&g.syncData?this.parseSnippets(g.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const a=(0,C.merge)(n,r,i);return this.getResourcePreviews(a,u,r||{},i||{})}async hasRemoteChanged(m){const g=m.syncData?this.parseSnippets(m.syncData):null;if(g===null)return!0;const f=await this.getSnippetsFileContents(),u=this.toSnippetsContents(f),n=(0,C.merge)(u,g,g);return Object.keys(n.remote.added).length>0||Object.keys(n.remote.updated).length>0||n.remote.removed.length>0||n.conflicts.length>0}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,f,u){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,f,u){const n=f.map(([r,i])=>({...r,acceptResult:i}));n.every(({localChange:r,remoteChange:i})=>r===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),n.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(n),await this.updateLocalSnippets(n,u)),n.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(n,m,u)),g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of n)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,g,f,u){const n=new Map;for(const r of Object.keys(m.local.added)){const i={content:m.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(m.local.updated)){const i={content:m.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0},a=g[r]?g[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[r],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},a=g[r]?g[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[r],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(m.remote.added)){const i={content:m.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1},a=g[r]?g[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[r],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(m.remote.updated)){const i={content:m.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2},a=g[r]?g[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[r],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of m.conflicts){const i={content:g[r]?g[r].value.toString():null,hasConflicts:!0,localChange:g[r]?2:1,remoteChange:f[r]?2:1},a=g[r]?g[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[r]||null,localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g))if(!n.has(r)){const i={content:g[r]?g[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},a=g[r]?g[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[r]||null,localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...n.values()]}async getAssociatedResources({uri:m}){const g=await super.resolveContent(m);if(g){const f=this.parseSyncData(g);if(f){const u=this.parseSnippets(f),n=[];for(const r of Object.keys(u)){const i=this.extUri.joinPath(m,r),a=this.extUri.joinPath(this.snippetsFolder,r),c=await this.fileService.exists(a);n.push({resource:i,comparableResource:c?a:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})})}return n}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const f=this.parseSyncData(g);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const g={};for(const f of m)f.fileContent&&(g[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(g)))}async updateLocalSnippets(m,g){for(const{fileContent:f,acceptResult:u,localResource:n,remoteResource:r,localChange:i}of m)if(i!==0){const a=r?this.extUri.basename(r):this.extUri.basename(n),c=this.extUri.joinPath(this.snippetsFolder,a);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(c)),await this.fileService.del(c),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(c))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(c)),await this.fileService.createFile(c,k.VSBuffer.fromString(u.content),{overwrite:g}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(c))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(c)),await this.fileService.writeFile(c,k.VSBuffer.fromString(u.content),g?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(c)))}}async updateRemoteSnippets(m,g,f){const u=g.syncData?this.parseSnippets(g.syncData):{},n=(0,T.deepClone)(u);for(const{acceptResult:r,localResource:i,remoteResource:a,remoteChange:c}of m)if(c!==0){const s=i?this.extUri.basename(i):this.extUri.basename(a);c===3?delete n[s]:n[s]=r.content}return(0,C.areSame)(u,n)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),g=await this.updateRemoteUserData(JSON.stringify(n),f?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),g}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const g={};for(const f of Object.keys(m))g[f]=m[f].value.toString();return g}async getSnippetsFileContents(){const m={};let g;try{g=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof I.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of g.children||[]){const u=f.resource,n=this.extUri.extname(u);if(n===".json"||n===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,u),i=await this.fileService.readFile(u);m[r]=i}}return m}};S=me([Q(0,A.IEnvironmentService),Q(1,I.IFileService),Q(2,E.IUserDataProfilesService),Q(3,b.IStorageService),Q(4,d.IUserDataSyncStoreService),Q(5,d.IUserDataSyncBackupStoreService),Q(6,d.IUserDataSyncLogService),Q(7,L.IConfigurationService),Q(8,d.IUserDataSyncEnablementService),Q(9,P.ITelemetryService),Q(10,D.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let w=class extends p.AbstractInitializer{constructor(m,g,f,u,n){super("snippets",g,f,u,m,n)}async doInitialize(m){const g=m.syncData?JSON.parse(m.syncData.content):null;if(!g){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(g)){const n=g[u];if(n){const r=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(r,k.VSBuffer.fromString(n)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};w=me([Q(0,I.IFileService),Q(1,E.IUserDataProfilesService),Q(2,A.IEnvironmentService),Q(3,d.IUserDataSyncLogService),Q(4,D.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(re[250],se([0,1,16,18,15,13,22,21,33,28,47,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(w,h){try{return JSON.parse(w).tasks}catch(m){return h.error(m),null}}e.getTasksContentFromSyncContent=p;let C=class extends D.AbstractFileSynchroniser{constructor(h,m,g,f,u,n,r,i,a,c,s){super(s.defaultProfile.tasksResource,"tasks",n,r,i,h,m,u,a,g,f,c);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,m,g,f){const u=h.syncData?p(h.syncData.content,this.logService):null;m=m===null&&g?h:m;const n=m?.syncData?p(m.syncData.content,this.logService):null,r=await this.getLocalFileContent();let i=null,a=!1,c=!1,s=!1;if(u){const v=r?r.value.toString():null;if(!n||n!==v||n!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const y=S(v,u,n);i=y.content,s=y.hasConflicts,a=y.hasLocalChanged,c=y.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=r.value.toString(),c=!0);const o={content:i,localChange:a?r?2:1:0,remoteChange:c?2:0,hasConflicts:s},l=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:n!==null?n:l,localResource:this.localResource,localContent:l,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const m=h?.syncData?p(h.syncData.content,this.logService):null;if(m===null)return!0;const g=await this.getLocalFileContent(),f=g?g.value.toString():null,u=S(f,m,m);return u.hasLocalChanged||u.hasRemoteChanged}async getMergeResult(h,m){return h.previewResult}async getAcceptResult(h,m,g,f){if(this.extUri.isEqual(m,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return g===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(h,m,g,f){const{fileContent:u}=g[0][0],{content:n,localChange:r,remoteChange:i}=g[0][1];if(r===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),u&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(u.value.toString()))),await this.updateLocalFileContent(n||"{}",u,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),i!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const a=JSON.stringify(this.toTasksSyncContent(n||"{}"));h=await this.updateRemoteUserData(a,f?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:h}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(h,"tasks.json"),comparableResource:m}]}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let m=await super.resolveContent(h);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(h)),m){const g=this.parseSyncData(m);if(g)switch(this.extUri.basename(h)){case"tasks.json":return p(g.content,this.logService)}}return null}toTasksSyncContent(h){return{tasks:h}}};C=me([Q(0,E.IUserDataSyncStoreService),Q(1,E.IUserDataSyncBackupStoreService),Q(2,E.IUserDataSyncLogService),Q(3,t.IConfigurationService),Q(4,E.IUserDataSyncEnablementService),Q(5,L.IFileService),Q(6,T.IEnvironmentService),Q(7,A.IStorageService),Q(8,I.ITelemetryService),Q(9,b.IUriIdentityService),Q(10,P.IUserDataProfilesService)],C),e.TasksSynchroniser=C;let d=class extends D.AbstractInitializer{constructor(h,m,g,f,u){super("tasks",m,g,f,h,u);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const m=h.syncData?p(h.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(m)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=me([Q(0,L.IFileService),Q(1,P.IUserDataProfilesService),Q(2,T.IEnvironmentService),Q(3,E.IUserDataSyncLogService),Q(4,b.IUriIdentityService)],d),e.TasksInitializer=d;function S(w,h,m){if(w===null&&h===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=m!==w,f=m!==h;return!g&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!f?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!g?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[73],se([0,1,3,2,5,25]),function(Z,e,k,t,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,T.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(b,P){super();this.userDataSyncStoreService=b,this.logService=P,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=me([Q(0,L.IUserDataSyncStoreService),Q(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(re[251],se([0,1,6,16,62,2,19,18,15,13,25]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends L.Disposable{constructor(C,d,S,w){super();this.environmentService=C,this.fileService=d,this.configurationService=S,this.logService=w,D.ALL_SYNC_RESOURCES.forEach(h=>this.cleanUpBackup(h))}async getAllRefs(C){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,C),S=await this.fileService.resolve(d);return S.children?S.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort().reverse().map(h=>({ref:h.name,created:this.getCreationTime(h)})):[]}async resolveContent(C,d){if(!d){const S=await this.getAllRefs(C);S.length&&(d=S[S.length-1].ref)}if(d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,C,d);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(C,d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,C),w=(0,A.joinPath)(S,`${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(w,t.VSBuffer.fromString(d))}catch(h){this.logService.error(h)}try{this.cleanUpBackup(C)}catch{}}async cleanUpBackup(C){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,C);try{try{if(!await this.fileService.exists(d))return}catch{return}const S=await this.fileService.resolve(d);if(S.children){const w=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=w.filter(f=>Date.now()-this.getCreationTime(f)>h);const g=w.length-m.length;g<10&&(m=m.slice(10-g)),await k.Promises.settled(m.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(C){return C.ctime||new Date(parseInt(C.name.substring(0,4)),parseInt(C.name.substring(4,6))-1,parseInt(C.name.substring(6,8)),parseInt(C.name.substring(9,11)),parseInt(C.name.substring(11,13)),parseInt(C.name.substring(13,15))).getTime()}};E=me([Q(0,b.IEnvironmentService),Q(1,P.IFileService),Q(2,I.IConfigurationService),Q(3,D.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(re[252],se([0,1,3,2,4,15,22,21,25]),function(Z,e,k,t,T,L,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const P="sync.enable";let D=class extends t.Disposable{constructor(p,C,d,S){super();this.storageService=p,this.telemetryService=C,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(P,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(P,{enabled:p}),this.storageService.store(P,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,b.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,C){if(this.isResourceEnabled(p)!==C){const d=(0,b.getEnablementKey)(p);this.storeResourceEnablement(d,C)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,C){this.storageService.store(p,C,-1,T.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(P===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const C=b.ALL_SYNC_RESOURCES.filter(d=>(0,b.getEnablementKey)(d)===p.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}};D=me([Q(0,A.IStorageService),Q(1,I.ITelemetryService),Q(2,L.IEnvironmentService),Q(3,b.IUserDataSyncStoreManagementService)],D),e.UserDataSyncEnablementService=D}),define(re[253],se([0,1,2,8]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class T{constructor(p){this.service=p}listen(p,C){switch(C){case"onError":return this.service.onError}throw new Error(`Event not found: ${C}`)}call(p,C,d){switch(C){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=T;class L{constructor(p){this.service=p}listen(p,C){throw new Error(`Event not found: ${C}`)}call(p,C,d){switch(C){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=A;class I{constructor(p){this.service=p}listen(p,C){switch(C){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${C}`)}async call(p,C,d){switch(C){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class b{constructor(p){this.service=p}listen(p,C){switch(C){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${C}`)}call(p,C,d){switch(C){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class P{constructor(p){this.service=p}listen(p,C){switch(C){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${C}`)}call(p,C,d){switch(C){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=P;class D extends k.Disposable{constructor(p){super();this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:t.URI.revive(p.url),type:p.type,defaultUrl:t.URI.revive(p.defaultUrl),insidersUrl:t.URI.revive(p.insidersUrl),stableUrl:t.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(re[254],se([0,1,15,7]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends t.AbstractLogger{constructor(A,I){super();this.logger=this._register(A.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...I){this.logger.trace(A,...I)}debug(A,...I){this.logger.debug(A,...I)}info(A,...I){this.logger.info(A,...I)}warn(A,...I){this.logger.warn(A,...I)}error(A,...I){this.logger.error(A,...I)}critical(A,...I){this.logger.critical(A,...I)}flush(){this.logger.flush()}};T=me([Q(0,t.ILoggerService),Q(1,k.IEnvironmentService)],T),e.UserDataSyncLogService=T}),define(re[74],se([0,1,3,2,4,26,164,15,13,5,24,49,22,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,P.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",S="Safari",w="Chrome",h="Edge",m="Firefox",g="Android";function f(r){switch(r){case S:case w:case h:case m:case g:case(0,T.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function u(){return T.isSafari?S:T.isChrome?w:T.isEdge?h:T.isFirefox?m:T.isAndroid?g:(0,T.PlatformToString)(T.isWeb?0:T.platform)}let n=class nt extends t.Disposable{constructor(i,a,c,s,o,l){super();this.storageService=c,this.userDataSyncStoreService=s,this.logService=o,this.productService=l,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(i,a,c)}async getMachines(i){const a=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===a}))}async addCurrentMachine(i){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(i);c.machines.some(({id:s})=>s===a)||(c.machines.push({id:a,name:this.computeCurrentMachineName(c.machines),platform:u()}),await this.writeMachinesData(c))}async removeCurrentMachine(i){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(i),s=c.machines.filter(({id:o})=>o!==a);s.length!==c.machines.length&&(c.machines=s,await this.writeMachinesData(c))}async renameMachine(i,a,c){const s=await this.readMachinesData(c),o=s.machines.find(({id:l})=>l===i);if(o){o.name=a,await this.writeMachinesData(s);const l=await this.currentMachineIdPromise;i===l&&this.storageService.store(d,a,-1,1)}}async setEnablements(i){const a=await this.readMachinesData();for(const[c,s]of i){const o=a.machines.find(l=>l.id===c);o&&(o.disabled=s?void 0:!0)}await this.writeMachinesData(a)}computeCurrentMachineName(i){const a=this.storageService.get(d,-1);if(a)return a;const c=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,s=new RegExp(`${(0,L.escapeRegExpCharacters)(c)}\\s#(\\d+)`);let o=0;for(const l of i){const v=s.exec(l.name),y=v?parseInt(v[1]):0;o=y>o?y:o}return`${c} #${o+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const a=this.parse(this.userData);if(a.version!==nt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return a}async writeMachinesData(i){const a=JSON.stringify(i),c=await this.userDataSyncStoreService.write(nt.RESOURCE,a,this.userData?.ref||null);this.userData={ref:c,content:a},this._onDidChange.fire()}async readUserData(i){if(this.userData){const a=i&&i.latest?i.latest[nt.RESOURCE]:void 0;if(this.userData.ref===a)return this.userData;if(a===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(nt.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(a){this.logService.error(a)}return{version:nt.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=me([Q(0,I.IEnvironmentService),Q(1,b.IFileService),Q(2,p.IStorageService),Q(3,C.IUserDataSyncStoreService),Q(4,C.IUserDataSyncLogService),Q(5,D.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[255],se([0,1,6,62,37,9,3,2,4,19,8,162,24,22,21,25,73,74]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",g="sync.sessionId",f="sync.storeUrl",u="sync.productQuality";let n=class extends I.Disposable{constructor(a,c,s,o,l,v,y,O,_,N){super();this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=o,this.userDataSyncService=l,this.logService=v,this.userDataSyncAccountService=y,this.telemetryService=O,this.userDataSyncMachinesService=_,this.storageService=N,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=a.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(c.onDidChangeUserDataSyncStore(()=>{(0,P.isEqual)(this.syncUrl,c.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(y.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(R=>this.triggerSync([R],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,R])=>R)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const a=this.storageService.get(f,-1);return a?D.URI.parse(a):void 0}set syncUrl(a){a?this.storageService.store(f,a.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(u,-1)}set productQuality(a){a?this.storageService.store(u,a,-1,1):this.storageService.remove(u,-1)}updateAutoSync(){const{enabled:a,message:c}=this.isAutoSyncEnabled();a?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(c&&this.logService.info(c),this.autoSync.clear()):c&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(c))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(a,c,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,-1),a?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(c)this.logService.error(o),this.updateEnablement(!1);else throw o}}updateEnablement(a){this.userDataSyncEnablementService.isEnabled()!==a&&(this.userDataSyncEnablementService.setEnablement(a),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(a){if(!a){this.successiveFailures=0;return}const c=S.UserDataSyncError.toUserDataSyncError(a);c instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:c.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),c.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):c.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):c.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):c.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):c.code==="UpgradeRequired"||c.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):c.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with newer version than of client. Requires client upgrade.`)):c.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with older version than of client. Requires server reset.`)):c.code==="ServiceChanged"||c.code==="DefaultServiceChanged"?b.isWeb&&c.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(c),this.successiveFailures++),this._onError.fire(c)}async disableMachineEventually(){this.storageService.store(m,!0,-1,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(m,-1)}async triggerSync(a,c,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(c&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...a),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=me([Q(0,p.IProductService),Q(1,S.IUserDataSyncStoreManagementService),Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncEnablementService),Q(4,S.IUserDataSyncService),Q(5,S.IUserDataSyncLogService),Q(6,w.IUserDataSyncAccountService),Q(7,d.ITelemetryService),Q(8,h.IUserDataSyncMachinesService),Q(9,C.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends I.Disposable{constructor(a,c,s,o,l,v,y,O){super();this.lastSyncUrl=a,this.interval=c,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncService=l,this.userDataSyncMachinesService=v,this.logService=y,this.storageService=O,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(a,c){const s=(0,k.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,L.isCancellationError)(l))return}return this.doSync(a,c,o)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,P.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const a=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),c=this.userDataSyncStoreManagementService.userDataSyncStore;return!!c&&!!a&&(!(0,P.isEqual)(c.defaultUrl,a.defaultUrl)||!(0,P.isEqual)(c.insidersUrl,a.insidersUrl)||!(0,P.isEqual)(c.stableUrl,a.stableUrl))}async doSync(a,c,s){this.logService.info(`Auto Sync: Triggered by ${a}`),this._onDidStartSync.fire();let o;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,c),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const l=this.storageService.get(g,-1);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const y=v.find(O=>O.isCurrent);if(y?.disabled)throw new S.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new S.UserDataAutoSyncError((0,T.toErrorMessage)(O),O instanceof S.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(g,this.manifest.session,-1,1),s.isCancellationRequested)return;y||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),o=l}this._onDidFinishSync.fire(o)}register(a){return super._register(a)}}r.INTERVAL_SYNCING="Interval"}),define(re[256],se([0,1,17,6,37,3,2,19,14,31,18,30,5,22,21,243,245,246,248,249,250,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let r=class extends A.Disposable{constructor(o,l,v,y,O,_,N,R){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=l,this.instantiationService=v,this.configurationService=y,this.logService=O,this.telemetryService=_,this.storageService=N,this.userDataSyncEnablementService=R,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(n,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,l){this.checkEnablement();const v=(0,P.generateUuid)();try{const R=(0,u.createSyncHeaders)(v);l&&(R["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,R)}catch(R){const M=u.UserDataSyncError.toUserDataSyncError(R);throw this.reportUserDataSyncError(M,v),M}const y=!1,O=this,_=this.getEnabledSynchronizers();let N;return{manifest:o,async run(){if(y)throw new Error("Can run a task only once");return N=(0,t.createCancelablePromise)(R=>O.sync(_,o,v,R)),N.finally(()=>N=void 0)},async stop(){if(N&&N.cancel(),O.status!=="idle")return O.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,P.generateUuid)(),l=(0,u.createSyncHeaders)(o);let v;try{v=await this.userDataSyncStoreService.manifest(null,l)}catch(_){const N=u.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(N,o),N}await this.resetLocal();const y=this.getEnabledSynchronizers(),O=async()=>{await this.stop(y),await this.resetLocal()};return new i(o,v,l,y,O,this.configurationService,this.logService)}async sync(o,l,v,y){if(y.isCancellationRequested||!o.length)return;const O=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,u.createSyncHeaders)(v);for(const N of o){if(y.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(N.resource))return;try{await N.sync(l,_)}catch(R){let M=!1;if(R instanceof u.UserDataSyncError)switch(R.code){case"TooLarge":R=new u.UserDataSyncError(R.message,R.code,N.resource),M=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":M=!0;break}const F=u.UserDataSyncError.toUserDataSyncError(R);if(this.reportUserDataSyncError(F,v),M)throw F;this.logService.error(R),this.logService.error(`${N.resource}: ${(0,T.toErrorMessage)(R)}`),this._syncErrors.push([N.resource,F])}}this.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),this.updateLastSyncTime()}catch(_){const N=u.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(N,v),N}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const l of o)try{l.status!=="idle"&&await l.stop()}catch(v){this.logService.error(v)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(o))return!0})}async accept(o,l,v,y){this.checkEnablement(),await this.performSynchronizerAction(async O=>{if(O.resource===o)return await O.accept(l,v),y&&await O.apply(!1,(0,u.createSyncHeaders)((0,P.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async l=>{const v=await l.resolveContent(o);if(v)return v})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,l){return await this.performSynchronizerAction(async y=>{if(y.resource===o)return y.getAssociatedResources(l)})||[]}async getMachineId(o,l){return await this.performSynchronizerAction(async y=>{if(y.resource===o)return await y.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(n,-1),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(l){this.logService.error(`${o.resource}: ${(0,T.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const l=new A.DisposableStore;try{const v=this.synchronizers.value||l.add(this.instantiationService.createInstance(a,()=>{},()=>{},()=>{})),y=[...v.enabled,...v.disabled.map(O=>l.add(v.createSynchronizer(O)))];for(const O of y){const _=await o(O);if(!(0,b.isUndefined)(_))return _}return null}finally{l.dispose()}}setStatus(o){const l=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const l=this.computeStatus(o);this.setStatus(l)}updateConflicts(o){const l=this.computeConflicts(o);(0,k.equals)(this._conflicts,l,([v,y],[O,_])=>v===v&&(0,k.equals)(y,_,(N,R)=>(0,I.isEqual)(N.previewResource,R.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(l))}computeConflicts(o){return o.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(c)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(l=>l.status==="hasConflicts")?"hasConflicts":o.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,l){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof u.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof u.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(a,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=me([Q(0,u.IUserDataSyncStoreService),Q(1,u.IUserDataSyncStoreManagementService),Q(2,p.IInstantiationService),Q(3,D.IConfigurationService),Q(4,u.IUserDataSyncLogService),Q(5,d.ITelemetryService),Q(6,C.IStorageService),Q(7,u.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class i extends A.Disposable{constructor(o,l,v,y,O,_,N){super();this.id=o,this.manifest=l,this.syncHeaders=v,this.synchronisers=y,this.onStop=O,this.configurationService=_,this.logService=N,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,l){try{return await this.performAction(o,v=>v.accept(o,l))}catch(v){throw this.logService.error(v),v}}async merge(o){try{return o?await this.performAction(o,l=>l.merge(o)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(o){try{return await this.performAction(o,l=>l.discard(o))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,l]of this.previews)for(const v of l.resourcePreviews)v.mergeState==="conflict"&&o.push(v.previewResource);for(const l of o)await this.discard(l);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[l,v]of this.previews){this.synchronizingResources.push([l,v.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const y=this.synchronisers.find(_=>_.resource===l);for(const _ of v.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await y.merge(_.previewResource);const O=await y.apply(!1,this.syncHeaders);O&&o.push(this.toSyncResourcePreview(y.resource,O)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(y=>y.resource===o);for(const y of l.resourcePreviews)await v.accept(y.remoteResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(y=>y.resource===o);for(const y of l.resourcePreviews)await v.accept(y.localResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const v=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:W,previewResource:z,remoteResource:te})=>(0,I.isEqual)(o,W)||(0,I.isEqual)(o,z)||(0,I.isEqual)(o,te)));if(v===-1)return this.previews;const[y,O]=this.previews[v],_=O.resourcePreviews.find(({localResource:j,remoteResource:W,previewResource:z})=>(0,I.isEqual)(j,o)||(0,I.isEqual)(W,o)||(0,I.isEqual)(z,o));if(!_)return this.previews;let N=this.synchronizingResources.find(j=>j[0]===y);N||(N=[y,[]],this.synchronizingResources.push(N)),N[1].some(j=>(0,I.isEqual)(j,_.localResource))||(N[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const R=this.synchronisers.find(j=>j.resource===this.previews[v][0]),M=await l(R);M?this.previews.splice(v,1,this.toSyncResourcePreview(R.resource,M)):this.previews.splice(v,1);const F=this.synchronizingResources.findIndex(j=>j[0]===y);return this.synchronizingResources[F][1].splice(N[1].findIndex(j=>(0,I.isEqual)(j,_.localResource)),1),N[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[l,v]of this.previews){this.synchronizingResources.push([l,v.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const y=this.synchronisers.find(_=>_.resource===l);let O=v;for(const _ of v.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(O=await y.merge(_.previewResource));O&&o.push(this.toSyncResourcePreview(y.resource,O)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const l=[],v=await this.getUserDataSyncConfiguration();for(const y of this.synchronisers){if(o.isCancellationRequested)return[];const O=await y.preview(this.manifest,v,this.syncHeaders);O&&l.push(this.toSyncResourcePreview(y.resource,O))}return l}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(v=>v instanceof m.SettingsSynchroniser);if(l){const v=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...v}}return o}toSyncResourcePreview(o,l){return[o,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(c)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let a=class extends A.Disposable{constructor(o,l,v,y,O,_,N){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=l,this.onDidChangeLocal=v,this.userDataSyncEnablementService=y,this.instantiationService=O,this.extensionGalleryService=_,this.logService=N,this._enabled=[],this._register(y.onDidChangeResourceEnablement(([R,M])=>this.onDidChangeResourceEnablement(R,M))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,R])=>R.dispose())));for(const R of u.ALL_SYNC_RESOURCES)y.isResourceEnabled(R)&&this.registerSynchronizer(R)}get enabled(){return this._enabled.sort((o,l)=>o[1]-l[1]).map(([o])=>o)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,l){l?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([O])=>O.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,v=l.add(this.createSynchronizer(o));l.add(v.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(v.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(v.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const y=this.getOrder(o);this._enabled.push([v,y,l])}deRegisterSynchronizer(o){const l=this._enabled.findIndex(([v])=>v.resource===o);if(l!==-1){const v=this._enabled.splice(l,1);for(const[y,,O]of v){if(y.status!=="idle"){const _=y.conflicts.length>0;y.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}O.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(m.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(h.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(w.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};a=me([Q(3,u.IUserDataSyncEnablementService),Q(4,p.IInstantiationService),Q(5,E.IExtensionGalleryService),Q(6,u.IUserDataSyncLogService)],a);function c(s){return{baseResource:s.baseResource,localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(re[257],se([0,1,3,2,14,8,25]),function(Z,e,k,t,T,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class I{constructor(E,p){this.service=E,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(E,p,C){try{return await this._call(E,p,C)}catch(d){throw this.logService.error(d),d}}async _call(E,p,C){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(C[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(C[0],L.URI.revive(C[1]),C[2],C[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(C[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(C[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(C[0]);case"getAssociatedResources":return this.service.getAssociatedResources(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"getMachineId":return this.service.getMachineId(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const d=p.substring("manualSync/".length),S=C[0],w=this.getManualSyncTask(S);switch(C=C.slice(1),d){case"preview":return w.preview();case"accept":return w.accept(L.URI.revive(C[0]),C[1]);case"merge":return w.merge(L.URI.revive(C[0]));case"discard":return w.discard(L.URI.revive(C[0]));case"discardConflicts":return w.discardConflicts();case"apply":return w.apply();case"pull":return w.pull();case"push":return w.push();case"stop":return w.stop();case"_getStatus":return w.status;case"dispose":return this.disposeManualSyncTask(w)}}throw new Error("Invalid call")}getManualSyncTask(E){const p=this.manualSyncTasks.get(this.createKey(E));if(!p)throw new Error(`Manual sync taks not found: ${E}`);return p.manualSyncTask}async createManualSyncTask(){const E=new t.DisposableStore,p=E.add(await this.service.createManualSyncTask());return E.add(p.onSynchronizeResources(C=>this.onManualSynchronizeResources.fire({manualSyncTaskId:p.id,data:C}))),this.manualSyncTasks.set(this.createKey(p.id),{manualSyncTask:p,disposables:E}),{id:p.id,manifest:p.manifest,status:p.status}}disposeManualSyncTask(E){E.dispose();const p=this.createKey(E.id);this.manualSyncTasks.get(p)?.disposables.dispose(),this.manualSyncTasks.delete(p)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=I;class b extends t.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,C,d){return E.call(p,C,d).then(null,S=>{throw A.UserDataSyncError.toUserDataSyncError(S)})},listen(p,C){return E.listen(p,C)}},this.channel.call("_getInitialData").then(([p,C,d])=>{this.updateStatus(p),this.updateConflicts(C),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(([C,d])=>[C,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:p,status:C}=await this.channel.call("createManualSyncTask"),d=this,S=new P(E,p,C,{async call(w,h,m){return d.channel.call(`manualSync/${w}`,[E,...(0,T.isArray)(h)?h:[h]],m)},listen(w,h){return k.Event.map(k.Event.filter(d.channel.listen(`manualSync/${w}`,h),m=>!S.isDiposed()&&m.manualSyncTaskId===E),m=>m.data)}});return S}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,p,C,d){return this.channel.call("accept",[E,p,C,d])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:C,uri:d})=>({created:C,uri:L.URI.revive(d)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:C,uri:d})=>({created:C,uri:L.URI.revive(d)}))}async getAssociatedResources(E,p){return(await this.channel.call("getAssociatedResources",[E,p])).map(({resource:d,comparableResource:S})=>({resource:L.URI.revive(d),comparableResource:L.URI.revive(S)}))}async getMachineId(E,p){return this.channel.call("getMachineId",[E,p])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([p,C])=>[p,C.map(d=>({...d,baseResource:L.URI.revive(d.baseResource),localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class P extends t.Disposable{constructor(E,p,C,d){super();this.id=E,this.manifest=p,this._disposed=!1,this._status=C;const S=this;this.channel={async call(w,h,m){try{const g=await d.call(w,h,m);return S.isDiposed()||(S._status=await d.call("_getStatus")),g}catch(g){throw A.UserDataSyncError.toUserDataSyncError(g)}},listen(w,h){return d.listen(w,h)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,p){const C=await this.channel.call("accept",[E,p]);return this.deserializePreviews(C)}async merge(E){const p=await this.channel.call("merge",[E]);return this.deserializePreviews(p)}async discard(E){const p=await this.channel.call("discard",[E]);return this.deserializePreviews(p)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([p,C])=>[p,{isLastSyncFromCurrentMachine:C.isLastSyncFromCurrentMachine,resourcePreviews:C.resourcePreviews.map(d=>({...d,baseResource:L.URI.revive(d.baseResource),localResource:L.URI.revive(d.localResource),remoteResource:L.URI.revive(d.remoteResource),previewResource:L.URI.revive(d.previewResource),acceptedResource:L.URI.revive(d.acceptedResource)}))}])}}}),define(re[258],se([0,1,6,23,9,3,2,125,4,19,14,8,31,18,15,13,24,44,49,22,25]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,c=1e3*60*5;let s=class extends A.Disposable{constructor(_,N,R){super();this.productService=_,this.configurationService=N,this.storageService=R,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(R.onDidChangeValue,M=>M.key===f.SYNC_SERVICE_URL_TYPE&&M.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,_,-1,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,N){_=b.isWeb&&_?.web?{..._,..._.web}:_;const R={..._||{},...N||{}};if(R&&(0,D.isString)(R.url)&&(0,D.isObject)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(M=>(0,D.isArray)(R.authenticationProviders[M].scopes))){const M=R,F=!!M.canSwitch&&!N?.url,j=M.url===M.insidersUrl?"insiders":"stable",W=(F?this.userDataSyncStoreType:void 0)||j,z=N?.url||(W==="insiders"?M.insidersUrl:W==="stable"?M.stableUrl:M.url);return{url:E.URI.parse(z),type:W,defaultType:j,defaultUrl:E.URI.parse(M.url),stableUrl:E.URI.parse(M.stableUrl),insidersUrl:E.URI.parse(M.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(M.authenticationProviders).reduce((te,G)=>(te.push({id:G,scopes:M.authenticationProviders[G].scopes}),te),[])}}}};s=me([Q(0,w.IProductService),Q(1,C.IConfigurationService),Q(2,g.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let o=class extends s{constructor(_,N,R){super(_,N,R);const M=this.storageService.get(u,-1);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const F=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(u,JSON.stringify(F),-1,1):this.storageService.remove(u,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};o=me([Q(0,w.IProductService),Q(1,C.IConfigurationService),Q(2,g.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let l=class extends A.Disposable{constructor(_,N,R,M,F,j,W){super();this.requestService=R,this.logService=M,this.storageService=W,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,m.getServiceMachineId)(F,j,W).then(z=>{const te={"X-Client-Name":`${N.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(te["X-Client-Commit"]=N.commit),te}),this.session=new y(a,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(_,N){this.authToken={token:_,type:N}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,P.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(n,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(N=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_),R={},M=await this.request(N.toString(),{type:"GET",headers:R},[],t.CancellationToken.None);return(await(0,h.asJson)(M)||[]).map(({url:j,created:W})=>({ref:(0,P.relativePath)(N,N.with({path:j})),created:W*1e3}))}async resolveContent(_,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,N).toString(),M={};M["Cache-Control"]="no-cache";const F=await this.request(R,{type:"GET",headers:M},[],t.CancellationToken.None);return await(0,h.asTextOrError)(F)}async delete(_,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=N!==null?(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,N).toString():(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString(),M={};await this.request(R,{type:"DELETE",headers:M},[],t.CancellationToken.None)}async read(_,N,R={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,"latest").toString();R={...R},R["Cache-Control"]="no-cache",N&&(R["If-None-Match"]=N.ref);const F=await this.request(M,{type:"GET",headers:R},[304],t.CancellationToken.None);let j=null;if(F.res.statusCode===304&&(j=N),j===null){const W=F.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,h.asTextOrError)(F);if(!z&&F.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",M,"EmptyResponse",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);j={ref:W,content:z}}return j}async write(_,N,R,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString();M={...M},M["Content-Type"]=I.Mimes.text,R&&(M["If-Match"]=R);const j=await this.request(F,{type:"POST",data:N,headers:M},[],t.CancellationToken.None),W=j.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",j.res.statusCode,j.res.headers[f.HEADER_OPERATION_ID]);return W}async manifest(_,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,P.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",_&&(N["If-None-Match"]=_.ref);const M=await this.request(R,{type:"GET",headers:N},[304],t.CancellationToken.None);let F=null;if(M.res.statusCode===304&&(F=_),!F){const W=M.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",R,"NoRef",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,h.asTextOrError)(M);if(!z&&M.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",R,"EmptyResponse",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);z&&(F={...JSON.parse(z),ref:W})}const j=this.storageService.get(r,-1);return j&&F&&j!==F.session&&this.clearSession(),F===null&&j&&this.clearSession(),F&&this.storageService.store(r,F.session,-1,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":I.Mimes.text};await this.request(_,{type:"DELETE",headers:N},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(i,-1)}async request(_,N,R,M){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;N.headers={...N.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:_,type:N.type,headers:{...N.headers,authorization:void 0}});let j;try{j=await this.session.request(_,N,M)}catch(G){if(!(G instanceof f.UserDataSyncStoreError)){let K="RequestFailed";const X=(0,T.getErrorMessage)(G).toLowerCase();X.includes("xhr timeout")?K="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?K="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?K="RequestPathNotEscaped":X.includes("headers must be an object")?K="RequestHeadersNotObject":(0,T.isCancellationError)(G)&&(K="RequestCanceled"),G=new f.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,K,void 0,void 0)}throw this.logService.info("Request failed",_),G}const W=j.res.headers[f.HEADER_OPERATION_ID],z={url:_,status:j.res.statusCode,"execution-id":N.headers[f.HEADER_EXECUTION_ID],"operation-id":W},te=(0,h.isSuccess)(j)||j.res.statusCode&&R.indexOf(j.res.statusCode)!==-1;if(te?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",j.res.statusCode,W);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",j.res.statusCode,W);if(j.res.statusCode===410)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",j.res.statusCode,W);if(j.res.statusCode===412)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",j.res.statusCode,W);if(j.res.statusCode===413)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",j.res.statusCode,W);if(j.res.statusCode===426)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",j.res.statusCode,W);if(j.res.statusCode===429){const G=j.res.headers["retry-after"];throw G?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(G)*1e3)),new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",j.res.statusCode,W)):new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",j.res.statusCode,W)}if(!te)throw new f.UserDataSyncStoreError("Server returned "+j.res.statusCode,_,"Unknown",j.res.statusCode,W);return j}addSessionHeaders(_){let N=this.storageService.get(i,-1);N===void 0&&(N=(0,p.generateUuid)(),this.storageService.store(i,N,-1,1)),_["X-Machine-Session-Id"]=N;const R=this.storageService.get(r,-1);R!==void 0&&(_["X-User-Session-Id"]=R)}};l=me([Q(1,w.IProductService),Q(2,h.IRequestService),Q(3,f.IUserDataSyncLogService),Q(4,d.IEnvironmentService),Q(5,S.IFileService),Q(6,g.IStorageService)],l),e.UserDataSyncStoreClient=l;let v=class extends l{constructor(_,N,R,M,F,j,W){super(_.userDataSyncStore?.url,N,R,M,F,j,W);this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};v=me([Q(0,f.IUserDataSyncStoreManagementService),Q(1,w.IProductService),Q(2,h.IRequestService),Q(3,f.IUserDataSyncLogService),Q(4,d.IEnvironmentService),Q(5,S.IFileService),Q(6,g.IStorageService)],v),e.UserDataSyncStoreService=v;class y{constructor(_,N,R,M){this.limit=_,this.interval=N,this.requestService=R,this.logService=M,this.requests=[],this.startTime=void 0}request(_,N,R){if(this.isExpired()&&this.reset(),N.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(N,R)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=y}),define(re[259],se([0,1,3,68,24,22,21,255,25,73,74]),function(Z,e,k,t,T,L,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends I.UserDataAutoSyncService{constructor(C,d,S,w,h,m,g,f,u,n,r){super(C,d,S,w,h,g,f,u,n,r);this._register(k.Event.debounce(k.Event.any(k.Event.map(m.onDidFocusWindow,()=>"windowFocus"),k.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(i,a)=>i?[...i,a]:[a],1e3)(i=>this.triggerSync(i,!0,!1)))}};E=me([Q(0,T.IProductService),Q(1,b.IUserDataSyncStoreManagementService),Q(2,b.IUserDataSyncStoreService),Q(3,b.IUserDataSyncEnablementService),Q(4,b.IUserDataSyncService),Q(5,t.INativeHostService),Q(6,b.IUserDataSyncLogService),Q(7,P.IUserDataSyncAccountService),Q(8,A.ITelemetryService),Q(9,D.IUserDataSyncMachinesService),Q(10,L.IStorageService)],E),e.UserDataAutoSyncService=E}),define(re[260],se([0,1,6,3,2]),function(Z,e,k,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends T.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:b,getActiveWindowId:P}){super();this.disposables=this._register(new T.DisposableStore),t.Event.latch(t.Event.any(I,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>P()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(re[109],se([0,1,54,6,12,14,27,137,272,273]),function(Z,e,k,t,T,L,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=n,this.cause=r}}e.ExtractError=D;function E(u){const n=u.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function p(u){if(u instanceof D)return u;let n;return/end of central directory record signature not found/.test(u.message)&&(n="CorruptZip"),new D(n,u)}function C(u,n,r,i,a,c){const s=T.dirname(n),o=T.join(i,s);if(!o.startsWith(i))return Promise.reject(new Error(I.localize(0,null,n)));const l=T.join(i,n);let v;return c.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((y,O)=>{if(!c.isCancellationRequested)try{v=(0,k.createWriteStream)(l,{mode:r}),v.once("close",()=>y()),v.once("error",O),u.once("error",O),u.pipe(v)}catch(_){O(_)}}))}function d(u,n,r,i){let a=(0,t.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{a.cancel(),u.close()}),new Promise((s,o)=>{const l=new t.Sequencer,v=y=>{y.isCancellationRequested||(c++,u.readEntry())};u.once("error",o),u.once("close",()=>a.then(()=>{i.isCancellationRequested||u.entryCount===c?s():o(new D("Incomplete",new Error(I.localize(1,null,c,u.entryCount))))},o)),u.readEntry(),u.on("entry",y=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(y.fileName)){v(i);return}const O=y.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(O)){const R=T.join(n,O);a=(0,t.createCancelablePromise)(M=>A.Promises.mkdir(R,{recursive:!0}).then(()=>v(M)).then(void 0,o));return}const _=w(u,y),N=E(y);a=(0,t.createCancelablePromise)(R=>l.queue(()=>_.then(M=>C(M,O,N,n,r,R).then(()=>v(R)))).then(null,o))})})}function S(u,n=!1){return new Promise((r,i)=>{(0,b.open)(u,n?{lazyEntries:!0}:void 0,(a,c)=>{a?i(p(a)):r((0,L.assertIsDefined)(c))})})}function w(u,n){return new Promise((r,i)=>{u.openReadStream(n,(a,c)=>{a?i(p(a)):r((0,L.assertIsDefined)(c))})})}function h(u,n){return new Promise((r,i)=>{const a=new P.ZipFile;n.forEach(s=>{s.contents?a.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&a.addFile(s.localPath,s.path)}),a.end();const c=(0,k.createWriteStream)(u);a.outputStream.pipe(c),a.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(u))})}e.zip=h;function m(u,n,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=S(u,!0);return r.overwrite&&(c=c.then(s=>A.Promises.rm(n).then(()=>s))),c.then(s=>d(s,n,{sourcePathRegex:a},i))}e.extract=m;function g(u,n){return S(u).then(r=>new Promise((i,a)=>{r.on("entry",c=>{c.fileName===n&&w(r,c).then(s=>i(s),s=>a(s))}),r.once("close",()=>a(new Error(I.localize(2,null,n))))}))}function f(u,n){return g(u,n).then(r=>new Promise((i,a)=>{const c=[];r.once("error",a),r.on("data",s=>c.push(s)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=f}),define(re[261],se([0,1,109,146]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function T(L){return(0,k.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=T}),define(re[110],se([0,1,6,37,9,2,20,12,4,19,55,14,8,31,27,109,145,91,15,232,30,32,46,71,199,233,261,200,229,50,66,13,5,7,24,21,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n,r,i,a,c,s,o,l,v,y,O,_,N,R,M,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,O.refineServiceDecorator)(f.IServerExtensionManagementService);let j=class extends g.AbstractExtensionManagementService{constructor(Y,q,x,B,U,$,V,J,H,ee,ne,ae){super(ae,ne,Y,$,q,x,ee);this.environmentService=B,this.extensionsScannerService=U,this.downloadService=V,this.fileService=H;const ue=this._register(J.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(J.createInstance(W,fe=>ue.postUninstall(fe))),this.manifestCache=this._register(new s.ExtensionsManifestCache(B,this)),this.extensionsDownloader=this._register(J.createInstance(i.ExtensionsDownloader));const Se=this._register(new o.ExtensionsWatcher(this,H,B,x,ne));this._register(Se.onDidChangeExtensionsByAnotherSource(({added:fe,removed:pe})=>{fe.length&&this._onDidInstallExtensions.fire(fe.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),pe.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Y){this.logService.trace("ExtensionManagementService#zip",Y.identifier.id);const q=await this.collectFiles(Y),x=await(0,S.zip)((0,P.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,q);return p.URI.file(x)}async unzip(Y){return this.logService.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const q=await this.downloadVsix(Y),x=I.resolve(q.fsPath);return(0,c.getManifest)(x)}getInstalled(Y,q){return this.extensionsScanner.scanExtensions(Y??null,q)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(Y,q={}){this.logService.trace("ExtensionManagementService#install",Y.toString());const x=await this.downloadVsix(Y),B=await(0,c.getManifest)(I.resolve(x.fsPath));if(B.engines&&B.engines.vscode&&!(0,v.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,u.getGalleryExtensionId)(B.publisher,B.name),this.productService.version));return this.installExtension(B,x,q)}getMetadata(Y){return this.extensionsScannerService.scanMetadata(Y.location)}async updateMetadata(Y,q){this.logService.trace("ExtensionManagementService#updateMetadata",Y.identifier.id);const x={...q};return q.isPreReleaseVersion&&(x.preRelease=!0),Y=await this.extensionsScanner.updateMetadata(Y,x),this.manifestCache.invalidate(),Y}async updateExtensionScope(Y,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Y.identifier.id),Y=await this.extensionsScanner.updateMetadata(Y,{isMachineScoped:q}),this.manifestCache.invalidate(),Y}removeUninstalledExtensions(Y){return this.extensionsScanner.cleanUp(Y)}async downloadVsix(Y){if(Y.scheme===A.Schemas.file)return Y;const q=(0,P.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(Y,q),q}createDefaultInstallExtensionTask(Y,q,x){return p.URI.isUri(q)?new G(Y,q,x,this.galleryService,this.extensionsScanner,this.logService):new te(Y,q,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createDefaultUninstallExtensionTask(Y,q){return new K(Y,q,this.extensionsScanner)}async collectFiles(Y){const q=async B=>{let U=await d.Promises.readdir(B);U=U.map(J=>I.join(B,J));const $=await Promise.all(U.map(J=>d.Promises.stat(J)));let V=Promise.resolve([]);return $.forEach((J,H)=>{const ee=U[H];J.isFile()&&(V=V.then(ne=>[...ne,ee])),J.isDirectory()&&(V=V.then(ne=>q(ee).then(ae=>[...ne,...ae])))}),V};return(await q(Y.location.fsPath)).map(B=>({path:`extension/${I.relative(Y.location.fsPath,B)}`,localPath:B}))}};j=me([Q(0,f.IExtensionGalleryService),Q(1,R.ITelemetryService),Q(2,_.ILogService),Q(3,m.INativeEnvironmentService),Q(4,r.IExtensionsScannerService),Q(5,n.IExtensionsProfileScannerService),Q(6,h.IDownloadService),Q(7,O.IInstantiationService),Q(8,y.IFileService),Q(9,N.IProductService),Q(10,M.IUriIdentityService),Q(11,F.IUserDataProfilesService)],j),e.ExtensionManagementService=j;let W=class extends L.Disposable{constructor(Y,q,x,B){super();this.beforeRemovingExtension=Y,this.fileService=q,this.extensionsScannerService=x,this.logService=B,this.uninstalledPath=(0,P.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new k.Queue}async cleanUp(Y){await this.removeUninstalledExtensions(),Y&&await this.removeOutdatedExtensions()}async scanExtensions(Y,q){const x={includeInvalid:!0,profileLocation:q};let B=[];return Y===null||Y===0?B.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},x)):Y===1&&B.push(...await this.extensionsScannerService.scanUserExtensions(x)),B=Y!==null?B.filter(U=>U.type===Y):B,Promise.all(B.map(U=>this.toLocalExtension(U)))}async scanUserExtensions(Y){const q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(q.map(x=>this.toLocalExtension(x)))}async extractUserExtension(Y,q,x,B){const U=Y.toString(),$=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,C.generateUuid)()}`),V=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await d.Promises.rm(V)}catch{throw new f.ExtensionManagementError(w.localize(1,null,V,Y.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(Y,q,$,B),x={...x,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(p.URI.file($),x);try{await this.rename(Y,$,V,Date.now()+2*60*1e3),this.logService.info("Renamed to",V)}catch(J){try{await d.Promises.rm($)}catch{}if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(J)}. Deleted from extracted location`,$),J}return this.scanLocalExtension(p.URI.file(V),1)}async updateMetadata(Y,q){return await this.extensionsScannerService.updateMetadata(Y.location,q),this.scanLocalExtension(Y.location,Y.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...Y){const q=Y.map(x=>u.ExtensionKey.create(x));await this.withUninstalledExtensions(x=>{q.forEach(B=>x[B.toString()]=!0)})}async setInstalled(Y){await this.withUninstalledExtensions(B=>delete B[Y.toString()]);const x=(await this.scanUserExtensions(!0)).find(B=>u.ExtensionKey.create(B).equals(Y))||null;return x?this.updateMetadata(x,{installedTimestamp:Date.now()}):null}async removeExtension(Y,q){this.logService.trace(`Deleting ${q} extension from disk`,Y.identifier.id,Y.location.fsPath),await d.Promises.rm(Y.location.fsPath),this.logService.info("Deleted from disk",Y.identifier.id,Y.location.fsPath)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.withUninstalledExtensions(q=>delete q[u.ExtensionKey.create(Y).toString()])}async withUninstalledExtensions(Y){return this.uninstalledFileLimiter.queue(async()=>{let q;try{q=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let x={};if(q)try{x=JSON.parse(q)}catch{}return Y&&(Y(x),Object.keys(x).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(x)):await d.Promises.rm(this.uninstalledPath)),x})}async extractAtLocation(Y,q,x,B){this.logService.trace(`Started extracting the extension from ${q} to ${x}`);try{await d.Promises.rm(x)}catch(U){throw new f.ExtensionManagementError(this.joinErrors(U).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(q,x,{sourcePath:"extension",overwrite:!0},B),this.logService.info(`Extracted extension to ${x}:`,Y.id)}catch(U){try{await d.Promises.rm(x)}catch{}let $=f.ExtensionManagementErrorCode.Extract;throw U instanceof S.ExtractError&&(U.type==="CorruptZip"?$=f.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&($=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(U.message,$)}}async rename(Y,q,x,B){try{await d.Promises.rename(q,x)}catch(U){if(b.isWindows&&U&&U.code==="EPERM"&&Date.now()<B)return this.logService.info(`Failed renaming ${q} to ${x} with 'EPERM' error. Trying again...`,Y.id),this.rename(Y,q,x,B);throw new f.ExtensionManagementError(U.message||w.localize(2,null,q,x),U.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Y,q){const x=await this.extensionsScannerService.scanExistingExtension(Y,q,{includeInvalid:!0});if(x)return this.toLocalExtension(x);throw new Error(w.localize(3,null,Y.path))}async toLocalExtension(Y){const q=await this.fileService.resolve(Y.location);let x,B;return q.children&&(x=q.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,B=q.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:x,changelogUrl:B,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated}}async removeUninstalledExtensions(){const Y=await this.getUninstalledExtensions(),q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),x=new Set;for(const $ of q)Y[u.ExtensionKey.create($).toString()]||x.add($.identifier.id.toLowerCase());const B=(0,u.groupByExtension)(q,$=>$.identifier);await k.Promises.settled(B.map(async $=>{const V=$.sort((J,H)=>D.rcompare(J.manifest.version,H.manifest.version))[0];x.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(V))}));const U=q.filter($=>Y[u.ExtensionKey.create($).toString()]);await k.Promises.settled(U.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const Y=await this.extensionsScannerService.scanSystemExtensions({}),q=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),x=[],B=await this.extensionsScannerService.getTargetPlatform(),U=(0,u.groupByExtension)(q,$=>$.identifier);for(const $ of U)if($.length>1&&x.push(...$.sort((V,J)=>{const H=D.rcompare(V.manifest.version,J.manifest.version);return H!==0?H:V.targetPlatform===B?-1:1}).slice(1)),$[0].type===0){const V=Y.find(J=>(0,u.areSameExtensions)(J.identifier,$[0].identifier));(!V||D.gte(V.manifest.version,$[0].manifest.version))&&x.push($[0])}await k.Promises.settled(x.map($=>this.removeExtension($,"outdated")))}joinErrors(Y){const q=Array.isArray(Y)?Y:[Y];return q.length===1?q[0]instanceof Error?q[0]:new Error(q[0]):q.reduce((x,B)=>new Error(`${x.message}${x.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};W=me([Q(1,y.IFileService),Q(2,r.IExtensionsScannerService),Q(3,_.ILogService)],W);class z extends g.AbstractExtensionTask{constructor(Y,q,x,B,U){super();this.identifier=Y,this.source=q,this.options=x,this.extensionsScanner=B,this.logService=U,this._operation=2}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(Y,q){try{const x=await this.unsetUninstalledAndGetLocal(Y.key);if(x)return Y.metadata?this.extensionsScanner.updateMetadata(x,Y.metadata):x}catch{throw b.isMacintosh?new f.ExtensionManagementError(w.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(w.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(Y,q)}async unsetUninstalledAndGetLocal(Y){if(!await this.isUninstalled(Y))return null;this.logService.trace("Removing the extension from uninstalled list:",Y.id);const x=await this.extensionsScanner.setInstalled(Y);return this.logService.info("Removed the extension from uninstalled list:",Y.id),x}async isUninstalled(Y){return!!(await this.extensionsScanner.getUninstalledExtensions())[Y.toString()]}async extract({zipPath:Y,key:q,metadata:x},B){const U=await this.extensionsScanner.extractUserExtension(q,Y,x,B);return this.logService.info("Extracting completed.",q.id),U}}class te extends z{constructor(Y,q,x,B,U,$){super(q.identifier,q,x,U,$);this.manifest=Y,this.gallery=q,this.extensionsDownloader=B}async doRun(Y){const x=(await this.extensionsScanner.scanExtensions(null,void 0)).find($=>(0,u.areSameExtensions)($.identifier,this.gallery.identifier));x&&(this._operation=3);const B={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,l.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||x?.isMachineScoped,isBuiltin:this.options.isBuiltin||x?.isBuiltin,isSystem:x?.type===0?!0:void 0,updated:!!x,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:x?.preRelease)};if(x?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(x,B),metadata:B};const U=await this.downloadExtension(this.gallery,this._operation);try{const $=await this.installExtension({zipPath:U,key:u.ExtensionKey.create(this.gallery),metadata:B},Y);return x&&!this.options.profileLocation&&(x.targetPlatform!==$.targetPlatform||D.neq(x.manifest.version,$.manifest.version))&&await this.extensionsScanner.setUninstalled(x),{local:$,metadata:B}}catch($){throw await this.deleteDownloadedVSIX(U),$}}async deleteDownloadedVSIX(Y){try{await this.extensionsDownloader.delete(p.URI.file(Y))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",Y.toString(),(0,T.getErrorMessage)(q))}}async downloadExtension(Y,q){let x;try{this.logService.trace("Started downloading extension:",Y.identifier.id),x=(await this.extensionsDownloader.downloadExtension(Y,q)).fsPath,this.logService.info("Downloaded extension:",Y.identifier.id,x)}catch(B){throw new f.ExtensionManagementError((0,g.joinErrors)(B).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,c.getManifest)(x),x}catch(B){throw await this.deleteDownloadedVSIX(x),new f.ExtensionManagementError((0,g.joinErrors)(B).message,f.ExtensionManagementErrorCode.Invalid)}}}class G extends z{constructor(Y,q,x,B,U,$){super({id:(0,u.getGalleryExtensionId)(Y.publisher,Y.name)},q,x,U,$);this.manifest=Y,this.location=q,this.galleryService=B}async doRun(Y){const q=new u.ExtensionKey(this.identifier,this.manifest.version),B=(await this.extensionsScanner.scanExtensions(1,void 0)).find(V=>(0,u.areSameExtensions)(this.identifier,V.identifier)),U=await this.getMetadata(this.identifier.id,this.manifest.version,Y);if(U.isApplicationScoped=(0,l.isApplicationScopedExtension)(this.manifest),U.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,U.isBuiltin=this.options.isBuiltin||B?.isBuiltin,B)if(this._operation=3,q.equals(new u.ExtensionKey(B.identifier,B.manifest.version)))try{await this.extensionsScanner.removeExtension(B,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&D.gt(B.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(B);else{const V=await this.unsetUninstalledAndGetLocal(q);if(V)try{await this.extensionsScanner.removeExtension(V,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:q,metadata:U},Y),metadata:U}}async getMetadata(Y,q,x){try{let[B]=await this.galleryService.getExtensions([{id:Y,version:q}],x);if(B||([B]=await this.galleryService.getExtensions([{id:Y}],x)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class K extends g.AbstractExtensionTask{constructor(Y,q,x){super();this.extension=Y,this.options=q,this.extensionsScanner=x}async doRun(Y){const q=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const B=u.ExtensionKey.create(this.extension);q.push(...x.filter(U=>B.equals(u.ExtensionKey.create(U))))}else q.push(...x.filter(B=>(0,u.areSameExtensions)(B.identifier,this.extension.identifier)));if(!q.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const B of q)try{Y.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(B)}catch(U){throw new Error(w.localize(9,null,(0,t.toErrorMessage)(U)))}}}}),define(re[262],se([0,1,2,30,32,46,72,198,110,50,5,7,22,33,28]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let w=class extends k.Disposable{constructor(g,f,u,n,r,i,a,c){super();this.userDataProfilesService=f,g.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===0),(0,I.migrateUnsupportedExtensions)(g,u,n,r,c),A.ExtensionStorageService.removeOutdatedExtensionVersions(g,a),this._register(i.createInstance(h))}};w=me([Q(0,b.INativeServerExtensionManagementService),Q(1,d.IUserDataProfilesService),Q(2,t.IExtensionGalleryService),Q(3,A.IExtensionStorageService),Q(4,t.IGlobalExtensionEnablementService),Q(5,D.IInstantiationService),Q(6,p.IStorageService),Q(7,E.ILogService)],w),e.ExtensionsCleaner=w;let h=class extends k.Disposable{constructor(g,f,u,n,r){super();this.extensionManagementService=g,this.userDataProfilesService=f,this.extensionsProfileScannerService=u,this.uriIdentityService=n,this.logService=r,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new k.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:g,removed:f,all:u}){try{await Promise.all(f.map(n=>n.extensionsResource?this.removeExtensionsFromProfile(n.extensionsResource):Promise.resolve()))}catch(n){this.logService.error(n)}if(u.length===0){this.profileModeDisposables.clear();const n=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{n.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{g.length&&(await Promise.all(g.map(n=>n.extensionsResource?this.populateExtensionsFromProfile(n.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new k.DisposableStore,this.profileModeDisposables.value.add((0,k.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(n=>this.onDidChangeProfiles(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(n=>this.onDidUninstallExtension(n))),await this.uninstallExtensionsNotInProfiles()))}catch(n){this.logService.error(n)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(u=>!this.profileExtensionsLocations.has(this.getKey(u.identifier,u.manifest.version)));f.length&&await Promise.all(f.map(u=>this.extensionManagementService.uninstall(u,S)))}async onDidInstallExtensions(g){for(const{local:f,profileLocation:u}of g)!f||!u||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),u)}async onDidUninstallExtension(g){!g.profileLocation||!g.version||this.removeExtensionWithKey(this.getKey(g.identifier,g.version),g.profileLocation)&&await this.uninstallExtensions([{identifier:g.identifier,version:g.version}])}async populateExtensionsFromProfile(g){const f=await this.extensionsProfileScannerService.scanProfileExtensions(g);for(const u of f)this.addExtensionWithKey(this.getKey(u.identifier,u.version),g)}async removeExtensionsFromProfile(g){const f=[];for(const u of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(u,g))continue;const n=this.fromKey(u);n&&f.push(n)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(g,f){let u=this.profileExtensionsLocations.get(g);u||(u=[],this.profileExtensionsLocations.set(g,u)),u.push(f)}removeExtensionWithKey(g,f){const u=this.profileExtensionsLocations.get(g);if(u){const n=u.findIndex(r=>this.uriIdentityService.extUri.isEqual(r,f));n>-1&&u.splice(n,1)}return u?.length?!1:(this.profileExtensionsLocations.delete(g),!0)}async uninstallExtensions(g){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(n=>g.some(r=>this.getKey(n.identifier,n.manifest.version)===this.getKey(r.identifier,r.version)));u.length&&await Promise.all(u.map(n=>this.extensionManagementService.uninstall(n,S)))}getKey(g,f){return`${P.ExtensionIdentifier.toKey(g.id)}@${f}`}fromKey(g){const[f,u]=(0,T.getIdAndVersion)(g);return u?{identifier:{id:f},version:u}:void 0}};h=me([Q(0,b.INativeServerExtensionManagementService),Q(1,d.IUserDataProfilesService),Q(2,L.IExtensionsProfileScannerService),Q(3,C.IUriIdentityService),Q(4,E.ILogService)],h)}),define(re[263],se([0,1,93,61,35,16,9,3,2,12,4,31,39,84,274]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(y,O=""){this.debugLabel=O,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}traceSocketEvent(y,O){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const O=_=>{this.traceSocketEvent("read",_),y(L.VSBuffer.wrap(_))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(y){const O=_=>{this.traceSocketEvent("close",{hadError:_}),y({type:0,hadError:_,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(y){const O=()=>{this.traceSocketEvent("nodeEndReceived"),y()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(y){if(!this.socket.destroyed)try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=S;var w;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var h;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(h||(h={}));class m extends b.Disposable{constructor(y,O,_,N){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:_?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,O,_,N,this._onData,(R,M)=>this._write(R,M))),this._register(this._flowManager.onError(R=>{console.error(R),(0,A.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(y,O){this.socket.traceSocketEvent(y,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._flowManager.writeMessage(y)}_write(y,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let _=2;y.byteLength<126?_+=0:y.byteLength<2**16?_+=2:_+=8;const N=L.VSBuffer.alloc(_);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),y.byteLength<126)N.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){N.writeUInt8(126,1);let R=1;N.writeUInt8(y.byteLength>>>8&255,++R),N.writeUInt8(y.byteLength>>>0&255,++R)}else{N.writeUInt8(127,1);let R=1;N.writeUInt8(0,++R),N.writeUInt8(0,++R),N.writeUInt8(0,++R),N.writeUInt8(0,++R),N.writeUInt8(y.byteLength>>>24&255,++R),N.writeUInt8(y.byteLength>>>16&255,++R),N.writeUInt8(y.byteLength>>>8&255,++R),N.writeUInt8(y.byteLength>>>0&255,++R)}this.socket.write(L.VSBuffer.concat([N,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),_=O.readUInt8(0),N=(_&128)>>>7,R=(_&64)>>>6,M=O.readUInt8(1),F=(M&128)>>>7,j=M&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),_=O.readUInt8(1),N=(_&128)>>>7;let R=_&127,M=1;R===126?R=O.readUInt8(++M)*2**8+O.readUInt8(++M):R===127&&(R=O.readUInt8(++M)*0+O.readUInt8(++M)*0+O.readUInt8(++M)*0+O.readUInt8(++M)*0+O.readUInt8(++M)*2**24+O.readUInt8(++M)*2**16+O.readUInt8(++M)*2**8+O.readUInt8(++M));let F=0;N&&(F=O.readUInt8(++M)*2**24+O.readUInt8(++M)*2**16+O.readUInt8(++M)*2**8+O.readUInt8(++M)),this._state.state=3,this._state.readLen=R,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),n(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class g extends b.Disposable{constructor(y,O,_,N,R,M){super();this._tracer=y,this._onData=R,this._writeFn=M,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new f(this._tracer,N,_,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(y){this._writeQueue.push(y),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const y=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,y);this._writeFn(O,!0)}else this._writeFn(y,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(y,O){return new Promise((_,N)=>{y.write(O),y.flush(R=>_(R))})}acceptFrame(y,O,_){this._readQueue.push({data:y,isCompressed:O,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const y=this._readQueue.shift();if(this._zlibInflateStream&&y.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,y.data,y.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(y.data)}this._isProcessingReadQueue=!1}}_inflateFrame(y,O,_){return new Promise((N,R)=>{y.write(O),_&&y.write(L.VSBuffer.fromByteArray([0,0,255,255])),y.flush(M=>N(M))})}}class f extends b.Disposable{constructor(y,O,_,N){super();this._tracer=y,this._recordInflateBytes=O,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(N),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(L.VSBuffer.wrap(R))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(y){this._recordInflateBytes&&this._recordedInflateBytes.push(y.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",y),this._zlibInflate.write(y.buffer)}flush(y){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,y(O)})}}class u extends b.Disposable{constructor(y,O){super();this._tracer=y,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(L.VSBuffer.wrap(_))})}write(y){this._tracer.traceSocketEvent("zlibDeflateWrite",y.buffer),this._zlibDeflate.write(y.buffer)}flush(y){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),y(O)})}}function n(v,y){if(y===0)return;const O=v.byteLength>>>2;for(let j=0;j<O;j++){const W=v.readUInt32BE(j*4);v.writeUInt32BE(W^y,j*4)}const _=O*4,N=v.byteLength-_,R=y>>>24&255,M=y>>>16&255,F=y>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(_)^R,_),N>=2&&v.writeUInt8(v.readUInt8(_+1)^M,_+1),N>=3&&v.writeUInt8(v.readUInt8(_+2)^F,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function i(){const v=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):y=(0,P.join)((0,T.tmpdir)(),`vscode-ipc-${v}.sock`),c(y),y}e.createRandomIPCHandle=i;function a(v,y,O){const _=(0,k.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${O}-${y}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${O}-${y}.sock`):N=(0,P.join)(v,`${O}-${y}.sock`),c(N),N}e.createStaticIPCHandle=a;function c(v){const y=r[D.platform];typeof y=="number"&&v.length>=y&&console.warn(`WARNING: IPC handle "${v}" is longer than ${y} chars, try a shorter --user-data-dir`)}class s extends p.IPCServer{constructor(y){super(s.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const O=I.Event.fromNodeEventEmitter(y,"connection");return I.Event.map(O,_=>({protocol:new C.Protocol(new S(_,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(v){return new Promise((y,O)=>{const _=(0,t.createServer)();_.on("error",O),_.listen(v,()=>{_.removeListener("error",O),y(new s(_))})})}e.serve=o;function l(v,y){return new Promise((O,_)=>{const N=(0,t.createConnection)(v,()=>{N.removeListener("error",_),O(C.Client.fromSocket(new S(N,`ipc-client${y}`),y))});N.once("error",_)})}e.connect=l}),define(re[264],se([0,1,61,263]),function(Z,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(T,L,A,I,b,P){const D=p=>P(p,void 0),E=k.createConnection({host:T,port:L},()=>{E.removeListener("error",D);const p=Buffer.alloc(16);for(let w=0;w<16;w++)p[w]=Math.round(Math.random()*256);const C=p.toString("base64"),d=[`GET ws://${/:/.test(T)?`[${T}]`:T}:${L}${A}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`];E.write(d.join(`\r
`)+`\r
\r
`);const S=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",S),P(void 0,new t.NodeSocket(E,b)))};E.on("data",S)});E.setNoDelay(!0),E.once("error",D)}}}),define(re[265],se([0,1,61,117,264,6,2,18,7,24,202,70,102]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function C(m,g,f,u,n){let r;for(let i=3;i&&(r&&r.dispose(),r=await new d(m,g,f,u,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class d extends A.Disposable{constructor(g,f,u,n,r){super();this.defaultTunnelHost=f,this.suggestedLocalPort=r,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=k.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let g=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(g){g.pause();const f=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,D.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),n=u.getSocket().socket,r=u.readEntireBuffer();u.dispose(),r.byteLength>0&&g.write(r.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),n.end()}),g.on("close",()=>n.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),n.destroy()}),n.on("end",()=>g.end()),n.on("close",()=>g.end()),n.on("error",()=>{g.destroy()}),g.pipe(n),n.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),n.end()})}}let S=class extends E.AbstractTunnelService{constructor(g,f,u,n,r){super(f);this.socketFactory=g,this.signService=u,this.productService=n,this.configurationService=r}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,f,u,n,r,i,a){const c=this.getTunnelFromMap(f,u);if(c)return++c.refcount,c.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,u,n,r,i,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${u} on local port ${n}.`);const s={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},o=C(s,this.defaultTunnelHost,f,u,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,u,o),o}}};S=me([Q(1,b.ILogService),Q(2,p.ISignService),Q(3,P.IProductService),Q(4,I.IConfigurationService)],S),e.BaseTunnelService=S;let w=class extends S{constructor(g,f,u,n){super(T.nodeSocketFactory,g,f,u,n)}};w=me([Q(0,b.ILogService),Q(1,p.ISignService),Q(2,P.IProductService),Q(3,I.IConfigurationService)],w),e.TunnelService=w;let h=class extends A.Disposable{constructor(g,f,u,n){super();this.logService=g,this.productService=f,this.signService=u,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(g,f,u,n,r,i,a,c){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${n} on local port ${r}.`),!this._tunnelServices.has(g)){const s=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(g,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(f,u,n,r,i,a,c)}};h=me([Q(0,b.ILogService),Q(1,P.IProductService),Q(2,p.ISignService),Q(3,I.IConfigurationService)],h),e.SharedTunnelsService=h}),define(re[275],se([0,1,85,35,37,9,2,20,19,8,39,134,191,262,192,183,184,185,172,175,18,196,90,214,91,205,15,209,235,236,30,174,237,110,92,170,13,187,189,56,5,181,95,182,96,67,201,7,97,68,98,24,204,44,22,238,213,21,103,104,105,45,218,219,106,221,227,72,108,25,73,251,253,254,74,252,256,257,258,259,260,102,211,70,265,203,228,101,208,33,230,4,231,176,194,193,71,234,28,46,190,58,239,217]),function(Z,e,k,t,T,L,A,I,b,P,D,E,p,C,d,S,w,h,m,g,f,u,n,r,i,a,c,s,o,l,v,y,O,_,N,R,M,F,j,W,z,te,G,K,X,Y,q,x,B,U,$,V,J,H,ee,ne,ae,ue,Se,fe,pe,Ce,be,Ie,qe,Qe,Ke,Ye,oe,le,he,Ee,Pe,Ue,Re,Ne,_e,Te,Me,ie,ce,de,ve,ge,we,De,ke,Le,Ae,Fe,$e,Xe,rt,St,Dt,yt,Rt,kt,Lt,wt,Tt,Et,At,_t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ot extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",ze=(xe,Ze)=>this.onDisposeWorker(Ze);k.ipcRenderer.on(Oe,ze),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Oe,ze)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,le.registerConfiguration)(),ye.invokeFunction(Oe=>{const ze=Oe.get(x.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(ze)}),this._register((0,A.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(d.LanguagePackCachedDataCleaner),ye.createInstance(h.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(w.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(C.ExtensionsCleaner)))}async initServices(){const ye=new G.ServiceCollection,Oe={_serviceBrand:void 0,...$.default};ye.set(V.IProductService,Oe);const ze=new D.StaticRouter(He=>He==="main"),xe=new K.MessagePortMainProcessService(this.server,ze);ye.set(X.IMainProcessService,xe);const Ze=this.configuration.policiesData?new Tt.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,Ze);const We=new s.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(c.INativeEnvironmentService,We);const at=new B.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),et=new B.LoggerChannelClient(this.configuration.logLevel,at.onDidChangeLogLevel,xe.getChannel("logger"));ye.set(x.ILoggerService,et);const ut=this._register(new x.MultiplexLogService([this._register(new x.ConsoleLogger(this.configuration.logLevel)),this._register(et.createLogger((0,b.joinPath)(P.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),je=this._register(new B.FollowerLogService(at,ut));ye.set(x.ILogService,je),this.sharedProcessWorkerService=new Ae.SharedProcessWorkerService(je),ye.set(Le.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new F.FileService(je));ye.set(M.IFileService,Ve);const ht=this._register(new j.DiskFileSystemProvider(je));Ve.registerProvider(I.Schemas.file,ht);const dt=this._register(new rt.FileUserDataProvider(I.Schemas.file,this._register(new St.DiskFileSystemProviderClient(xe.getChannel(St.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Xe.isLinux})),I.Schemas.vscodeUserData,je));Ve.registerProvider(I.Schemas.vscodeUserData,dt);const tt=this._register(new At.UserDataProfilesNativeService(this.configuration.profiles,xe,We,Ve,je));ye.set(Lt.IUserDataProfilesService,tt);const Be=this._register(new u.ConfigurationService(tt.defaultProfile.settingsResource,Ve,Ze,je));ye.set(f.IConfigurationService,Be);const st=new ne.NativeStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},xe,We);ye.set(ee.IStorageService,st),this._register((0,A.toDisposable)(()=>st.flush())),await Promise.all([Be.initialize(),st.initialize()]),ye.set(Fe.IUriIdentityService,new $e.UriIdentityService(Ve)),ye.set(H.IRequestService,new W.SyncDescriptor(J.RequestService)),ye.set(m.IChecksumService,new W.SyncDescriptor(g.ChecksumService)),ye.set(yt.IV8InspectProfilingService,new W.SyncDescriptor(Dt.InspectProfilingService));const ct=D.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(U.INativeHostService,ct),ye.set(i.IDownloadService,new W.SyncDescriptor(a.DownloadService));const ft=this._register(new ce.ActiveWindowManager(ct)),Mt=new D.StaticRouter(He=>ft.getActiveClientId().then(gt=>He===gt));ye.set(N.IExtensionRecommendationNotificationService,new R.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let lt;const it=[];if((0,Ce.supportsTelemetry)(Oe,We)){const He=new fe.TelemetryLogAppender(et,We);it.push(He);const{installSourcePath:gt}=We;if(Be.getValue("telemetry.internalTesting")&&Oe.aiConfig?.ariaKey){const ot=new _t.OneDataSystemWebAppender(Be,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>ot.flush())),it.push(ot)}else if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=new be.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>ot.flush())),it.push(ot)}lt=new pe.TelemetryService({appenders:it,commonProperties:(0,ae.resolveCommonProperties)(Ve,(0,t.release)(),(0,t.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:(0,Ce.getPiiPathsFromEnvironment)(We)},Be,Oe)}else{lt=Ce.NullTelemetryService;const He=Ce.NullAppender;it.push(He)}this.server.registerChannel("telemetryAppender",new Se.TelemetryAppenderChannel(it)),ye.set(ue.ITelemetryService,lt);const Ft=new Ie.CustomEndpointTelemetryService(Be,lt,et,We,Oe);ye.set(ue.ICustomEndpointTelemetryService,Ft),ye.set(wt.IExtensionsProfileScannerService,new W.SyncDescriptor(wt.ExtensionsProfileScannerService)),ye.set(Rt.IExtensionsScannerService,new W.SyncDescriptor(kt.ExtensionsScannerService)),ye.set(_.INativeServerExtensionManagementService,new W.SyncDescriptor(_.ExtensionManagementService)),ye.set(v.IExtensionGalleryService,new W.SyncDescriptor(l.ExtensionGalleryService)),ye.set(v.IExtensionTipsService,new W.SyncDescriptor(O.ExtensionTipsService)),ye.set(Y.ILanguagePackService,new W.SyncDescriptor(q.NativeLanguagePackService)),ye.set(n.IDiagnosticsService,new W.SyncDescriptor(r.DiagnosticsService)),ye.set(he.IUserDataSyncAccountService,new W.SyncDescriptor(he.UserDataSyncAccountService)),ye.set(le.IUserDataSyncLogService,new W.SyncDescriptor(Ue.UserDataSyncLogService)),ye.set(le.IUserDataSyncUtilService,new Pe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ye.set(v.IGlobalExtensionEnablementService,new W.SyncDescriptor(o.GlobalExtensionEnablementService)),ye.set(oe.IIgnoredExtensionsManagementService,new W.SyncDescriptor(oe.IgnoredExtensionsManagementService)),ye.set(Ye.IExtensionStorageService,new W.SyncDescriptor(Ye.ExtensionStorageService)),ye.set(le.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Me.UserDataSyncStoreManagementService)),ye.set(le.IUserDataSyncStoreService,new W.SyncDescriptor(Me.UserDataSyncStoreService)),ye.set(Re.IUserDataSyncMachinesService,new W.SyncDescriptor(Re.UserDataSyncMachinesService)),ye.set(le.IUserDataSyncBackupStoreService,new W.SyncDescriptor(Ee.UserDataSyncBackupStoreService)),ye.set(le.IUserDataSyncEnablementService,new W.SyncDescriptor(Ne.UserDataSyncEnablementService)),ye.set(le.IUserDataSyncService,new W.SyncDescriptor(_e.UserDataSyncService));const Ct=new Ke.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,We,je);return Ct.initialize(),ye.set(Qe.ILocalPtyService,this._register(Ct)),ye.set(de.ISignService,new W.SyncDescriptor(ve.SignService)),ye.set(ge.ISharedTunnelsService,new W.SyncDescriptor(we.SharedTunnelsService)),ye.set(De.ISharedProcessTunnelService,new W.SyncDescriptor(ke.SharedProcessTunnelService)),new te.InstantiationService(ye)}initChannels(ye){const Oe=new y.ExtensionManagementChannel(ye.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const ze=D.ProxyChannel.fromService(ye.get(Y.ILanguagePackService));this.server.registerChannel("languagePacks",ze);const xe=D.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",xe);const Ze=new y.ExtensionTipsChannel(ye.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const We=D.ProxyChannel.fromService(ye.get(m.IChecksumService));this.server.registerChannel("checksum",We);const at=D.ProxyChannel.fromService(ye.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",at);const et=new Pe.UserDataSyncMachinesServiceChannel(ye.get(Re.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",et);const ut=D.ProxyChannel.fromService(ye.get(ue.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ut);const je=new Pe.UserDataSyncAccountServiceChannel(ye.get(he.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",je);const Ve=new Pe.UserDataSyncStoreManagementServiceChannel(ye.get(le.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const ht=new Te.UserDataSyncChannel(ye.get(le.IUserDataSyncService),ye.get(x.ILogService));this.server.registerChannel("userDataSync",ht);const dt=this._register(ye.get(z.IInstantiationService).createInstance(ie.UserDataAutoSyncService)),tt=new Pe.UserDataAutoSyncChannel(dt);this.server.registerChannel("userDataAutoSync",tt);const Be=ye.get(Qe.ILocalPtyService),st=D.ProxyChannel.fromService(Be);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,st);const ct=D.ProxyChannel.fromService(ye.get(De.ISharedProcessTunnelService));this.server.registerChannel(De.ipcSharedProcessTunnelChannelName,ct);const ft=D.ProxyChannel.fromService(ye.get(Le.ISharedProcessWorkerService));this.server.registerChannel(Le.ipcSharedProcessWorkerChannelName,ft)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const ze=(0,T.toErrorMessage)(Oe,!0);!ze||ye.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Ut(bt){const ye=new Ot(bt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ut})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b06ae3b2d2dbfe28bca3134cc6be65935cdfea6a/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
